#include <algorithm>
#include <set>
//#include <map>
#include <vector>
//#include <queue>
//#include <string>

#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cctype>

//#include <iostream>
//#include <sstream>
using namespace std;

#define REP(i,n) for(__typeof(n) i=0; i<n; i++)
#define FOR(i,a,b) for(__typeof(b) i=(a); i<=(b); i++)
#define FORD(i,a,b) for(__typeof(a) i=(a); i>=(b); i--)
#define FORE(it,e) for(__typeof((e).begin()) it=(e).begin(); it!=(e).end(); it++)
#define FORER(it,e) for(__typeof((e).rbegin()) it=(e).rbegin(); it!=(e).rend(); it++)

struct B
{
  int a, b, c;
};

int cmp(const void *aa, const void *bb)
{
  const struct B *a=(const struct B*)aa;
  const struct B *b=(const struct B*)bb;
  
  if(a->c>b->c)
    return -1;
  
  if(a->c<b->c)
    return 1;
  
  return 0;
}

static long long obs;


static int n, m;
static struct B *b;

static set<pair<int,int> > s;

void pridaj(int a, int b)
{
  int kam, bkam;
  set<pair<int,int> >::iterator it, itt;
  pair<int,int> pp;
  
  it=s.upper_bound(pair<int,int> (b, a));
  
  if(a<=it->second)
    return;
  
  it--;
  
  itt=it;
  itt++;
  pp=*itt;
  kam=pp.second;
  bkam=kam;
  
  while(it->second<=a)
  {
    itt=it;
    it--;
    
    obs-=(long long)itt->first*(long long)(itt->second-kam);
    kam=itt->second;
    s.erase(itt);
  }
  
  obs-=(long long)it->first*(long long)(it->second-kam);
  obs+=(long long)it->first*(long long)(it->second-a);
  obs+=(long long)b*(long long)(a-bkam);
  
  s.insert(pair<int,int> (b, a));
}

int main()
{
  int n, m;

  b=(struct B*)malloc(100010*sizeof(struct B));
  scanf("%d %d ", &n, &m);
  while (n || m)
  {
    int i, j;
    
    for(i=0; i<n; i++)
      scanf("%d %d %d ", &b[i].a, &b[i].b, &b[i].c);
    
    qsort(b, n, sizeof(struct B), cmp);
    
    i=0;
    j=m;
    
    long long sum=(long long)m*(long long)m*(long long)m;
    
    s.clear();
    s.insert(pair<int,int> (1000000, 0));
    s.insert(pair<int,int> (0, 1000000));
    obs=0;
    for(i=0; i<n; i++)
    {
      if(b[i].c<j)
      {
        sum-=obs*(long long)(j-b[i].c);
        j=b[i].c;
      }
      
      pridaj(b[i].a, b[i].b);
    }
    
    sum-=obs*(long long)j;
    
    printf("%lld\n", sum);
    
    scanf("%d %d ", &n, &m);
  }
  
  return 0;
}
