#include <algorithm>

using namespace std;

#include <stdio.h>
#include <string.h>

typedef void (*grr)(int *x, int *y);

static int n;

void op0(int *x, int *y)
{
  int xx=*x;
  int yy=*y;
  
  *x=yy;
  *y=n-1-xx;
}

void op1(int *x, int *y)
{
  int xx=*x;
  int yy=*y;
  
  *x=n-1-yy;
  *y=xx;
}


void op2(int *x, int *y)
{
  int xx=*x;
  int yy=*y;
  
  *x=n-1-xx;
  *y=yy;
}


void op3(int *x, int *y)
{
  int xx=*x;
  int yy=*y;
  
  if(yy<n/2)
    return;
  
  *x=n-1-xx;
  *y=yy;
}


void op4(int *x, int *y)
{
  int xx=*x;
  int yy=*y;
  
  if(yy<n/2)
    return;
  
  *x=xx;
  *y=3*n/2-yy-1;
}


void op5(int *x, int *y)
{
  int xx=*x;
  int yy=*y;
  
  if(yy%2==0)
    *y=yy/2;
   else
    *y=n/2+yy/2;
}


void op6(int *x, int *y)
{
  int xx=*x;
  int yy=*y;
  
  if(yy<n/2)
    *y=2*yy;
   else
    *y=2*(yy-n/2)+1;
}


void op7(int *x, int *y)
{
  int xx=*x;
  int yy=*y;
  
  if(xx<n/2 && yy%2==0)
  {
    *x=2*xx;
  }
   else
  if(xx>=n/2 && yy%2==0)
  {
    *x=2*xx-n;
    *y=yy+1;
  }
   else

  if(xx<n/2 && yy%2==1)
  {
    *x=2*xx+1;
    *y=yy-1;
  }
   else
  if(xx>=n/2 && yy%2==1)
  {
    *x=2*xx-n+1;
  }
}


void op8(int *x, int *y)
{
  int xx=*x;
  int yy=*y;
  
  if(xx%2==0 && yy%2==0)
  {
    *x=xx/2;
  }
   else
  if(xx%2==0 && yy%2==1)
  {
    *x=xx/2+n/2;
    *y=yy-1;
  }
   else

  if(xx%2==1 && yy%2==0)
  {
    *x=xx/2;
    *y=yy+1;
  }
   else
  if(xx%2==1 && yy%2==1)
  {
    *x=xx/2+n/2;
  }
}

static int bol[1024][1024];
static int mam;

int main()
{
  scanf("%d ", &n);
  grr fn[9];
  
  fn[0]=op0;
  fn[1]=op1;
  fn[2]=op2;
  fn[3]=op3;
  fn[4]=op4;
  fn[5]=op5;
  fn[6]=op6;
  fn[7]=op7;
  fn[8]=op8;
  
  
  while(n)
  {
    char buffer[1000];
    int op[32];
    int ops;
    gets(buffer);
    
    char *c;
    
    c=strtok(buffer, " ");
    ops=0;

    while(c)
    {
      if(!strcmp(c, "rot"))
        op[ops++]=0;
      if(!strcmp(c, "rot-"))
        op[ops++]=1;
      if(!strcmp(c, "sym"))
        op[ops++]=2;
      if(!strcmp(c, "sym-"))
        op[ops++]=2;
      if(!strcmp(c, "bhsym"))
        op[ops++]=3;
      if(!strcmp(c, "bhsym-"))
        op[ops++]=3;
      if(!strcmp(c, "bvsym"))
        op[ops++]=4;
      if(!strcmp(c, "bvsym-"))
        op[ops++]=4;
      if(!strcmp(c, "div"))
        op[ops++]=5;
      if(!strcmp(c, "div-"))
        op[ops++]=6;
      if(!strcmp(c, "mix"))
        op[ops++]=7;
      if(!strcmp(c, "mix-"))
        op[ops++]=8;
      
      c=strtok(NULL, " ");
    }
    
    memset(bol, 0, sizeof(bol));
    
    int ii, jj;
    
    int qq;
    
    qq=1;
    
    int nn=n;
    if(nn>100)
      nn=100;
    
    for(ii=0; ii<nn; ii++)
      for(jj=0; jj<nn; jj++)
        if(!bol[ii][jj])
    {
      int x, y, cnt;
      
      x=ii;
      y=jj;
      
      cnt=0;
      while(!bol[x][y])
      {
        cnt++;
        bol[x][y]=1;
        
        for(int k=ops-1; k>=0; k--)
          fn[op[k]](&x, &y);
      }
      
//      printf("%d\n", cnt);
      
      qq=(qq/__gcd(qq,cnt))*cnt;
    }
    
    printf("%d\n", qq);
    
    scanf("%d ", &n);
  }
  
  return 0;
}
