#include <stdio.h>
#include <string.h>

#define P(x,y) ((x)+(y)*n)
#define LL long long

int Transf[6][1500000];

void rot(int n)
{
  int i,j;
  for(i=0;i<n;i++)for(j=0;j<n;j++)Transf[0][P(i,j)]=P(j,n-1-i);
}
void sym(int n)
{
  int i,j;
  for(i=0;i<n;i++)for(j=0;j<n;j++)Transf[1][P(i,j)]=P(n-1-i,j);
}
void bhsym(int n)
{
  int i,j;
  for(j=0;j<n/2;j++)for(i=0;i<n;i++)Transf[2][P(i,j)]=P(i,j);
  for(j=n/2;j<n;j++)for(i=0;i<n;i++)Transf[2][P(i,j)]=P(n-1-i,j);
}
void bvsym(int n)
{
  int i,j;
  for(j=0;j<n/2;j++)for(i=0;i<n;i++)Transf[3][P(i,j)]=P(i,j);
  for(j=n/2;j<n;j++)for(i=0;i<n;i++)Transf[3][P(i,j)]=P(i,n-1-j+n/2);
}
void div(int n)
{
  int i,j;
  int k=0;
  for(j=0;j<n;j+=2,k++)for(i=0;i<n;i++)Transf[4][P(i,j)]=P(i,k);
  for(j=1;j<n;j+=2,k++)for(i=0;i<n;i++)Transf[4][P(i,j)]=P(i,k);
}
void mix(int n)
{
  int i,j;
/*  for(j=0;j<n;j+=2)
  {
    for(i=0;i<n;i+=2)Transf[5][P(i,j)]=P(i/2,j);
    for(i=1;i<n;i+=2)Transf[5][P(i,j)]=P((i-2)/2,j+1);
    for(i=0;i<n;i+=2)Transf[5][P(i,j+1)]=P(i/2+n/2,j);
    for(i=1;i<n;i+=2)Transf[5][P(i,j+1)]=P((i-1)/2+n/2,j+1);
  }
  */
  for(j=0;j<n;j+=2)
  {
    for(i=0;i<n/2;i++)Transf[5][P(i,j)]=P(2*i,j);
    for(i=n/2;i<n;i++)Transf[5][P(i,j)]=P(2*i-n,j+1);
    for(i=0;i<n/2;i++)Transf[5][P(i,j+1)]=P(2*i+1,j);
    for(i=n/2;i<n;i++)Transf[5][P(i,j+1)]=P(2*i+1-n,j+1);
  }
}

LL gcd(LL a,LL b)
{
  if(b==0)return a;
  return gcd(b,a%b);
}

LL lcm(LL a,LL b)
{
  return a/gcd(a,b)*b;
}

int N;
int St[2][1500000];

void dit(int T,int t)
{
  int i;
  for(i=0;i<N*N;i++)St[t][Transf[T][i]]=St[1-t][i];
}
void dt(int T,int t)
{
  int i;
  for(i=0;i<N*N;i++)St[t][i]=St[1-t][Transf[T][i]];
}

int do1()
{
  char cmd[19],inv;
  int t,i,j;
  
  scanf("%d ",&N);
  if(N==0)return 0;
  
  rot(N); sym(N); bhsym(N); bvsym (N); div(N); mix(N);
  for(i=0;i<N*N;i++)St[0][i]=i;
  t=1;
  while(scanf("%[a-z]%c ",cmd,&inv)==2)
  {
    if(!strcmp(cmd,"rot"))
    {
      if(inv=='-')dit(0,t); else dt(0,t);
      t=1-t;
    }
    if(!strcmp(cmd,"sym"))
    {
      if(inv=='-')dit(1,t); else dt(1,t);
      t=1-t;
    }
    if(!strcmp(cmd,"bhsym"))
    {
      if(inv=='-')dit(2,t); else dt(2,t);
      t=1-t;
    }
    if(!strcmp(cmd,"bvsym"))
    {
      if(inv=='-')dit(3,t); else dt(3,t);
      t=1-t;
    }
    if(!strcmp(cmd,"div"))
    {
      if(inv=='-')dit(4,t); else dt(4,t);
      t=1-t;
    }
    if(!strcmp(cmd,"mix"))
    {
      if(inv=='-')dit(5,t); else dt(5,t);
      t=1-t;
    }
  }
  
  LL ord=1;
  t=1-t;
  for(i=0;i<N*N;i++)if(St[t][i]!=-1)
  {
    LL len=0;
    j=i;
    while(St[t][j]!=-1)
    {
      int k=St[t][j];
      St[t][j]=-1;
      j=k;
      len++;
    }
    ord=lcm(ord,len);
  }
  printf("%lld\n",ord);
  return 1;
}

int main()
{
  while(do1());
  return 0;
}
