#include<cstdio>
#include<cstring>
#include<map>
using namespace std;
int n;
map< int,int> S;

#define M 26*26
int h[M][M];
char p[1005];
void addvertex(int a){
  if (S.find(a)==S.end()) {
    int k=S.size();
    S[a]=k;
  }
}
void addedge(int a,int b ,int c){
  addvertex(a);
  addvertex(b);
  h[a][b]>?=c;
//      printf("#edge %d %d-> %d\n",a,b,c);
}
  double ep=1E12;
double gv(double c){
//  printf("%lf\n",c);
  int n=S.size();
  double d[M][M];
  
  for(int i=0;i<M;i++) if (S.find(i)!=S.end())
    
  for(int j=0;j<M;j++) if (S.find(j)!=S.end()) {
    if (h[i][j]) {
      
      d[S[i]][S[j]]=+(double)h[i][j]-c; 
  //    printf("edge %d %d-> %d\n",S[i],S[j],h[i][j]);
    }
      else d[S[i]][S[j]]=ep;   
  }
//  for(int i=0;i<M;i++) d[i][j]=0;
  for(int k=0;k<n;k++)
  for(int i=0;i<n;i++)
  for(int j=0;j<n;j++) d[i][j]<?=d[i][k]+d[k][j];
  double rv=ep;

  for(int i=0;i<n;i++) rv<?=d[i][i];
  return rv;
}
double solve(){
  double ub=1000.0,lb=0.0f;
  for(int i=0;i<42;i++){
     double c=(ub+lb )/2.0;
     double r = gv(c);
     if (r>ep-1.0) return ep;
     if (r > 0 ) lb=c;else ub=c; 
  }
return (lb);  
}
int main(){
  while(1){    
    S.clear();    
    scanf("%d ",&n);
    if (!n) break;
    for(int i=0;i<M;i++) for(int j=0;j<M;j++) h[i][j]=0;
    for(int i=0;i<n;i++) {scanf("%s ",p);
      int k=strlen(p);          
      addedge(26*(p[0]-'a')+p[1]-'a', 26*(p[k-2]-'a')+p[k-1]-'a', k);      
    }
      double res=solve();
      if (res > ep-1.0) printf("No solution."); else printf("%.2lf\n",res);
      
  }
  return 0;
}
