#include <cstdio>
#include <algorithm>
#include <iterator>
#include <string>
#include <vector>
#include <map>
#include <numeric>

using namespace std;

typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;

#define MP make_pair
#define FOR(i,a,b) for(int i=a; i<=b; ++i)
#define FORD(i,a,b) for(int i=a; i>=b; --i)
#define REP(i,n) for(int i=0;i<n; ++i)
#define VAR(v,i) __typeof(i) v=(i)
#define FOREACH(i,c) for(VAR(i,(c).begin()); i!=(c).end(); ++i)
#define PB push_back
#define ST first
#define ND second
#define ALL(c) c.begin(),c.end()
#define SIZE(x) (int)x.size()

const int N=1010;
int n,m;
int kraw[N][N];
int moze[N],vis[N];
int l;
VI maly[N];
VI ktore;
int dodane[N],nowy_vis[N],low[N];
vector<PII> stos;


void dodaj(int a,int b){
  //printf("%d %d\n",a,b);
  if (!dodane[a]) dodane[a]=1,ktore.PB(a);
  if (!dodane[b]) dodane[b]=1,ktore.PB(b);
  maly[a].PB(b);
  maly[b].PB(a);
}

int nowydfs(int x,int kolor){
  nowy_vis[x]=kolor;
  FOREACH(it,maly[x]) 
    if (nowy_vis[*it]==-1){
      if (nowydfs(*it,1-kolor) == 0)
        return 0;      
    }
    else if (nowy_vis[*it]==kolor) return 0;
  return 1;
}

void kasuj(){
  FOREACH(it,ktore) nowy_vis[*it]=-1;
  bool zle=false;
  FOREACH(it,ktore) if (nowy_vis[*it]==-1){
    if (!nowydfs(*it,0)){
      zle=true; break;
    }
  }
  if (zle) FOREACH(it,ktore) moze[*it]=1;
  FOREACH(it,ktore){
    int x=*it;
    dodane[x]=0;
    maly[x].clear();
  }
  ktore.clear();
}

void dfs(int v,int u){
  vis[v]=low[v]=l++;
  PII p;
  REP(i,n) if (kraw[v][i]){
    int w=i;
    if (vis[w]==-1){
      stos.PB(MP(v,w));
      dfs(w,v);
      if (low[w]>vis[v]) stos.pop_back();
      else if (low[w]==vis[v]){
        //printf("FAZA\n");
        do{
           p=stos.back();
           stos.pop_back();
           dodaj(p.ST,p.ND);
        } while (p!=MP(v,w));
        kasuj();
      } else low[v]<?=low[w];
    } else if (vis[w]<vis[v] && w!=u) stos.PB(MP(v,w)),low[v]<?=vis[w];
  }
}

void doit(){
  l=0;
  stos.clear();
  REP(i,n) vis[i]=-1; //t
  REP(i,n) if (vis[i]==-1) dfs(i,-1);
}


int main(){  
  while (1){
    scanf("%d %d",&n,&m);
    if (n+m==0) break;
    REP(i,n) REP(j,n) kraw[i][j]=1;
    REP(i,n) kraw[i][i]=0;
    REP(i,m){
      int a,b;
      scanf("%d %d",&a,&b);
      a--; b--;
      kraw[a][b]=kraw[b][a]=0;
    }
    REP(i,n) moze[i]=0;
    doit();
    printf("%d\n",n-accumulate(moze,moze+n,0));
  }
  return 0;
}
