#include <cstdio>
#include <algorithm>
#include <iterator>
#include <string>
#include <vector>
#include <map>

using namespace std;

typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;

#define MP make_pair
#define FOR(i,a,b) for(int i=a; i<=b; ++i)
#define FORD(i,a,b) for(int i=a; i>=b; --i)
#define REP(i,n) for(int i=0;i<n; ++i)
#define VAR(v,i) __typeof(i) v=(i)
#define FOREACH(i,c) for(VAR(i,(c).begin()); i!=(c).end(); ++i)
#define PB push_back
#define ST frirst
#define ND second
#define ALL(c) c.begin(),c.end()
#define SIZE(x) (int)x.size()

const int L='z'-'a'+1;
const int K=L*L+1;
int waga[K][K];
int mem[K][K]; //(dlugosc, dokad)
int dist[K],nowy_dist[K];
char s[1000001];
const int INF=1000000;

int licz(char a, char b){
  return (int)(a-'a')*L+(int)(b-'a');
}

int jest[K];


int main(){  
  while (1){
    int n;
    scanf("%d",&n);
    if (n==0) break;
    REP(i,K) REP(j,K) waga[i][j]=-INF;
    double res=(double)INF;
    REP(i,K) jest[i]=0;
    jest[K-1]=1;
    REP(i,n){
      scanf("%s",s);
      int k=strlen(s);
      int a=licz(s[0],s[1]);
      int b=licz(s[k-2],s[k-1]);
//      if (a==b) res>?=(double)k;
      jest[a]=jest[b]=1;
      waga[a][b]>?=k;
    }
    REP(i,K-1) waga[K-1][i]=0;
    REP(i,K) if (jest[i]) REP(j,K) waga[i][j]=waga[i][j]==-INF?INF:1001-waga[i][j];
    REP(i,K) dist[i]=INF;
    dist[K-1]=0;
    REP(i,K){
    //  printf("%d\n",i);
      REP(j,K) mem[i][j]=dist[j],nowy_dist[j]=INF;
      REP(a,K) if (jest[a]) REP(b,K) nowy_dist[b]<?=waga[a][b]+dist[a];
      REP(j,K) dist[j]=nowy_dist[j];
    }
    REP(v,K){
      double best=-INF;
      bool change=0;
      REP(k,K) if (dist[v]!=INF && mem[k][v]!=INF){
        best>?=(double)(dist[v]-mem[k][v])/(double)(K-k);
        change=1;
//        if (dist[v]==mem[k][v]) printf("ERROR %d %d\n",v,k);
//      if (best/(n-k)<=t) ok=true;
      }
      if (change) res<?=(double)best;
    }
    res=-res+1001.0;
    if (res<-0.5) printf("No solution.\n");
    else printf("%.6lf\n",res);
  }
  return 0;
}
