#include<cstdio>
#include<cstdlib>
#include<cmath>
#include<cstring>
#include<string>
#include<complex>
#include<algorithm>
#include<set>
#include<map>
#include<vector>
#include<queue>

using namespace std;
#define REP(i,n) for(int i=0;i<(int)(n);i++)
#define FOR(i,a,b) for(int i=(int)(a);i<=(int)(b);i++)
#define FORE(i,c) for(__typeof(c.begin()) i=(c).begin();i!=(c).end();i++)

#define FORI(p,q) for(int i = p; i < q; ++i)
#define FORJ(p,q) for(int j = p; j < q; ++j)
#define FORK(p,q) for(int k = p; k < q; ++k)
#define FORL(p,q) for(int l = p; l < q; ++l)

#define PI pair<int,int>
#define X first
#define Y second
#define VI vector<int>

#define S size()
#define PB push_back

struct state{
  int k;
  unsigned long long tab[5];
  
  state(){}
  state(const state & st){
    k = st.k;
    memcpy(tab, st.tab, sizeof(tab));
  }
  
  void read(){
    scanf("%d", &k);
    tab[0] = tab[1] = tab[2] = tab[3] = tab[4] = 0;

    FORI(0, k){
      int x;
      scanf("%d", &x);
      tab[x / 64] |= (1ULL << (x % 64));
    }
  }

  bool is_subset(const state & st)const{
    if(k > st.k)return false;
    if((tab[0] & (~st.tab[0])) != 0)return false;
    if((tab[1] & (~st.tab[1])) != 0)return false;
    if((tab[2] & (~st.tab[2])) != 0)return false;
    if((tab[3] & (~st.tab[3])) != 0)return false;
    if((tab[4] & (~st.tab[4])) != 0)return false;
    return true;
  }

  bool operator<(const state & st)const{
    return (k < st.k);
  }

  void clear(const state & st){
    tab[0] &= ~st.tab[0];
    tab[1] &= ~st.tab[1];
    tab[2] &= ~st.tab[2];
    tab[3] &= ~st.tab[3];
    tab[4] &= ~st.tab[4];
  }

  bool null(){
    return (tab[0] == 0 && tab[1] == 0 && tab[2] == 0 && tab[3] == 0 && tab[4] == 0);
  }
};

int main()
{
  while(1){
    int n, m;
    scanf("%d %d", &n, &m);
    if(n == 0 && m == 0)break;

    state st[201];
    
    FORI(0, m){
      st[i].read();
    }

    sort(st, st + m);
    reverse(st,st+m);

    int res = 0;
    FORI(0, m){
      state nst = st[i];
      if(nst.null()){
	++res;
	continue;
      }
      FORJ(i+1,m){
        if(! st[j].is_subset(st[i]))continue;
	nst.clear(st[j]);
	if(nst.null()){
	  ++res;
	  break;
	}
      }
    }
    printf("%d\n",res);
  }
}
