#include<cstdio>
#include<cstdlib>
#include<cmath>
#include<cstring>
#include<string>
#include<complex>
#include<algorithm>
#include<set>
#include<map>
#include<vector>
#include<queue>

using namespace std;
#define REP(i,n) for(int i=0;i<(int)(n);i++)
#define FOR(i,a,b) for(int i=(int)(a);i<=(int)(b);i++)
#define FORE(i,c) for(__typeof(c.begin()) i=(c).begin();i!=(c).end();i++)

#define FORI(p,q) for(int i = p; i < q; ++i)
#define FORJ(p,q) for(int j = p; j < q; ++j)
#define FORK(p,q) for(int k = p; k < q; ++k)
#define FORL(p,q) for(int l = p; l < q; ++l)

#define PI pair<long long,long long>
#define PPI pair<PI,int>
#define X first
#define Y second
#define VI vector<int>

#define S size()
#define PB push_back

int tab[700][700];

struct cmp{
    bool operator()(const PPI & ppi1, const PPI & ppi2)const{
	return (ppi1.X.X * ppi2.X.Y > ppi1.X.Y * ppi2.X.X);
    }
};

int main(){
	while(1){
		memset(tab, 0, sizeof(tab));
		
		int n;
		scanf("%d", &n);
		if(n == 0)break;

		FORI(0, n){
			char str[1024];
			scanf("%s", str);
			int len = strlen(str);
			tab[(str[0]-'a')*26+(str[1]-'a')][(str[len-2]-'a')*26+(str[len-1]-'a')] >?= len;
		}

		PI res(0, 1);
		PI best[700];
		FORI(0, 700)best[i] = PI(0, 1);

		int color[700];
		memset(color, 0, sizeof(color));

		FORI(0, 700){
			if(color[i])continue;
			priority_queue<PPI, vector<PPI>, cmp > q;
			q.push(PPI(PI(0,0),i));
			color[i]=1;

			while(! q.empty()){
				PPI ppi = q.top();
//				printf("wyjalem %lld %lld %d\n",ppi.X.X,ppi.X.Y,ppi.Y);
				q.pop();
				color[ppi.Y]=2;
				FORI(0, 700){
					if(tab[ppi.Y][i] == 0)continue;
					if(color[i] > 1)continue;
//					printf("mam droge do %d z %d\n",i,ppi.Y);
					PPI nppi(PI(ppi.X.X + tab[ppi.Y][i], ppi.X.Y + 1), i);
					if(best[i].X == 0){
						q.push(nppi);
						best[i] = nppi.X;
						color[i]=1;
						continue;
					}
					//PI diff(best[i].X * nppi.X.Y - best[i].Y * nppi.X.X, best[i].Y * nppi.X.Y);
					PI diff(-best[i].X + nppi.X.X, nppi.X.Y - best[i].Y);
					if(diff.X >= 0){
//						printf("ale nie wkladam\n");
						//diff.X *= -1;
						if(diff.X * res.Y > res.X * diff.Y)res = diff;
					}else{
						diff.X *= -1;
						best[i] = nppi.X;
						if(diff.X * res.Y > res.X * diff.Y)res = diff;
						q.push(nppi);
//						printf("%d %lld/%lld\n",nppi.Y,nppi.X.X,nppi.X.Y);
					}
					color[i]=1;
				}
			}
		}

		if(res.X>0)printf("%.2Lf\n",((long double)(res.X)) / res.Y);
		else printf("No solution.\n");
	}
}
