{$apptype console}

// (C) Timofey S. Chistyakov 2005

uses
  SysUtils, StrUtils;
  
const
  TR: array [0..8, 1..9] of integer = (
    (1, 0, 0, 0, 0, 0, 0, 0, 0),
    (1, 1, 0, 0, 0, 0, 0, 0, 0),
    (1, 2, 1, 0, 0, 0, 0, 0, 0),
    (1, 3, 3, 1, 0, 0, 0, 0, 0),
    (1, 4, 6, 4, 1, 0, 0, 0, 0),
    (1, 5, 10, 10, 5, 1, 0, 0, 0),
    (1, 6, 15, 20, 15, 6, 1, 0, 0),
    (1, 7, 21, 35, 35, 21, 7, 1, 0),
    (1, 8, 28, 56, 70, 56, 28, 8, 1)
  );

var
  n, k: integer;
  fi, fo: textfile;
  i, p, ps: integer;
  s, c: string;
begin
  assignfile(fi, 'input.txt');
  reset(fi);
  assignfile(fo, 'output.txt');
  rewrite(fo);

  read(fi, n, k);
  if n = 0 then begin
    p := 1;
    for i := 1 to k do
      p := p * 11;
    write(fo, p);
  end
  else begin
    // 1030301
    // 1004006004001
    // 1008028056070056028008001
    // 1..1..1..1..1..1..1..1..1
    s := '1' + DupeString(StringOfChar('0', n) + '1', k);
    // 1, (n + 1), (n + 1), ...
    for i := 2 to k do begin
      c := IntToStr(TR[k, i]);
      ps := (i - 2) * (n + 1) + 2; 
      Move(c[1], s[ps + (n + 1) - Length(c)], Length(c)); 
    end;
    write(fo, s);
  end;

  closefile(fo);
  closefile(fi);
end.
