{---------------------------------------------------------------}
{ ACM ICPC 2005-2006, NEERC                                     }
{ Northern Subregional Contest                                  }
{ St Petersburg, October 29, 2005                               }
{---------------------------------------------------------------}
{ Problem C. Cutting a Block                                    }
{                                                               }
{ Original idea         Georgiy Korneev                         }
{ Problem statement     Georgiy Korneev                         }
{ Testset               Georgiy Korneev                         }
{---------------------------------------------------------------}
{ Solution with test checker                                    }
{                                                               }
{ Author:               Georgiy Korneev                         }
{---------------------------------------------------------------}

{$q+,r+,o-}

const
    max_c = 1000;
    max_n = 1000;

var
    x, y, z, n, i: longint;
begin
    assign(input, 'cutting.in'); reset(input);
    assign(output, 'cutting.out'); rewrite(output);

    read(x, y, z, n);

    assert((1 <= x) and (x <= max_c));
    assert((1 <= y) and (y <= max_c));
    assert((1 <= z) and (z <= max_c));
    assert((1 <= n) and (n <= max_n));

    for i := 1 to n do begin
        writeln(0, ' ', 0, ' ', z / n * (i - 1):0:8, ' ', x, ' ', y, ' ', z / n * i:0:8);
    end;

    close(input);
    close(output);
end.