/*---------------------------------------------------------------*/
/* ACM ICPC 2005-2006, NEERC                                     */
/* Northern Subregional Contest                                  */
/* St Petersburg, October 29, 2005                               */
/*---------------------------------------------------------------*/
/* Problem C. Cutting a Block                                    */
/*                                                               */
/* Original idea         Georgiy Korneev                         */
/* Problem statement     Georgiy Korneev                         */
/* Testset               Georgiy Korneev                         */
/*---------------------------------------------------------------*/
/* Solution                                                      */
/*                                                               */
/* Author:               Pavel Mavrin                            */
/*---------------------------------------------------------------*/

import java.util.Scanner;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.FileOutputStream;

public class cutting_pm {

    static PrintWriter writer;
    static Scanner scanner;


    public static void main(String[] args) throws FileNotFoundException {
        scanner = new Scanner(new File("cutting.in"));
        writer = new PrintWriter(new FileOutputStream("cutting.out"));

        double x = scanner.nextInt();
        double y = scanner.nextInt();
        double z = scanner.nextInt();
        int n = scanner.nextInt();

        for (int i = 0; i < n; i++) {
            writer.println("" + x * i / n + ' ' + 0 + ' ' + 0 + ' ' + x * (i + 1) / n + ' ' + y + ' ' + z);
        }

        writer.close();
    }
}
