#include <stdio.h>
#include <string.h>

#define maxc 10
#define baza 100000000
#define format "%08d"
#define fwd 2

typedef int BigNum[maxc];

#define LMAX 128

void add(BigNum, BigNum, BigNum);
void dec(BigNum, BigNum);
void mult(int, BigNum, BigNum);

char s[LMAX], l[256];
int flit[LMAX], bb[LMAX];
BigNum nm[2][LMAX], naux1, naux2, t;
int i, j, k, N, min, max, cur, ant, firstlet;

int main()
{
	freopen("i.in", "r", stdin);
	//freopen("i.out", "w", stdout);

	scanf("%d %d", &min, &max);
	gets(s + 1);
	gets(s + 1);

	memset(l, 0, sizeof(l));
	l['A'] = 1, l['B'] = 1, l['C'] = 1,
	l['E'] = 1, l['H'] = 1, l['K'] = 1,
	l['M'] = 1, l['O'] = 1, l['P'] = 1,
	l['T'] = 1, l['X'] = 1, l['a'] = 1,
	l['c'] = 1, l['e'] = 1, l['o'] = 1,
	l['p'] = 1, l['x'] = 1, l['y'] = 1;

	N = strlen(s + 1);
	if (s[N] == '\n')
		N--;

	if (N >= LMAX)
	{
		while (1)
			i = j;
	}

	memset(flit, 0, sizeof(flit));
	memset(bb, 0, sizeof(bb));

	if (s[1] != ' ')
		flit[1] = 1, firstlet = 0;
	else
		firstlet = 1;

	bb[1] = 0;

	for (i = 2; i <= N; i++)
	{
		if (s[i] != ' ' && s[i - 1] == ' ')
		{
			flit[i] = 1, bb[i] = bb[i - 1] + 1;
			
			if (firstlet)
				bb[i]++;

			firstlet = 0;
		}
		else
		if (s[i - 1] == ' ')
			bb[i] = bb[i - 1] + 1;
		else
			bb[i] = 0;
	}

	memset(nm, 0, sizeof(nm));

	cur = 0;
	nm[cur][0][0] = nm[cur][0][1] = 1;

	for (i = 1; i <= N + 1; i++)
	{
		ant = cur;
		cur =  1 - cur;

		memset(nm[cur][0], 0, sizeof(BigNum));

		if (i == N + 1)
		{
			for (j = 1; j < LMAX; j++)
				memmove(nm[cur][j], nm[ant][j], sizeof(BigNum));

			if (s[N] == ' ')
				break;

			// add trailing blanks
			for (j = 1; j < LMAX; j++)
				for (k = 0; k < j; k++)
				{
					add(nm[cur][j], nm[ant][k], naux1); 
					memmove(nm[cur][j], naux1, sizeof(BigNum));
				}

			break;
		}
		else
			for (j = 1; j < LMAX; j++)
				memmove(nm[cur][j], nm[ant][j - 1], sizeof(BigNum));


		if (flit[i]) // add spaces before word
			for (j = 1; j < LMAX; j++)
				for (k = 0; k < j - 1; k++)
				{
					add(nm[cur][j], nm[ant][k], naux1); 
					memmove(nm[cur][j], naux1, sizeof(BigNum));
				}

		if (flit[i] && bb[i] > 1) // delete spaces before word
			for (j = 1; j < LMAX; j++)
				for (k = j; k < LMAX && k + 1 - j <= bb[i] - 1; k++)
				{
					add(nm[cur][j], nm[ant][k], naux1); 
					memmove(nm[cur][j], naux1, sizeof(BigNum));
				}

		if (i == N && s[i] == ' ')
		{
			// add trailing blanks
			for (j = 1; j < LMAX; j++)
				for (k = 0; k < j - 1; k++)
				{
					add(nm[cur][j], nm[ant][k], naux1); 
					memmove(nm[cur][j], naux1, sizeof(BigNum));
				}

			// delete trailing blanks
			for (j = 1; j < LMAX; j++)
				for (k = j; k < LMAX && k + 1 - j <= bb[i] + 1; k++)
				{
					add(nm[cur][j], nm[ant][k], naux1); 
					memmove(nm[cur][j], naux1, sizeof(BigNum));
				}

			break;
		}
		/*
		else
		if (l[s[i]])
			for (j = 0; j < LMAX; j++)
			{
				mult(2, nm[cur][j], naux1);
				memmove(nm[cur][j], naux1, sizeof(BigNum));
			}
		*/
	}

	// compute result

	memset(t, 0, sizeof(BigNum));
	t[0] = 1;

	for (i = min; i <= max; i++)
	{
		add(t, nm[cur][i], naux1);
		memmove(t, naux1, sizeof(BigNum));
	}

	for (i = 1; i <= N; i++)
		if (l[s[i]])
		{
			mult(2, t, naux1);
			memmove(t, naux1, sizeof(BigNum));
		}

	if (min <= N && N <= max)
	{
		dec(t, naux1);
		memmove(t, naux1, sizeof(BigNum));
	}

	printf("%d", t[t[0]]);
	for (i = t[0] - 1; i >= 1; i--)
		printf(format, t[i]);

	printf("\n");

	return 0;
}

void add(BigNum n1, BigNum n2, BigNum rez)
{
int i, ndigits = n1[0];

if (n2[0] > ndigits)
  ndigits = n2[0];

memset(rez, 0, sizeof(BigNum));
for (i = 1; i <= ndigits; i++)
  rez[i] = n1[i]+n2[i];

for (i = 1 ;i <= (ndigits+fwd); i++)
  if (rez[i] >= baza)
    {
      rez[i+1] += (rez[i]/baza);
      rez[i] %= baza;
    }

for (i = (ndigits+fwd); i >= 1; i--)
  if (rez[i] > 0)
    {
      rez[0] = i;
      break;
    }
}

void dec(BigNum n, BigNum res)
{
int i, ndigits = n[0];

memset(res, 0, sizeof(BigNum));
for (i = 1; i <= ndigits; i++)
  res[i] = n[i];

for (res[1]--, i = 1; i <= ndigits; i++)
  if (res[i] < 0)
    {
      res[i] += baza;
      res[i+1]--;
    }

for (res[0] = 1, i = ndigits; i >= 1; i--)
  if (res[i])
    {
      res[0] = i;
      break;
    }
}

void mult(int x, BigNum num, BigNum rez)
{
int i, ndigits = num[0];

memset(rez, 0, sizeof(BigNum));
for (i = 1; i <= ndigits; i++)
  rez[i] = num[i]*x;

for (i = 1; i <= (ndigits+fwd); i++)
  if (rez[i] >= baza)
    {
    rez[i+1] += (rez[i]/baza);
    rez[i] %= baza;
    }

for (i = (ndigits+fwd); i >= 1; i--)
  if (rez[i] > 0)
    {
    rez[0] = i;
    break;
    }
}
