#include <stdio.h>
#include <string.h>

#define NMAX 1066

int a[NMAX], bip[2 * NMAX];
int avail[NMAX], availprim[NMAX], nzeroleft[NMAX], nzeroright[NMAX];
int i, j, k, N, li, ls;

void compute_nzeros(void)
{
	nzeroleft[0] = 0;
	for (i = 1; i <= N; i++)
	{
		nzeroleft[i] = nzeroleft[i - 1];

		if (a[i] == 0 && avail[i])
			nzeroleft[i]++;
	}

	nzeroright[N + 1] = 0;
	for (i = N; i >= 1; i--)
	{
		nzeroright[i] = nzeroright[i + 1];

		if (a[i] == 0 && avail[i])
			nzeroright[i]++;
	}
}

int main()
{
	scanf("%d", &N);

	for (i = 1; i <= N; i++)
	{
		scanf("%d", &a[i]);
		avail[i] = 1;
	}

	memset(availprim, 0, sizeof(availprim));

	compute_nzeros();

	li = ls = 0;
	for (k = 0; k < 2 * N; k++)
	{
		/* incearca sa puna un element din {1,..,N} */

		//for (i = N; i >= 1; i--)
		for (i = 1; i <= N; i++)
			if (avail[i] && a[i] == 0 && nzeroleft[i - 1] == 0)
				break;

		if (/* i > 0 */ i <= N)
		{
			avail[i] = 0;

			for (j = 1; j < i; j++)
				a[j]--;

			availprim[ls++] = i;
			bip[k] = i;

			compute_nzeros();
			
			continue;
		}

		/* incearca sa puna un element din multimea {1', .., N'} */

		if (li == ls)
			break;

		i = availprim[li++];

		if (nzeroright[i + 1] == 0)
		{
			for (j = i + 1; j <= N; j++)
				a[j]--;

			bip[k] = -i;

			compute_nzeros();

			continue;
		}

		break;
	}

	if (k < 2 * N)
		printf("NO\n");
	else
	{
		printf("YES\n");
		for (i = 2 * N - 1; i >= 1; i--)
			printf("%d ", bip[i]);
		printf("%d\n", bip[0]);
	}

	return 0;
}