{ XV ᨩ᪠  誮쭨  ଠ⨪       }
{  ""                                            }
{ : .. 娭, .. ९                        }
{ 襭:  祢                                     }

Program MegaTrain;
Const
  TaskID='russia';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
Type
  Integer=LongInt;
Const
  MaxM=1002;
  MaxV=2*MaxM;
Var
  N,M:Integer;
  A,B,Len:Array[1..MaxM]Of System.Integer;
  SameTo:Array[1..MaxM]Of System.Integer;
  VS,VE:Array[1..MaxM]Of System.Integer;
  Who:Array[1..MaxV]Of System.Integer;
  IsA:Array[1..MaxV]Of Boolean;
  NV:Integer;
  Big:Integer;
  MaxPart:Integer;
  Part:Array[1..MaxV]Of System.Integer;
  Color:Array[1..MaxV]Of Byte;
  NoSol:Boolean;
  Perm:Array[1..MaxM]Of System.Integer;
  Perm2:Array[1..MaxV]Of System.Integer;
  At:Array[1..MaxV]Of Integer;
Procedure Load;
Var
  I:Integer;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N,M);
  For I:=1 To M Do
    Read(A[I],B[I]);
  Close(Input);
End;
Procedure DFS(Start,Col:Integer);
Var
  I:Integer;
  Cur:Integer;
Begin
  If Color[Start]=3-Col Then Begin
    NoSol:=True;
    Exit;
  End;
  If Color[Start]=Col Then Exit;
  Part[Start]:=MaxPart;
  Color[Start]:=Col;
  Cur:=Who[Start];
  If IsA[Start] Then Begin
    For I:=1 To M Do If SameTo[I]=0 Then
      If (A[I]<A[Cur]) And (B[I]>A[Cur]) Then Begin
        If B[I]>B[Cur] Then
          DFS(VE[Cur],Col)
        Else If B[I]<B[Cur] Then
          DFS(VE[I],3-Col);
        If NoSol Then Exit;
      End;
  End Else Begin
    For I:=1 To M Do If SameTo[I]=0 Then
      If (A[I]<B[Cur]) And (B[I]>B[Cur]) Then Begin
        If A[I]>A[Cur] Then
          DFS(VS[I],3-Col)
        Else If A[I]<A[Cur] Then
          DFS(VS[Cur],Col);
        If NoSol Then Exit;
      End;
  End;
End;
Procedure InitializeGraph;
Var
  I:Integer;
Begin
  MaxPart:=0;
  FillChar(Part,SizeOf(Part),0);
  FillChar(Color,SizeOf(Color),0);
  For I:=1 To NV Do
    If Part[I]=0 Then Begin
      Inc(MaxPart);
      DFS(I,1);
      If NoSol Then Exit;
    End;
End;
procedure QSort(l,r: integer);
var
  i,j,x,y: integer;
begin
  i:=l; j:=r; x:=Perm[(l+r) DIV 2];
  repeat
    while Len[Perm[i]]<Len[x] do Inc(I);
    while Len[x]<Len[Perm[j]] do Dec(J);
    if i<=j then
    begin
      y:=Perm[i]; Perm[i]:=Perm[j]; Perm[j]:=y;
      Inc(I); Dec(J);
    end;
  until i>j;
  if l<j then QSort(l,j);
  if i<r then QSort(i,r);
end;
procedure QSort2(l,r: integer);
var
  i,j,x,y: integer;
begin
  i:=l; j:=r; x:=Perm2[(l+r) DIV 2];
  repeat
    while At[Perm2[i]]<At[x] do Inc(I);
    while At[x]<At[Perm2[j]] do Dec(J);
    if i<=j then
    begin
      y:=Perm2[i]; Perm2[i]:=Perm2[j]; Perm2[j]:=y;
      Inc(I); Dec(J);
    end;
  until i>j;
  if l<j then QSort2(l,j);
  if i<r then QSort2(i,r);
end;
Procedure WorkOutCollisions;
Var
  Prt,CPrt,I,J,Cur,CShift:Integer;
Begin
  For I:=1 To M Do
    Perm[I]:=I;
  QSort(1,M);
  CShift:=M;
  For I:=1 To M Do If SameTo[Perm[I]]=0 Then Begin
    Cur:=Perm[I];
    If (Part[VS[Cur]]<>Part[VE[Cur]]) Then Begin
      Prt:=Part[VE[Cur]];
      CPrt:=Part[VS[Cur]];
      If Color[VS[Cur]]<>Color[VE[Cur]] Then Begin
        For J:=1 To NV Do
          If Part[J]=Prt Then
            Color[J]:=3-Color[J];
      End;
      For J:=1 To NV Do
        If Part[J]=Prt Then
          Part[J]:=CPrt;
      Inc(At[VS[Cur]],CShift);
      Dec(At[VE[Cur]],CShift);
    End Else If Color[VS[Cur]]=Color[VE[Cur]] Then Begin
      Inc(At[VS[Cur]],CShift);
      Dec(At[VE[Cur]],CShift);
    End Else Begin
      Dec(At[VS[Cur]],CShift);
      Inc(At[VE[Cur]],CShift);
    End;
    Dec(CShift);
  End;
End;
Procedure CutTheSame;
Var
  I,J:Integer;
Begin
  FillChar(SameTo,SizeOf(SameTo),0);
  For I:=1 To M Do
    For J:=1 To I-1 Do
      If (A[J]=A[I]) And (B[J]=B[I]) Then Begin
        SameTo[I]:=J;
        Break;
      End;
End;
Procedure Solve;
Var
  I:Integer;
Begin
  CutTheSame;
  NoSol:=False;
  Big:=3*(M+10);
  NV:=0;
  For I:=1 To M Do If SameTo[I]=0 Then Begin
    Inc(NV,2);
    At[NV-1]:=A[I]*Big;
    At[NV]:=B[I]*Big;
    Len[I]:=B[I]-A[I];
    VS[I]:=NV-1;
    VE[I]:=NV;
    Who[NV-1]:=I;
    Who[NV]:=I;
    IsA[NV-1]:=True;
    IsA[NV]:=False;
  End;
  InitializeGraph;
  If NoSol Then Exit;
  WorkOutCollisions;
  For I:=1 To NV Do
    Perm2[I]:=I;
  QSort2(1,NV);
End;
Procedure Save;
Var
  I,J,K,Cur,CSeg:Integer;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  If NoSol Then
    WriteLn(0)
  Else For I:=1 To N Do Begin
    For J:=1 To NV Do Begin
      Cur:=Perm2[J];
      If Not IsA[Cur] And (B[Who[Cur]]=I) Then Begin
        CSeg:=Who[Cur];
        If Color[VS[CSeg]]=Color[VE[CSeg]] Then Begin
          For K:=M DownTo 1 Do
            If SameTo[K]=CSeg Then
              WriteLn(3,' ',K);
          WriteLn(3,' ',CSeg);
        End Else Begin
          WriteLn(3,' ',CSeg);
          For K:=1 To M Do
            If SameTo[K]=CSeg Then
              WriteLn(3,' ',K);
        End;
      End;
    End;
    For J:=1 To NV Do Begin
      Cur:=Perm2[J];
      If IsA[Cur] And (A[Who[Cur]]=I) Then Begin
        WriteLn(Color[Cur],' ',Who[Cur]);
        For K:=1 To M Do
          If SameTo[K]=Who[Cur] Then
            WriteLn(Color[Cur],' ',K);
      End;
    End;
  End;
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.
