const
 Base = 100000;
 BaseL = 5;

type
 TLongNum = record
  P: Boolean;
  A: array [0..3] of LongInt;
 end;

procedure Add(var A, B, C: TLongNum);
var
 i, p: LongInt;
begin
 i:=0;
 p:=0;
 While (i < A.A[0]) and (i < B.A[0]) do
  begin
   inc(i);
   p:=A.A[i]+B.A[i]+p;
   C.A[i]:=p mod Base;
   p:=p div Base;
  end;
 If A.A[0] > B.A[0]
  then C.A[0]:=A.A[0]
  else C.A[0]:=A.A[0];
 If p <> 0 then
  begin
   inc(C.A[C.A[0]]);
   C.A[C.A[0]]:=p;
  end;
end;

procedure Sub(var A, B, C: TLongNum);
var
 p, i: LongInt;
begin
 i:=0;
 p:=0;
 While (i < A.A[0]) and (i < B.A[0]) do
  begin
   inc(i);
   dec(A.A[i], p);
   p:=0;
   C.A[i]:=A.A[i]-B.A[i];
   If C.A[i] < 0 then
    begin
     inc(C.A[i], Base);
     p:=1;
    end;
  end;
 C.A[0]:=i;
 While (C.A[C.A[0]] = 0) and (C.A[0] > 1) do
  dec(C.A[0]);
end;

function Greater(A, B: TLongNum): Boolean;
var
 i: Byte;
begin
 If A.P and not B.P then
  begin
   Greater:=True;
   Exit;
  end;
 If not A.P and B.P then
  begin
   Greater:=False;
   Exit;
  end;
 If A.A[0] > B.A[0]
  then i:=A.A[0]
  else i:=B.A[0];
 If A.A[0] = B.A[0]
  then
   begin
    While A.A[i] = B.A[i] do
     inc(i);
    Greater:=A.A[i] > B.A[i];
   end
  else Greater:=A.A[0] > B.A[0];
end;

var
 S: String;
 N, i: LongInt;
 A, B: TLongNum;

begin
 Assign(Input, 'Sum.in');
 Reset(Input);
 Assign(Output, 'Sum.out');
 ReWrite(Output);
 Read(N);
 A.P:=N >= 0;
 N:=Abs(N);
 i:=0;
 Repeat
  inc(i);
  A.A[i]:=N mod Base;
  N:=N div Base;
 until N <= 0;
 A.A[0]:=i;
 Read(N);
 B.P:=N >= 0;
 N:=Abs(N);
 i:=0;
 Repeat
  inc(i);
  B.A[i]:=N mod Base;
  N:=N div Base;
 until N <= 0;
 B.A[0]:=i;
 If A.P and B.P or not A.P and not B.P
  then Add(A, B, A)
  else
   If Greater(A, B)
    then Sub(A, B, A)
    else
     begin
      Sub(B, A, B);
      A:=B;
     end;
 If not A.P then Write('-');
 For i:=A.A[0] downto 1 do
  begin
   Str(A.A[i], S);
   While (Length(S) < BaseL) and (i <> 1) do
    S:='0'+S;
   Write(S);
  end;
 Close(Input);
 Close(Output);
end.