const max_value = 1000000000;

procedure Operate1 (a,b :longint; var C,d :longint);
begin
  d := a mod max_value + b mod max_value;
  c := a div max_value + b div max_value;
  while d>max_value do begin d := d-max_value; c := c+1; end;
end;

procedure Operate2 (a,b :longint; var C,d :longint);
begin
  d := a mod max_value - b mod max_value;
  c := a div max_value - b div max_value;
  while d>max_value do begin d := d-max_value; c := c+1; end;
  while d<0         do begin d := d+max_value; c := c-1; end;
end;

procedure Operate (a,b :longint; var c,d :longint; var is_otr :boolean);
begin
  if (a>0) and (b>0) then Operate1 (a,b,c,d);
  if (a<0) and (b<0) then Operate1 (-a,-b,c,d);
  if (a<0) and (b>0) then if abs(a) > abs(b) then Operate2 (-a,b,c,d)
                                             else Operate2 (b,-a,c,d);
  if (a>0) and (b<0) then if abs(a) > abs(b) then Operate2 (a,-b,c,d)
                                             else Operate2 (-b,a,c,d);
  is_otr := ((a<0) and (b<0)) or
            ((a<0) and (b>0) and (abs(a)>abs(b))) or
            ((a>0) and (b<0) and (abs(a)<abs(b)));
end;

function to_char (a :byte) :char;
begin
  if a = 0 then to_char := '0';
  if a = 1 then to_char := '1';
  if a = 2 then to_char := '2';
  if a = 3 then to_char := '3';
  if a = 4 then to_char := '4';
  if a = 5 then to_char := '5';
  if a = 6 then to_char := '6';
  if a = 7 then to_char := '7';
  if a = 8 then to_char := '8';
  if a = 9 then to_char := '9';
end;

procedure to_str (a,b :longint; var s :string);
begin
  s := '';
  while not (a=0) do begin
    s := s+to_char(a mod 10);
    a := a div 10; end;
  while not (b=0) do begin
    s := s+to_char(b mod 10);
    b := b div 10; end;
end;

procedure Slogit (a,b :longint; var s :string);
var c,d :longint; f :boolean;
begin Operate (a,b,c,d,f);
      to_str (c,d,s);
      if f then s := '-' + s;
end;

procedure ReadOfFile (var a,b :longint);
var F:text;
begin assign (F, 'sum.in'); reset (F);
      read (F, a); read (F,b); close (F);
end;

procedure WriteInFile (s :string);
var F:text;
begin assign (F, 'sum.out'); rewrite (F);
      write (F, s); close (F);
end;

var a,b :longint; s :string;
begin ReadOfFile (a,b);
      Slogit (a,b,s);
      if s = '' then s := '0';
      WriteInFile (s);
end.
