{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 63840,0,655360}
program p060305;
const
  max = 2000;
  infile = 'glass.in'; outfile = 'glass.out';
type
  point = record
    x, y: integer;
  end;
  tr = record
    a: array[1..3] of point;
    w: longint;
  end;
  list = array[0..max, 1..2] of integer;
var
  trs: array[1..max] of tr;
  t: point;
  n, d, h, u, nl, nr, nu, nd: longint;
  may: boolean;
  cl, cr, cu, cd: list;
  un: array[1..8] of record
    num, flag: longint;
  end;


 function min(a, b: longint): longint;
  begin
    if a < b then min := a else min := b;
  end;

procedure quicksort(var a: list; Lo,Hi: integer);
var
  i: integer;

procedure sort(l,r: integer);
var
  i,j,x: integer;
begin
  i:=l; j:=r; x:=a[(l+r) DIV 2, 1];
  repeat
    while a[i, 1]<x do i:=i+1;
    while x<a[j, 1] do j:=j-1;
    if i<=j then
    begin
      a[0]:=a[i]; a[i]:=a[j]; a[j]:=a[0];
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;

begin {quicksort};
  sort(Lo,Hi);
end;
 procedure indata;
  var
    i, j: longint;
  begin
    assign(input, infile); reset(input);
    readln(n);
    for i := 1 to n do begin
      with trs[i] do
        for j := 1 to 3 do
          read(a[j].x, a[j].y);
        readln;
    end;
    close(input);
  end;


 procedure solve;
  var
    i: longint;
   procedure try;
    var
      i, j, tx, ty: longint;
    begin
      nl := 0; nr := 0; nu := 0; nd := 0;
      may := true;
      for i := 1 to n do begin
        with trs[i] do begin
          tx := a[w].x; ty := a[w].y;
          for j := 1 to 3 do begin
            a[j].x := a[j].x + t.x  - tx;
            a[j].y := a[j].y + t.y  - ty;
          end;
          if (a[w mod 3 + 1].y = a[(w mod 3 + 1) mod 3 + 1].y) then begin
             if a[w].y > a[w mod 3 + 1].y then begin
               inc(nu);
               cu[nu, 1] := min(a[w mod 3 + 1].x, a[(w mod 3 + 1) mod 3 + 1].x);
               cu[nu, 2] := a[w mod 3 + 1].x + a[(w mod 3 + 1) mod 3 + 1].x
                 - min(a[w mod 3 + 1].x, a[(w mod 3 + 1) mod 3 + 1].x);
             end else begin
               inc(nd);
               cd[nd, 1] := min(a[w mod 3 + 1].x, a[(w mod 3 + 1) mod 3 + 1].x);
               cd[nd, 2] := a[w mod 3 + 1].x + a[(w mod 3 + 1) mod 3 + 1].x
                 - min(a[w mod 3 + 1].x, a[(w mod 3 + 1) mod 3 + 1].x);
             end;
          end else begin
             if a[w].x > a[w mod 3 + 1].x then begin
               inc(nr);
               cr[nr, 1] := min(a[w mod 3 + 1].y, a[(w mod 3 + 1) mod 3 + 1].y);
               cr[nr, 2] := a[w mod 3 + 1].y + a[(w mod 3 + 1) mod 3 + 1].y
                 - min(a[w mod 3 + 1].y, a[(w mod 3 + 1) mod 3 + 1].y);
             end else begin
               inc(nl);
               cl[nl, 1] := min(a[w mod 3 + 1].y, a[(w mod 3 + 1) mod 3 + 1].y);
               cl[nl, 2] := a[w mod 3 + 1].y + a[(w mod 3 + 1) mod 3 + 1].y
                 - min(a[w mod 3 + 1].y, a[(w mod 3 + 1) mod 3 + 1].y);
             end;
          end;
        end;
      end;
      quicksort(cl, 1, nl);
      for i := 2 to nl do begin
        may := may and (cl[i, 1] = cl[i - 1, 2]);
        if not may then exit;
      end;
      may := may and (cl[1, 1] = 0) and (cl[nl, 2] = t.y + h);
      for i := 2 to nr do begin
        may := may and (cr[i, 1] = cl[i - 1, 2]);
        if not may then exit;
      end;
      may := may and (cr[1, 1] = 0) and (cr[nr, 2] = t.y + h);
      for i := 2 to nu do begin
        may := may and (cu[i, 1] = cu[i - 1, 2]);
        if not may then exit;
      end;
      may := may and (cu[1, 1] = 0) and (cu[nu, 2] = t.x + d);
      for i := 2 to nd do begin
        may := may and (cd[i, 1] = cd[i - 1, 2]);
        if not may then exit;
      end;
      may := may and (cd[1, 1] = 0) and (cd[nd, 2] = t.x + d);
    end;


  begin
    may := true;
    t.x := 0; t.y := 0; h := 0; d := 0;
    u := 0;
    fillchar(cl, sizeof(cl), 0);
    fillchar(cr, sizeof(cr), 0);
    fillchar(cu, sizeof(cu), 0);
    fillchar(cd, sizeof(cd), 0);
    for i := 1 to n do begin
      with trs[i] do begin
        if ((a[1].x - a[2].x) * (a[1].x - a[3].x) * (a[2].x - a[3].x) = 0) and
           ((a[1].y - a[2].y) * (a[1].y - a[3].y) * (a[2].y - a[3].y) <> 0) then begin
          if a[1].x = a[2].x then w := 3 else
           if a[1].x = a[3].x then w := 2 else w := 1;
          if a[w].x > a[w mod 3 + 1].x then begin
            if t.x * (t.x - a[w].x + a[w mod 3 + 1].x) = 0 then begin
              t.x := a[w].x - a[w mod 3 + 1].x;
            end else begin
              may := false;
              exit;
            end;
          end else begin
            if d * (d + a[w].x - a[w mod 3 + 1].x) = 0 then begin
              d := - a[w].x + a[w mod 3 + 1].x;
            end else begin
              may := false;
              exit;
            end;
          end;
        end else if ((a[1].x - a[2].x) * (a[1].x - a[3].x) * (a[2].x - a[3].x) <> 0) and
           ((a[1].y - a[2].y) * (a[1].y - a[3].y) * (a[2].y - a[3].y) = 0) then begin
          if a[1].y = a[2].y then w := 3 else
           if a[1].y = a[3].y then w := 2 else w := 1;
          if a[w].y > a[w mod 3 + 1].y then begin
            if t.y * (t.y - a[w].y + a[w mod 3 + 1].y) = 0 then begin
              t.y := a[w].y - a[w mod 3 + 1].y;
            end else begin
              may := false;
              exit;
            end;
          end else begin
            if h * (h + a[w].y - a[w mod 3 + 1].y) = 0 then begin
              h := - a[w].y + a[w mod 3 + 1].y;
            end else begin
              may := false;
              exit;
            end;
          end;
        end else if ((a[1].x - a[2].x) * (a[1].x - a[3].x) * (a[2].x - a[3].x) *
           (a[1].y - a[2].y) * (a[1].y - a[3].y) * (a[2].y - a[3].y) <> 0) then begin
          may := true;
          exit;
        end else begin  {pryamougol'nyi treugol'nik}

        end;
      end;
    end;
    try;

  end;

 procedure outdata;
  var
    i, j: longint;
  begin
    assign(output, outfile); rewrite(output);
    if may then begin
      for i := 1 to n do begin
        for j := 1 to 3 do
          write(trs[i].a[j].x, ' ', trs[i].a[j].y, ' ');
        writeln;
      end;
    end else writeln('NO');
    close(output);
  end;
begin
  indata;
  solve;
  outdata;
end.