{$M 65535,28000000,28000000}
{$R-} {$Q-} {$S-}
program glass;
const
 maxN=2000;
type
 TPoint=record
  x,y:integer;
 end;
 TTr=array[1..4] of TPoint;
var
 TrList:array[1..maxN] of TTr;
 TrL2:array[1..3*MaxN] of TTr;
 origN:array[1..3*MaxN] of integer;
 isIN:array[1..maxN] of boolean;
 isInS:array[1..3*MaxN] of boolean;
 ordChanged:array[1..maxN] of boolean;
 ptrl2:integer;
{ canbeComp:array[1..maxN,1..3,1..maxN,1..3] of byte;
 toCntr:array[1..maxN] of integer;}
 N:integer;
 cntS:integer;
 solveFound:boolean;


procedure load;
var
 i,j:integer;
 fin:text;
begin
 assign(fin,'glass.in');
 reset(fin);
 readln(fin,N);
 for i:=1 to N do begin
  for j:=1 to 3 do with TrList[i,j] do read(fin,x,y);
  readln(fin);
  TrList[i,4].x:=TrList[i,1].x;
  TrList[i,4].y:=TrList[i,1].y;
 end;
 close(fin);
end;

procedure moveTr(i:integer; dx,dy:integer);
var
 j:integer;
begin
 for j:=1 to 3 do with trList[i,j] do begin
  x:=x+dx;
  y:=y+dy;
 end;
end;

{function isEq(var p1,p2,p3,p4:TPoint):boolean;
var
 dx1,dy1,dx2,dy2:integer;
begin
 dx1:=p2.x-p1.x; dx2:=p4.x-p3.x;
 if not (abs(dx1)=abs(dx2)) then begin isEq:=false; exit; end;
 dy1:=p2.y-p1.y; dy2:=p4.y-p3.y;
 if not (dx1=dx2) then begin dx1:=-dx1; dy1:=-dy1; end;
 isEq:=((dx1=dx2) and (dy1=dy2));
end;

procedure apply(st,ss,dt,ds:integer):
var
 dx,dy:integer;
 x1,x2,x3,x4,y1,y2,y3,y4,i:integer;
begin
 with trList[st,ss] do begin x1:=x; y1:=y; end;
 with trList[st,ss+1] do begin x2:=x; y2:=y; end;
 with trList[dt,ds] do begin x3:=x; y4:=y; end;
 with trList[dt,ds+1] do begin x4:=x; y4:=y; end;
 if ((longint(x2-x1)*(y2-y1)+longint(x4-x3)*(y4-y3))>0) then begin
  dx:=x3-x1;
  dy:=y3-y1;
 end else begin
  dx:=x3-x2;
  dy:=y3-y2;
 end;
 for i:=1 to 4 do begin
  with trList[dt,i] do begin x:=x-dx; y:=y-dy; end;
 end;
end;

procedure makecanbecomp;
var
 i,j,k,l:integer;
begin
 for i:=1 to N do for k:=1 to 3 do begin
  for j:=1 to N do for l:=1 to 3 do begin
   if isEq(trList[i,k],trList[i,k+1],trList[j,l],trList[j,l+1]) then
      canbecomp[i,k,j,l]:=1 else canbecomp[i,k,j,l]:=0;
  end;
 end;
end;

procedure searchcirc;
var
 isConn:array[1..maxn,1..3] of boolean;
 connNum:array[1..maxn] of byte;

 procedure searchA:integer;
 begin
 end;

begin
 fillchar(isConn,sizeof(isConn),0);
 fillchar(connNum,sizeof(connum),0);
end;}

procedure sortTr_1;
var
 i:integer;
 Tr:TTr;
 dx1,dx2,dy1,dy2:integer;
begin
 for i:=1 to N do begin
  move(trList[i],Tr,sizeof(tr));
  dx1:=Tr[2].x-Tr[1].x;
  dx2:=Tr[3].x-Tr[2].x;
  dy1:=Tr[2].y-Tr[1].y;
  dy2:=Tr[3].y-Tr[2].y;
  if ((dx1*dy2)-(dy1*dx2)<0) then begin
   ordChanged[i]:=true;
   move(Tr[3],trlist[i,2],sizeof(TPoint));
   move(Tr[2],trlist[i,3],sizeof(TPoint));
  end else ordChanged[i]:=false;
 end;
end;

function canTakeFr(tr:integer; v:integer ):boolean;
const
 vAc:array[1..3] of integer=(2,3,1);
 vBc:array[1..3] of integer=(3,1,2);
var
 xA,yA,xB,yB:integer;
 vA,vB:integer;
begin
 vA:=vAc[v]; vB:=vBc[v];
 with trList[tr,va] do begin xa:=x; ya:=y; end;
 with trList[tr,vb] do begin xb:=x; yb:=y; end;
 canTakeFr:=((xB=xA) or (yB=yA));
end;

procedure makeTrL2;
var
 i,j,k,v,x0,y0:integer;
begin
 pTrl2:=0;
 for i:=1 to N do begin
 for j:=1 to 3 do if cantakefr(i,j) then begin
  inc(ptrl2);
  v:=j;
  for k:=1 to 3 do begin
   move(trList[i,v],trl2[ptrl2,k],sizeof(TPoint));
   v:=v+1; if (v>3) then v:=1;
  end;
  with trl2[ptrl2,1] do begin x0:=x; y0:=y; x:=0; y:=0; end;
  with trl2[ptrl2,2] do begin x:=x-x0; y:=y-y0; end;
  with trl2[ptrl2,3] do begin x:=x-x0; y:=y-y0; end;
  move(trl2[ptrl2,1],trl2[ptrl2,4],sizeof(TPoint));
  origN[pTrl2]:=i;
 end;
 end;
end;

function isGr(var a,b:TPoint):boolean;
const
 eV:array[1..4] of array[1..2] of integer=((1,0),(0,1),(-1,0),(0,-1));
var
 i:integer;
 ma,mb:integer;
begin
 i:=1;
 while ((i<4) and not ((a.x*eV[i,2]-a.y*eV[i,1]<0) and (b.x*eV[i,2]-b.y*eV[i,1]<0))) do inc(i);
 ma:=a.x*eV[i,1]+a.y*eV[i,2];
 mb:=b.x*eV[i,1]+b.y*eV[i,2];
 isGr:=(ma>mb);
end;

procedure sortTrL2;
var
 Tmp:TTr;
 i,j,k,itmp:integer;
begin
 for i:=1 to pTrl2 do for j:=1 to pTrl2-1 do
  if not isGr(trl2[j][2],trl2[j+1][2]) then begin
   move(trl2[j],tmp,sizeof(tTr));
   move(trl2[j+1],trl2[j],sizeof(tTr));
   move(tmp,trl2[j+1],sizeof(tTr));
   itmp:=origN[j]; origN[j]:=orign[j+1]; orign[j+1]:=itmp;
 end;
end;

procedure fixsolve; forward;

procedure solveA(p:TPoint; l,i0:integer);
var
 i:integer;
begin
 if solvefound then exit;
 if (l=N) then begin
  fixSolve;
  exit;
 end;
 for i:=i0 to ptrl2 do if ((not isIn[origN[i]]) and
                     ((p.x=trl2[i,2].x) and (p.y=trl2[i,2].y)) ) then begin
  isIn[origN[i]]:=true;
  isInS[i]:=true;
  solveA(trl2[i,3],l+1,i+1);
  if solvefound then exit;
  isInS[i]:=false;
  isIn[origN[i]]:=false;
 end;
 for i:=1 to (i0-1) do if ((not isIn[origN[i]]) and
                     ((p.x=trl2[i,2].x) and (p.y=trl2[i,2].y)) ) then begin
  isIn[origN[i]]:=true;
  isInS[i]:=true;
  solveA(trl2[i,3],l+1,i+1);
  isInS[i]:=false;
  isIn[origN[i]]:=false;
 end;
end;

procedure solve;
var
 i:integer;
begin
 i:=1;
 solvefound:=false;
 for i:=1 to ptrl2 do if (OrigN[i]=1) then begin
  isIn[origN[i]]:=true;
  isInS[i]:=true;
  solveA(trl2[i,3],1,i+1);
  isInS[i]:=false;
  isIn[origN[i]]:=false;
 end;
end;

procedure save;
var
 i:integer;
 fout:text;
begin
 assign(fout,'glass.out');
 rewrite(fout);
 for i:=1 to N do begin
  write(fout,trlist[i,1].x,' ');
  write(fout,trlist[i,1].y,' ');
  if not ordChanged[i] then begin
   write(fout,trlist[i,2].x,' ');
   write(fout,trlist[i,2].y,' ');
   write(fout,trlist[i,3].x,' ');
   writeln(fout,trlist[i,3].y);
  end else begin
   write(fout,trlist[i,3].x,' ');
   write(fout,trlist[i,3].y,' ');
   write(fout,trlist[i,2].x,' ');
   writeln(fout,trlist[i,2].y);
  end;
 end;
 close(fout);
end;

procedure fixsolve;
var
 minx0,miny0:integer;
 tXs,tYs,tYo,tXo:integer;
 dx:integer;
 dy:integer;
 i,k,j:integer;
begin
 solvefound:=true;
 for k:=1 to n do begin
  i:=1; while not ((origN[i]=k) and isInS[i]) do inc(i);
  tXs:=-32000; tXo:=-32000;
  tYs:=-32000; tYo:=-32000;
  for j:=1 to 3 do with trlist[k,j] do begin
   if (x>tXo) then txo:=x; if (y>tyo) then tyo:=y;
  end;
  for j:=1 to 3 do with trl2[i,j] do begin
   if (x>tXs) then txs:=x; if (y>tys) then tys:=y;
  end;
  dx:=txs-txo; dy:=tys-tyo;
  moveTr(k,dx,dy);
 end;

 minx0:=32000; miny0:=32000;
 for i:=1 to N do for j:=1 to 3 do with TrList[i,j] do begin
  if (x<minx0) then minx0:=x;
  if (y<miny0) then miny0:=y;
 end;
 for i:=1 to N do moveTr(i,0-minX0,0-minY0);
 save;
end;

procedure answerNO;
var
 fout:text;
begin
 assign(fout,'glass.out');
 rewrite(fout);
 writeln(fout,'NO');
 close(fout);
end;


begin
 load;
 sorttr_1;
 makeTrl2;
 sortTrl2;
 solve;
 if not solvefound then answerNO;
end.
