const infile = 'glass.in'; outfile = 'glass.out';
      max = 2005; eps = 0.0000001;
type pt = record x,y: longint; end;
var a: array [1..max,1..3] of pt;
    ms: array [1..max] of pt;
    rr: array [1..max] of longint;
    otr: array [1..max] of pt;
    c,p1,p2: pt;
    ok: boolean;
    n,m: longint;

procedure init;
var i: longint;
begin
     assign(input,infile);
     reset(input);
     read(n);
     for i:=1 to n do read(a[i,1].x,a[i,1].y,a[i,2].x,a[i,2].y,a[i,3].x,a[i,3].y);
     close(input);
end;

procedure trans(q,num: longint);
var i: longint;
begin
     for i:=1 to 3 do
         if i <> num then begin
            a[q,i].x:=a[q,i].x+(c.x-a[q,num].x);
            a[q,i].y:=a[q,i].y+(c.y-a[q,num].y);
         end;
     if ms[q].x < 0 then ms[q].y:=ms[q].y+(c.y-a[q,num].y)
        else ms[q].x:=ms[q].x+(c.x-a[q,num].x);
     a[q,num]:=c;
end;

function par(q,num1,num2: longint): boolean;
begin
     if (a[q,num1].x = a[q,num2].x) then begin
        ms[q].x:=a[q,num1].x; ms[q].y:=-10; par:=true; exit;
     end;
     if (a[q,num1].y = a[q,num2].y) then begin
        ms[q].y:=a[q,num1].y; ms[q].x:=-10; par:=true; exit;
     end;
     par:=false;
end;

function check(q: longint): boolean;
begin
     check:=true;
     if ms[q].x < 0 then begin
        if (p1.y = ms[q].y)or(p2.y = ms[q].y) then exit;
        if p1.y < 0 then begin p1.y:=ms[q].y; exit; end;
        if p2.y < 0 then begin p2.y:=ms[q].y; exit; end;
        check:=false;
     end
        else begin
        if (p1.x = ms[q].x)or(p2.x = ms[q].x) then exit;
        if p1.x < 0 then begin p1.x:=ms[q].x; exit; end;
        if p2.x < 0 then begin p2.x:=ms[q].x; exit; end;
        check:=false;
     end;
end;

procedure trans_all;
var i,j,z: longint;
begin
     if p2.x < p1.x then begin
        z:=p1.x; p1.x:=p2.x; p2.x:=z;
        z:=p1.y; p1.y:=p2.y; p2.y:=z;
     end;
     if p2.y < p1.y then begin
        z:=p1.y; p1.y:=p2.y; p2.y:=z;
     end;
     for i:=1 to n do
         for j:=1 to 3 do begin
             a[i,j].x:=a[i,j].x-p1.x;
             a[i,j].y:=a[i,j].y-p1.y;
         end;
end;

function s(q: longint): extended;
var t1x,t2x,t3x,t1y,t2y,t3y: extended;
begin
     t1x:=a[q,1].x; t1y:=a[q,1].y;
     t2x:=a[q,2].x; t2y:=a[q,2].y;
     t3x:=a[q,3].x; t3y:=a[q,3].y;
     s:=abs(t1x*t2y-t2x*t1y+t2x*t3y-t3x*t2y+t3x*t1y-t1x*t3y)/2;
end;

function check_s: boolean;
var i: longint;
    qs,z1,z2: extended;
begin
     qs:=0;
     for i:=1 to n do qs:=qs+s(i);
     z1:=(p2.x-p1.x); z2:=(p2.y-p1.y);
     if abs(z1*z2-qs) < eps then check_s:=true
        else check_s:=false;
end;

procedure solve;
var i,j,z: longint;
begin
     ok:=false; m:=0;
     c.x:=100000; c.y:=100000;
     p1.x:=-10; p1.y:=-10;
     p2.x:=-10; p2.y:=-10;
     for i:=1 to n do begin
         j:=1;
         while (j <= 3)and(not par(i,j,(j mod 3)+1)) do inc(j);
         if j > 3 then exit
            else trans(i,((j mod 3)+1) mod 3+1);
         z:=1;
         while (z <= m)and(not((otr[z].x = a[i,j].x)and(otr[z].y = a[i,j].y))) do inc(z);
         if z > m then begin
            inc(m); otr[m]:=a[i,j]; rr[m]:=1;
         end
            else inc(rr[z]);
         if (m > n)or(rr[z] > 2) then exit;
         z:=1;
         while (z <= m)and(not((otr[z].x = a[i,j mod 3+1].x)and(otr[z].y = a[i,j mod 3+1].y))) do inc(z);
         if z > m then begin
            inc(m); otr[m]:=a[i,j mod 3+1]; rr[m]:=1;
         end
            else inc(rr[z]);
         if (m > n)or(rr[z] > 2) then exit;
     end;
     if m <> n then exit;
     for i:=1 to m do
         if rr[i] <> 2 then exit;
     for i:=1 to n do
         if not check(i) then exit;
     trans_all;
     if not check_s then exit;
     ok:=true;
end;

procedure done;
var i: longint;
begin
     assign(output,outfile);
     rewrite(output);
     if ok then
        for i:=1 to n do
            writeln(a[i,1].x,' ',a[i,1].y,' ',a[i,2].x,' ',a[i,2].y,' ',a[i,3].x,' ',a[i,3].y)
        else write('NO');
     close(output);
end;

begin
     init;
     solve;
     done;
end.
