#include <stdio.h>

int ox1[2000],oy1[2000],ox2[2000],oy2[2000],ox3[2000],oy3[2000];

inline char is_sline(int x1,long y1,long x2,long y2)
{
  return ((x1==x2)||(y1==y2));
}


inline void add_answer(int i,int x1,int y1,int x2,int y2,int x3,int y3)
{
  ox1[i]=x1;
  oy1[i]=y1;
  ox2[i]=x2;
  oy2[i]=y2;
  ox3[i]=x3;
  oy3[i]=y3;
}


void main()
{
  FILE *inp=fopen("glass.in","r");
  FILE *out=fopen("glass.out","w");
  int N,x1[2000],y1[2000],x2[2000],y2[2000],x3[2000],y3[2000];
  int sx1,sy1,sx2,sy2,cx,cy,top,bottom,left,right;
  char used[2000];
  int i,k,l,j;

  fscanf(inp,"%d",&N);

  for (i=0;i<N;++i)
  {
    fscanf(inp,"%d%d%d%d%d%d",&x1[i],&y1[i],&x2[i],&y2[i],&x3[i],&y3[i]);
    used[i]=1;
  }

  for (i=0;i<N;++i)
  {
    l=is_sline(x1[i],y1[i],x2[i],y2[i]);
    l+=is_sline(x1[i],y1[i],x3[i],y3[i]);
    l+=is_sline(x2[i],y2[i],x3[i],y3[i]);
    if (l==1)
    {
      k=i;
      break;
    }
  }
  if (l==2) k=0;

  i=k;
  used[i]=0;
  if (is_sline(x1[i],y1[i],x2[i],y2[i]))
  {
    cx=x3[i];
    cy=y3[i];
    sx1=x1[i]-cx;
    sy1=y1[i]-cy;
    sx2=x2[i]-cx;
    sy2=y2[i]-cy;
    add_answer(i,sx1,sy1,sx2,sy2,0,0);
  }
  else if (is_sline(x1[i],y1[i],x3[i],y3[i]))
  {
    cx=x2[i];
    cy=y2[i];
    sx1=x1[i]-cx;
    sy1=y1[i]-cy;
    sx2=x3[i]-cx;
    sy2=y3[i]-cy;
    add_answer(i,sx1,sy1,0,0,sx2,sy2);
  }
  else if (is_sline(x2[i],y2[i],x3[i],y3[i]))
  {
    cx=x1[i];
    cy=y1[i];
    sx1=x2[i]-cx;
    sy1=y2[i]-cy;
    sx2=x3[i]-cx;
    sy2=y3[i]-cy;
    add_answer(i,0,0,sx1,sy1,sx2,sy2);
  }
  bottom=sy1;
  left=sx1;

  j=N-1;
  while (j)
  {
    l=j;
    for (i=0;i<N;++i)
      if (used[i])
      {
	if (((x2[i]-x1[i])==sx1)&&((y2[i]-y1[i])==sy1))
	  if(is_sline(x2[i],y2[i],x3[i],y3[i]))
	  {
	    used[i]=0;
	    sx1=x3[i]-x1[i];
	    sy1=y3[i]-y1[i];
	    add_answer(i,0,0,x2[i]-x1[i],y2[i]-y1[i],sx1,sy1);
	    --j;
	    break;
	  }
	if (((x1[i]-x2[i])==sx1)&&((y1[i]-y2[i])==sy1))
	  if(is_sline(x1[i],y1[i],x3[i],y3[i]))
	  {
	    used[i]=0;
	    sx1=x3[i]-x2[i];
	    sy1=y3[i]-y2[i];
	    add_answer(i,x1[i]-x2[i],y1[i]-y2[i],0,0,sx1,sy1);
	    --j;
	    break;
	  }
	if (((x2[i]-x1[i])==sx2)&&((y2[i]-y1[i])==sy2))
	  if(is_sline(x2[i],y2[i],x3[i],y3[i]))
	  {
	    used[i]=0;
	    sx2=x3[i]-x1[i];
	    sy2=y3[i]-y1[i];
	    add_answer(i,0,0,x2[i]-x1[i],y2[i]-y1[i],sx2,sy2);
	    --j;
	    break;
	  }
	if (((x1[i]-x2[i])==sx2)&&((y1[i]-y2[i])==sy2))
	  if(is_sline(x1[i],y1[i],x3[i],y3[i]))
	  {
	    used[i]=0;
	    sx2=x3[i]-x2[i];
	    sy2=y3[i]-y2[i];
	    add_answer(i,x1[i]-x2[i],y1[i]-y2[i],0,0,sx2,sy2);
	    --j;
	    break;
	  }
	if (((x2[i]-x3[i])==sx1)&&((y2[i]-y3[i])==sy1))
	  if(is_sline(x2[i],y2[i],x1[i],y1[i]))
	  {
	    used[i]=0;
	    sx1=x1[i]-x3[i];
	    sy1=y1[i]-y3[i];
	    add_answer(i,sx1,sy1,x2[i]-x3[i],y2[i]-y3[i],0,0);
	    --j;
	    break;
	  }
	if (((x3[i]-x2[i])==sx1)&&((y3[i]-y2[i])==sy1))
	  if(is_sline(x3[i],y3[i],x1[i],y1[i]))
	  {
	    used[i]=0;
	    sx1=x1[i]-x2[i];
	    sy1=y1[i]-y2[i];
	    add_answer(i,sx1,sy1,0,0,x3[i]-x2[i],y3[i]-y2[i]);
	    --j;
	    break;
	  }
	if (((x2[i]-x3[i])==sx2)&&((y2[i]-y3[i])==sy2))
	  if(is_sline(x2[i],y2[i],x1[i],y1[i]))
	  {
	    used[i]=0;
	    sx2=x1[i]-x3[i];
	    sy2=y1[i]-y3[i];
	    add_answer(i,sx2,sy2,x2[i]-x3[i],y2[i]-y3[i],0,0);
	    --j;
	    break;
	  }
	if (((x3[i]-x2[i])==sx2)&&((y3[i]-y2[i])==sy2))
	  if(is_sline(x3[i],y3[i],x1[i],y1[i]))
	  {
	    used[i]=0;
	    sx2=x1[i]-x2[i];
	    sy2=y1[i]-y2[i];
	    add_answer(i,sx2,sy2,0,0,x3[i]-x2[i],y3[i]-y2[i]);
	    --j;
	    break;
	  }
	if (((x1[i]-x3[i])==sx1)&&((y1[i]-y3[i])==sy1))
	  if(is_sline(x1[i],y1[i],x2[i],y2[i]))
	  {
	    used[i]=0;
	    sx1=x2[i]-x3[i];
	    sy1=y2[i]-y3[i];
	    add_answer(i,x1[i]-x3[i],y1[i]-y3[i],sx1,sy1,0,0);
	    --j;
	    break;
	  }
	if (((x3[i]-x1[i])==sx1)&&((y3[i]-y1[i])==sy1))
	  if(is_sline(x3[i],y3[i],x2[i],y2[i]))
	  {
	    used[i]=0;
	    sx1=x2[i]-x1[i];
	    sy1=y2[i]-y1[i];
	    add_answer(i,0,0,sx1,sy1,x3[i]-x1[i],y3[i]-y1[i]);
	    --j;
	    break;
	  }
	if (((x1[i]-x3[i])==sx2)&&((y1[i]-y3[i])==sy2))
	  if(is_sline(x1[i],y1[i],x2[i],y2[i]))
	  {
	    used[i]=0;
	    sx2=x2[i]-x3[i];
	    sy2=y2[i]-y3[i];
	    add_answer(i,x1[i]-x3[i],y1[i]-y3[i],sx2,sy2,0,0);
	    --j;
	    break;
	  }
	if (((x3[i]-x1[i])==sx2)&&((y3[i]-y1[i])==sy2))
	  if(is_sline(x3[i],y3[i],x2[i],y2[i]))
	  {
	    used[i]=0;
	    sx2=x2[i]-x1[i];
	    sy2=y2[i]-y1[i];
	    add_answer(i,0,0,sx2,sy2,x3[i]-x1[i],y3[i]-y1[i]);
	    --j;
	    break;
	  }
	if (sx1<left) left=sx1;
	if (sy1<bottom) bottom=sy1;
	if (sx2<left) left=sx2;
	if (sy2<bottom) bottom=sy2;
      }
      if (j==l)
      {
	fprintf(out,"NO");
	fclose(inp);
	fclose(out);
	return;
      }
  }
  if ((sx1!=sx2)||(sy1!=sy2))
  {
    fprintf(out,"NO");
    fclose(inp);
    fclose(out);
    return;
  }

  for (i=0;i<N;++i)
  {
    fprintf(out,"%d %d %d %d %d %d\n",ox1[i]-left,oy1[i]-bottom,
	ox2[i]-left,oy2[i]-=bottom,
	ox3[i]-left,oy3[i]-=bottom);
  }
  fclose(inp);
  fclose(out);
}