program task;
type
  TLst = array[0..1000] of byte;
  TLGlst = array[1..250] of boolean;
  PNode = ^Tnode;
  TNode = record
            n:integer;
            next:array[1..1000] of PNode;
          end;
var
  n : integer;
  Logo : string[250];
  err:boolean;
  s:array[1..1000] of string[10];
  cuts:array[1..2,1..1000] of char;
  lg:TLGlst;
  lastlev:integer;
  lslg:longint;
  count,used,lst,list:TLst;
  root:PNode;


  procedure ReadData;
  var
    f:Text;
    i:integer;
  begin
    assign(f,'chain.in');
    reset(f);
    read(f,logo);
    readln(f,n);
    for i:=1 to n do
      readln(f,s[i]);
    close(f);
  end;

  procedure Prepare;
  var
    i:integer;
  begin
    err:=false;
    LastLev:=MaxInt;
    for i:=1 to 1000 do
      begin
      used[i]:=0;
      list[i]:=0;
      lst[i]:=0;
      end;
    for i:=1 to 250 do
        lg[i]:=false;
    for i:=1 to n do
      begin
        cuts[1,i]:=s[i][1];
        cuts[2,i]:=s[i][length(s[i])];
      end;
  end;

  procedure DoAct;
  var
    h,g,i,j:integer;
    c:char;
    vr:boolean;
    tmp:string[1];
  begin
  {Check for used words}
  vr:=false;
    for i:=1 to n do
      begin
        c:=cuts[1,i];
         for j:=1 to n do
         if j<>i then
           begin
             if cuts[2,j]=c then begin vr:=true; used[i]:=1; end;
             if vr then break;
           end;
        if vr then vr:=false else
          begin
            for g:=1 to n do
              begin
                for h:=1 to n do
                  if g<>h then
                    begin
                      if cuts[2,i]=cuts[1,h] then begin vr:=true; used[i]:=1; end;
                      if vr then break;
                    end;
              if vr then break else used[i]:=0;
              end;
          end;
        vr:=false;
      end;
    {Check for Impossible}
    for i:=1 to length(logo) do
     for j:=1 to n do
     if used[j]=1 then
      begin
      tmp:='';
      tmp:=copy(logo,i,1);
        if pos(tmp,s[j])>0 then lg[i]:=true;
      end;
    for i:=1 to length(logo) do
      if not lg[i] then begin err:=true; break; end;
    if err then exit;

  end;

  procedure Outpt;
  var
    o:Text;
    i:integer;
  begin
    assign(o,'chain.out');
    rewrite(o);
    if lastlev=MaxInt then err:=true;
    if not err then
       begin
         for i:=1 to lastlev do
           if list[i]<>0 then
           writeln(o,s[list[i]]);
       end
    else write(o,'?');
    close(o);
  end;

  procedure Store(l:integer;ls:TLst);
  var
    g:PNode;
    lk:integer;
    t:Longint;
    i:integer;
  begin
  t:=0;
  for i:=1 to l do if ls[i]>0 then t:=t+length(s[ls[i]]);
  if t>=lslg then Exit;
  for i:=1 to 1000 do list[i]:=0;
  for i:=1 to l do list[i]:=ls[i];
    lastlev:=l;
    lslg:=t;
    Outpt;
  end;

  function CheckForFinal(level:integer;ls:Tlst):boolean;
  var
    r:boolean;
    g:TLGLst;
    p,i,j:integer;
    needp,needj:integer;
    tmp:string[1];
  begin
  needp:=0;
  needj:=0;
  r:=false;
  CheckForFinal:=r;
  for i:=1 to 250 do g[i]:=false;
  i:=1;
  for i:=1 to length(logo) do
   begin
   p:=0;
     for j:=1 to level do
      if used[ls[j]]=1 then
        begin
          tmp:=copy(logo,i,1);
          p:=pos(tmp,s[ls[j]]);
          if (p>0)and((j>needj)or((j=needj)and(p>needp))) then
            begin
              g[i]:=true;
              needp:=p;
              needj:=j;
              break;
            end;
        end;
   end;
  r:=true;
   for i:=1 to length(logo) do
      if g[i]=false then begin r:=false; break; end;
  if r then if lastlev>level then Store(level,lst);
  CheckForFinal:=r;
  end;

  function Getad(q,nn,level:integer):boolean;
  var
    ok,ad:boolean;
    ii,w:integer;
  begin
  ad:=true;
    {Del It}
    for ii:=1 to 1000 do count[ii]:=0;
      for w:=1 to level do
        if lst[w]=q then inc(count[w]);
    for ii:=1 to level do if count[ii]>2 then begin ad:=false; break; end;
    {Del It}
{                       for w:=1 to level do
                         if lst[w]=q then ad:=false;
}
        ok:=false;
      if nn<>0 then
            begin
              if cuts[2,nn]=cuts[1,q] then ok:=true;
              if not ok then ad:=false;
            end;
   GetAd:=ad;
  end;

  procedure BuildTree(level:integer;node:PNode);
  label gg;
  var
    ii,q:integer;
  begin
    if node=nil then Exit;
    if level>n+3 then Exit;
    lst[level]:=node^.n;
    if CheckforFinal(level,lst) then goto gg;

    for q:=1 to n do
      if (used[q]=1)and(q<>node^.n) then
      if Getad(q,node^.n,level) then
        begin
          new(node^.next[q]);
          node^.next[q]^.n:=q;
          for ii:=1 to 1000 do node^.next[q]^.next[ii]:=nil;
          BuildTree(level+1,node^.next[q]);
        end;
    gg:
      dispose(node);
  end;

begin
  ReadData;
  Prepare;
  DoAct;
  if not err then
    begin
     new(root);
     root^.n:=0;
     for lslg:=1 to 1000 do root^.next[lslg]:=nil;
    end;
  lslg:=MaxLongInt;
  if not err then BuildTree(0,root);
OutPt;
end.