program Broken_Glass;

type
  tpoint = record
    x,y : longint;
  end;
  ttrio = record
    a,b,c : tpoint;
  end;

const
  maxn = 2010; {2000}

var
  n,m,k : integer;
  shift : array [1..maxn] of tpoint;
  xn,xnx,xxx : array [1..maxn] of integer;
  trio,triox,triof,trioq : array [1..maxn] of ttrio;
  veca,vecb : array [1..maxn] of integer;
  rot : array [1..maxn] of boolean;
  next : array [1..maxn] of integer;
  ans : boolean;
  cp : tpoint;

procedure Load;
var
  i : integer;
  t : ttrio;
  temp : tpoint;
  s : longint;
  tmp : longint;
begin
  assign(input,'glass.in'); reset(input);
  assign(output,'glass.out'); rewrite(output);
  read(n);
  m := 0;
  k := 0;
  ans := true;
  for i:=1 to n do
  begin
     read(t.a.x,t.a.y,
     t.b.x,t.b.y,
     t.c.x,t.c.y);
     trioq[i] := t;
     s := (t.a.x-t.b.x)*(t.a.y+t.b.y)+
     (t.b.x-t.c.x)*(t.b.y+t.c.y)+
     (t.c.x-t.a.x)*(t.c.y+t.a.y);
     if s<0 then
     begin
       temp := t.a;
       t.a := t.c;
       t.c := temp;
     end;
     tmp := 0;
     if (t.a.x=t.b.x) or (t.a.y=t.b.y) then
       inc(tmp);
     if (t.b.x=t.c.x) or (t.b.y=t.c.y) then
       inc(tmp);
     if (t.c.x=t.a.x) or (t.c.y=t.a.y) then
       inc(tmp);
     if tmp=1 then
     begin
       if (t.a.x=t.b.x) or (t.a.y=t.b.y) then
       begin
         temp := t.a;
         t.a := t.c;
         t.c := t.b;
         t.b := temp;
       end
       else
       if (t.c.x=t.a.x) or (t.c.y=t.a.y) then
       begin
         temp := t.a;
         t.a := t.b;
         t.b := t.c;
         t.c := temp;
       end;
       inc(m);
       trio[m] := t;
       xn[m] := i;
     end
     else
     if tmp=2 then
     begin
       if (t.a.x<>t.b.x) and (t.a.y<>t.b.y) then
       begin
         temp := t.a;
         t.a := t.c;
         t.c := t.b;
         t.b := temp;
       end
       else
       if (t.c.x<>t.a.x) and (t.c.y<>t.a.y) then
       begin
         temp := t.a;
         t.a := t.b;
         t.b := t.c;
         t.c := temp;
       end;
       inc(k);
       triox[k] := t;
       xnx[k] := i;
     end
     else
       ans := false;
  end;
  ans := ans and (k<=8);
end;

function greater(a,b : tpoint) : boolean;
var
  cheta,chetb : integer;
begin
  cheta := ord((a.y<0) or ((a.y=0) and (a.x<0)));
  chetb := ord((b.y<0) or ((b.y=0) and (b.x<0)));
  if cheta = chetb then
    greater := a.x*b.y < b.x*a.y
  else
    greater := (cheta>chetb);
end;

procedure fin;
var
  i,t : integer;
  hs,hs2 : integer;
  t1,t2 : integer;
  aa,bb : integer;

procedure swap(a,b : integer);
var
  t : integer;
begin
  t := veca[a];
  veca[a] := veca[b];
  veca[b] := t;
end;

procedure heapify(a : integer);
var
  l : integer;
begin
  l := a;
  if (2*a<=hs) and (not greater(triof[veca[2*a]].b,triof[veca[l]].b)) then l := 2*a;
  if (2*a+1<=hs) and (not greater(triof[veca[2*a+1]].b,triof[veca[l]].b)) then l := 2*a+1;
  if l<>a then
  begin
    swap(l,a);
    heapify(l);
  end;
end;

procedure swap2(a,b : integer);
var
  t : integer;
begin
  t := vecb[a];
  vecb[a] := vecb[b];
  vecb[b] := t;
end;

procedure heapify2(a : integer);
var
  l : integer;
begin
  l := a;
  if (2*a<=hs2) and (not greater(triof[vecb[2*a]].c,triof[vecb[l]].c)) then l := 2*a;
  if (2*a+1<=hs2) and (not greater(triof[vecb[2*a+1]].c,triof[vecb[l]].c)) then l := 2*a+1;
  if l<>a then
  begin
    swap2(l,a);
    heapify2(l);
  end;
end;

begin
  ans := true;
  aa := 0;
  bb := 0;
  for i:=1 to m do
  begin
    triof[i] := trio[i];
    xxx[i] := xn[i];
  end;
  for i:=1 to k do
  begin
    xxx[i+m] := xnx[i];
    if rot[i] then
    begin
      triof[i+m].a := triox[i].b;
      triof[i+m].b := triox[i].c;
      triof[i+m].c := triox[i].a;
      inc(aa);
    end
    else
    begin
      triof[i+m].a := triox[i].c;
      triof[i+m].c := triox[i].b;
      triof[i+m].b := triox[i].a;
      inc(bb);
    end;
  end;
  if aa<>bb then begin ans := false; exit; end;
  for i:=1 to n do
  begin
    veca[i] := i;
    vecb[i] := i;
    shift[xxx[i]] := triof[i].a;
    triof[i].b.x := triof[i].b.x - triof[i].a.x;
    triof[i].b.y := triof[i].b.y - triof[i].a.y;
    triof[i].c.x := triof[i].c.x - triof[i].a.x;
    triof[i].c.y := triof[i].c.y - triof[i].a.y;
    triof[i].a.x := 0;
    triof[i].a.y := 0;
  end;
  hs := n;
  for i:=n downto 1 do
    heapify(i);
  while hs>1 do
  begin
    swap(1,hs);
    dec(hs);
    heapify(1);
  end;
  hs2 := n;
  for i:=n downto 1 do
    heapify2(i);
  while hs2>1 do
  begin
    swap2(1,hs2);
    dec(hs2);
    heapify2(1);
  end;
  for i:=1 to n do
  begin
    ans := ans and (triof[veca[i]].b.x=triof[vecb[i]].c.x) and
    (triof[veca[i]].b.y=triof[vecb[i]].c.y);
    next[veca[i]] := vecb[i];
    {prev[vecb[i]] := next[veca[i]];}
  end;
  if not ans then exit;
  t:=0;
  i:=1;
  repeat
    inc(t);
    i := next[i];
  until i=1;
  ans := ans and (t=n);
  if not ans then exit;
  t1 := 1;
  repeat
    t2 := next[t1];
    ans := ans and
    ((triof[t2].b.x-triof[t1].b.x)*(triof[t2].b.y+triof[t1].b.y)+
    (triof[t1].b.x-triof[t1].c.x)*(triof[t1].b.y+triof[t1].c.y)+
    (triof[t1].c.x-triof[t2].b.x)*(triof[t1].c.y+triof[t2].b.y)>=0);
    t1 := t2;
  until t1=1;
  cp.x := 0;
  cp.y := 0;
  if not ans then exit;
  for i:=1 to n do
  begin
    if (triof[i].b.x<cp.x) and (triof[i].b.y<cp.y) then
      cp := triof[i].b;
    if (triof[i].c.x<cp.x) and (triof[i].c.y<cp.y) then
      cp := triof[i].c;
  end;
end;

procedure go(a : integer);
begin
  if ans then exit;
  if a=k+1 then
    fin
  else
  begin
    rot[a] := false;
    go(a+1);
    if ans then exit;
    rot[a] := true;
    go(a+1);
  end;
end;

procedure Solve;
begin
  if not ans then exit;
  ans := false;
  go(1);
end;

procedure Save;
var
  i : integer;
begin
  if ans then
  begin
    for i:=1 to n do
    begin
      writeln(trioq[i].a.x-shift[i].x-cp.x,' ',
      trioq[i].a.y-shift[i].y-cp.y,' ',
      trioq[i].b.x-shift[i].x-cp.x,' ',
      trioq[i].b.y-shift[i].y-cp.y,' ',
      trioq[i].c.x-shift[i].x-cp.x,' ',
      trioq[i].c.y-shift[i].y-cp.y);
    end;
  end
  else
    writeln('NO');
  close(input); close(output);
end;

begin
  Load;
  Solve;
  Save;
end.