{$I-,Q-,R-,S-}
Const
  MaxN = 1000;
  MaxSt = 100000;

Type
  TWord = Record
    S: String[250];
    A: Array [1..MaxN] Of Word;
  End;

Var
  Slogan: String;
  KIndex, K, I, J, N: LongInt;
  A: Array [1..MaxN] Of TWord;
  L, BL: LongInt;
  Depth, Letters: Array [0..MaxN] Of Word;
  St, Best: Array [0..MaxSt] Of Word;

Procedure Try(Index: Word);
Var
  Incr, I: Word;
Begin
  Inc(St[0]);
  St[St[0]] := Index;
  Letters[Index] := KIndex;

  If (Index = 0) Or (KIndex > Length(Slogan))  Then
    Exit;

  Incr := 0;
  For I := 1 To Length(A[Index].S) Do
    If A[Index].S[I] = Slogan[KIndex] Then
      Inc(Incr);

  KIndex := KIndex + Incr;
  If KIndex > Length(Slogan) Then
  Begin
    L := 0;
    For J := 1 To St[0] Do
      L := L + Length(A[St[J]].S);
    If L < Bl Then
    Begin
      Best := St;
      BL := L;
    End;
  End;

  If KIndex <= Length(Slogan) Then
  For I := 1 To N Do
    If (A[Index].A[I] > 0) Then
    If (Letters[I] < KIndex) Or
       (Depth[I] > Depth[Index]) Then
    Begin
      Depth[I] := Depth[Index] + 1;
      Try(I);
    End;

  St[St[0]] := 0;
  Dec(St[0]);
  KIndex := KIndex - Incr;
End;


Begin
  Assign(Input, 'chain.in');
  ReSet(Input);
  Assign(Output, 'chain.out');
  ReWrite(Output);

  ReadLn(Slogan);
  ReadLn(N);
  For I := 1 To N Do
    ReadLn(A[I].S);

  For I := 1 To N Do
    For J := 1 To N Do
      If A[I].S[Length(A[I].S)] = A[J].S[1] Then
        A[I].A[J] := Length(A[I].S);

  K := 1;
  Best[0] := 0;
  BL := 60000;

  For I := 1 To N Do
  Begin
    KIndex := 1;
    St[0] := 0;
    L := 0;
    FillChar(Letters, SizeOf(Letters), 0);
    FillChar(Depth, SizeOf(Depth), 0);
    Depth[I] := 1;
    Try(I);
  End;

  If Best[0] = 0 Then
    WriteLn('?')
  Else
    For I := 1 To Best[0] Do
      WriteLn(A[Best[I]].S);

  Close(Input);
  Close(Output);
End.
