program Mirrow;
const
  MaxN= 2008;
  inf= 10000;
var
  Tri: array[1..MaxN,1..3] of record x,y: integer; end;
  Cycle: array[1..MaxN] of
  record
    IDtri,IDv,cxf,cyf,cxl,cyl: integer;
    t: byte;
  end;
  Whos: array[1..MaxN] of integer;

  p: array[1..MaxN] of integer;
  used: array[1..MaxN] of boolean;
  cn: integer;

  Usdn: integer;
  N: integer;

  CanDone: boolean;


  procedure ReadIn;
  var
    i,j: integer;
    f: Text;
  begin
    assign(f,'glass.in');
    reset(f);

    readln(f,N);
    for i:=1 to N do
    begin
      readln(f,Tri[i,1].x,Tri[i,1].y,Tri[i,2].x,Tri[i,2].y,Tri[i,3].x,Tri[i,3].y);
    end;

    close(f);
    candone:= true;
  end;

  procedure CheckTris;
  var
    i,j: integer;
    n1,n2: integer;
  begin
    cn:= 0;
    for i:=1 to N do
    for j:=1 to 3 do
    begin
      n1:= j+1;
      n2:= n1+1;
      if n1>3 then
        n1:= n1-3;
      if n2>3 then
        n2:= n2-3;
      if Tri[i,n1].x=Tri[i,n2].x then
      begin
        if Tri[i,n1].x<Tri[i,j].x then
        begin
          inc(cn);
          Cycle[cn].IDTri:= i;
          Cycle[cn].IDv:= j;
          Cycle[cn].t:= 3;
        end
        else
        begin
          inc(cn);
          Cycle[cn].IDTri:= i;
          Cycle[cn].IDv:= j;
          Cycle[cn].t:= 1;
        end;
      end;

      if Tri[i,n1].y=Tri[i,n2].y then
      begin
        if Tri[i,n1].y<Tri[i,j].y then
        begin
          inc(cn);
          Cycle[cn].IDTri:= i;
          Cycle[cn].IDv:= j;
          Cycle[cn].t:= 0;
        end
        else
        begin
          inc(cn);
          Cycle[cn].IDTri:= i;
          Cycle[cn].IDv:= j;
          Cycle[cn].t:= 2;
        end;
      end;
    end;
  end;

  procedure Findn1n2(var n1,n2: integer; i: integer);
  begin
    n1:= 1;
    n2:= 2;
    if Cycle[i].IDv=1 then
      n1:=3;
    if Cycle[i].IDv=2 then
      n2:=3;
  end;

  procedure CalcCtgs;
  var
    i,j,ct,cv,n1,n2,t,k: integer;
  begin
    for i:=1 to cn do
    begin
      Findn1n2(n1,n2,i);
      ct:= Cycle[i].IDTri;
      cv:= Cycle[i].IDv;
      case Cycle[i].t of
      0:  if Tri[ct,n1].x>Tri[ct,n2].x then
          begin
            t:= n1;
            n1:= n2;
            n2:= t;
          end;
      1:  if Tri[ct,n1].y>Tri[ct,n2].y then
          begin
            t:= n1;
            n1:= n2;
            n2:= t;
          end;
      2:  if Tri[ct,n1].x<Tri[ct,n2].x then
          begin
            t:= n1;
            n1:= n2;
            n2:= t;
          end;
      3:  if Tri[ct,n1].y<Tri[ct,n2].y then
          begin
            t:= n1;
            n1:= n2;
            n2:= t;
          end;
      end; {of case};
      Cycle[i].cxl:= Tri[ct,cv].x-Tri[ct,n2].x;
      Cycle[i].cyl:= Tri[ct,cv].y-Tri[ct,n2].y;
      Cycle[i].cxf:= Tri[ct,cv].x-Tri[ct,n1].x;
      Cycle[i].cyf:= Tri[ct,cv].y-Tri[ct,n1].y;
    end;
  end;

  procedure FillUsed;
  var
    i: integer;
  begin
    for i:=1 to N do
      used[i]:= false;
  end;

  procedure FindStart;
  var
    i: integer;
  begin
    for i:=1 to cn do
    begin
      if Cycle[i].cxl<>0 then
      begin
        p[1]:= i;
        break
      end;
    end;
  end;

  function CanBeNext(s,t: integer): boolean;
  var
    can: boolean;
  begin
    can:= Cycle[s].cxl=Cycle[t].cxf;
    can:= can and (Cycle[s].cyl=Cycle[t].cyf);
    if cycle[s].t<3 then
      can:= can and ((Cycle[s].t=Cycle[t].t) or (Cycle[s].t+1=Cycle[t].t))
    else
      can:= can and ((Cycle[s].t=Cycle[t].t) or (Cycle[t].t=0));
    CanBeNext:= can;
  end;

  function Calc: boolean;
  var
    pl: integer;
    i: integer;
    found: boolean;
  begin
    FindStart;
    pl:= 1;
    usdn:= 1;
    used[Cycle[p[1]].IDTri]:= true;
    repeat
      found:= false;
      for i:=Whos[p[pl]] to cn do
      begin
        if Used[Cycle[i].IDTri] then continue;
        if CanBeNext(p[pl],i) then
        begin
          inc(pl);
          p[pl]:= i;
          used[Cycle[i].IDTri]:= true;
          inc(usdn);
          found:= true;
          break;
        end;
      end;
      if not found then
        break;
    until usdn=N;
    Calc:= usdn=N;
  end;

  procedure WriteNonRes;
  var
    f: Text;
  begin
    assign(f,'glass.out');
    rewrite(f);

    writeln(f,'NO');

    close(f);
  end;

  procedure SdvigToCenter;
  var
    i,j: integer;
    xt,yt: integer;
    sdx,sdy: integer;
  begin
    xt:= Tri[Cycle[p[1]].IDTri,Cycle[p[1]].IDv].x;
    yt:= Tri[Cycle[p[1]].IDTri,Cycle[p[1]].IDv].y;
    for i:=1 to usdn do
    begin
      sdx:=xt-Tri[Cycle[p[i]].IDTri,Cycle[p[i]].IDv].x;
      sdy:=yt-Tri[Cycle[p[i]].IDTri,Cycle[p[i]].IDv].y;
      for j:=1 to 3 do
      begin
        Tri[Cycle[p[i]].IDTri,j].x:= Tri[Cycle[p[i]].IDTri,j].x+sdx;
        Tri[Cycle[p[i]].IDTri,j].y:= Tri[Cycle[p[i]].IDTri,j].y+sdy;
      end;
    end;
  end;

  procedure Change(a,b: integer);
  var
    t: integer;
  begin
    t:= Cycle[a].IDTri;
    Cycle[a].IDTri:= Cycle[b].IDTri;
    Cycle[b].IDTri:= t;
    t:= Cycle[a].IDV;
    Cycle[a].IDV:= Cycle[b].IDV;
    Cycle[b].IDV:= t;
    t:= Cycle[a].t;
    Cycle[a].t:= Cycle[b].t;
    Cycle[b].t:= t;
  end;

  procedure SortCycle;
  var
    t,i,l: integer;
    st: integer;
    was: boolean;
  begin
    st:= 1;
    l:= 0;
    for t:= 0 to 3 do
    begin
      was:= false;
      for i:=st to cn do
      begin
        if Cycle[i].t=t then
        begin
          inc(l);
          change(l,i);
          Whos[l]:= st;
        end;
      end;
      st:= l+1;
    end;
  end;

  procedure WriteRes;
  var
    i,j: integer;
    f: Text;
    xmin,ymin: integer;
  begin
    assign(f,'glass.out');
    rewrite(f);

    SdvigToCenter;

    xmin:= inf;
    ymin:= inf;
    for i:=1 to N do
    for j:=1 to 3 do
    begin
      if Tri[i,j].x<xmin then
        xmin:=Tri[i,j].x;
      if Tri[i,j].y<ymin then
        ymin:=Tri[i,j].y;
    end;

    for i:=1 to N do
    for j:=1 to 3 do
    begin
      Tri[i,j].x:= Tri[i,j].x-xmin;
      Tri[i,j].y:= Tri[i,j].y-ymin;
    end;

    for i:=1 to N do
    begin
      writeln(f,Tri[i,1].x,' ',Tri[i,1].y,' ',
      Tri[i,2].x,' ',Tri[i,2].y,' ',
      Tri[i,3].x,' ',Tri[i,3].y);
    end;

    close(f);
  end;

begin
  ReadIn;
  if CanDone then
  begin
    CheckTris;
    SortCycle;
    CalcCtgs;
    FillUsed;
    if Calc then
      writeRes
    else
      writeNonRes;
  end
  else
    writeNonRes;
end.