#include <fstream.h>
#include <string.h>
#include <bios.h>
#include <stdlib.h>

ifstream ifile ("chain.in");
ofstream ofile ("chain.out");

char g[2];

long weneedcheck;
long time_was;
void checktime ();


struct word
{
	char itself[11];
	int len;
	word* nexts[25];
	int nextcount;
} words[500];

char lozung[256];
long bestlen = 2000000000;

int tr (word* from, int stepnow, int where, int what);

char* best;
char* supstring;

int main ()
{

	weneedcheck=0;
	time_was = biostime (0,0);
	g[0]='*';
	g[1]=0;


	supstring = new char [10000];
	supstring[0]=0;
	best = new char[10000];
	best[0]=0;

	int N;
	ifile >> lozung >> N;
	if (N>500) {ofile << "?"; ofile.close(); return 0;}

	for (int i=0;i<N;i++)
	{
		ifile >> words[i].itself;
		words[i].len = strlen(words[i].itself);
		words[i].nextcount = 0;
	}

	for (int who=0;who<N;who++)
	{
		for (int with=0;with<N;with++)
		{
			if (with==who) continue;
			if (words[with].itself[0] == words[who].itself[words[who].len-1])
			{
				words[who].nexts[words[who].nextcount++] = &words[with];
				if (words[who].nextcount >= 25) words[who].nextcount = 24;
			}
		}
	}



	for (int first = 0; first < N; first++)
	{
		if (!strchr (words[first].itself, lozung[0])) continue;
		strcpy (supstring, words[first].itself);
		strcat (supstring, g);
		tr (&(words[first]), 0, 0,0);
	}
	if (strlen (best)==0)
	{
		ofile << "?";
		ofile.close();
		return 0;
	}
	else
	{
		for (int i=0;i<bestlen;i++)
		{
			if (best[i] != '*')
			{
				ofile << best[i];
			}
			else
			{
				ofile << "\n";
			}
		}
	}
	return 0;

}


int check_sup (char* supstring, int from_loz=0, int from_sup=0)
{
	int cur_in_loz = from_loz;
	for (int i=from_sup;i< strlen(supstring);i++)
	{
		if (supstring[i]==lozung[cur_in_loz]) cur_in_loz++;
		if (cur_in_loz >= strlen(lozung))
		 return -1;
	}
	return cur_in_loz;
}

int tr (word* from, int stepnow, int where, int what)
{
	weneedcheck++;
	if (weneedcheck > 1000)
	{
		weneedcheck=0;
		checktime();
	}

	int code=check_sup(supstring,what,where);
	if (code==-1)
	{
		if (strlen (supstring) < bestlen)
		{
			bestlen = strlen(supstring);
			strcpy (best, supstring);
		}
		return 1;
	}
	if (stepnow > 15) return 0;

	int last_len;
	for (int i=0;i<from->nextcount;i++)
	{
		last_len = from->nexts[i]->len + strlen (g);
		strncat (supstring, from->nexts[i]->itself, 9999);
		strncat (supstring, g, 9999);
		int curlen = strlen (supstring);
		tr(from->nexts[i], stepnow+1, curlen-last_len, code);

		supstring[curlen-last_len] = 0;
	}
	return 0;
}










void checktime ()
{
	if (biostime(0,0)-time_was > 30)
	{
		if (strlen (best)==0)
	{
		ofile << "?";
		ofile.close();
		exit(0);
	}
	else
	{
		for (int i=0;i<bestlen;i++)
		{
			if (best[i] != '*')
			{
				ofile << best[i];
			}
			else
			{
				ofile << "\n";
			}
		}
	}
	}
}
