{$A+,B-,D-,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
program n3;
const
 f_in='chain.in';
 f_out='chain.out';
 count=1000;
 timelimit=2;
type
 Tstring=string[10];
var
 timer:longint absolute $40:$6c;
 timeold:longint;
 p:string;
 n:integer;
 letters:array[0..count] of integer; {used from word p on position st[top]}
 last:integer;
 stlen:integer;{len of current sequence}
 used:array[1..count] of 0..1; {used letters in sequence}
 st:array[1..count] of integer; {sequence}
 top:integer;
 cur:integer;
 border:integer;
 can:boolean;
 b:array[1..count] of 0..1;
 best:array[1..count] of integer;
 topbest:integer;
 bestlen:integer;
 s:array[1..count] of Tstring;
{--------------------------------stack---------------------------------------}
function numof(lastk:integer;var w:Tstring):integer;
 var r:integer;
     i:integer;
 begin
  r:=0;
  for i:=1 to length(w) do
   if w[i]=p[lastk+r+1] then r:=r+1;
  numof:=r;
 end;{f..numof}
procedure addpath;
 var i:integer;
 begin
  topbest:=top;
  for i:=1 to top do best[i]:=st[i];
  bestlen:=stlen;
  can:=true;
 end;{p..addpath}
procedure add(x:integer);
 begin
  border:=0;
  top:=top+1;
  st[top]:=x;
  cur:=x;
  stlen:=stlen+length(s[cur]);
  if top<>1 then stlen:=stlen-1;
  used[cur]:=1;
  last:=last+numof(last,s[cur]);
  letters[top]:=last;
 end;{p..add}
{---------------------------procedures and functions-------------------------}
procedure initial;
 begin
  fillchar(p,ofs(s)-ofs(p)+sizeof(s),0);
 end;{p..initial}
procedure readdata;
 var i:integer;
 begin
  assign(input,f_in);
  reset(input);
  readln(p);
  readln(n);
  for i:=1 to n do begin
   readln(s[i]);
   if pos(p[1],s[i])<>0 then b[i]:=1;
  end;{for i}
  close(input);
 end;{p..readdata}
function connect(var u,v:Tstring):boolean;
 begin
  connect:=false;
  if u[length(u)]=v[1] then connect:=true;
 end;{f..connect}
function next:boolean;
 var i:integer;
 begin
  next:=false;
  if last=length(p) then begin
   addpath;
   exit;
  end;{if}
  if top=0 then begin
   i:=border+1;
   while (b[i]=0) and (i<=n) do i:=i+1;
   if i=n+1 then exit
            else begin add(i); next:=true; exit; end;
  end
  else begin
   i:=border+1;
   while i<=n do begin
    if used[i]=0 then
     if connect(s[cur],s[i]) then
      if length(s[i])+stlen<bestlen then begin add(i); next:=true; exit; end;
    i:=i+1;
   end;{while}
  end;{else}
 end;{p..next}
procedure reverse;
 begin
  border:=cur;
  used[cur]:=0;
  stlen:=stlen-length(s[cur]);
  st[top]:=0;
  top:=top-1;
  last:=letters[top];
  cur:=st[top];
 end;{p..reverse}
procedure solve;
 begin
  can:=false;
  bestlen:=maxint;
  while true do begin
   if timer-timeold>18.2*(timelimit-0.2) then exit;
   if not next then
       if top=1 then exit
                else reverse;
  end;{while}
 end;{p..solve}
procedure print;
 var i:integer;
 begin
  assign(output,f_out);
  rewrite(output);
  if not can then writeln('?')
             else begin
              for i:=1 to topbest do writeln(s[best[i]]);
             end;{else}
  close(output);
 end;{p..print}
{-------------------------------------main-----------------------------------}
begin
 timeold:=timer;
 initial;
 readdata;
 solve;
 print;
end.