{$A+,B-,D-,E-,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y-}
{$M 65520,0,655360}
const
  MAXN=2010;
type
  integer=longint;
  TPoint=record
    x,y:integer;
  end;
  TTreg=record
    t1,t2,t3:TPoint;
    uk:array[1..3] of byte;
  end;
var
  a:array[1..MAXN] of TTreg;
  n:integer;

procedure INit;
var i:integer;
begin
  assign(input,'glass.in');
  reset(input);
  assign(output,'glass.out');
  rewrite(output);
  read(n);
  for i:=1 to n do begin
    read(a[i].t1.x, a[i].t1.y, a[i].t2.x, a[i].t2.y, a[i].t3.x, a[i].t3.y);
    a[i].uk[1]:=1;
    a[i].uk[2]:=2;
    a[i].uk[3]:=3;
  end;
end;

procedure Swap(var a,b:TPoint);
var t:TPoint;
begin
  t:=a;
  a:=b;
  b:=t;
end;

procedure Print(const b:boolean);
var i,j,k:integer;
begin
  if not b then writeln('NO') else begin
    for i:=1 to n do begin
      for j:=1 to 3 do begin
        k:=a[i].uk[j];
        case k of
          1:begin
            write(a[i].t1.x, ' ',a[i].t1.y,' ');
          end;
          2:
          begin
            write(a[i].t2.x, ' ',a[i].t2.y, ' ');
          end;
          3:
          begin
            write(a[i].t3.x, ' ',a[i].t3.y,' ');
          end;
        end;
      end;
      writeln;
    end;
  end;
  halt;
end;

procedure SwapI(var a,b:byte);
var t:integer;
begin
  t:=a;
  a:=b;
  b:=t;
end;

procedure Solve;
var i,num,dx,dy:integer;
    t:tPoint;
    can:boolean;
begin
  for i:=1 to n do
  begin
    if a[i].t1.x=a[i].t2.x then
    begin
      swap(a[i].t1,a[i].t3);
      swapI(a[i].uk[1],a[i].uk[3]);
    end else if a[i].t1.y=a[i].t2.y then
      begin
        swap(a[i].t1,a[i].t3);
        swapI(a[i].uk[1],a[i].uk[3]);
      end else if a[i].t1.x=a[i].t3.x then
        begin
          swap(a[i].t1,a[i].t2);
          swapI(a[i].uk[1],a[i].uk[2]);
        end else if a[i].t1.y=a[i].t3.y then
          begin
            swap(a[i].t1,a[i].t2);
            swapI(a[i].uk[1],a[i].uk[2]);
          end else if a[i].t2.x=a[i].t3.x then
            begin
              {none}
            end else if a[i].t2.y=a[i].t3.y then
              begin
                {none}
              end else Print(false);
  end;
  t.x:=30000;
  t.y:=30000;
  for i:=1 to n do begin
    if (a[i].t2.y>=0) and (a[i].t2.x>=0) then if a[i].t2.y<=t.y then
      if a[i].t2.x<=t.x then begin
        t.x:=a[i].t2.x;
        t.y:=a[i].t2.y;
        num:=i;
      end;
  end;
  dec(a[num].t1.x,t.x);
  dec(a[num].t1.y,t.y);
  dec(a[num].t2.x,t.x);
  dec(a[num].t2.y,t.y);
  dec(a[num].t3.x,t.x);
  dec(a[num].t3.y,t.y);
  for i:=1 to n do if i<>num then begin
    dx:=a[i].t1.x-a[num].t1.x;
    dy:=a[i].t1.y-a[num].t1.y;
    dec(a[i].t1.x,dx);
    dec(a[i].t1.y,dy);
    dec(a[i].t2.x,dx);
    dec(a[i].t2.y,dy);
    dec(a[i].t3.x,dx);
    dec(a[i].t3.y,dy);
  end;
  for i:=1 to n do begin
    if (a[i].t1.x<0) or (a[i].t1.y<0) or (a[i].t2.x<0) or (a[i].t2.y<0)
      or (a[i].t3.x<0) or (a[i].t3.y<0) then Print(false);
    can:=false;
    if ((a[i].t1.x=a[num].t1.x) and (a[i].t1.y=a[num].t1.y)) or ((a[i].t2.x=a[num].t1.x)
      and (a[i].t2.y=a[num].t1.y)) or ((a[i].t3.x=a[num].t1.x) and (a[i].t3.y=a[num].t1.y)) then
      can:=true;
    if not can then print(false);
  end;
end;

begin
  INit;
  Solve;
  Print(true);
end.