{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 1000000,0,655360}
  Const Inp='chain.in';
        Out='chain.out';
        MaxN=1000;
  Type Tip=Integer;
  Var Map : Array [1..MaxN,1..MaxN] Of Byte;
      Loz : String;
      N : Tip;
      SLova : Array [1..MaxN] Of String[10];
      Stek,Answer : Array [1..MaxN*MaxN*2] Of Record
                                  From : Tip;
                                  Len : Tip;
                                  Sl : Tip;
                                End;

Procedure OpenFiles;
Begin
  Assign(Input,Inp);
  ReSet(Input);
  Assign(Output,Out);
  ReWrite(Output);
End;

Procedure ReadFile;
  Var Perebor : Tip;
Begin
  ReadLn(Loz);
  ReadLn(N);
  For perebor :=1 To N Do
    Readln(Slova[Perebor]);
End;

Function _(Const A : Char; B : String; C : Tip) : Boolean;
  Var Ok : Boolean;
      Slovo : String;
      Pol : Tip;
Begin
  Slovo :=B;
  Ok :=False;
  Pol :=0;
  While (Not Ok) And (Pos(A,Slovo)>0) Do
    Begin
      Ok :=Pos(A,Slovo)+Pol>C;
      Delete(Slovo,Pos(A,B),1);
      Inc(Pol);
    End;
  _ :=Ok;
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Procedure Solve;
  Var Per,P,Pol,Len,AnsLen,Nahoj,AnsPol : Tip;
      MayAnswer : Boolean;
      Pred : Tip;
      Slovo : String;

Procedure WriteAns(A : Tip);
Begin
  If Answer[A].From<>0 Then
    WriteAns(Answer[A].From);
  Writeln(Slova[Answer[A].Sl]);
End;

Function GetLen(Const A : Tip) : Tip;
  Var Pol,Len : Tip;
Begin
  Len :=0;
  Pol :=A;
  While Pol<>0 Do
    Begin
      Inc(Len,Length(Slova[Stek[Pol].Sl]));
      Pol :=Stek[Pol].From;
    End;
  GetLen :=Len;
End;

Begin
  MayAnswer :=False;
  AnsLen :=0;
  FillChar(Map,SIzeOf(Map),0);
  For Per :=1 To N Do
    For P :=1 To N Do
      If Slova[Per,1]=Slova[P,Length(Slova[P])] Then
        Map[P,Per] :=1;
  For Per :=1 To N Do
    If _(Loz[1],SLova[Per],0) Then
      Begin
        Pol :=1;
        Len :=1;
        FillChar(Stek,SIzeOf(Stek),0);
        Stek[1].Len :=1;
        While (Stek[Len].Len<Length(Loz)) And _(Loz[Stek[Len].Len+1],Slova[Per],Pred) Do
          Begin
            Pred :=Pos(Loz[Stek[Len].Len+1],Slova[Per]);
            Stek[Len].Len :=Stek[Len].Len+1;
          End;
        Stek[1].Sl :=Per;
        While Pol<=Len Do
          Begin
            If Stek[Pol].Len=Length(Loz) Then
              If (AnsLen=0) Or (GetLen(Pol)<AnsLen) Then
                Begin
                  MayAnswer :=True;
                  AnsPol :=Pol;
                  AnsLen :=GetLen(Pol);
                  Answer :=Stek;
                End
              Else Begin
                   End
            Else
              For P :=1 To N Do
                If (Map[Stek[Pol].Sl,P]=1) Then
                  Begin
                    Inc(Len);
                    Stek[Len].From :=Pol;
                    Stek[Len].Sl :=P;
                    Stek[Len].Len :=Stek[Pol].Len;
                    Pred :=0;
                    While (Stek[Len].Len<Length(Loz)) And _(Loz[Stek[Len].Len+1],Slova[P],Pred) Do
                      Begin
                        Pred :=Pos(Loz[Stek[Len].Len+1],Slova[P]);
                        Stek[Len].Len :=Stek[Len].Len+1;
                      End;
                  End;
            Inc(Pol);
            If Pol>N*MaxN Div 10 Then Break;
          End;
      End;
  If MayAnswer Then
    WriteAns(AnsPol)
  Else Writeln('?');
End;

Begin
  OpenFiles;
  ReadFile;
  Solve;
  CloseFiles;
End.
