{$A+,B-,D-,E+,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
Program pr_5;
const
  inpfile='glass.in';
  outfile='glass.out';
  nm=2005;
  eps=1e-6;
type
  Coord=record
    x,y : Extended;
    n : LongInt;
  end;
  Triang=record
    a,b,c : Coord;
    n : LongInt;
  end;
  Sor=record
    n,v : LongInt;
  end;
var
  a,b,c,d,e,f,g : array [1..nm] of Triang;
  ka,kb,kc,kd,kf,kg,n : LongInt;
  r : array [1..nm,1..3] of Coord;
  r1,r2,r3,r4 : Coord;
  la,lb : Extended;
  res : Boolean;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n);
  for i:=1 to n do
  begin
    read(e[i].a.x,e[i].a.y,e[i].b.x,e[i].b.y,e[i].c.x,e[i].c.y);
    e[i].a.n:=1; e[i].b.n:=2; e[i].c.n:=3;
    e[i].n:=i;
  end;
end;
{}
Procedure Out;
var
  i,j : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  if not res then writeln('NO')
  else begin
    for i:=1 to n do
    begin
      for j:=1 to 3 do write(r[i,j].x:0:0,' ',r[i,j].y:0:0,' ');
      writeln;
    end;
  end;
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(c,sizeof(c),0);
  fillchar(d,sizeof(d),0);
  fillchar(e,sizeof(e),0);
  fillchar(f,sizeof(f),0);
  fillchar(g,sizeof(g),0);
end;
{}
Function Sc(x1,y1,x2,y2 : Extended) : Extended;
begin
  Sc:=x1*x2+y1*y2;
end;
{}
Function Vc(x1,y1,x2,y2 : Extended) : Extended;
begin
  Vc:=x1*y2-y1*x2;
end;
{}
Function Eq(q,w : Extended) : Boolean;
begin
  if abs(q-w)<eps then Eq:=true
                  else Eq:=false;
end;
{}
Procedure Swap(var q,w : Coord);
var
  bak : Coord;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure BuildEF;
var
  i : LongInt;
begin
  for i:=1 to n do
  begin
    if Eq(e[i].a.x,e[i].b.x) then
    begin
      if e[i].a.y>e[i].b.y then Swap(e[i].a,e[i].b);
      inc(kf);
      f[kf]:=e[i];
    end else
    if Eq(e[i].b.x,e[i].c.x) then
    begin
      Swap(e[i].c,e[i].a);
      if e[i].a.y>e[i].b.y then Swap(e[i].a,e[i].b);
      inc(kf);
      f[kf]:=e[i];
    end else
    if Eq(e[i].a.x,e[i].c.x) then
    begin
      Swap(e[i].c,e[i].b);
      if e[i].a.y>e[i].b.y then Swap(e[i].a,e[i].b);
      inc(kf);
      f[kf]:=e[i];
    end else
    if Eq(e[i].a.y,e[i].b.y) then
    begin
      if e[i].a.x>e[i].b.x then Swap(e[i].a,e[i].b);
      inc(kg);
      g[kg]:=e[i];
    end else
    if Eq(e[i].b.y,e[i].c.y) then
    begin
      Swap(e[i].c,e[i].a);
      if e[i].a.x>e[i].b.x then Swap(e[i].a,e[i].b);
      inc(kg);
      g[kg]:=e[i];
    end else
    if Eq(e[i].a.y,e[i].c.y) then
    begin
      Swap(e[i].c,e[i].b);
      if e[i].a.x>e[i].b.x then Swap(e[i].a,e[i].b);
      inc(kg);
      g[kg]:=e[i];
    end else begin res:=false; Out; end;
  end;
end;
{}
Procedure BuildABCD;
var
  i : LongInt;
begin
  for i:=1 to kf do
    if Vc(0,f[i].b.y-f[i].a.y,f[i].c.x-f[i].a.x,f[i].c.y-f[i].a.y)>eps then
    begin
      inc(ka); la:=la+f[i].b.y-f[i].a.y;
      a[ka]:=f[i];
    end else
    begin
      inc(kb);
      b[kb]:=f[i];
    end;
  for i:=1 to kg do
    if Vc(g[i].b.x-g[i].a.x,0,g[i].c.x-g[i].a.x,g[i].c.y-g[i].a.y)>eps then
    begin
      inc(kc); lb:=lb+g[i].b.x-g[i].a.x;
      c[kc]:=g[i];
    end else
    begin
      inc(kd);
      d[kd]:=g[i];
    end;
end;
{}
Function EqP(q,w : Coord) : Boolean;
begin
  if Eq(q.x,w.x) and Eq(q.y,w.y) then EqP:=true
                                 else EqP:=false;
end;
{}
Function Check1(q,w : Triang) : Boolean;
var
  c1,c2 : Coord;
begin
  c1:=q.c;
  c2.x:=q.b.x+w.c.x-w.a.x;
  c2.y:=q.b.y+w.c.y-w.a.y;
  if EqP(c1,c2) then Check1:=true
                else Check1:=false;
end;
{}
Function Check2(q,w : Triang) : Boolean;
var
  c1,c2 : Coord;
begin
  c1:=w.c;
  c2.x:=w.b.x+q.c.x-q.a.x;
  c2.y:=w.b.y+q.c.y-q.a.y;
  if EqP(c1,c2) then Check2:=true
                else Check2:=false;
end;
{}
Procedure ConnectA;
var
  i,j,k,min,max : LongInt;
  y : Extended;
  tr : Triang;
  u : array [1..nm] of Boolean;
  s : array [1..nm] of Sor;
  {}
  Procedure SortA(l,r: LongInt);
  var
    i,j,x: LongInt;
    y : Sor;
  begin
    i:=l; j:=r; x:=s[(l+r) DIV 2].v;
    repeat
      while s[i].v<x do i:=i+1;
      while x<s[j].v do j:=j-1;
      if i<=j then
      begin
        y:=s[i]; s[i]:=s[j]; s[j]:=y;
        i:=i+1; j:=j-1;
      end;
    until i>j;
    if l<j then SortA(l,j);
    if i<r then SortA(i,r);
  end;


  {}
begin
  fillchar(u,sizeof(u),0);
  fillchar(s,sizeof(s),0);
  k:=ka; tr:=a[1]; u[1]:=true;
  j:=1; s[1].n:=a[1].n; s[1].v:=1;
  min:=1; max:=1;
  while k>1 do
  begin
    for i:=1 to ka do
    if not u[i] then
    begin
      if Check1(tr,a[i]) then
      begin
        tr.b.y:=tr.b.y+a[i].b.y-a[i].a.y;
        dec(k); u[i]:=true;
        inc(j); s[j].n:=a[i].n; s[j].v:=max+1;
        inc(max);
      end else
      if Check2(tr,a[i]) then
      begin
        tr.a.y:=tr.a.y-(a[i].b.y-a[i].a.y);
        dec(k); u[i]:=true;
        inc(j); s[j].n:=a[i].n; s[j].v:=min-1;
        dec(min);
      end;
    end;
  end;
  r1.x:=lb-(tr.a.x-tr.c.x);
  r1.y:=tr.c.y-tr.a.y;
  SortA(1,ka); y:=0;
  for i:=1 to ka do
  begin
    r[s[i].n,e[s[i].n].a.n].x:=lb;
    r[s[i].n,e[s[i].n].b.n].x:=lb;
    r[s[i].n,e[s[i].n].c.n].x:=lb+e[s[i].n].c.x-e[s[i].n].a.x;

    r[s[i].n,e[s[i].n].a.n].y:=y;
    r[s[i].n,e[s[i].n].b.n].y:=y+e[s[i].n].b.y-e[s[i].n].a.y;
    r[s[i].n,e[s[i].n].c.n].y:=y+e[s[i].n].c.y-e[s[i].n].a.y;
    y:=y+e[s[i].n].b.y-e[s[i].n].a.y;
  end;
end;
{}
Procedure ConnectB;
var
  i,j,k,min,max : LongInt;
  y : Extended;
  tr : Triang;
  u : array [1..nm] of Boolean;
  s : array [1..nm] of Sor;
  {}
  Procedure SortB(l,r: LongInt);
  var
    i,j,x: LongInt;
    y : Sor;
  begin
    i:=l; j:=r; x:=s[(l+r) DIV 2].v;
    repeat
      while s[i].v<x do i:=i+1;
      while x<s[j].v do j:=j-1;
      if i<=j then
      begin
        y:=s[i]; s[i]:=s[j]; s[j]:=y;
        i:=i+1; j:=j-1;
      end;
    until i>j;
    if l<j then SortB(l,j);
    if i<r then SortB(i,r);
  end;


  {}
begin
  fillchar(u,sizeof(u),0);
  fillchar(s,sizeof(s),0);
  k:=kb; tr:=b[1]; u[1]:=true;
  j:=1; s[1].n:=b[1].n; s[1].v:=1;
  min:=1; max:=1;
  while k>1 do
  begin
    for i:=1 to kb do
    if not u[i] then
    begin
      if Check1(tr,b[i]) then
      begin
        tr.b.y:=tr.b.y+b[i].b.y-b[i].a.y;
        dec(k); u[i]:=true;
        inc(j); s[j].n:=b[i].n; s[j].v:=max+1;
        inc(max);
      end else
      if Check2(tr,b[i]) then
      begin
        tr.a.y:=tr.a.y-(b[i].b.y-b[i].a.y);
        dec(k); u[i]:=true;
        inc(j); s[j].n:=b[i].n; s[j].v:=min-1;
        dec(min);
      end;
    end;
  end;
  r2.x:=tr.c.x-tr.a.x;
  r2.y:=tr.c.y-tr.a.y;
  SortB(1,kb); y:=0;
  for i:=1 to kb do
  begin
    r[s[i].n,e[s[i].n].a.n].x:=0;
    r[s[i].n,e[s[i].n].b.n].x:=0;
    r[s[i].n,e[s[i].n].c.n].x:=e[s[i].n].c.x-e[s[i].n].a.x;

    r[s[i].n,e[s[i].n].a.n].y:=y;
    r[s[i].n,e[s[i].n].b.n].y:=y+e[s[i].n].b.y-e[s[i].n].a.y;
    r[s[i].n,e[s[i].n].c.n].y:=y+e[s[i].n].c.y-e[s[i].n].a.y;
    y:=y+e[s[i].n].b.y-e[s[i].n].a.y;
  end;
end;
{}
Procedure ConnectC;
var
  i,j,k,min,max : LongInt;
  x : Extended;
  tr : Triang;
  u : array [1..nm] of Boolean;
  s : array [1..nm] of Sor;
  {}
  Procedure SortC(l,r: LongInt);
  var
    i,j,x: LongInt;
    y : Sor;
  begin
    i:=l; j:=r; x:=s[(l+r) DIV 2].v;
    repeat
      while s[i].v<x do i:=i+1;
      while x<s[j].v do j:=j-1;
      if i<=j then
      begin
        y:=s[i]; s[i]:=s[j]; s[j]:=y;
        i:=i+1; j:=j-1;
      end;
    until i>j;
    if l<j then SortC(l,j);
    if i<r then SortC(i,r);
  end;


  {}
begin
  fillchar(u,sizeof(u),0);
  fillchar(s,sizeof(s),0);
  k:=kc; tr:=c[1]; u[1]:=true;
  j:=1; s[1].n:=c[1].n; s[1].v:=1;
  min:=1; max:=1;
  while k>1 do
  begin
    for i:=1 to kc do
    if not u[i] then
    begin
      if Check1(tr,c[i]) then
      begin
        tr.b.x:=tr.b.x+c[i].b.x-c[i].a.x;
        dec(k); u[i]:=true;
        inc(j); s[j].n:=c[i].n; s[j].v:=max+1;
        inc(max);
      end else
      if Check2(tr,c[i]) then
      begin
        tr.a.x:=tr.a.x-(c[i].b.x-c[i].a.x);
        dec(k); u[i]:=true;
        inc(j); s[j].n:=c[i].n; s[j].v:=min-1;
        dec(min);
      end;
    end;
  end;
  r3.x:=tr.c.x-tr.a.x;
  r3.y:=tr.c.y-tr.a.y;
  SortC(1,kc); x:=0;
  for i:=1 to kc do
  begin
    r[s[i].n,e[s[i].n].a.n].y:=0;
    r[s[i].n,e[s[i].n].b.n].y:=0;
    r[s[i].n,e[s[i].n].c.n].y:=e[s[i].n].c.y-e[s[i].n].a.y;

    r[s[i].n,e[s[i].n].a.n].x:=x;
    r[s[i].n,e[s[i].n].b.n].x:=x+e[s[i].n].b.x-e[s[i].n].a.x;
    r[s[i].n,e[s[i].n].c.n].x:=x+e[s[i].n].c.x-e[s[i].n].a.x;
    x:=x+e[s[i].n].b.x-e[s[i].n].a.x;
  end;
end;

{}
Procedure ConnectD;
var
  i,j,k,min,max : LongInt;
  x : Extended;
  tr : Triang;
  u : array [1..nm] of Boolean;
  s : array [1..nm] of Sor;
  {}
  Procedure SortD(l,r: LongInt);
  var
    i,j,x: LongInt;
    y : Sor;
  begin
    i:=l; j:=r; x:=s[(l+r) DIV 2].v;
    repeat
      while s[i].v<x do i:=i+1;
      while x<s[j].v do j:=j-1;
      if i<=j then
      begin
        y:=s[i]; s[i]:=s[j]; s[j]:=y;
        i:=i+1; j:=j-1;
      end;
    until i>j;
    if l<j then SortD(l,j);
    if i<r then SortD(i,r);
  end;


  {}
begin
  fillchar(u,sizeof(u),0);
  fillchar(s,sizeof(s),0);
  k:=kd; tr:=d[1]; u[1]:=true;
  j:=1; s[1].n:=d[1].n; s[1].v:=1;
  min:=1; max:=1;
  while k>1 do
  begin
    for i:=1 to kd do
    if not u[i] then
    begin
      if Check1(tr,d[i]) then
      begin
        tr.b.x:=tr.b.x+d[i].b.x-d[i].a.x;
        dec(k); u[i]:=true;
        inc(j); s[j].n:=d[i].n; s[j].v:=max+1;
        inc(max);
      end else
      if Check2(tr,d[i]) then
      begin
        tr.a.x:=tr.a.x-(d[i].b.x-d[i].a.x);
        dec(k); u[i]:=true;
        inc(j); s[j].n:=d[i].n; s[j].v:=min-1;
        dec(min);
      end;
    end;
  end;
  r4.x:=tr.c.x-tr.a.x;
  r4.y:=la-(tr.a.y-tr.c.y);
  SortD(1,kd); x:=0;
  for i:=1 to kd do
  begin
    r[s[i].n,e[s[i].n].a.n].y:=la;
    r[s[i].n,e[s[i].n].b.n].y:=la;
    r[s[i].n,e[s[i].n].c.n].y:=la+e[s[i].n].c.y-e[s[i].n].a.y;

    r[s[i].n,e[s[i].n].a.n].x:=x;
    r[s[i].n,e[s[i].n].b.n].x:=x+e[s[i].n].b.x-e[s[i].n].a.x;
    r[s[i].n,e[s[i].n].c.n].x:=x+e[s[i].n].c.x-e[s[i].n].a.x;
    x:=x+e[s[i].n].b.x-e[s[i].n].a.x;
  end;
end;

{}
Procedure Solve;
var
  i,j : LongInt;
begin
  res:=true; la:=0; lb:=0;
  ka:=0; kb:=0; kc:=0; kd:=0; kf:=0; kg:=0;
  BuildEF;
  if (kf<2) or (kg<2) then begin res:=false; Out; end;
  BuildABCD;
  ConnectA;
  ConnectB;
  ConnectC;
  ConnectD;
  if (ka=0) or (kb=0) or (kc=0) or (kd=0) then begin res:=false; Out; end;
  if not (EqP(r1,r2) and EqP(r2,r3) and EqP(r3,r4)) then res:=false;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
