program problemF;

procedure readInput(var inputFile: text; var N: longint; var K: longint);
    begin
        reset(inputFile);
        read(inputFile, n);
        read(inputFile, k);
        close(inputFile);
    end;{readInput}

procedure writeOutput(n, k: longint; var outputFile: text);
    var i, normal, extra, res: longint;
    begin
        rewrite(outputFile);
        if ((n div 2)*2<>n)
            then write(outputFile, 'NO')
            else begin
                normal:=trunc(sqrt(k));
                extra:=k-normal*normal;
                res:=n-(4*(normal+1)+2*extra);
                if (n<4*(normal+1)+2*extra)
                    then write(outputFile, 'NO')
                    else begin
                        writeln(outputFile, 'YES');
                        for i:=0 to normal+extra+1 do
                        begin
                            write(outputFile, i);
                            write(outputFile, ' ');
                            write(outputFile, 0);
                            write(outputFile, ' ');
                        end;
                        write(outputFile, normal+extra+1);
                        write(outputFile, ' ');
                        write(outputFile, 1);
                        write(outputFile, ' ');
                        for i:=normal+extra+1 downto normal+1 do
                        begin
                            write(outputFile, i);
                            write(outputFile, ' ');
                            write(outputFile, 2);
                            write(outputFile, ' ');
                        end;
                        for i:=3 to normal+1 do
                        begin
                            write(outputFile, normal+1);
                            write(outputFile, ' ');
                            write(outputFile, i);
                            write(outputFile, ' ');
                        end;
                        for i:=normal downto 0 do
                        begin
                            write(outputFile, i);
                            write(outputFile, ' ');
                            write(outputFile, normal+1);
                            write(outputFile, ' ');
                        end;
                        for i:=normal downto 1 do
                        begin
                            write(outputFile, 0);
                            write(outputFile, ' ');
                            write(outputFile, i);
                            write(outputFile, ' ');
                        end;
                        for i:=-1 downto -(res div 2) do
                        begin
                            write(outputFile, i);
                            write(outputFile, ' ');
                            write(outputFile, 1);
                            write(outputFile, ' ');
                        end;
                        for i:=-(res div 2) to -1 do
                        begin
                            write(outputFile, i);
                            write(outputFile, ' ');
                            write(outputFile, 0);
                            write(outputFile, ' ');
                        end;
                    end;
            end;
        close(outputFile);
    end;{writeOutput}

var
    n, k: longint;
    inputFile, outputFile: text;

begin
    assign(inputFile, 'squares.in');
    assign(outputFile, 'squares.out');
    readInput(inputFile, n, k);
    writeOutput(n, k, outputFile);
end.{problemF}