#include <stdio.h>
#include <math.h>

long S = 0;

void line( FILE *O, long x, long y, long x1, long y1 )
{
  int di = 1;
  long i;

  if (x == x1 && y == y1)
  {
    fprintf(O, "%li %li  ", x, y);
    S++;
    return;
  }

  if (x == x1)
  {
    if (y1 < y)
      di = -1;

    for (i = y + di; i != y1; i += di, S++)
      fprintf(O, "%li %li  ", x, i);
    fprintf(O, "%li %li  ", x, i);
    S++;
  }
  else
  {
    if (x1 < x)
      di = -1;

    for (i = x + di; i != x1; i += di, S++)
      fprintf (O, "%li %li  ", i, y);
    fprintf (O, "%li %li  ", i, y);
    S++;
  }
}

int main( void )
{
  FILE *I, *O;
  long N, K, a, ost, j;

  I = fopen ("squares.in", "rt");
  O = fopen ("squares.out", "wt");

  fscanf(I, "%li%li", &N, &K);

  a = (long) sqrtl(K);
  ost = K - a * a;

  if (ost != 0)
  {
    if ((ost <= a) && (4 * a + 6 > N))
    {
      fprintf(O, "NO\n");
      fclose(I);
      fclose(O);

      return 0;
    }

    if ((ost > a) && ((a + 1) * 2 + 2 * a + 6 > N))
    {
      fprintf(O, "NO\n");
      fclose(I);
      fclose(O);

      return 0;
    }
  }
  else if (N < 4 * a + 4)
  {
    fprintf(O, "NO\n");
    fclose(O);
    fclose(I);
    return 0;
  }

  if (a * a == K)
  {
    fprintf(O, "YES\n");
    line(O, 0, 0, 0, 0);
    line(O, 0, 0, 0, a + 1);
    line(O, 0, a + 1, a + 1, a + 1);
    line(O, a + 1, a + 1, a + 1, 0);
    line(O, a + 1, 0, 1, 0);
  }
  else if (ost < a)
  {
    fprintf(O, "YES\n");
    line(O, 0, 0, 0, 0);
    line(O, 0, 0, 0, a + 2);
    line(O, 0, a + 2, ost + 1, a + 2);
    line(O, ost + 1, a + 2, ost + 1, a + 1);
    line(O, ost + 1, a + 1, a + 1, a + 1);
    line(O, a + 1, a + 1, a + 1, 0);
    line(O, a + 1, 0, 1, 0);
  }
  else if (ost == a)
  {
    fprintf(O, "YES\n");
    line(O, 0, 0, 0, 0);
    line(O, 0, 0, 0, a + 2);
    line(O, 0, a + 2, a + 1, a + 2);
    line(O, a + 1, a + 2, a + 1, 0);
    line(O, a + 1, 0, 1, 0);
  }
  else if (ost > a)
  {
    fprintf(O, "YES\n");
    line(O, 0, 0, 0, 0);
    line(O, 0, 0, 0, a + 2);
    line(O, 0, a + 2, a + 2, a + 2);
    line(O, a + 2, a + 2, a + 2, 2 * a - ost + 1);
    line(O, a + 2, 2 * a - ost + 1, a + 1, 2 * a - ost + 1);
    line(O, a + 1, 2 * a - ost + 1, a + 1, 0);
    line(O, a + 1, 0, 1, 0);
  }

  j = N - S;

  if (j % 2 == 0 && j > 2)
  {
    line(O, 1, 0, 1, -(int) j / 2);
    line(O, 1, -(int) j / 2, 0, -(int) j / 2);
    line(O, 0, -(int) j / 2, 0, -1);
  }
  else if (j == 2 && j % 2 == 0)
  {
    line(O, 1, 0, 1, -1);
    line(O, 1, -1, 0, -1);
  }
  else if (j != 0)
  {
    fclose(O);
    O = fopen("squares.out", "wt");
    fprintf(O, "NO\n");
  }

  fclose(I);
  fclose(O);

  return 0;
}

