#include <stdio.h>
#include <stdlib.h>
#include <math.h>

typedef struct {
	int x;
	int y;
}coord;

int main() {
	FILE *in = fopen("squares.in", "r"),
		*out = fopen("squares.out", "w");

	coord *arr;
	int n, k, i, j, tmp, local, yo1, yo2;
	int a, b;

	fscanf(in, "%d%d", &n, &k);

	a = (n-4)/4;
	b = ((n-4)-a*2)/2;

	if((n % 2 != 0) ||
	   (n < 4) ||
	   (a * b < k)) {
		fprintf(out, "NO\n");
		fclose(in);
		fclose(out);
		return 0;
	}

	arr = (coord *)calloc((n + 10),sizeof(coord));

	local = 0;

	// |
	// |
	// |

	for(i=0; i<a+2; i++) {
		arr[local].x = 0;
		arr[local].y = i;
		local ++;
	}

	// |---
	// |
	// |

	tmp = k/a;
	tmp = (tmp * a == k) ? tmp : tmp+1;
	if(k % a != 0) {
		for(i=0; i<tmp-1; i++) {
			arr[local].x = i+1;
			arr[local].y = a+1;
			local ++;
		}

		// |---|
		// |   |
		// |

		for(i=0; i<=a-k%a; i++) {
			arr[local].x = tmp;
			arr[local].y = a-i+1;
			local ++;
		}

		yo1 = arr[local-1].x;
		yo2 = arr[local-1].y;

		// |---|
		// |   |--|
		// |      |
		// |

		for(i=0; i<=k%a; i++) {
			arr[local].x = yo1+1;
			arr[local].y = yo2-i;
			local ++;
		}

		// |---|
		// |   |-|
		// |     |---
		// |


		yo1 = arr[local-1].x;

		for(i=0; i<b+1-yo1; i++) {
			arr[local].x = i+yo1+1;
			arr[local].y = 1;
			local ++;
		}
	}else {
		for(i=0; i<tmp; i++) {
			arr[local].x = i+1;
			arr[local].y = a+1;
			local ++;
		}

		// |---|
		// |   |
		// |

		for(i=0; i<=a; i++) {
			arr[local].x = tmp+1;
			arr[local].y = a-i+1;
			local ++;
		}

		yo1 = arr[local-1].x;

		// |---|
		// |   |--|
		// |      |
		// |

		for(yo1=yo1+1; yo1<=b+1; yo1++) {
			arr[local].x = yo1;
			arr[local].y = 1;
			local ++;
		}
	}

	// |---|
	// |   |--|
	// |      |---|
	// |----------|

	for(i=0; i<b+2; i++) {
		arr[local].x = b-i+1;
		arr[local].y = 0;
		local ++;
	}

	// print result...
	fprintf(out, "YES\n");
	for(i=0; i<n; i++) {
		fprintf(out, "%d %d\n", arr[i].x, arr[i].y);
	}

	fclose(in);
	fclose(out);
	return 0;
}