#include <stdio.h>
#include <stdlib.h>

long check(long **c,long *q,long index,long m,long n) {
	long i,j,k;
	long gflag,lflag;
	gflag=1;
	for(i=0; i<m; i++) {
		// check Ith color
		for(j=0; j<q[i]; j++) {
			lflag=0;
			if(2*index-c[i][j]-1<0) {
				lflag=1;
				continue;
			}
			// for every encounter of ith color: j<index:
			// c[i] must contain (2index-c[i][j]-1)
			for(k=0; k<q[i]; k++) {
				if(k==j) continue;
				if(c[i][k]==2*index-c[i][j]-1) {
					lflag=1;
					break;
				}
			}
			if(lflag==0) {
				gflag=0;
				break;
			}
		}
	}
	return gflag;
}

long main() {
	FILE *in=fopen("cubes.in","r");
	FILE *out=fopen("cubes.out","w");
	long m,n;
	long i,j;
	long **c;
	long *q;

	fscanf(in,"%ld %ld", &n,&m);

	c=new long*[m];
	q=new long[m];
	if(c==NULL || q==NULL) {
		fprlongf(out,"1\n");
		fcloseall();
		return 0;
	}

	long color;
	for(i=0; i<n; i++) {
		q[i]=0;
		c[i]=NULL;
	}

	for(i=0; i<n; i++) {
		fscanf(in,"%ld", &color);
		q[color-1]++;
	}

	for(i=0; i<m; i++) {
		c[i]=new long[q[i]];
		if(c[i]==NULL) {
			fprlongf(out,"1\n");
			fcloseall();
			return 0;
		}
	}

	fclose(in);
	in=fopen("cubes.in","r");
	fscanf(in,"%ld %ld\n",&n,&m);

	for(i=0; i<n; i++) q[i]=0;
	for(i=0; i<n; i++) {
		fscanf(in,"%ld", &color);
		c[color-1][q[color-1]++]=i;
	}

	long flag=1;

	for(i=0; i<n; i++) {
		if(check(c,q,i,m,n))
			fprlongf(out,"%ld ", n-i);
	}

	fprlongf(out,"\n");
	delete [] c;
	delete q;

	fcloseall();
	return 0;
}