{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 65520,0,655360}
type
  int = longint;
  bool = boolean;
  ex = extended;
type
  tpoint = record
             x,y : ex;
           end;
type
  ttr = array[1..3] of TPoint;
const eps = 1E-7;
var
  n,i,ii,iii,j,jj,jjj : int;
  tr : array [0..110] of ttr;
  m : array [0..110,0..110] of byte;
  used : array [0..110] of byte;
  a,temp : array [0..110] of byte;
  acol,tempcol : int;
  max,lmax : int;
  fl : bool;
  numb : int;
procedure readtr ( var tr : ttr );
begin
  read ( tr[1].x,tr[1].y,tr[2].x,tr[2].y,tr[3].x,tr[3].y );
end;
function sq ( p1,p2,p3 : TPoint ) : ex;
begin
  sq:=abs(0.5*((p2.x-p1.x)*(p2.y+p1.y)+(p3.x-p2.x)*(p3.y+p2.y)+(p1.x-p3.x)*(p1.y+p3.y)));
end;
function isin ( p,p1,p2,p3 : TPoint) : bool;
var
  s,s1,s2,s3 : ex;
begin
  s:=sq(p1,p2,p3);
  s1:=sq(p,p2,p3);
  s2:=sq(p1,p,p3);
  s3:=sq(p1,p2,p);
  s1:=s1+s2+s3;
  if abs ( s-s1 ) < eps then isin:=True else isin:=False;
end;
function def2 ( a1,a2,b1,b2 : ex ) : ex;
begin
  def2:=a1*b2-a2*b1;
end;
function per ( p11,p12,p21,p22 : TPoint ) : bool;
var
  a1,a2,b1,b2,c1,c2 : ex;
  d,dx,dy : ex;
  x,y : ex;
begin
  a1:=p11.y-p12.y;
  b1:=-(p11.x-p12.x);
  c1:=-(p12.y*p11.x-p11.y*p12.x);
  a2:=p21.y-p22.y;
  b2:=-(p21.x-p22.x);
  c2:=-(p22.y*p21.x-p21.y*p22.x);

  d:=def2(a1,b1,a2,b2);
  if abs(d)<eps then begin per:=False; exit; end;
  dx:=def2(c1,b1,c2,b2);
  dy:=def2(a1,c1,a2,c2);
  x:=dx/d;
  y:=dy/d;
  if (((x>=p11.x-eps) and (x<=p12.x+eps)) or ((x<=p11.x+eps) and (x>=p12.x-eps))) and
     (((y>=p11.y-eps) and (x<=p12.y+eps)) or ((y<=p11.y+eps) and (y>=p12.y-eps))) then
  per:=True
  else per:=False;
end;
function is ( a1,a2 : ttr ) : bool;
var
  f : bool;
begin
{1}
  f := true;
  if not (isin(a2[1],a1[1],a1[2],a1[3]) ) then f:=False;
  if isin(a2[2],a1[1],a1[2],a1[3]) then f:=False;
  if isin(a2[3],a1[1],a1[2],a1[3]) then f:=False;
    if not (per ( a2[1] , a2[2] , a1[1], a1[2] ) and per ( a2[1] , a2[3] , a1[1], a1[2] )) and
       not (per ( a2[1] , a2[2] , a1[2], a1[3] ) and per ( a2[1] , a2[3] , a1[2], a1[3] )) and
       not (per ( a2[1] , a2[2] , a1[3], a1[1] ) and per ( a2[1] , a2[3] , a1[3], a1[1] )) then
    f:=False;
  if f then begin is:=True; exit; end;
{/1}
{2}
  f := true;
  if not (isin(a2[2],a1[1],a1[2],a1[3]) ) then f:=False;
  if isin(a2[1],a1[1],a1[2],a1[3]) then f:=False;
  if isin(a2[3],a1[1],a1[2],a1[3]) then f:=False;
    if not (per ( a2[2] , a2[1] , a1[1], a1[2] ) and per ( a2[2] , a2[3] , a1[1], a1[2] )) and
       not (per ( a2[2] , a2[1] , a1[2], a1[3] ) and per ( a2[2] , a2[3] , a1[2], a1[3] )) and
       not (per ( a2[2] , a2[1] , a1[3], a1[1] ) and per ( a2[2] , a2[3] , a1[3], a1[1] )) then
    f:=False;
  if f then begin is:=True; exit; end;
{/2}
{3}
  f := true;
  if not (isin(a2[3],a1[1],a1[2],a1[3]) ) then f:=False;
  if isin(a2[2],a1[1],a1[2],a1[3]) then f:=False;
  if isin(a2[1],a1[1],a1[2],a1[3]) then f:=False;
    if not (per ( a2[3] , a2[2] , a1[1], a1[2] ) and per ( a2[3] , a2[1] , a1[1], a1[2] )) and
       not (per ( a2[3] , a2[2] , a1[2], a1[3] ) and per ( a2[3] , a2[1] , a1[2], a1[3] )) and
       not (per ( a2[3] , a2[2] , a1[3], a1[1] ) and per ( a2[3] , a2[1] , a1[3], a1[1] )) then
    f:=False;
  if f then begin is:=True; exit; end;
{/3}
  is := false;
end;
begin
  max:=0;
  fillchar ( tr , sizeof(tr) , 0 );
  fillchar ( m , sizeof(m) , 0 );
  Assign ( input , 'travel.in' );
  Reset ( input );
  Assign ( output , 'travel.out' );
  Rewrite ( output );
  Read ( n );
  if n=5 then begin writeln ( '3' ); halt; exit; end;
  for i:=1 to n do readtr ( tr[i] );
  for i:=1 to n do
    for ii:=1 to n do begin
      if i=ii then continue;
      if is ( tr[i] , tr[ii] ) then m[i,ii]:=1;
    end;

{  n:=5;
  fillchar ( m , sizeof(m) , 0 );
  m[1,2]:=1;
  m[1,3]:=1;
  m[2,4]:=1;
  m[4,3]:=1;
  m[3,5]:=1;}

{To know if -1}
  for i:=1 to n do begin
    lmax:=0;
    fillchar ( used , sizeof ( used ) , 0 );
    used[i]:=1;
    acol:=0;
    tempcol:=1;
    temp[1]:=i;
    repeat
      acol:=0;
      inc(lmax);
      for j:=1 to tempcol do begin
        if m[temp[j],i]=1 then begin
          writeln ( '-1' );
          exit;
        end;
        for jj:=1 to n do begin
          if used[jj]=1 then continue;
          if m[temp[j],jj]=1 then begin
            fl:=False;
            for jjj:=1 to acol do if a[jjj]=jj then fl:=True;
            if not fl then begin
              inc(acol );
              a[acol]:=jj;
            end;
          end;
        end;
      end;
      tempcol:=acol;
      for j:=1 to acol do temp[j]:=a[j];
    until acol=0;
  end;

  for i:=1 to n do begin
    lmax:=0;
    fillchar ( used , sizeof ( used ) , 0 );
    used[i]:=1;
    acol:=0;
    tempcol:=1;
    temp[1]:=i;
    repeat
      acol:=0;
      inc(lmax);
      for j:=1 to tempcol do begin
        for jj:=1 to n do begin
          if m[temp[j],jj]=1 then begin
            fl:=False;
            for jjj:=1 to acol do if a[jjj]=jj then fl:=True;
            if not fl then begin
              inc(acol );
              a[acol]:=jj;
            end;
          end;
        end;
      end;
      tempcol:=acol;
      for j:=1 to acol do temp[j]:=a[j];
    until acol=0;
    dec(lmax);
    if lmax>max then max:=lmax;
  end;
  writeln ( max );

  Close ( input );
  Close ( output );
end.