{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 16384,0,655360}
{$R+,S+,Q+}
  Const
    inp = 'c.in';
    out = 'c.out';
    MaxN = 1000;

  Type
    TA = Array [0..MaxN] Of Longint;

  Var
    b, a: TA;
    Num, Res: Array [0..MaxN] Of Integer;
    N: Integer;

  Procedure Init;
    Var i: Integer; ch: Char;
  Begin
    Assign(input, inp); Reset(input);
     a[0] := 10001000; n := 0;
     While Not SeekEof Do
      Begin
        Read(ch); inc(n);
        Case UpCase(ch) of
         'E': a[n] := a[n-1] + 10000;
         'W': a[n] := a[n-1] - 10000;
         'N': a[n] := a[n-1] + 1;
         'S': a[n] := a[n-1] - 1;
        End;
      End;
     b := a;
    Close(input);
  End;

  Procedure Swap(i,j: Integer);
    Var c: Longint;
  Begin
    c := Num[i]; Num[i] := Num[j]; Num[j] := c;
    c := a[i]; a[i] := a[j]; a[j] := c;
  End;

  Procedure QSort(b,l: Integer);
    Var i,j: Integer; x: Longint;
  Begin
    i := b; j := l; x := a[(i+j) shr 1];
    Repeat
      While (x > a[i]) Do inc(i);
      While (x < a[j]) Do dec(j);
      If i <= j Then
       Begin
         Swap(i,j); inc(i); dec(j);
       End;
    Until i > j;
    If b < j Then QSort(b,j);
    If i < l Then QSort(i,l);
  End;

  Procedure Invert(x,y: Integer);
    Var i, cx, cy, t: Integer;
  Begin
    i := 1; cx := 0; cy := 0;
    While (cx=0) Or (cy=0) Do
     Begin
       if Res[i] = x Then cx := i;
       if Res[i] = y Then cy := i;
       inc(i);
     End;
    If (cx > cy) Then Begin i := cy; cy := cx; cx := i End;
    For i := cx To (cy+cx) shr 1 Do
     Begin t := Res[i]; Res[i] := Res[cy-i+cx]; Res[cy-i+cx] := t End;
  End;

  Procedure Solve;
    Var i: Integer; t: Longint;
  Begin
    For i := 1 to N Do num[i] := i;
    Res := Num; Res[0] := 0;
    If n >= 2 Then QSort(1, N-1);
    For i := 2 To N-1 Do
     Begin
       t := abs(b[Num[i]+1]-b[Num[i]-1]);
       If (a[i-1] = a[i]) And ((t = 2) Or (t = 20000)) Then 
         Invert(Num[i-1], Num[i]);
     End;
  End;

  Procedure OutD(x1,x2: Longint);
  Begin
    Case x2-x1 Of
          1: Write('N');
         -1: Write('S');
      10000: Write('E');
     -10000: Write('W');
    End;
  End;

  Procedure Done;
    Var i: Integer;
  Begin
    Assign(output, out); Rewrite(output);
     For i := 1 To N Do OutD(b[Res[i-1]], b[Res[i]]);
    Close(output);
  End;

BEGIN
  Init; Solve; Done;
END.