{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 16384,0,655360}
{$R+,S+,Q+}
  Const
    MaxN = 1000;

  Type
    Float = Extended;
    TPoint = Record
               x,y: Longint;
             End;

  Var N: Integer;
      P: Array [1..MaxN] Of TPoint;
      Sc: Array [1..MaxN] Of Longint;
      Best: Float;

  Procedure Init;
    Var i: Integer;
  Begin
    Assign(input,'d.in'); Reset(input);
      Read(N); For i := 1 To N Do With p[i] Do Read(x,y);
    Close(input);
  End;

  Function GLine(Const p1,p2,p: TPoint): Longint;
  Begin
    GLine := (p.x-p1.x)*(p2.y-p1.y) - (p.y-p1.y)*(p2.x-p1.x);
  End;

  Function Search(a,b: Integer): Integer;
    Var i: Integer;
  Begin
    i := 1; While (i < n) And (GLine(p[a],p[b],p[i]) = 0) Do inc(i);
    Search := i;
  End;

  Procedure Swap(i,j: Integer);
    Var c: TPoint; t: Longint;
  Begin
    c := p[i]; p[i] := p[j]; p[j] := c;
    t := sc[i]; sc[i] := sc[j]; sc[j] := t;
  End;

  Procedure QSort(b,l: Integer);
    Var i,j: Integer; x: Longint;
  Begin
    i := b; j := l; x := Sc[(i+j) shr 1];
    Repeat
      While (x > sc[i]) Do inc(i);
      While (x < sc[j]) Do dec(j);
      If i<=j Then
       Begin
         Swap(i,j); Inc(i); Dec(j);
       End;
    Until i>j;
    If i < l Then QSort(i,l);
    If b < j Then QSort(b,j);
  End;

  Function Len(a,b: Integer): Float;
  Begin
    Len := Sqrt(Sqr(p[a].x-p[b].x)+Sqr(p[a].y-p[b].y));
  End;

  Function Min(a,b: Float): Float;
  Begin
    If a < b Then Min := a Else Min := b;
  End;

  Procedure Solve;
    Var r,i: Integer; t: Float;
  Begin
    If GLine(p[1],p[2],p[3]) = 0 Then r := Search(1,2)
    Else If N > 3 Then
      Begin
        If GLine(p[1],p[2],p[4]) = 0 Then r := Search(1,2) Else
        If GLine(p[2],p[3],p[4]) = 0 Then r := Search(2,3) Else
        If GLine(p[1],p[3],p[4]) = 0 Then r := Search(1,3) Else
         WriteLn('Error');
      End
    Else r := 3;
    Swap(n,r);
    For i := 1 To n-1 Do
      sc[i] := (p[2].x-p[1].x)*(p[i].x-p[1].x) +
               (p[2].y-p[1].y)*(p[i].y-p[1].y);
    QSort(1, n-1);
    Best := Len(1,n-1) + Min(Len(n,1), Len(n,n-1));
    For i := 1 To N-2 Do
     Begin
       t := Len(1,i) + Len(i+1,n-1);
       Best := Min(Best,t+Len(i,n)+Len(i+1,n));
       Best := Min(Best,t+Len(i,n)+Len(n-1,n));
       Best := Min(Best,t+Len(1,n)+Len(i+1,n));
       Best := Min(Best,t+Len(1,n)+Len(n-1,n));
     End;
  End;

  Procedure Done;
  Begin
    Assign(output, 'd.out'); Rewrite(output);
      WriteLn(Best:0:15);
    Close(output);
  End;

BEGIN
  Init; Solve; Done;
END.