Program ColouredPermutations;
Const
  InFile='perm.in';
  OutFile='perm.out';
  MaxN=100002;
  NCol=3;
  ColName:Array[1..NCol]Of Char='RGB';
Type
  Integer=LongInt;
Type
  TPerm=Array[1..MaxN]Of Integer;
Var
  N:Integer;
  A,B,UnB,C:TPerm;
  Col,Res:Array[1..MaxN]Of Integer;
  Last:Array[1..MaxN]Of Integer;
  IsSol:Boolean;
Procedure ReadPerm(Var A:TPerm);
Var
  I:Integer;
Begin
  For I:=1 To N Do
    Read(A[I]);
End;
Procedure Load;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N);
  ReadPerm(A);
  ReadPerm(B);
  Close(Input);
End;
Procedure Solve;
Var
  I,J:Integer;
  Ok:Boolean;
Begin
  For I:=1 To N Do
    UnB[B[I]]:=I;
  For I:=1 To N Do
    C[I]:=UnB[A[I]];
  FillChar(Last,SizeOf(Last),0);
  IsSol:=False;
  For I:=1 To N Do Begin
    Ok:=False;
    For J:=1 To NCol Do
      If Last[J]<C[I] Then Begin
        Last[J]:=C[I];
        Col[I]:=J;
        Ok:=True;
        Break;
      End;
    If Not Ok Then Exit;
  End;
  For I:=1 To N Do
    Res[A[I]]:=Col[I];
  IsSol:=True;
End;
Procedure Save;
Var
  I:Integer;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  If IsSol Then Begin
    For I:=1 To N Do
      Write(ColName[Res[I]]);
    WriteLn;
  End Else WriteLn('NO');
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.
