{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}

program Dyatlov_AND_Orlov;
const infile = 'birds.in'; outfile = 'birds.out'; max = 105;
type pt = record x,y: longint; end;
var r,d: array [1..max] of pt;
    sd,sr: array [1..max,1..max,1..max] of longint;
    ans: array [1..max] of longint;
    n,m,na: longint;

function s(e1,e2,e3: pt): longint;
begin
     s:=abs(e1.x*e2.y-e2.x*e1.y+e2.x*e3.y-e3.x*e2.y+e3.x*e1.y-e1.x*e3.y);
end;

procedure init;
var i: longint;
begin
     assign(input,infile);
     reset(input);
     read(n);
     for i:=1 to n do read(r[i].x,r[i].y);
     read(m);
     for i:=1 to m do read(d[i].x,d[i].y);
     close(input);
end;

procedure check_tr;
var i,j,k,p,mi,mj,mk: longint;
begin
     for i:=1 to n do
         for j:=1 to n do if i <> j then
             for k:=1 to m do
                 sd[k,i,j]:=s(d[k],r[i],r[j]);
     for i:=1 to n do
         for j:=1 to n do if (j <> i) then
             for k:=1 to n do if (k <> j)and(k <> i) then
                 sr[i,j,k]:=s(r[i],r[j],r[k]);
     mi:=0; mj:=0; mk:=0; na:=0;
     for i:=1 to n-2 do
         for j:=i+1 to n-1 do
             for k:=j+1 to n do begin
                 for p:=1 to m do
                     if sd[p,i,j]+sd[p,i,k]+sd[p,k,j] = sr[i,j,k] then break;
                 if sd[p,i,j]+sd[p,i,k]+sd[p,k,j] = sr[i,j,k] then continue;
                 if (mi = 0)or(sr[i,j,k] > sr[mi,mj,mk]) then begin
                    mi:=i; mj:=j; mk:=k;
                 end;
             end;
     if mi > 0 then begin na:=3; ans[1]:=mi; ans[2]:=mj; ans[3]:=mk; end;
end;

function se(e1,e2,e3: pt): longint;
begin
     se:=e1.x*e2.y-e2.x*e1.y+e2.x*e3.y-e3.x*e2.y+e3.x*e1.y-e1.x*e3.y;
end;

procedure find_f(var f: longint);
var i,e: longint;
begin
     e:=1;
     for i:=1 to n do
         if (r[i].x < r[e].x)or((r[i].x = r[e].x)and(r[i].y < r[e].y)) then e:=i;
     f:=e;
end;

function dist(e1,e2: pt): longint;
begin
     dist:=(e1.x-e2.x)*(e1.x-e2.x)+(e1.y-e2.y)*(e1.y-e2.y);
end;

procedure solve;
var i,j,v,h,t,s,sm: longint;
    nnew,b: array [1..max] of longint;
begin
     fillchar(nnew,SizEOf(nnew),0);
     find_f(v); h:=1; b[1]:=v;
     repeat
           t:=1;
           while (nnew[t] = 1) do inc(t);
           for i:=1 to n do
               if (se(r[b[h]],r[i],r[t]) < 0)or((se(r[b[h]],r[i],r[t]) = 0)and
                  (dist(r[b[h]],r[i]) > dist(r[b[h]],r[t]))) then t:=i;
           inc(h); b[h]:=t;
     until t = v;
     sm:=0; dec(h);
     for i:=2 to h do
         sm:=sm+sr[b[1],b[i],b[i mod h+1]];
     for i:=1 to m do begin
         s:=0;
         for j:=1 to h do
             s:=s+sd[i,b[j],b[j mod h+1]];
         if s = sm then exit;
     end;
     na:=h;
     for i:=1 to h do ans[i]:=b[i];
end;

procedure done;
var i: longint;
begin
     assign(output,outfile);
     rewrite(output);
     writeln(na);
     for i:=1 to na do
         write(ans[i],' ');
     close(output);
end;

begin
     init;
     check_tr;
     solve;
     done;
end.
