const pi = 3.1415926535897932384626433832795;
var
  kp, xx, yy, i, j, s, k, m: longint;
  xn, yn, nn, x, y, nm: array [0..200] of longint;
  a: array [0..200] of real;
  q, qb: array [0..200] of longint;
  f: array [0..200] of longint;
  ql, qqb: longint;
  sc, sb: real;
  mx, my: longint;
  ma: real;

procedure change(var a, b: longint);
var c : longint;
begin
    c:=a; a:=b; b:=c;
end;

procedure change_real(var a, b: real);
var c : real;
begin
    c:=a; a:=b; b:=c;
end;

function vec(p: longint; xc, yc: longint): longint;
var xa, ya, xb, yb: longint;
begin
    xa := xn[q[p]] - xn[q[p - 1]];
    ya := yn[q[p]] - yn[q[p - 1]];
    xb := xc - x[q[p - 1]];
    yb := yc - y[q[p - 1]];
    vec := xa * yb - xb * ya;
end;

procedure quick_sort(l, r: longint);
var
  i,j : longint;
begin
    i:=l; j:=r;
    mx:=x[(l+r) shr 1]; my:=y[(l + r) shr 1];
    repeat
       while (y[i] < my) or
            ((y[i] = my) and (x[i] < mx)) do inc(i);
       while (y[j] > my) or
            ((y[j] = my) and (x[j] > mx)) do dec(j);
       if (i <= j) then
       begin
         change(x[i], x[j]); change(y[i], y[j]); change(nm[i], nm[j]);
         inc(I); dec(j);
       end;
    until i > j;
    if (i < r) then quick_sort(i, r);
    if (j > l) then quick_sort(l, j);
  end;
procedure mega_sort(l, r: longint);
var i,j: longint;
begin
    i := l; j := r;
    my := yn[(l + r) shr 1]; ma := a[(l + r) shr 1];
    repeat
       while (a[i] < ma) or
            ((a[i] = ma) and (yn[i] < my)) do inc(i);
       while (a[j] > ma) or
            ((a[j] = ma) and (yn[j] > my)) do dec(j);
       if (i <= j) then
       begin
         change(xn[i], xn[j]); change(yn[i], yn[j]); change(nn[i], nn[j]);
         change_real(a[i], a[j]);
         inc(I); dec(j);
       end;
    until i > j;
    if (i < r) then quick_sort(i, r);
    if (j > l) then quick_sort(l, j);
  end;
var
  l, n: longint;
  procedure search;
  var
    fl, ok: boolean;
    i, j, k, aa, bb, cc,
    xa, ya, xb, yb, xc, yc, xd, yd: longint;
  begin
     ok := false;
     for i := q[ql] + 1 to l do
       if (nn[i] <= n) then
       begin
         for j := ql downto 2 do
         begin
           if (vec(j, xn[i], yn[i]) >= 0) then
           begin
             fl := true;
             for k := q[j] to i - 1 do
               if (nn[k] > n) then
               begin
                 xd := xn[k]; yd := yn[k];
                 xa := xn[1]; ya := yn[1];
                 xb := xn[j]; yb := yn[j];
                 xc := xn[i]; yc := yn[i];
                 aa := (xb - xa)*(yd - ya) -
                       (xd - xa)*(yb - ya);
                 bb := (xc - xb)*(yd - yb) -
                       (xd - xb)*(yc - yb);
                 cc := (xa - xc)*(yd - yc) -
                       (xd - xc)*(yb - yc);
                 if ((aa >= 0) and (bb >= 0) and (cc >= 0)) or
                    ((aa <= 0) and (bb <= 0) and (cc <= 0)) then
                      fl := false;
               end;
             if fl then
             begin
               ok := true;
               inc(ql); q[ql] := i;
               search;
               q[ql] := 0; dec(ql);
             end;
           end;
         end;
       end;
     if not ok then
     begin
         q[ql + 1] := 1;
         for j :=1 to ql do
           sc := sc + xn[q[j]] * yn[q[j + 1]] -
                     xn[q[j + 1]] * yn[q[j]];
         sc := 0.5 * abs(sc);
         if (sc > sb) then
         begin
           sb := sc; qb := q;
           for j := 1 to ql + 1 do
             qb[j] := nn[qb[j]];
           qqb := ql;
         end;
         q[ql + 1] := 0;
     end;
  end;

begin
  assign(input,'birds.in');
  reset(input);
  assign(output,'birds.out');
  rewrite(output);
  readln(input,n);
  for i := 1 to n do
  begin
    read(input, x[i], y[i]); nm[i] := i;
  end;
  readln(input, m);
  for i := n + 1 to n + m do
  begin
    readln(input, x[i], y[i]); nm[i] := i;
  end;
  close(input);
  quick_sort(1, n + m);
  for i := 1 to n + m do
    if (nm[i] <= n) then
    begin
      l:= n+m-i+1;
      for j:=1 to l do begin
        xn[j] := x[j+i-1];
        yn[j] := y[j+i-1];
        nn[j] := nm[j+i-1];
      end;
      for j:=2 to l do
      begin
        xx:=xn[j]-xn[1];
        yy:=yn[j]-yn[1];
        xn[j]:=xx; yn[j]:=yy;
        if (yy = 0) and (xx > 0) then
         a[j]:= 0 else
           if (yy = 0) and (xx < 0) then
           begin
             a[j] := pi;
           end else
             if (xx = 0) then a[j]:=pi/2
              else
                if (xx > 0) then a[j]:=arctan(yy/xx)
                 else
                   a[j]:=pi-arctan(yy/abs(xx));
      end;
      if (l > 2) then
        mega_sort(2, l);
      fillchar(q, sizeof(q), 0); ql := 0;
      q[1] := 1;
      for k := 2 to l-1 do
        if (nn[k] <= n) then
        begin
          q[2] := k; ql := 2;
          search;
        end;
  end;
  if (sb > 0) then
  begin
    writeln(output, qqb);
    for i := 1 to qqb do
      write(output, qb[i], ' ');
  end else
    writeln(output, 0);
  close(output);
end.
