var n,m,lh:longint;
    ra,rb,rw:array[1..5000] of integer;
    a:array[1..100,1..5000] of integer;
    la:array[1..100] of integer;
    b:array[0..5000,1..100] of integer;
    lb:array[0..5000] of integer;
    heap:array[1..5000] of integer;
procedure setl(x,l:integer);
begin
  if x<n then
    la[x]:=l
  else
    lb[x-n]:=l;
end;
procedure setx(x,c,l:integer);
begin
  if x<n then
    a[x,c]:=l
  else
    b[x-n,c]:=l;
end;
function getl(x:integer):integer;
begin
  if x<n then
    getl:=la[x]
  else
    getl:=lb[x-n]
end;
function getx(x,c:integer):integer;
begin
  if x<n then
    getx:=a[x,c]
  else
    getx:=b[x-n,c]
end;
procedure init;
var i:integer;
begin
  assign(input,'roads.in');
  reset(input);
  readln(n,m);
  for i:=1 to m do
    readln(ra[i],rb[i],rw[i]);
  close(input);
end;
var pt:array[1..100] of integer;
    lpt,fk:integer;
    ws:array[1..100] of boolean;
function dfs(k:integer):boolean;
var i:integer;
begin
  ws[k]:=true;
  if k=fk then
    begin
      dfs:=true;
      exit;
    end;
  inc(lpt);
  for i:=1 to n-1 do
    if (ra[i]=k) and (not ws[rb[i]]) then
      begin
        pt[lpt]:=i;
        if dfs(rb[i]) then
          begin
            dfs:=true;
            exit;
          end;
      end
    else
    if (rb[i]=k) and (not ws[ra[i]]) then
      begin
        pt[lpt]:=i;
        if dfs(ra[i]) then
          begin
            dfs:=true;
            exit;
          end;
      end;
  dec(lpt);
end;
procedure done;
var i:longint;
begin
  assign(output,'roads.out');
  rewrite(output);
  writeln(n,' ',m);
  for i:=1 to m do
    writeln(ra[i],' ',rb[i],' ',rw[i]);
  close(output);
  halt(0);
end;
procedure heapify(k:integer);
var ms:integer;
    tmp:integer;
begin
  ms:=k;
  if (k*2<=lh) and (getl(heap[k*2])>getl(heap[ms])) then
    ms:=k*2;
  if (k*2+1<=lh) and (getl(heap[k*2+1])>getl(heap[ms])) then
    ms:=k*2+1;
  if ms<>k then
    begin
      tmp:=heap[ms];
      heap[ms]:=heap[k];
      heap[k]:=tmp;
      heapify(ms);
    end;
end;
procedure run;
var i,j,k,z,bg:integer;
begin
  fillchar(la,sizeof(la),0);
  fillchar(lb,sizeof(lb),0);
  for i:=n to m do
    begin
      fillchar(ws,sizeof(ws),false);
      lpt:=0;
      fk:=rb[i];
      dfs(ra[i]);
      for j:=1 to lpt do
        if rw[pt[j]]>rw[i] then
          begin
            bg:=getl(i);
            setl(i,bg+1);
            setx(i,bg+1,pt[j]);
            bg:=getl(pt[j]);
            setl(pt[j],bg+1);
            setx(pt[j],bg+1,i);
          end;
    end;
  lh:=0;
  for i:=1 to m do
    if getl(i)>0 then
      begin
        inc(lh);
        heap[lh]:=i;
      end;
  for i:=(lh div 2)+(lh mod 2) downto 1 do
    heapify(i);
  while lh>0 do
    begin
      k:=heap[1];
      if k<n then
        begin
          z:=0;
          for i:=1 to getl(k) do
            if rw[getx(k,i)]>z then
              z:=rw[getx(k,i)];
          rw[k]:=z;
          i:=1;
          while i<=getl(k) do
            begin
              if rw[k]<=rw[getx(k,i)] then
                begin
                  j:=1;
                  while j<=getl(getx(k,i)) do
                    begin
                      if getx(getx(k,i),j)=k then
                        begin
                          setx(getx(k,i),j,getx(getx(k,i),getl(getx(k,i))));
                          setl(getx(k,i),getl(getx(k,i))-1);
                        end
                      else
                        inc(j);
                    end;
                  setx(k,i,getx(k,getl(k)));
                  setl(k,getl(k)-1);
                end
              else
                inc(i);
            end;
        end
      else
        begin
          z:=10000;
          for i:=1 to getl(k) do
            if rw[getx(k,i)]<z then
              z:=rw[getx(k,i)];
          rw[k]:=z;
          i:=1;
          while i<=getl(k) do
            begin
              if rw[k]>=rw[getx(k,i)] then
                begin
                  j:=1;
                  while j<=getl(getx(k,i)) do
                    begin
                      if getx(getx(k,i),j)=k then
                        begin
                          setx(getx(k,i),j,getx(getx(k,i),getl(getx(k,i))));
                          setl(getx(k,i),getl(getx(k,i))-1);
                        end
                      else
                        inc(j);
                    end;
                  setx(k,i,getx(k,getl(k)));
                  setl(k,getl(k)-1);
                end
              else
                inc(i);
            end;
        end;
      i:=1;
      while i<=lh do
        begin
          if getl(heap[i])=0 then
            begin
              heap[i]:=heap[lh];
              dec(lh);
            end
          else
            inc(i);
        end;
      for i:=(lh div 2)+(lh mod 2) downto 1 do
        heapify(i);
    end;
end;
begin
  init;
  run;
  done;
end.
