{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}

const infile = 'cows.in'; outfile = 'cows.out'; max = 10005;
type dist = array [1..max] of longint;
var g: array [1..2*max,1..3] of longint;
    s: array [1..max,1..2] of longint;
    num: array [1..max] of longint;
    n,m,mi,mj,mx: longint;

procedure init;
var i,p,q: longint;
begin
     assign(input,infile);
     reset(input);
     read(n);
     for i:=1 to n-1 do begin
         read(p,q); g[i,1]:=p; g[i,2]:=q; read(g[i,3]);
         g[i+n-1,1]:=q; g[i+n-1,2]:=p; g[i+n-1,3]:=g[i,3];
     end;
     m:=2*n-2;
     close(input);
end;

procedure swap(x,y: longint);
var c: longint;
begin
     c:=g[x,1]; g[x,1]:=g[y,1]; g[y,1]:=c;
     c:=g[x,2]; g[x,2]:=g[y,2]; g[y,2]:=c;
     c:=g[x,3]; g[x,3]:=g[y,3]; g[y,3]:=c;
end;

procedure sort(l,t: longint);
var i,j,x: longint;
begin
     i:=l; j:=t; x:=g[(l+t) div 2,1];
     repeat
           while g[i,1] < x do inc(i);
           while g[j,1] > x do dec(j);
           if i <= j then begin
              swap(i,j); inc(i); dec(j);
           end;
     until i > j;
     if i < t then sort(i,t);
     if j > l then sort(l,j);
end;

procedure gen_s;
var i: longint;
begin
     for i:=1 to n do begin
         s[i,1]:=1; s[i,2]:=0;
     end;
     s[g[1,1],1]:=1;
     for i:=2 to m do
         if g[i,1] <> g[i-1,1] then begin
            s[g[i-1,1],2]:=i-1;
            s[g[i,1],1]:=i;
         end;
     s[g[m,1],2]:=m;
end;

procedure bfs(v: longint; var r: dist);
var og: array [1..max] of longint;
    i,yk1,yk2: longint;
begin
     fillchar(r,sizeOf(r),0);
     fillchar(og,Sizeof(og),0);
     yk1:=1; yk2:=0; og[1]:=v; r[v]:=0;
     while yk1 > yk2 do begin
           inc(yk2);
           for i:=s[og[yk2],1] to s[og[yk2],2] do
               if (r[g[i,2]] = 0)and(g[i,2] <> v) then begin
                  inc(yk1); og[yk1]:=g[i,2];
                  r[og[yk1]]:=r[og[yk2]]+g[i,3];
               end;
     end;
end;

procedure sort_num;
var r: dist;
    i,j,b: longint;
begin
     fillchar(r,Sizeof(r),0);
     for i:=1 to n do begin
         b:=0;
         for j:=s[i,1] to s[i,2] do
             if g[j,3] > b then b:=g[j,3];
         r[i]:=b;
     end;
     for i:=1 to n do num[i]:=i;
     for i:=n downto 2 do
         for j:=1 to i-1 do
             if r[num[j]] < r[num[j+1]] then begin
                b:=num[j]; num[j]:=num[j+1]; num[j+1]:=b;
             end;
end;

procedure solve;
var i,j,k,x,y,z: longint;
    r1,r2: dist;
begin
     sort(1,m); gen_s; mx:=maxlongint;
     sort_num;
     for z:=1 to n do begin
         i:=num[z];
         for j:=1 to n do if i <> j then begin
             bfs(i,r1); bfs(j,r2); y:=-1;
             for k:=1 to n do begin
                 if r1[k] < r2[k] then x:=r1[k]
                    else x:=r2[k];
                 if x > y then y:=x;
             end;
             if y < mx then begin
                mi:=i; mj:=j; mx:=y;
             end;
         end;
         if n*n*i > 7000000 then break;
     end;
end;

procedure done;
begin
     assign(output,outfile);
     rewrite(output);
     write(mi,' ',mj);
     close(output);
end;

begin
     init;
     solve;
     done;
end.
