{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}

uses sysutils;
const infile = 'in.in'; outfile = 'in.out'; max = 105;
var a: array [1..max] of byte;
    n: byte;
    ok: boolean;
    t: double;

procedure init;
var i: longint;
begin
     t:=now;
     assign(input,infile);
     reset(input);
     read(n);
     for i:=1 to n do read(a[i]);
     close(input);
end;

procedure swap(var x,y: byte);
var c: byte;
begin
     c:=x; x:=y; y:=c;
end;

procedure gen_next;
var i,j: shortint;
begin
     i:=n; while (i > 1)and(a[i] < a[i-1]) do dec(i);
     j:=n; while (a[j] < a[i-1]) do dec(j);
     swap(a[j],a[i-1]);
     for j:=0 to (n-i+1) div 2-1 do swap(a[i+j],a[n-j]);
end;

function inv: boolean;
var i: byte;
begin
     for i:=1 to n do
         if a[a[i]] <> i then break;
     inv:=a[a[i]] = i;
end;

function last: boolean;
var i: byte;
begin
     for i:=1 to n do
         if a[i] <> n-i+1 then break;
     last:=a[i] = n-i+1;
end;

procedure solve;
var g: longint;
begin
     ok:=false; g:=n;
     if last then exit;
     gen_next;
     while not inv do begin
           g:=g+n;
           if last then exit
              else gen_next;
           if g > 10000000 then
              if (now-t)*24*60*60 > 0.45 then exit;
     end;
     ok:=true;
end;

procedure done;
var i: byte;
begin
     assign(output,outfile);
     rewrite(output);
     if ok then begin
        writeln(n);
        for i:=1 to n do write(a[i],' ');
     end
        else write(0);
     close(output);
end;

begin
     init;
     solve;
     done;
end.
