{$D-,L-,Q-,R-,S-,I-}
Program pr_a;
const
  inpfile='palindr.in';
  outfile='palindr.out';
  nm=100005;
var
  a : array [1..nm] of LongInt;
  b,b2,b3,s,s2,s3 : array [0..nm] of LongInt;
  res : Extended;
  n : LongInt;
{}
Procedure Inp;
var
  i : LongInt;
  ch : Char;
begin
  assign(input,inpfile);
  reset(input); n:=0;
  while not eoln do begin
    inc(n); read(ch);
    a[n]:=ord(ch)-ord('a')+1;
  end;
end;
{}
Procedure Out;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(res:0:0);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(s,sizeof(s),0);
  fillchar(s2,sizeof(s2),0);
  fillchar(s3,sizeof(s3),0);
  fillchar(b,sizeof(b),0);
  fillchar(b2,sizeof(b2),0);
  fillchar(b3,sizeof(b3),0);
end;
{}
Procedure CountS;
var
  i,j : LongInt;
  x : LongInt;
begin
  for i:=1 to n do begin
    x:=a[i];
    b[i]:=x;
    s[i]:=s[i-1]+x;
    x:=a[i]*a[i];
    b2[i]:=x;
    s2[i]:=s2[i-1]+x;
    x:=x*a[i];
    b3[i]:=x;
    s3[i]:=s3[i-1]+x;
  end;
end;
{}
Function Pal(x1,y1,x2,y2 : LongInt) : Boolean;
var
  m,ran : LongInt;
begin
  Pal:=true;
  if s[y2]-s[x2]+b[x2]<>s[y1]-s[x1]+b[x1] then Pal:=false;
  if s2[y2]-s2[x2]+b2[x2]<>s2[y1]-s2[x1]+b2[x1] then Pal:=false;
  if s3[y2]-s3[x2]+b3[x2]<>s3[y1]-s3[x1]+b3[x1] then Pal:=false;

  m:=(y1-x1+1) div 2; ran:=random(y1-x1+1);
  if (a[x1]<>a[y2]) or (a[y1]<>a[x2])
  or (a[y1-m]<>a[x2+m]) or (a[y1-ran]<>a[x2+ran]) then Pal:=false;

  ran:=(y1-x1+1) div 3;
  if a[y1-ran]<>a[x2+ran] then Pal:=false;

  ran:=(y1-x1+1) div 5;
  if a[y1-ran]<>a[x2+ran] then Pal:=false;
end;
{}
Function Min(q,w : LongInt) : LongInt;
begin
  if q<w then min:=q else min:=w;
end;
{}
Procedure Bin(x,y,l,r : LongInt);
var
  m : LongInt;
begin
  if l>r then exit;
  if l+1>=r then begin
    if l=r then
      if Pal(x-r,x,y,y+r) then begin
        res:=res+r;
        if x<>y then res:=res+1;
      end;


    if l<>r then begin
      if Pal(x-r,x,y,y+r) then begin
        res:=res+r;
        if x<>y then res:=res+1;
      end else
      if Pal(x-l,x,y,y+l) then begin
        res:=res+l;
        if x<>y then res:=res+1;
      end;
    end;



    exit;
  end;

  m:=(l+r) div 2;

  if Pal(x-m,x,y,y+m) then Bin(x,y,m,r)
                      else Bin(x,y,l,m-1);
end;
{}
Procedure Solve;
var
  i,j,d : LongInt;
begin
  CountS; res:=0;
  for i:=1 to n-1 do begin
    d:=min(i-1,n-i);
    Bin(i,i,1,d);
    d:=min(i-1,n-i-1);
    Bin(i,i+1,0,d);
  end;
end;
{}
Begin
  randomize;
  Init;
  Inp;
  Solve;
  Out;
End.
