{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}

const infile = 'road.in'; outfile = 'road.out';
      maxn = 3005; maxc = (maxn*(maxn+1)) div 2;
type pt = record x,y: longint; end;
var g: array [1..maxn,1..maxn] of byte;
    p: array [1..maxn] of pt;
    f: array [1..maxn] of longint;
    s: array [1..maxc,1..2] of integer;
    ans: array [1..maxn,1..2] of longint;
    n,m,sm,num_cmp,ans_num: longint;

procedure init;
var i,q1,q2: longint;
begin
     assign(input,infile);
     reset(input);
     read(n,m);
     for i:=1 to n do read(p[i].x,p[i].y);
     fillchar(g,Sizeof(g),0);
     for i:=1 to m do begin read(q1,q2); g[q1,q2]:=1; g[q2,q1]:=1; end;
     close(input);
end;

procedure create(v: longint);
var og: array [1..maxn] of longint;
    yk1,yk2,i: longint;
begin
     fillchar(og,Sizeof(og),0);
     yk1:=1; yk2:=0; og[1]:=v; f[v]:=v;
     while yk1 > yk2 do begin
           inc(yk2);
           for i:=1 to n do
               if (g[og[yk2],i] = 1)and(f[i] = 0) then begin
                  inc(yk1); og[yk1]:=i; f[i]:=v;
               end;
     end;
end;

procedure change(v1,v2: longint);
var i: longint;
begin
     for i:=1 to n do
         if (i <> v2)and(f[i] = f[v2]) then f[i]:=f[v1];
     f[v2]:=f[v1];
end;

function dist(v1,v2: longint): longint;
begin
     dist:=(p[v1].x-p[v2].x)*(p[v1].x-p[v2].x)+(p[v1].y-p[v2].y)*(p[v1].y-p[v2].y);
end;

procedure fill_free;
var i,j: longint;
begin
     sm:=0;
     for i:=1 to n-1 do
         for j:=i+1 to n do
             if (f[i] <> f[j])and(g[i,j] = 0) then begin
                inc(sm); s[sm,1]:=i; s[sm,2]:=j;
             end;
end;

procedure swap(v1,v2: longint);
var i: longint;
begin
     i:=s[v1,1]; s[v1,1]:=s[v2,1]; s[v2,1]:=i;
     i:=s[v1,2]; s[v1,2]:=s[v2,2]; s[v2,2]:=i;
end;

procedure sort(l,m: longint);
var i,j,x: longint;
begin
     i:=l; j:=m; x:=dist(s[(l+m) div 2,1],s[(l+m) div 2,2]);
     repeat
           while dist(s[i,1],s[i,2]) < x do inc(i);
           while dist(s[j,1],s[j,2]) > x do dec(j);
           if i <= j then begin
              swap(i,j); inc(i); dec(j);
           end;
     until i > j;
     if i < m then sort(i,m);
     if j > l then sort(l,j);
end;

procedure solve;
var i,j,k,p1,p2: longint;
begin
     fillchar(f,sizeof(f),0);
     for i:=1 to n do
         if f[i] = 0 then create(i);
     num_cmp:=1;
     for i:=2 to n do begin
         for j:=1 to i-1 do
             if f[i] = f[j] then break;
         if f[i] <> f[j] then inc(num_cmp);
     end;
     fill_free;
     sort(1,sm);
     i:=1;
     for k:=1 to num_cmp-1 do begin
         while (f[s[i,1]] = f[s[i,2]]) do inc(i);
         change(s[i,1],s[i,2]); inc(ans_num);
         ans[ans_num,1]:=s[i,1]; ans[ans_num,2]:=s[i,2];
     end;
end;

procedure done;
var i: longint;
begin
     assign(output,outfile);
     rewrite(output);
     if num_cmp = 1 then write(0)
        else begin
             writeln(ans_num);
             for i:=1 to ans_num-1 do
                 writeln(ans[i,1],' ',ans[i,2]);
             write(ans[ans_num,1],' ',ans[ans_num,2]);
        end;
     close(output);
end;

begin
     init;
     solve;
     done;
end.
