program Nice_Tables;

const
  MAXN = 1000; {1000}

var
  m, n : integer;
  t1, t2 : array [1..MAXN,1..MAXN] of boolean;
  fs, fs1 : longint;
  fx, fy, fx1, fy1 : array [1..MAXN*MAXN] of integer;

procedure Load(infile, outfile : string);
var
  i, j, c : integer;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(n,m);
  for i:=1 to n do
    for j:=1 to m do
    begin
      read(c);
      t1[i,j] := boolean(c);
    end;
  for i:=1 to n do
    for j:=1 to m do
    begin
      read(c);
      t2[i,j] := boolean(c);
    end;
end;

procedure Think;
var
  i, j : integer;
begin
  fs := 0;
  for i:=1 to n do
    for j:=1 to m do
      if ord(t1[i,j])<>(i+j) mod 2 then
      begin
        if (i<n) and (j<m) and (t1[i,j] xor t1[i+1,j])
          and (t1[i,j] xor t1[i,j+1]) and (t1[i,j] xor t1[i+1,j+1]) then
        begin
          inc(fs,2);
          fx[fs-1] := i;
          fy[fs-1] := j+1;
          fx[fs] := i;
          fy[fs] := j;
          t1[i,j+1] := not t1[i,j+1];
          t1[i,j] := not t1[i,j];
        end
        else
        begin
          inc(fs);
          fx[fs] := i;
          fy[fs] := j;
          t1[i,j] := not t1[i,j];
        end;
      end;
end;

procedure Solve;
begin
  think;
  fs1 := fs;
  fx1 := fx;
  fy1 := fy;
  t1 := t2;
  think;
end;

procedure Save;
var
  i : longint;
begin
  writeln(fs+fs1);
  for i:=1 to fs1 do
    writeln(fx1[i],' ',fy1[i]);
  for i:=fs downto 1 do
    writeln(fx[i],' ',fy[i]);
  close(input);
  close(output);
end;

begin
  Load('nice.in','nice.out');
  Solve;
  Save;
end.