{$I-,Q-,R-,S-}
type
  p1=^t1;
  t1=record
    next,pred:p1;
    i:word;
  end;

var
  ss:array[1..3000] of p1;
  k,i,j,z,n,m:word;
  a:array[1..3000,1..3000] of byte;
  x,y:array[1..3000] of longint;
  c:array[1..3000] of word;
  b:array[1..3000,1..3000] of word;
  sm:array[1..3000] of record
    count:word;
    v:array[1..3000] of word;
  end;
  ans1,ans2:array[1..3000] of word;
  min1,min2:word;
  colored:p1;
  uncolored:p1;
  p,pc,pu:p1;

procedure out;
var
  i:word;
begin
  writeln(k);
  for i:=1 to k do
    writeln(ans1[i],' ',ans2[i]);
  close(input);
  close(output);
  halt(0);
end;

procedure delete(i:word);
var
  p:p1;
begin
  p:=ss[i];
  if p^.pred<>nil then p^.pred^.next:=p^.next;
  if p^.next<>nil then p^.next^.pred:=p^.pred;
  if uncolored=p then uncolored:=p^.next;
  dispose(p);
end;

procedure add(i:word);
var
  p:p1;
begin
  new(p);
  p^.pred:=nil;
  p^.next:=colored;
  p^.i:=i;
  if colored<>nil then colored^.pred:=p;
  colored:=p;
end;

procedure color(i,col:word);
var
  k:word;
begin
  if (col=0) and (c[i]<>0) then begin
    delete(i);
    add(i);
    inc(z);
  end;
  c[i]:=col;
  for k:=1 to sm[i].count do begin
    if c[sm[i].v[k]]<>col then color(sm[i].v[k],col);
  end;
end;

function dl(i,j:word):cardinal;
var
  i1,j1:word;
  c1:cardinal;
begin
  if i<j then begin
    i1:=i;
    j1:=j;
  end else begin
    i1:=j;
    j1:=i;
  end;
  if b[i,j]=0 then begin
    c1:=sqr(x[i]-x[j])+sqr(y[i]-y[j]);
    b[i1,j1]:=c1 div 60000;
    b[j1,i1]:=c1 mod 60000;
  end;
  c1:=b[i1,j1];
  c1:=c1*60000;
  c1:=c1+b[j1,i1];
  dl:=c1;
end;

begin
  assign(input,'road.in');
  reset(input);
  assign(output,'road.out');
  rewrite(output);

  readln(n,m);
  for i:=1 to n do begin
    readln(x[i],y[i]);
    c[i]:=i;
  end;

  fillchar(a,sizeof(a),0);
  fillchar(sm,sizeof(sm),0);
  for z:=1 to m do begin
    readln(i,j);
    a[i,j]:=1;
    a[j,i]:=1;
    inc(sm[i].count);
    sm[i].v[sm[i].count]:=j;
    inc(sm[j].count);
    sm[j].v[sm[j].count]:=i;
    color(j,c[i]);
  end;

  z:=0;
  colored:=nil;
  uncolored:=nil;
  for i:=1 to n do begin
    new(p);
    p^.pred:=nil;
    p^.next:=uncolored;
    p^.i:=i;
    ss[i]:=p;
    if uncolored<>nil then uncolored^.pred:=p;
    uncolored:=p;
  end;
  color(1,0);

  if z<n then
    fillchar(b,sizeof(b),0);


  k:=0;

  while z<n do begin

    min1:=1;
    min2:=uncolored^.i;

    pc:=colored;
    while pc<>nil do begin
      pu:=uncolored;
      while pu<>nil do begin
        if dl(pc^.i,pu^.i)<dl(min1,min2) then begin
          min1:=pc^.i;
          min2:=pu^.i;
        end;
        pu:=pu^.next;
      end;
      pc:=pc^.next;
    end;

    inc(k);
    ans1[k]:=min1;
    ans2[k]:=min2;
    a[min1,min2]:=1;
    a[min2,min1]:=1;
    inc(sm[min1].count);
    sm[min1].v[sm[min1].count]:=min2;
    inc(sm[min2].count);
    sm[min2].v[sm[min2].count]:=min1;
    color(min2,0);
  end;

  out;
end.
