{$I-,Q-,R-,S-}
type
  p1=^t1;
  t1=record
    next,pred:p1;
    x,y:integer;
  end;

var
  a,b:array[0..1001,0..1001] of byte;
  i,j,m,n:integer;
  k:longint;
  x,y:array[1..7000000] of integer;
  pos,p,p2:p1;
  flag1:boolean;

procedure out;
var
  z:longint;
begin
  writeln(k);
  if k>0 then
    for z:=1 to k do writeln(x[z],' ',y[z]);

  close(input);
  close(output);
  halt(0);
end;

procedure addtoans(i,j:word);
begin
  inc(k);
  x[k]:=i;
  y[k]:=j;
end;

procedure add(i,j:word);
var
  p:p1;
begin
  new(p);
  p^.next:=pos;
  p^.x:=i;
  p^.y:=j;
  p^.pred:=nil;
  if pos<>nil then pos^.pred:=p;
  pos:=p;
end;

procedure delete(p:p1);
begin
  if p^.pred<>nil then p^.pred^.next:=p^.next;
  if p^.next<>nil then p^.next^.pred:=p^.pred;
  if p=pos then pos:=p^.next;
  dispose(p);
end;

function can(i,j:word):boolean;
var
  z:byte;
begin
  z:=1-a[i,j];
  can:= not(
  ((a[i-1,j]=z) and (a[i-1,j-1]=z) and (a[i,j-1]=z))
  or
  ((a[i-1,j]=z) and (a[i-1,j+1]=z) and (a[i,j+1]=z))
  or
  ((a[i+1,j]=z) and (a[i+1,j-1]=z) and (a[i,j-1]=z))
  or
  ((a[i+1,j]=z) and (a[i+1,j+1]=z) and (a[i,j+1]=z))
  or
  (i<1) or (i>n) or (j<1) or (j>m));
end;

begin
  assign(input,'nice.in');
  reset(input);
  assign(output,'nice.out');
  rewrite(output);

  readln(m,n);
  fillchar(a,sizeof(a),2);
  fillchar(b,sizeof(b),2);

  pos:=nil;
  k:=0;
  for i:=1 to n do
    for j:=1 to m do
      read(a[i,j]);
  for i:=1 to n do
    for j:=1 to m do begin
      read(b[i,j]);
      if a[i,j]<>b[i,j] then add(i,j);
  end;
  while pos<>nil do begin
    p:=pos;
    while (p<>nil) and (can(p^.x,p^.y)) do begin
      addtoans(p^.x,p^.y);
      p2:=p^.next;
      delete(p);
      p:=p2;
    end;
    if p<>nil then begin
      flag1:=false;
      for i:=-1 to 1 do
        for j:=-1 to 1 do
          if can(p^.x+i,p^.y+j) then begin
            add(p^.x+i,p^.y+j);
            addtoans(p^.x+i,p^.y+j);
            addtoans(p^.x,p^.y);
            delete(p);
            flag1:=true;
            break;
          end;
      if not flag1 then  begin
        k:=-1;
        out;
      end;
    end;
  end;

  out;
end.
