{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 65000,0,655360}
Const INPUTFILE='road.in';
      OUTPUTFILE='road.out';

Const MaxN=3000;
      MaxM=MaxN*(MaxN-1) div 2;

Type Real=Double;
     Point=record
     x,y:Longint;
     end;
     Pair=Array[1..2] of Integer;

var cit:Array[1..MaxN] of Point;
    Roads:Array[1..MaxM] of Pair;
    c,ct:Array[1..MaxN] of Integer;

    Ans:Array[1..MaxN] of Pair;
    N,M:Longint;
    i,j,t:Longint;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Read(N,M);
for i:=1 to N do
  Read(cit[i].x,cit[i].y);
for i:=1 to M do
begin
  Read(j,t);
  Roads[i,1]:=j;
  Roads[i,2]:=t;
end;
Close(Input);

FillChar(c,SizeOf(c),0);
FillChar(ct,SizeOf(ct),0);
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
Writeln(Answer);
for i:=1 to Answer do
  if Ans[i,1]<Ans[i,2] then
    Writeln(Ans[i,1],' ',Ans[i,2])
  else
    Writeln(Ans[i,2],' ',Ans[i,1]);

Close(Output);

Halt;
end;

Function LRoads(i:Integer):Longint;
begin
LRoads:=Sqr(cit[Roads[i,1]].x-cit[Roads[i,2]].x)+Sqr(cit[Roads[i,1]].y-cit[Roads[i,2]].y)
end;

Procedure QSort(L,R:Longint);
var i,j,x:Longint;
    tl:Longint;
    tp:Pair;
begin
i:=L;
j:=R;
x:=LRoads((i+j) div 2);
Repeat
  While LRoads(i)<x Do Inc(i);
  While LRoads(j)>x Do Dec(j);
  if i<=j then
  begin
    tp:=Roads[i];
    Roads[i]:=Roads[j];
    Roads[j]:=tp;

    Inc(i);
    Dec(j);
  end;
Until i>j;
if i<R then QSort(i,R);
if j>L then QSort(L,j);
end;

Procedure Solve;
var g,h,l,K:Longint;
begin
for i:=1 to N do
  c[i]:=i;
for i:=1 to M do
  if c[Roads[i,1]]<>c[Roads[i,2]] then
  begin
    for j:=1 to N do
      if c[j]=c[Roads[i,2]] then
        c[j]:=c[Roads[i,1]];
  end;

for i:=1 to N do
  ct[c[i]]:=i;
l:=N;
for i:=1 to N do
  if ct[i]=0 then Dec(l);

g:=0;
for i:=1 to N do
for j:=i+1 to N do
begin
  Inc(g);
  Roads[g,1]:=i;
  Roads[g,2]:=j;
end;

if L=1 then FWrite(0);
QSort(1,g);
i:=0;
K:=0;
While K<L-1 Do
begin
  Inc(i);
  if c[Roads[i,1]]<>c[Roads[i,2]] then
  begin
    Inc(K);
    Ans[K]:=Roads[i];
  end;
end;
FWrite(K);
end;

begin
FRead;
Solve;
end.
