program RoadsPrimCruscall;

const max = 2250000;

type edge= record
  len: cardinal;
  a, b: word;
end;

var f: text;
    hh, k, ed: cardinal;
    coms, comp, ver, i, j, a, b: word;
    x, y: array [1..3000] of longint;
    com: array [1..3000] of word;
    tt, e: edge;
    hp: array [1..max] of edge;

procedure siftup (x: cardinal);
begin
  if (x > 1) and (hp [x] . len < hp [x shr 1] . len) then
  begin
    tt := hp [x];
    hp [x] := hp [x shr 1];
    hp [x shr 1] := tt;
    siftup (x shr 1);
  end;
end;

procedure sdown (x: cardinal);
begin
  if (x shl 1 <= hh) and (hp [x shl 1] . len < hp [x] . len) then
  begin
    tt := hp [x];
    hp [x] := hp [x shl 1];
    hp [x shl 1] := hp [x];
    sdown (x shl 1);
  end
  else
  if (x shl 1+1<= hh) and (hp [x shl 1+1] . len < hp [x] . len) then
  begin
    tt := hp [x];
    hp [x] := hp [x shl 1+1];
    hp [x shl 1+1] := hp [x];
    sdown (x shl 1+1);
  end
end;

procedure Add (i, j: word);
begin
  inc (hh);
  hp [hh] . len := sqr (x [i] - x [j]) + sqr (y [i] - y [j]);
  hp [hh] . a := i;
  hp [hh] . b := j;
  siftup (hh);
end;

begin
  hh := 0;
  assign (f, 'road.in');
  reset (f);
  read (f, ver);
  readln (f, ed);
  for i := 1 to ver do
  begin
    read (f, x [i]);
    readln (f, y [i]);
    com [i] := i;
  end;
  coms := ver;
  for k := 1 to ed do
  begin
    read (f, a);
    readln (f, b);
    if (com [a] <> com [b]) then
    begin
      a := com [a];
      b := com [b];
      if (a > b) then
      begin
        j := a;
        a := b;
        b := j;
      end;
      for i := 1 to ver do
      begin
        if (com [i] = b) then
        begin
          com [i] := a;
        end;
      end;
      dec (coms);
    end;
  end;
  close (f);
  assign (f, 'road.out');
  rewrite (f);
  for i := 1 to ver do
  begin
    if (com [i] = 1) then
    begin
      for j := 1 to ver do
      begin
        if (com [j] > 1) then
        begin
          Add (i, j);
        end;
      end;
    end;
  end;
  writeln (f, coms - 1);
  while (hh > 0) and (coms > 1) do
  begin
    repeat
      if (hh > 0) then
      begin
        e := hp [1];
        hp [1] := hp [hh];
        sdown (1);
      end;
    until (hh = 0) or (com [e.b] > 1);
    if (com [e.b] > 1) then
    begin
      writeln (f, e.a, ' ', e.b);
      comp := com [e.b];
      for i := 1 to ver do
      begin
        if (com [i] = comp) then
        begin
          com [i] := 1;
          for j := 1 to ver do
          begin
            if (com [j] > 1) and (com [j] <> comp) then
            begin
              Add (i, j);
            end;
          end;
        end;
      end;
      dec (coms);
    end;
  end;
  close (f);
end.
