#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <string.h>

#define NN 1510

struct PP {
  int a;
  PP *p;
};

FILE *fi, *fo;
PP *g[NN];
int w[NN+5];
bool used[NN];
int v[NN];
int r[NN];
int h,t;
int n;

void Add(int x, int y)
{
  PP *t;
  t=new PP;
  t->a=y;
  t->p=g[x];
  g[x]=t;
}

void bfs()
{
  int c;
  PP *p;
  while(h<t)
  {
    c=w[h];
    h++;
    for(p=g[c];p!=NULL;p=p->p)
    {
      if(!used[p->a])
      {
        used[p->a]=true;
        w[t]=p->a;
        r[p->a]=r[c]+1;
        t++;
      }
    }
  }
}

int main()
{
  int i,j;
  int x,y;
  fi=fopen("tree.in","rt");
  fo=fopen("tree.out","wt");

  fscanf(fi,"%i",&n);
  for(i=0;i<n;i++)
    g[i]=NULL;
  for(i=0;i<n-1;i++)
  {
    fscanf(fi,"%i%i",&x,&y);
    Add(x-1,y-1);
    Add(y-1,x-1);
  }

  for(i=0;i<n;i++)
  {
    for(j=0;j<n;j++)
      used[j]=false;
    h=0;
    t=1;
    w[0]=i;
    r[i]=0;
    used[i]=true;
    bfs();
    x=0;
    for(j=0;j<n;j++)
      if(r[j]>x)
        x=r[j];
    v[i]=x;
  }

  x=100000;
  for(i=0;i<n;i++)
    if(v[i]<x)
      x=v[i];

  y=0;
  for(i=0;i<n;i++)
    if(v[i]==x)
      y++;

  fprintf(fo,"%i\n",y);
  for(i=0;i<n;i++)
    if(v[i]==x)
      fprintf(fo,"%i ",i+1);

  fclose(fi);
  fclose(fo);
  return 0;
}
