{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 16384,0,655360}

Const INPUTFILE='graph.in';
      OUTPUTFILE='graph.out';

Const MaxN=40;
      MaxM=50000;
Const INF=842150450;

Type Real=Double;

var a:Array[1..MaxN,1..MaxN] of Longint;
    w:Array[1..MaxN,1..MaxN] of Byte;

    N,M:Longint;
    i,j:Longint;

Procedure FRead;
begin
FillChar(a,SizeOf(a),50);
FillChar(w,SizeOf(w),255);
Assign(Input,INPUTFILE);
Reset(Input);
Read(N,M);
for i:=1 to N do
begin
  w[i,i]:=0;
  a[i,i]:=0;
end;

Assign(Output,OUTPUTFILE);
Rewrite(Output);
end;

Procedure Solve;
var g,h,k:Longint;
    v1,v2:Integer;
    t,L:Integer;
begin
for k:=1 to M do
begin
  Read(t,v1,v2);
  if t=1 then
  begin
    Read(L);
    if w[v1,v2]>L then
    begin
      w[v1,v2]:=L;
      for i:=1 to N do
      for j:=1 to N do
        if a[i,v1]+w[v1,v2]+a[v2,j]<a[i,j] then a[i,j]:=a[i,v1]+w[v1,v2]+a[v2,j];
    end;
  end
  else
  begin
    if a[v1,v2]=INF then
      Writeln(-1)
    else
      Writeln(a[v1,v2]);
  end;
end;
end;

begin
FRead;
Solve;
Close(Input);
Close(Output);
end.
