{$D-,L-,Q-,R-,S-,I-,N+}
Program pr_b;
const
  inpfile='tree.in';
  outfile='tree.out';
  nm=1505;
type
  Rebr=record
    x,y : Integer;
  end;
var
  a : array [0..2*nm] of Rebr;
  p : array [0..nm] of Integer;
  u : array [1..nm] of Boolean;
  r : array [1..nm,1..nm] of Integer;
  res : array [1..nm] of Integer;
  n,m,z,rn : LongInt;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n); m:=n-1;
  for i:=1 to m do begin
    read(a[i].x,a[i].y);
    a[i+m].x:=a[i].y;
    a[i+m].y:=a[i].x;
  end;
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(rn);
  for i:=1 to rn do write(p[i],' ');
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(p,sizeof(p),0);
  fillchar(u,sizeof(u),0);
  fillchar(r,sizeof(r),0);
end;
{}
Procedure Swap(var q,w : Rebr);
var
  bak : Rebr;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure Sort(l,r: Integer);
var
  i,j,x : Integer;
begin
  i:=l; j:=r; x:=a[(l+r) div 2].x;
  repeat
    while a[i].x<x do inc(i);
    while x<a[j].x do dec(j);
    if not(i>j) then begin
      Swap(a[i],a[j]);
      inc(i); j:=j-1;
    end;
  until i>j;
  if l<j then Sort(l,j);
  if i<r then Sort(i,r);
end;
{}
Procedure CountP;
var
  i,j : LongInt;
begin
  for i:=1 to 2*m do begin
    p[a[i].x]:=i;
    if a[i].x<>a[i-1].x then
      for j:=a[i-1].x+1 to a[i].x-1 do p[j]:=i-1;
  end;
end;
{}
Procedure Dfs(x,h : Integer);
var
  i : Integer;
begin
  u[x]:=true; r[z,x]:=h;
  for i:=p[x-1]+1 to p[x] do
    if not u[a[i].y] then Dfs(a[i].y,h+1);
end;
{}
Procedure Solve;
var
  i,j,min : LongInt;
begin
  Sort(1,2*m); CountP;
  for z:=1 to n do begin
    fillchar(u,sizeof(u),0);
    Dfs(z,0);
  end;

  fillchar(res,sizeof(res),0);
  for i:=1 to n do
    for j:=1 to n do
      if res[i]<r[i,j] then res[i]:=r[i,j];

  rn:=0; min:=res[1];
  for i:=1 to n do begin
    if res[i]=min then begin
      inc(rn); p[rn]:=i;
    end else
    if res[i]<min then begin
      min:=res[i]; rn:=1;
      p[rn]:=i;
    end;
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
