type teg = array[1..2] of integer;
     tvert = record
       el,en: integer;
     end;

var es: array[1..10000{!!!}] of teg;
    vs: array[1..1000] of tvert;
    n,m: integer;
    path: array[1..10000{!!!}] of integer;
    pl: integer;
    mark: array[1..1000] of boolean;

procedure DFS(v: integer);
var i: integer;
    flag: boolean;
begin
 mark[v]:=true;
  inc(pl);
  path[pl]:=v;
  flag:=false;
  For i:=vs[v].el to vs[v].el+vs[v].en-1 do
    if not mark[es[i,1]] then begin
      flag:=true;
      DFS(es[i,1]);
    end;
  if flag then begin
    inc(pl);
    path[pl]:=v;
  end;
end;


procedure Solve;
var v,i: integer;
begin
  v:=1;
  For i:=2 to n do
    if odd(vs[i].en) then begin
      v:=i;
      break;
    end;
  DFS(v);
end;

procedure Save;
var f: text;
    i: integer;
begin
  Assign(f,'post.out');
  Rewrite(f);
  WriteLn(f,pl-1);
  For i:=1 to pl do Write(f,path[i],' ');
  Close(f);
end;

procedure Load;
var f: text;
    i,j,t: integer;
begin
  Assign(f,'post.in');
  Reset(f);
  Read(f,n);
  For i:=1 to n do begin
    Read(f,t);
    vs[i].en:=t;
    vs[i].el:=m+1;
    For j:=1 to t do begin
      inc(m);
      Read(f,es[m,1],es[m,2]);
    end;
  end;
  Close(f);
end;


Begin
  Load;
  Solve;
  Save;
End.
