#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <string.h>

#define NN 310
#define MANY 100000

struct BACK {
  int type;
  int a,b;
};

FILE *fi, *fo;
int a[NN][NN];
char c[NN];
BACK d[NN][NN];
int n;

char GetNextC()
{
  char c;
  c=getc(fi);
  while((c=='\n')||(c==' ')) c=getc(fi);
  return c;
}

void wr(int i,int j)
{
  if(i<=j)
  {
    if(d[i][j].type)
    {
      fprintf(fo,"%i %i %c\n",i+1,j+1,c[i]);
      wr(d[i][j].a,d[i][j].b);
    }
    else
    {
      wr(i,d[i][j].a);
      wr(d[i][j].a+1,j);
    }
  }
}

int main()
{
  int i,j;
  int i1,j1;
  fi=fopen("paint.in","rt");
  fo=fopen("paint.out","wt");

  fscanf(fi,"%i",&n);
  for(i=0;i<n;i++)
    c[i]=GetNextC();
  c[n]='\0';

  a[0][0]=1;
  d[0][0].type=1;
  d[0][0].a=-1;
  d[0][0].b=-2;

  for(j=1;j<n;j++)
  {
    for(i=j;i>=0;i--)
    {
      if(c[i]==c[j])
      {
         i1=i;
         while((c[i1]==c[i])&&(i1<=j)) i1++;
         j1=j;
         while((c[j1]==c[j])&&(j1>=i)) j1--;
         if(i1<=j1)
         {
           a[i][j]=a[i1][j1]+1;
           d[i][j].type=1;
           d[i][j].a=i1;
           d[i][j].b=j1;
         }
         else
         {
           a[i][j]=1;
           d[i][j].type=1;
           d[i][j].a=-1;
           d[i][j].b=-2;
         }
      }
      else
      {
        a[i][j]=MANY;
      }
      for(i1=i;i1<j;i1++)
      {
        if(a[i][j]>a[i][i1]+a[i1+1][j])
        {
          a[i][j]=a[i][i1]+a[i1+1][j];
          d[i][j].type=0;
          d[i][j].a=i1;
        }
      }
    }
  }

  fprintf(fo,"%i\n",a[0][n-1]);
  wr(0,n-1);
  
  fclose(fi);
  fclose(fo);
  return 0;
}
