{$N+}
const
  inf = 'convexh.in'; ouf = 'convexh.out';
  mx = 2500;
  pi = 3.1415926535897932385;
type
  real = extended;
  procedure swap(var a, b: real);
  var c: real;
  begin
    c := a; a := b; b := c;
  end;
var
  pr: array[1..mx] of record
                        xa, ya, xb, yb: longint;
                      end;
  a, x, y: array[1..mx shl 1 + 1] of real;
  xi, yi: real;
  hs, nn: longint;
  procedure put(k: longint);
  begin
    x[k] := xi; y[k] := yi;
  end;
  procedure heapify(k: longint);
  var
    lg, j: longint;
  begin
    lg := k; j := lg shl 1;
    if (j <= hs) and ((a[j] > a[lg]) or
      ((a[lg] = a[j]) and (a[lg] = 0) and (x[lg] > x[j]))) then lg := j;
    inc(j);
    if (j <= hs) and ((a[j] > a[lg]) or
     ((a[lg] = a[j]) and (a[lg] = 0) and (x[lg] > x[j]))) then lg := j;
    if (lg <> k) then
    begin
      swap(a[k], a[lg]); swap(x[k], x[lg]); swap(y[k], y[lg]);
      heapify(lg);
    end;
  end;
  procedure heapsort;
  var
    i: longint;
  begin
    hs := nn;
    for i := nn shr 1 downto 1 do heapify(i);
    for i := 1 to nn - 1 do
    begin
      swap(a[1], a[hs]); swap(x[1], x[hs]); swap(y[1], y[hs]);
      dec(hs); heapify(1);
    end;
  end;
  procedure cross(xa, ya, xb, yb, xc, yc, xd, yd: longint);
  var
    a, b, c, d, e, f: longint;
    t: real;
  begin
     a := xb - xa; b := xc - xd; c := xc - xa;
     d := yb - ya; e := yc - yd; f := yc - ya;
     t := a * e - d * b;
     t := (f * a - c * d) / t;
     xi :=  (1 - t) * xc + t * xd;
     yi :=  (1 - t) * yc + t * yd;
  end;
var
  qc, n, cr, i, j: longint; ym, xm, xx, yy, s: real;
begin
  assign(input, inf); reset(input);
  assign(output,ouf);rewrite(output);
  readln(input, n);
  for i := 1 to n do
    readln(input, pr[i].xa, pr[i].ya, pr[i].xb, pr[i].yb);
   nn := n shl 1; cr := 0;
  for i := 1 to n do
    with pr[i] do
    begin
      inc(cr, 2); qc := 0;
      for j := 1 to n do
      if (i <> j) then
      begin
         cross(xa, ya, xb, yb,
               pr[j].xa, pr[j].ya, pr[j].xb, pr[j].yb);
         if (qc = 0) then
         begin
            put(cr); put(cr - 1); inc(qc);
         end;
         if (xa = xb) then
         begin
            if (y[cr] > y[cr - 1]) then
            begin
              if (yi > y[cr]) then put(cr);
              if (yi < y[cr - 1]) then put(cr - 1);
            end else
            begin
              if (yi > y[cr - 1]) then put(cr - 1);
              if (yi < y[cr]) then put(cr);
            end;
         end else
         begin
           if (xi > x[cr]) then put(cr);
           if (xi < x[cr - 1]) then put(cr - 1);
         end;
      end;
    end;
  ym := y[1]; xm := x[1]; j := 1;
  for i := 2 to nn do
     if (y[i] < ym) or
        ((y[i] = ym) and (x[i] < xm))then
     begin
       ym := y[i]; xm := x[i]; j := i;
     end;
  a[j] := 0;
  for i := 1 to nn do
  if (i <> j) then
  begin
    xx := x[i] - xm; yy := y[i] - ym;
    if (xx <> 0) and (yy <> 0) then
      a[i] := arctan(xx/yy)
      else
        if (xx = 0) then  a[i] := pi/2 else
          a[i] := 0;
  end;
  i := 1; s := 0;
  heapsort;
  x[n + 1] := x[1]; y[n + 1] := y[1];
  for i := 1 to nn do
    s := s + x[i] * y[i + 1] - x[i + 1] * y[i];
  s := 0.5 * abs(s);
  writeln(output, s:2:2);
  close(input); close(output);
end.
