{$I-,Q-,R-,S-}
type real=extended;
const eps=1e-10;
var n,i,j:integer;
    x1,y1,x2,y2:array[1..2000] of real;
    x,y:array[1..4000] of real;
    npix:integer;
    t,maxt,mint,tm1,tm2,cx,cy:real;
    tgt:byte;
    left,right:array[1..4000] of integer;
    lsi,rsi:integer;
    s:real;

procedure getL(v:integer);
var k:boolean;
    i,j:integer;
    py,pr:real;
begin
 lsi:=1;
 left[1]:=v;
 repeat
  py:=y[v];
  k:=true;
  for i:=1 to npix do if y[i]<py then
   if k then begin
    k:=false;
    j:=i;
   end else begin
    pr:=(x[i]-x[v])*(y[j]-y[v])-(x[j]-x[v])*(y[i]-y[v]);
    if pr>0 then j:=i;
    if pr=0 then if sqr(x[i]-x[v])+sqr(y[i]-y[v])>sqr(x[j]-x[v])+sqr(y[j]-y[v]) then j:=i;
   end;
  if not k then begin
   inc(lsi);
   left[lsi]:=j;
   v:=j;
  end;
 until k;
end;

procedure getR(v:integer);
var k:boolean;
    i,j:integer;
    py,pr:real;
begin
 rsi:=2;
 right[1]:=v;
 v:=1;
 for i:=2 to npix do if
  (y[i]>y[v])or
  ((y[i]=y[v])and(x[i]>x[v])) then v:=i;
 right[2]:=v;
 repeat
  py:=y[v];
  k:=true;
  for i:=1 to npix do if y[i]<py then
   if k then begin
    k:=false;
    j:=i;
   end else begin
    pr:=(x[i]-x[v])*(y[j]-y[v])-(x[j]-x[v])*(y[i]-y[v]);
    if pr<0 then j:=i;
    if pr=0 then if sqr(x[i]-x[v])+sqr(y[i]-y[v])>sqr(x[j]-x[v])+sqr(y[j]-y[v]) then j:=i;
   end;
  if not k then begin
   inc(rsi);
   right[rsi]:=j;
   v:=j;
  end;
 until k;
end;

begin
 assign(input,'convexh.in'); reset(input);
 assign(output,'convexh.out'); rewrite(output);
 read(n);
 for i:=1 to n do read(x1[i],y1[i],x2[i],y2[i]);
 npix:=0;
 for i:=1 to n do begin
  tgt:=0;
  for j:=1 to n do if i<>j then begin
   tm1:=(y1[i]-y1[j])*(x2[j]-x1[j])-(x1[i]-x1[j])*(y2[j]-y1[j]);
   tm2:=(x2[i]-x1[i])*(y2[j]-y1[j])-(y2[i]-y1[i])*(x2[j]-x1[j]);
   if abs(tm2)>eps then begin
    t:=tm1/tm2;
    if tgt=0 then begin maxt:=t; mint:=t; tgt:=1 end;
    if t>maxt then maxt:=t;
    if t<mint then mint:=t;
   end;
  end;
  cx:=x2[i]*maxt+x1[i]*(1-maxt);
  cy:=y2[i]*maxt+y1[i]*(1-maxt);
  inc(npix); x[npix]:=cx; y[npix]:=cy;
  if maxt<>mint then begin
   cx:=x2[i]*mint+x1[i]*(1-mint);
   cy:=y2[i]*mint+y1[i]*(1-mint);
   inc(npix); x[npix]:=cx; y[npix]:=cy;
  end;
 end;
 if npix<=1 then begin writeln(0); close(output); close(input); halt end;
 j:=1;
 for i:=2 to npix do if
  (y[i]>y[j])or
  ((y[i]=y[j])and(x[i]<x[j])) then j:=i;
 GetL(j); GetR(j);
 if lsi>2 then
 for i:=3 to lsi do begin
  s:=s-((x[left[i]]-x[j])*(y[left[i-1]]-y[j])-(x[left[i-1]]-x[j])*(y[left[i]]-y[j]));
 end;
 if rsi>2 then
 for i:=3 to rsi do begin
  s:=s+(x[right[i]]-x[j])*(y[right[i-1]]-y[j])-(x[right[i-1]]-x[j])*(y[right[i]]-y[j]);
 end;
 s:=s+(x[left[lsi]]-x[j])*(y[right[rsi]]-y[j])-(x[right[rsi]]-x[j])*(y[left[lsi]]-y[j]);
 writeln(s/2:0:15);
 close(output); close(input);
end.
