{$N+}
var pa,pb,pc:array[1..2000] of extended;
    n,pcnt,nrc:longint;
    px,py:array[1..4000] of extended;
    nr:array[1..4000] of integer;
    nw:array[1..4000] of boolean;
    sq:extended;
procedure p2l(x1,y1,x2,y2:extended;var a,b,c:extended);
begin
  if abs(x1-x2)>0.0001 then
    begin
      if abs(y1-y2)>0.0001 then
        b:=1
      else
        b:=0;
      a:=(y2-y1)/(x1-x2);
    end
  else
    begin
      b:=(x1-x2)/(y2-y1);
      a:=0;
    end;
  c:=-a*x1-b*y1;
end;
procedure l2p(a1,b1,c1,a2,b2,c2:extended;var x,y:extended);
begin
  if abs(a1)>0.0001 then
    begin
      y:=(-c2+a2*c1/a1)/(b2-a2*b1/a1);
      x:=(b1*y+c1)/a1;
    end
  else
    begin
      y:=(-c1+a1*c2/a2)/(b1-a1*b2/a2);
      x:=(b1*y+c1)/a1;
    end;
end;
procedure init;
var x1,x2,y1,y2:extended;
    i:integer;
begin
  assign(input,'convexh.in');
  reset(input);
  readln(n);
  for i:=1 to n do
    begin
      readln(x1,y1,x2,y2);
      p2l(x1,y1,x2,y2,pa[i],pb[i],pc[i]);
    end;
  close(input);
end;
procedure done;
begin
  assign(output,'convexh.out');
  rewrite(output);
  write(sq:0:3);
  close(output);
  halt(0);
end;
function getcs(x1,y1,x2,y2,x3,y3:extended):extended;
var a2,b2,c2:extended;
begin
  a2:=sqr(x1-x2)+sqr(y1-y2);
  b2:=(sqr(x3-x2)+sqr(y3-y2));
  c2:=(sqr(x1-x3)+sqr(y1-y3));
  if abs((2*sqrt(a2)*sqrt(b2)))<=0.0001 then
    getcs:=1
  else
    getcs:=(a2+b2-c2)/(2*sqrt(a2)*sqrt(b2));
end;
procedure run;
var b:boolean;
    minx,maxx,x,y:extended;
    miny,maxy:extended;
    i,j,pmc:integer;
    pmy,pmx,plx,ply,curc,tmp:extended;
begin
  pcnt:=0;
  pmy:=1e12;
  pmx:=1e12;
  for i:=1 to n-1 do
    begin
      if abs(pa[i])>0.0001 then
        b:=true
      else
        b:=false;
      maxx:=-1e12;
      maxy:=-1e12;
      minx:=1e12;
      miny:=1e12;
      for j:=i+1 to n do
        begin
          l2p(pa[i],pb[i],pc[i],pa[j],pb[j],pc[j],x,y);
          if b then
            begin
              if y<miny then
                begin
                  miny:=y;
                  minx:=x;
                end;
              if y>maxy then
                begin
                  maxy:=y;
                  maxx:=x;
                end;
            end
          else
            begin
              if x<minx then
                begin
                  miny:=y;
                  minx:=x;
                end;
              if x>maxx then
                begin
                  maxy:=y;
                  maxx:=x;
                end;
            end;
        end;
      if (maxx=minx) and (maxy=miny) then
        begin
          inc(pcnt);
          px[pcnt]:=maxx;
          py[pcnt]:=maxy;
          if (maxy<pmy) or ((maxy=pmy)and(maxx<pmx)) then
            begin
              pmc:=pcnt;
              pmy:=maxy;
              pmx:=maxx;
            end;
        end
      else
        begin
          inc(pcnt);
          px[pcnt]:=maxx;
          py[pcnt]:=maxy;
          if (maxy<pmy) or ((maxy=pmy)and(maxx<pmx)) then
            begin
              pmc:=pcnt;
              pmy:=maxy;
              pmx:=maxx;
            end;
          inc(pcnt);
          px[pcnt]:=minx;
          py[pcnt]:=miny;
          if (miny<pmy) or ((miny=pmy)and(minx<pmx)) then
            begin
              pmc:=pcnt;
              pmy:=miny;
              pmx:=minx;
            end;
        end;
    end;
  plx:=pmx+100;
  ply:=pmy;
  fillchar(nw,sizeof(nw),false);
  nw[pmc]:=true;
  nrc:=1;
  nr[1]:=pmc;
  curc:=0;
  while curc<=1 do
    begin
      curc:=2;
      for i:=1 to pcnt do
        begin
          tmp:=getcs(plx,ply,pmx,pmy,px[i],py[i]);
          if tmp<curc then
            begin
              curc:=tmp;
              pmc:=i;
            end;
        end;
      if nw[pmc] then
        curc:=2
      else
        begin
          plx:=pmx;
          ply:=pmy;
          pmx:=px[pmc];
          pmy:=py[pmc];
          nw[pmc]:=true;
          inc(nrc);
          nr[nrc]:=pmc;
        end;
    end;
  sq:=px[nr[nrc]]*py[nr[1]]-px[nr[1]]*py[nr[nrc]];
  for i:=1 to nrc-1 do
    sq:=sq+px[nr[i]]*py[nr[i+1]]-px[nr[i+1]]*py[nr[i]];
  sq:=abs(sq/2);
end;
begin
  init;
  run;
  done;
end.
