{$I-,Q-,R-,S-}
type
  p_1=^t_1;
  t_1=record
    pred,next:p_1;
    i:integer;
  end;

var
  k,z,i,j,n,m:integer;
  b:array[1..300] of integer;
  pgr,mtr:array[1..300] of boolean;
  pgrsm,mtrsm:array[1..300] of p_1;
  p1,p2:p_1;
  flag1:boolean;

procedure add(var p:p_1;i:integer);
var
  p1:p_1;
begin
  new(p1);
  p1^.next:=p;
  if p<>nil then p^.pred:=p1;
  p1^.i:=i;
  p1^.pred:=nil;
  p:=p1;
end;

procedure delete(var p,p1:p_1);
begin
  if p1^.pred<>nil then p1^.pred^.next:=p1^.next;
  if p1^.next<>nil then p1^.next^.pred:=p1^.pred;
  if p=p1 then p:=p1^.next;
  dispose(p1);
end;

procedure clear(var p:p_1);
var
  p1:p_1;
begin
  p1:=p;
  while p1<>nil do begin
    p:=p1;
    p1:=p^.next;
    dispose(p);
  end;
  p:=nil;
end;

begin
  assign(input,'party.in');
  reset(input);
  assign(output,'party.out');
  rewrite(output);
  fillchar(pgr,sizeof(pgr),0);
  fillchar(mtr,sizeof(mtr),0);
  readln(n,m);
  for i:=1 to n do
    pgrsm[i]:=nil;
  for j:=1 to m do
    mtrsm[j]:=nil;
  for i:=1 to n do begin
    read(b[i]);
    for k:=1 to b[i] do begin
      read(j);
      add(pgrsm[i],j);
      add(mtrsm[j],i);
    end;
    dec(b[i]);
  end;
  k:=0;

  flag1:=true;
  while flag1 do begin
    flag1:=false;
    for i:=1 to n do
      if (not pgr[i]) and (b[i]<=0) then begin
        flag1:=true;
        inc(k);
        pgr[i]:=true;
        p1:=pgrsm[i];
        while p1<>nil do begin
          j:=p1^.i;
          mtr[j]:=true;
          p2:=mtrsm[j];
          while p2<>nil do begin
            z:=p2^.i;
            dec(b[z]);
            p2:=p2^.next;
          end;
          p1:=p1^.next;
        end;
      end;
  end;
  writeln(k);
  for i:=1 to n do if pgr[i] then
    write(i,' ');
  close(input);
  close(output);
end.