program ElectricScheme;

var f: text;
    comp: array [1..100] of byte;
    n, c3, c1, c2: byte;
    i, j, k, m, temp: word;
    phi: array [1..100, 0..100] of real;
    pip: array [1..5000, 1..3] of word;
    max, alp: real;
    poss: boolean;

begin
  assign (f, 'flow.in');
  reset (f);
  readln (f, n);
  for i := 1 to n do
  begin
    comp [i] := i;
    for j := 0 to n do phi [i, j] := 0;
  end;
  readln (f, m);
  for i := 1 to m do
  begin
    read (f, c1, c2);
    readln (f, temp);
    pip [i, 1] := c1;
    pip [i, 2] := c2;
    pip [i, 3] := temp;
    phi [c1, c1] := phi [c1, c1] + 1;
    phi [c2, c2] := phi [c2, c2] + 1;
    phi [c1, c2] := phi [c1, c2] - 1;
    phi [c2, c1] := phi [c2, c1] - 1;
    if (comp [c1] <> comp [c2]) then
    begin
      c1 := comp [c1];
      c2 := comp [c2];
      if (c1 > c2) then
begin
  c3 := c1;
c1 := c2;
c2 := c3;
end;
      for j := 1 to n do
        if (comp [j] = c2) then
        begin
          comp [j] := c1;
        end;
    end;
  end;
  close (f);
  if (comp [n] > 1) then
  begin
    assign (f, 'flow.out');
    rewrite (f);
    for i := 0 to m do
    begin
      writeln (f, '0.000000');
    end;
    close (f);
    halt;
  end;
  for i := 0 to n do
  begin
    phi [1, i] := 0;
    phi [n, i] := 0;
  end;
  phi [1, 1] := 1;
  phi [n, n] := 1;
  phi [1, 0] := 0;
  phi [n, 0] := -1;
  for i := n downto 1 do if (comp [i] = 1) then
  begin
    alp := - (1 / phi [i, i]);
    phi [i, i] := 0;
    for j := 0 to i - 1 do
    begin
      phi [i, j] := phi [i, j] * alp;
    end;
    for j := 1 to i - 1 do if (comp [i] = 1) then
    begin
      alp := phi [j, i];
      phi [j, i] := 0;
      for k := 0 to i - 1 do if (comp [i] = 1) then
      begin
        phi [j, k] := phi [j, k] + alp * phi [i, k];
      end;
    end;
{  for k := 1 to n do
  begin
    for j := 0 to n do write (phi [k, j]:4:1);
    writeln;
  end;
  readln;}
  end;
  for i := 2 to n do if (comp [i] = 1) then
  begin
    for j := 1 to i-1 do if (comp [i] = 1) then
    begin
      phi [i, 0] := phi [i, 0] + phi [i, j] * phi [j, 0];
    end;
  end;
{  for k := 1 to n do
  begin
    writeln (13*phi [k, 0]:0:4);
  end;
  readln;}
  max := 0;
  poss := true;
  for i := 1 to m do
  begin
    if (comp [pip [i, 1]] = 1) then
    begin
      alp := abs (phi [pip [i, 2], 0] - phi [pip [i, 1], 0]);
      if (alp > 0.00001) and (pip [i, 3] = 0) then
      begin
        poss := false;
      end
      else if (pip [i, 3] > 0) then
      begin
        alp := alp / pip [i, 3];
        if (alp > max) then max := alp;
      end;
    end;
  end;
  assign (f, 'flow.out');
  rewrite (f);
  if poss then
  begin
    alp := 1 / max;
    writeln (f, alp:0:6);
    for i := 1 to m do
    begin
      if (comp [pip [i, 1]] = 1) then
      begin
        writeln (f, alp*(phi [pip [i, 2], 0] - phi [pip [i, 1], 0]):0:6);
      end
      else
      begin
        writeln (f, '0.000000');
      end;
    end;
  end
  else
  begin
    for i := 0 to m do
    begin
      writeln (f, '0.000000');
    end;
  end;
  close (f);
end.
