{
  Dmitry Orlov
    SARATOV
    id = 33
}


{.$define debug}

{$R-,Q-,S-,I-,N+}


program template;
const
 nmax = 310;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'move.in';
 coutfile= 'move.out';
 {$endif}
type
 int = integer;
 real = extended;
var
 gr :array [1..2,1..nmax,1..nmax] of integer;
 graph :array [1..nmax,1..nmax] of int;
 pow :array [1..nmax] of int;
 ribs :array [1..nmax,0..nmax] of int;
 alpha :int;
 n,m :int;

procedure init;
begin
 fillchar (gr,sizeof(gr),0);
 fillchar (graph,sizeof(graph),0);
 fillchar (pow,sizeof(pow),0);
 fillchar (ribs,sizeof(ribs),0);
end;

procedure swap (var a,b :int);
begin
 a := a xor b;
 b := a xor b;
 a := a xor b;
end;

procedure repaint (part :byte; u :int; col :int);
var i,j,k :int;
    chain :array [1..2*nmax] of int;
    used :array [1..2,1..nmax] of boolean;
    b :array [1..2] of int;
    cur :int;
begin
 i := 1;
 while (gr[part][u][i] > 0) do
  inc(i);
 fillchar (chain,sizeof(chain),0);
 fillchar (used,sizeof(used),0);
 b[1] := col;
 b[2] := i;
 cur := u;
 k := 0;
 j := part;
 while {(gr[part][cur][b[1]] > 0)}
  (cur > 0) and not
  used[part][cur] do
  begin
   inc(k);
   chain[k] := cur;
   cur := gr[part][cur][b[1]];
   part := 3 - part;
   swap (b[1],b[2]);
  end;
 part := j;
 for i := 1 to k do
  begin
   swap (gr[part][chain[i]][b[1]],gr[part][chain[i]][b[2]]);
   part := 3 - part;
  end;
end;

procedure add (u,v :int);
var i :int;
begin
 i := 1;
 while (gr[1][u][i] > 0) and (gr[2][v][i] > 0) do
  inc(i);
 if (gr[1][u][i] = 0) and (gr[2][v][i] = 0) then
  begin
   gr[1][u][i] := v;
   gr[2][v][i] := u;
   exit;
  end;
 if gr[1][u][i] > 0 then
  repaint(1,u,i)
 else
  repaint(2,v,i);
 gr[1][u][i] := v;
 gr[2][v][i] := u;
end;

procedure readdata;
var i,j,u :int;
    d :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (n,m);
 alpha := 0;
 for i := 1 to n do
  begin
   read (d);
   ribs[i][0] := d;
   if d > alpha then
    alpha := d;
   for j := 1 to d do
    begin
     read (u);
     add (i,u);
     ribs[i][j] := u;
     inc(pow[u]);
    end;
  end;
 close (input);
end;

function max (a,b :int):int;
begin
 if a > b then
  max := a
 else
  max := b;
end;

procedure outdata;
var i,j,k :int;
begin
 assign (output,coutfile);
 rewrite (output);
 for i := 1 to n do
  begin
   for j := 1 to ribs[i][0] do
    write (graph[i,ribs[i][j]] - 1,' ');
   writeln;
  end;
 close (output);
end;

procedure solve;
var i,j :int;
begin
 for i := 1 to m do
  if pow[i] > alpha then
   alpha := pow[i];
 for i := 1 to n do
  for j := 1 to alpha do
   if gr[1][i][j] > 0 then
    graph[i,gr[1][i][j]] := j;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.