{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}

const infile = 'mayors.in'; outfile = 'mayors.out'; max = 20005;
type pt = record x,y: longint; end;
var a: array [1..max] of pt;
    ans,num,tmp: array [1..max] of longint;
    n: longint;

procedure init;
var i: longint;
begin
     assign(input,infile);
     reset(input);
     read(n);
     for i:=1 to n do
         read(a[i].x,a[i].y);
     close(input);
end;

procedure swap(v1,v2: longint);
var c: pt;
    w: longint;
begin
     c:=a[v1]; a[v1]:=a[v2]; a[v2]:=c;
     w:=num[v1]; num[v1]:=num[v2]; num[v2]:=w;
end;

procedure sort(l,t: longint);
var i,j,wx,wy: longint;
begin
     i:=l; j:=t; wx:=a[(l+t) div 2].x; wy:=a[(l+t) div 2].y;
     repeat
           while (a[i].y < wy)or((a[i].y = wy)and(a[i].x < wx)) do inc(i);
           while (a[j].y > wy)or((a[j].y = wy)and(a[j].x > wx)) do dec(j);
           if i <= j then begin
              swap(i,j); inc(i); dec(j);
           end;
     until i > j;
     if i < t then sort(i,t);
     if j > l then sort(l,j);
end;

procedure solve;
var i,j,cx,cy,c: longint;
begin
     for i:=1 to n do num[i]:=i;
     sort(1,n); tmp:=num;
     for i:=1 to n do num[tmp[i]]:=i;
     for i:=1 to n do begin
         cx:=0; cy:=0;
         for j:=1 to i-1 do begin
             if a[j].x = a[i].x then cx:=cx+ans[j];
             if a[j].y = a[i].y then cy:=cy+ans[j];
         end;
         if abs(cx) > abs(cy) then c:=cx else c:=cy;
         if c > 0 then ans[i]:=-1 else ans[i]:=1;
     end;
end;

procedure done;
var i: longint;
begin
     assign(output,outfile);
     rewrite(output);
     for i:=1 to n do
         if ans[num[i]] = -1 then writeln(0)
            else writeln(ans[num[i]]);
     close(output);
end;

begin
     init;
     solve;
     done;
end.