#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define NN 110000
#define KK 1000

struct EVENT {
  int type;
  int i;
  int c;
  int time;
};

int _stklen = 4000000;

FILE *fi, *fo;
int n,m;
int n1;
int res[NN];
int *a;
int s_a;
int *b;
int bf[KK];
int s_bf;
int s_used;
bool used[NN];
EVENT t[2*NN];

void sift(int p, int q)
{
  int i,j;
  EVENT x;
  i=p;
  j=2*i+1;
  x=t[i];
  if(j<q-1) if(t[j+1].time>t[j].time) j++;
  if(j<q) if(t[j].time<x.time) j=q+1;
  while(j<q)
  {
    t[i]=t[j];
    i=j;
    j=2*j+1;
    if(j<q-1) if(t[j+1].time>t[j].time) j++;
    if(j<q) if(t[j].time<x.time) j=q+1;
  }
  t[i]=x;
}

void Sort()
{
  EVENT x;
  int i,j;
  j=2*m;
  for(i=m+1;i>=0;i--)
    sift(i,j);
  i=0;
  while(j>1)
  {
    j--;
    x=t[j];
    t[j]=t[0];
    t[0]=x;
    sift(i,j);
  }
}

int bsearch(int c)
{
  int b,e;
  int t;
  b=0;
  e=s_a-1;
  if(a[b]>=c)
    return b;
  if(a[e]<c)
    return b;
  while((e-b)>1)
  {
    t=(b+e)/2;
    if(a[t]>=c)
      e=t;
    else
      b=t;
  }
  return e;
}

void ReCalk()
{
  int *tmp;
  int i_a;
  int i_bf;
  int i_b;
  i_a=0;
  i_b=0;
  i_bf=0;
  while((i_a<s_a)||(i_bf<s_bf))
  {
    if((i_a<s_a)&&(i_bf<s_bf))
    {
      if(a[i_a]<bf[i_bf])
      {
        if(!used[a[i_a]])
        {
          b[i_b]=a[i_a];
          i_b++;
        }
        i_a++;
      }
      else
      {
        if(!used[bf[i_bf]])
        {
          b[i_b]=bf[i_bf];
          i_b++;
        }
        i_bf++;
      }
    }
    else
    {
      if(i_a<s_a)
      {
        if(!used[a[i_a]])
        {
          b[i_b]=a[i_a];
          i_b++;
        }
        i_a++;
      }
      else
      {
        if(!used[bf[i_bf]])
        {
          b[i_b]=bf[i_bf];
          i_b++;
        }
        i_bf++;
      }
    }
//    i_b++;
  }
  s_a=i_b;
  s_bf=0;
  s_used=0;
  tmp=a;
  a=b;
  b=tmp;
}

void Insert(int i, int c)
{
  int j;
  int x;
  j=bsearch(c);
  while((used[a[j]])&&(j<s_a)) j++;
  x=0;
  while((bf[x]<c)&&(x<s_bf)) x++;
  while(true)
    if(x<s_bf)
      if(used[bf[x]])
        x++;
      else
        break;
    else
      break;
  if(j>=s_a) j=-1;
  if(x>=s_bf) x=-1;

  if((j>=0)||(x>=0))
  {
    if(j<0)
      x=bf[x];
    else
      if(x>=0)
        if(bf[x]<a[j])
          x=bf[x];
        else
          x=a[j];
      else
        x=a[j];
    used[x]=true;
    res[i]=x;
    s_used++;
    if(s_used>=n1)
      ReCalk();
    return ;
  }

  j=0;
//  while((used[a[j]])&&(j<s_a)) j++;
  while(true)
    if(j<s_a)
      if(used[a[j]])
        j++;
      else
        break;
    else
      break;
  if(j>=s_a)
    j=-1;
  x=0;
//  while((used[bf[x]])&&(x<s_bf)) x++;
  while(true)
    if(x<s_bf)
      if(used[bf[x]])
        x++;
      else
        break;
    else
      break;
  if(x>=s_bf)
    x=-1;
    
  if(j<0)
    x=bf[x];
  else
    if(x>=0)
      if(bf[x]<a[j])
        x=bf[x];
      else
        x=a[j];
    else
      x=a[j];
  used[x]=true;
  res[i]=x;
  s_used++;
  if(s_used>=n1)
    ReCalk();
}

void Extract(int i)
{
  int j;
  int x;
  j=0;
  used[res[i]]=false;
  while((bf[j]<res[i])&&(j<s_bf)) j++;
  for(x=s_bf;x>j;x--)
    bf[x]=bf[x-1];
  bf[j]=res[i];
  s_bf++;
  if(s_bf>=n1)
    ReCalk();
}

int main()
{
  int i,j;
  int x,y,z;
  fi=fopen("parking.in","rt");
  fo=fopen("parking.out","wt");

  a=new int [NN];
  b=new int [NN];

  fscanf(fi,"%i%i",&n,&m);
  n1=(int)sqrt(n)+1;
  for(i=0;i<m;i++)
  {
    fscanf(fi,"%i%i%i",&x,&y,&z);
    t[2*i].type=0;
    t[2*i].i=i;
    t[2*i].time=x;
    t[2*i].c=z-1;
    t[2*i+1].type=1;
    t[2*i+1].i=i;
    t[2*i+1].time=y;
  }

  Sort();

  for(i=0;i<n;i++)
  {
    used[i]=false;
    a[i]=i;
  }
  s_a=n;
  s_bf=0;
  s_used=0;

  for(i=0;i<2*m;i++)
  {
    if(t[i].type)
      Extract(t[i].i);
    else
      Insert(t[i].i,t[i].c);
  }

  for(i=0;i<m;i++)
  {
    fprintf(fo,"%i\n",res[i]+1);
  }

  fclose(fi);
  fclose(fo);
  return 0;
}
