program zzz;

const
  maxn = 100000;
type
  point = record
    x,y: double;
  end;
var
  i,sc,j,k,n,m: longint;
  a: array[1..maxn] of point;

function orsq(p1,p2,p3: point): double;
begin
  orsq := (p1.x-p2.x)*(p2.y-p3.y)-(p1.y-p2.y)*(p2.x-p3.x);
end;
function intr(p1,p2,p3,p4: point) : boolean;
var a,b,c,d: double;
begin
  a := orsq(p1,p2,p3); b := orsq(p1,p2,p4);
  c := orsq(p3,p4,p1); d := orsq(p3,p4,p2);
  intr := ((a > 0) xor (b > 0)) and ((c > 0) xor (d > 0));
end;
begin
  assign(input,'poly.in'); reset(input);
  assign(output,'poly.out'); rewrite(output);
  read(n);
  for i := 1 to n do begin
    read(a[i].x,a[i].y);
  end;
  for i := 1 to n-1 do begin
    for j := i+2 to n-1 do begin
      if intr(a[i],a[i+1],a[j],a[j+1]) then inc(sc);
    end;
  end;
  writeln(sc);
  close(output);
  close(input);
end.
