{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 500000,0,655360}

Const INPUTFILE='parking.in';
      OUTPUTFILE='parking.out';

Const Max=150000;
Type Real=Double;
Procedure TSet(i:Longint;Value:Byte);forward;

var a:Array[1..2*Max] of Byte;
    b:Array[1..Max,1..3] of Longint;

    Nums1,Nums2,RealPlace:Array[1..Max] of Longint;
    Ans:Array[1..Max] of Longint;
    N,M,oN:Longint;
    i,j:Longint;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Read(N,M);
for i:=1 to M do
for j:=1 to 3 do
  Read(b[i,j]);
Close(Input);
oN:=N;
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
for i:=1 to Answer do
  Writeln(Ans[i]);
Close(Output);

Halt;
end;

Procedure TInit;
var t:Longint;
begin
t:=1;
While t<N do t:=t shl 1;
N:=t;
FillChar(a,SizeOf(a),1);
for i:=oN+1 to N do
  TSet(i,0);
end;

Procedure TSet(i:Longint;Value:Byte);
var j:Longint;
begin
if Value=1 then
begin
  j:=i+N-1;
  Repeat
    a[j]:=1;
    j:=j shr 1;
  Until j=0;
end
else if Value=0 then
begin
  j:=i+N-1;
  Repeat
    a[j]:=0;
    j:=j div 2;
  Until (j=0) OR (a[j shl 1]=1) OR (a[j shl 1+1]=1);
end;
end;

Function TFind(i:Longint):Longint;
var j,oj:Longint;
begin
j:=N-1+i;
if a[j]=1 then
begin
  TFind:=i;
  Exit;
end;

Repeat
  oj:=j;
  j:=j shr 1;
  if j=0 then
  begin
    TFind:=TFind(1);
    Exit;
  end;
  if (a[j]=1) AND (Odd(oj)=False) AND (a[oj+1]=1) then Break;
Until 1=0;
j:=j shl 1+1;
While j<N Do
begin
  j:=j shl 1;
  if a[j]=0 then Inc(j);
end;

TFind:=j-N+1;
end;

Procedure QSort1(L,R:Longint);
var i,j:Longint;
    x,t:Longint;
begin
i:=L;
j:=R;
x:=b[Nums1[(i+j) div 2],1];

Repeat
  While b[Nums1[i],1]<x Do Inc(i);
  While b[Nums1[j],1]>x Do Dec(j);
  if i<=j then
  begin
    t:=Nums1[i];
    Nums1[i]:=Nums1[j];
    Nums1[j]:=t;

    Inc(i);
    Dec(j);
  end;
Until i>j;
if j>L then QSort1(L,j);
if i<R then QSort1(i,R);
end;

Procedure QSort2(L,R:Longint);
var i,j:Longint;
    x,t:Longint;
begin
i:=L;
j:=R;
x:=b[Nums2[(i+j) div 2],2];

Repeat
  While b[Nums2[i],2]<x Do Inc(i);
  While b[Nums2[j],2]>x Do Dec(j);
  if i<=j then
  begin
    t:=Nums2[i];
    Nums2[i]:=Nums2[j];
    Nums2[j]:=t;

    Inc(i);
    Dec(j);
  end;
Until i>j;
if j>L then QSort2(L,j);
if i<R then QSort2(i,R);
end;

Procedure SortAll;
var t:Longint;
begin
for i:=1 to M do
begin
  Nums1[i]:=i;
  Nums2[i]:=i;
end;
Randomize;
for i:=M downto 1 do
begin
  j:=Random(i)+1;
  t:=Nums1[i];
  Nums1[i]:=Nums1[j];
  Nums1[j]:=t;

  j:=Random(i)+1;
  t:=Nums2[i];
  Nums2[i]:=Nums2[j];
  Nums2[j]:=t;
end;

QSort1(1,M);
QSort2(1,M);
end;

Procedure Solve;
var g,h:Longint;
    K:Longint;
begin
TInit;
SortAll;

i:=1;
j:=1;
K:=0;
Repeat
  While (i<=M) AND (b[Nums1[i],1]<b[Nums2[j],2]) Do
  begin
    g:=TFind(b[Nums1[i],3]);
    TSet(g,0);
    Inc(K);
    Ans[Nums1[K]]:=g;
    RealPlace[Nums1[i]]:=g;
    Inc(i);
  end;
  if i>M then Break;

  While (j<=M) AND (b[Nums2[j],2]<b[Nums1[i],1]) Do
  begin
    TSet(RealPlace[Nums2[j]],1);
    Inc(j);
  end;
Until 1=0;
FWrite(K);
end;

begin
FRead;
Solve;
end.
