{$D-,L-,Q-,R-,S-,I-,N-}
Program pr_a;
const
  inpfile='parking.in';
  outfile='parking.out';
  nm=100005;
type
  Move=record
    b : Boolean;
    t : LongInt;
    n : LongInt;
  end;
var
  u : array [1..nm] of Boolean;
  r,q,p,t,z : array [1..nm] of LongInt;
  s : array [1..2*nm] of Move;
  tl : LongInt;
  n,m,mm : LongInt;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n,m);
  for i:=1 to m do begin
    read(s[i].t,s[i+m].t,q[i]);
    s[i].n:=i; s[i+m].n:=i;
    s[i].b:=true;
  end;
end;
{}
Procedure Out;
var
  i,j : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  for i:=1 to m do writeln(r[i]);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(u,sizeof(u),0);
  fillchar(q,sizeof(q),0);
  fillchar(r,sizeof(r),0);
  fillchar(s,sizeof(s),0);
  fillchar(p,sizeof(p),0);
  fillchar(t,sizeof(t),0);
end;
{}
Procedure Swap(var q,w : Move);
var
  bak : Move;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure Sort(l,r: LongInt);
var
  i,j,x : LongInt;
begin
  i:=l; j:=r; x:=s[(l+r) div 2].t;
  repeat
    while s[i].t<x do inc(i);
    while x<s[j].t do dec(j);
    if not(i>j) then begin
      Swap(s[i],s[j]);
      inc(i); dec(j);
    end;
  until i>j;
  if l<j then Sort(l,j);
  if i<r then Sort(i,r);
end;
{}
Procedure Solve;
var
  i,j : LongInt;
begin
  mm:=2*m; Sort(1,mm);

  tl:=-10;
  for i:=1 to n do begin
    p[i]:=i;
    z[i]:=i-1;
  end;

  for i:=1 to mm do begin
    if s[i].b then begin
      if tl>=t[p[q[s[i].n]]] then j:=q[s[i].n]-1
                             else j:=z[p[q[s[i].n]]];

      while u[j+1] do begin
        p[j+1]:=q[s[i].n];
        j:=(j+1) mod n;
      end;

      u[j+1]:=true; r[s[i].n]:=j+1; p[j+1]:=q[s[i].n];

      z[q[s[i].n]]:=(j+1) mod n; t[q[s[i].n]]:=s[i].t;
    end else begin
      u[r[s[i].n]]:=false;
      tl:=s[i].t;
    end;
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
