type tc=record who,t:longint; fir:boolean end;
var events:array[1..200000] of tc;
    cars:array[1..200000] of record a,b,c,r:longint; end;
    t_p:array[1..200000] of longint;
    t_m:array[1..200000] of longint;
    n,m,el:longint;
procedure init;
var i:longint;
begin
  assign(input,'parking.in');
  reset(input);
  readln(n,m);
  for i:=1 to m do
    begin
      readln(cars[i].a,cars[i].b,cars[i].c);
      events[2*i-1].who:=i;
      events[2*i-1].t:=cars[i].a;
      events[2*i-1].fir:=true;
      events[2*i].who:=i;
      events[2*i].t:=cars[i].b;
      events[2*i].fir:=false;
    end;
  close(input);
end;
procedure heapify(k:longint);
var ms:longint;
    tmp:tc;
begin
  ms:=k;
  if (k*2<=el) and (events[k*2].t<events[ms].t) then
    ms:=k*2;
  if (k*2+1<=el) and (events[k*2+1].t<events[ms].t) then
    ms:=k*2+1;
  if ms<>k then
    begin
      tmp:=events[ms];
      events[ms]:=events[k];
      events[k]:=tmp;
      heapify(ms);
    end;
end;
procedure bildheap;
var i:longint;
begin
  for i:=m downto 1 do
    heapify(i);
end;
function getp(k:longint;var mm:longint):longint;
var z:longint;
begin
  if (t_p[k]<>k) and (t_p[k]<>0) then
    begin
      t_p[k]:=getp(t_p[k],mm);
      while ((k<=mm)and(mm<t_p[k])) or ((t_p[k]<k)and(k<=mm)) or ((mm<t_p[k])and(t_p[k]<k))do
        begin
          t_p[k]:=mm;
          mm:=t_m[mm];
        end;
      getp:=t_p[k];
    end
  else
    begin
      getp:=k;
      mm:=t_m[k];
    end;
end;
procedure add(a,b:longint);
var x,y,z:longint;
begin
  x:=getp(a,z);
  y:=getp(b,z);
  t_p[y]:=t_p[x];
  t_m[x]:=t_m[y];
end;
procedure done;
var i:longint;
begin
  assign(output,'parking.out');
  rewrite(output);
  for i:=1 to m do
    writeln(cars[i].r);
  close(output);
  halt(0);
end;
procedure run;
var tmp:tc;
    z,i:longint;

begin
  el:=2*m;
  bildheap;
  for i:=1 to n do
    t_p[i]:=i;
  for i:=1 to n do
    t_m[i]:=(n+i-2) mod n+1;
  for i:=1 to 2*m do
    begin
      tmp:=events[1];
      events[1]:=events[el];
      dec(el);
      if el>0 then
        heapify(1);
      if tmp.fir then
        begin
          cars[tmp.who].r:=getp(cars[tmp.who].c,z);
          add((cars[tmp.who].r) mod n+1,cars[tmp.who].r);
        end
      else
        begin
          t_m[cars[tmp.who].r]:=t_m[getp(cars[tmp.who].r,z)];
          t_m[getp(cars[tmp.who].r,z)]:=cars[tmp.who].r;
          t_p[cars[tmp.who].r]:=cars[tmp.who].r;
        end;
    end;
end;
begin
  init;
  run;
  done;
end.
