#include <stdio.h>
#include <string.h>

#include "game.h"

struct TProbability {
  long c,d;
};
struct TProbsum {
  long c,d,e;
};
struct TRes {
  long z;
  short u;
};

short n,N,m;
TProbability*A,**a;
TProbsum*b;
short*g,*h;
char*O,**o;
TRes*r;

long trymove(short k,short&u) {
  if (g[k]<2) return(0);
  short i;
  TProbsum x,y,z;
  x.c=0; x.d=1; x.e=0;
  for (i=0; i<m; i++) if (i!=k) {
    y.c=x.c*b[g[i]].d+x.d*b[g[i]].c;
    y.d=x.c*b[g[i]].c+x.d*b[g[i]].d;
    y.e=(x.c+x.d)*b[g[i]].e+x.e*(b[g[i]].c+b[g[i]].d);
    x=y;
  }
  u=0;
  for (i=1; i<g[k]; i++) {
    y.c=x.c*a[g[k]][i].d+x.d*a[g[k]][i].c;
    y.d=x.c*a[g[k]][i].c+x.d*a[g[k]][i].d;
    y.e=x.e*(a[g[k]][i].c+a[g[k]][i].d);
    if ((y.c)&&(!y.d)) { u=i; return(-1); }
    if (!u) { u=i; z=y; } else
    if (z.c-z.d<y.c-y.d) { u=i; z=y; }
  }
  if (z.c<z.d) return(1); else return(z.c-z.d+2);
}
int selectmove(short&v,short&w) {
  short i;
  for (i=0; i<m; i++) if (g[i]>1) break;
  if (i>=m) return(0);
  short k,j; long z;
  for (i=0; i<m; i++) r[i].z=trymove(i,r[i].u);
  for (i=0; i<m; i++) if (r[i].z<0) break;
  if (i<m) k=i; else {
    z=0; k=-1;
    for (i=0; i<m; i++) if (r[i].z>z) { k=i; z=r[i].z; }
  }
  for (v=0; v<n; v++) if (o[k][v]) break;
  for (w=v+1,j=r[k].u; w<n; w++) {
    if (o[k][w]) j--;
    if (j<=0) break;
  }
  return(1);
}
void divide(short v,short w) {
  short k,i;
  if (v>w) { k=v; v=w; w=k; }
  for (k=0; k<m; k++) if (o[k][v]||o[k][w]) break;
  g[m]=0;
  for (i=v; i<=w; i++) if (o[k][i]) { o[k][i]=0; o[m][i]=1; g[m]++; }
  g[k]-=g[m]; g[m]-=2;
  o[m][v]=0; o[m][w]=0;
  m++;
}

int main(void) {
  n=(short)Init();
//printf("%hd:\n",n);
  short i,j;
  N=n*n;
  A=new TProbability[N+n]; a=new TProbability*[n+1]; b=new TProbsum[n+1];
  for (i=0,j=0; i<=n; i++,j+=n) a[i]=&A[j];
  memset(A,0,(N+n)*sizeof(TProbability));
  memset(b,0,(n+1)*sizeof(TProbsum));
  b[0].d=1; b[1].d=1;
  for (i=2; i<=n; i++) {
    for (j=1; j<i; j++) {
      a[i][j].c=b[j-1].c*b[i-j-1].c+b[j-1].d*b[i-j-1].d;
      a[i][j].d=b[j-1].c*b[i-j-1].d+b[j-1].d*b[i-j-1].c;
    }
    for (j=1; j<i; j++) {
      if (!a[i][j].d) { if (a[i][j].c) b[i].c++; }
      else if (!a[i][j].c) { if (a[i][j].d) b[i].d++; }
      else b[i].e++;
    }
  }
  short v,w,x,y; int X,Y;
  g=new short[n]; h=new short[n];
  O=new char[N]; o=new char*[n];
  for (i=0,j=0; i<n; i++,j+=n) o[i]=&O[j];
  memset(O,0,N*sizeof(char));
  for (i=0; i<n; i++) { h[i]=0; o[0][i]=1; }
  g[0]=n; m=1;
  r=new TRes[n];
  while (selectmove(v,w)) {
    divide(v,w);
    Move(((int)v+1),((int)w+1),&X,&Y);
    x=(short)X-1; y=(short)Y-1;
    if ((x<0)||(y<0)) continue;
    divide(x,y);
  }
  delete[]r;
  delete[]g; delete[]h; delete[]O; delete[]o;
  delete[]A; delete[]a; delete[]b;
  return(0);
}

