program skobki;

const
  osn = 10;
  maxn = 100;
  maxd = 1000;
type
  long = array[0..maxd] of longint;
var
  a1,a2: array[0..maxn] of long;
  buf: long;
  i,j,k,n,m: longint;
function max(a,b: longint): longint;
begin
  if a>b then max := a else max := b;
end;
procedure sum(a,b: long; var c: long);
var i,j: longint;
begin
  for i := 1 to max(a[0],b[0]) do c[i] := a[i] + b[i];
  for i := 1 to max(a[0],b[0]) do begin
    c[i+1] := c[i+1] + c[i] div osn;
    c[i] := c[i] mod osn;
  end;
  c[0] := max(a[0],b[0])+1;
  while c[c[0]] = 0 do dec(c[0]);
end;
procedure prod(a,b: long; var c: long);
var i,j: longint;
begin
  for i := 1 to a[0] + b[0] + 1 do c[i] := 0;
  for i := 1 to a[0] do begin
    for j := 1 to b[0] do begin
      c[i+j-1] := c[i+j-1] + a[i]*b[j];
    end;
  end;
  for i := 1 to a[0]+b[0] do begin
    c[i+1] := c[i+1] + c[i] div osn;
    c[i] := c[i] mod osn;
  end;
  c[0] := a[0]+b[0]+1;
  while c[c[0]] = 0 do dec(c[0]);
end;
procedure zero(var a: long);
var i: longint;
begin
  for i := 1 to a[0] do a[i] := 0;
  a[0] := 0;
end;
procedure outlng(a: long);
var i: longint;
begin
  for i := a[0] downto 1 do write(a[i]);
  writeln;
end;
begin
  assign(input,'brackets.in'); reset(input);
  assign(output,'brackets.out'); rewrite(output);
  read(n);
  a1[0,0] := 1;
  a1[0,1] := 1;
  a2[0,1] := 1;
  a2[0,0] := 1;
  for i := 1 to n do begin
    for j := 0 to i-1 do begin
      zero(buf);
      prod(a2[j],a2[i-j-1],buf);
      sum(a2[i],buf,a2[i]);
      sum(a2[i],buf,a2[i]);
      zero(buf);
      prod(a1[j],a1[i-j-1],buf);
      sum(a1[i],buf,a1[i]);
      sum(a1[i],buf,a1[i]);
      zero(buf);
      prod(a2[j],a1[i-j-1],buf);
      sum(a1[i],buf,a1[i]);
    end;
  end;
  outlng(a1[n]);
  close(input);
  close(output);
end.
