{
  Dmitry Orlov
    SARATOV
    id = 33
}


{.$define debug}

{$R-,Q-,S-,I-,N+}


program template;
const
 h = 15000000;
 maxvolume = 100000;
 inf = maxlongint;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'cnk.in';
 coutfile= 'cnk.out';
 {$endif}
type
 int = longint;
 real = extended;
var
 m,p :int;
 d :array [0..h] of byte;
 ans :int;
 b :array [1..maxvolume] of int;
 k :int;

procedure init;
begin
 ans := 0;
 fillchar (d,sizeof(d),0);
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (m,p);
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans);
 close (output);
end;

procedure putbit (var res :byte; pos :byte);
begin
 res := res or (1 shl pos);
end;

function gcd (a,b :int):int;
var r :int;
begin
 if a < b then
  begin
   a := a xor b;
   b := a xor b;
   a := a xor b;
  end;
 while b > 0 do
  begin
   r := a mod b;
   a := b;
   b := r;
  end;
 gcd := a;
end;

function binomial (n,k :int):int;
const
 maxl = 30;
var b :array [1..maxl] of int;
    l :int;
    res :real;
    i,j :int;
    t,tmp :int;
begin
 binomial := inf;
 fillchar (b,sizeof(b),0);
 l := 0;
 for i := n-k+1 to n do
  begin
   inc(l);
   if l > maxl then
    exit;
   b[l] := i;
  end;
 for i := 1 to k do
  begin
   t := i;
   for j := 1 to l do
    begin
     tmp := gcd(t,b[j]);
     b[j] := b[j] div tmp;
     t := t div tmp;
     if t = 1 then
      break;
    end;
  end;
 res := 1.0;
 for i := 1 to l do
  res := res * b[i];
 if res > inf + 1e-5 then
  exit;
 binomial := round(res);
end;

procedure swap (var a,b :int);
begin
 a := a xor b;
 b := a xor b;
 a := a xor b;
end;

procedure sort (l,r :int);
var i,j :int;
    x :int;
begin
 i := l;
 j := r;
 x := b[l + random(r-l+1)];
 repeat;
  while b[i] < x do
   inc(i);
  while b[j] > x do
   dec(j);
  if i <= j then
   begin
    if not (i = j) then
     swap (b[i],b[j]);
    inc(i);
    dec(j);
   end;
 until i > j;
 if i < r then
  sort (i,r);
 if l < j then
  sort (l,j);
end;

function getnumber :int;
var dp :int;
    i,j :int;
begin
 sort (1,k);
 dp := 1;
 for i := 2 to k do
  begin
   if not (b[i] = b[i-1]) then
    inc(dp);
   if dp = p then
    begin
     getnumber := b[i];
     exit;
    end;
  end;
end;

procedure solve;
var i,j :int;
    t :int;
begin
 for i := 1 to m do
  begin
   j := 1;
   t := binomial (i,j);
   while (t < 8*h) and (j <= i shr 1 + 1) do
    begin
     putbit (d[t shr 3],t and 7);
     inc(j);
     t := binomial (i,j);
    end;
   while (t < 100*h) and (j <= i shr 1 + 1) do
    begin
     if k < maxvolume then
      begin
       inc(k);
       b[k] := t;
      end;
     inc(j);
     t := binomial (i,j);
    end;
  end;
 ans := 0;
 while p > 0 do
  begin
   inc(ans);
   if ans >= 8*h then
    begin
     ans := getnumber;
     exit;
    end;
   if d[ans shr 3] and (1 shl (ans and 7)) > 0 then
    dec(p);
  end;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.