{
  Dmitry Orlov
    SARATOV
    id = 33
}


{.$define debug}

{$R-,Q-,S-,I-,N+}


program template;
const
 nmax = 105;
 maxlen = 35;
 osn = 10000;
 dig = 4;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'brackets.in';
 coutfile= 'brackets.out';
 {$endif}
type
 int = longint;
 real = extended;
 tlong = array [0..maxlen] of int;
var
 b,d :array [1..nmax] of tlong;
 ans :tlong;
 n :int;

procedure init;
begin
 fillchar (b,sizeof(b),0);
 fillchar (d,sizeof(d),0);
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 read (n);
 close (input);
end;

procedure outdata;
var i,j :int;
    s :string[6];
begin
 assign (output,coutfile);
 rewrite (output);
 write (ans[ans[0]]);
 for i := ans[0]-1 downto 1 do
  begin
   str (ans[i],s);
   while length(s) < dig do
    s := '0' + s;
   write (s);
  end;
 close (output);
end;

procedure summ (var res :tlong; var a :tlong);
var i,j :int;
    ost :int;
    tmp :int;
begin
 if a[0] > res[0] then
  res[0] := a[0];
 ost := 0;
 for i := 1 to res[0] do
  begin
   tmp := a[i] + res[i] + ost;
   if tmp >= osn then
    begin
     res[i] := tmp - osn;
     ost := 1;
    end
   else
    begin
     res[i] := tmp;
     ost := 0;
    end;
  end;
 if ost > 0 then
  begin
   inc(res[0]);
   res[res[0]] := ost;
  end;
end;

procedure mult (var a :tlong; x :int; var res :tlong);
var i,j :int;
    ost :int;
    tmp :int;
begin
 fillchar (res,sizeof(res),0);
 res[0] := a[0];
 ost := 0;
 for i := 1 to res[0] do
  begin
   tmp := a[i]*x + ost;
   res[i] := tmp mod osn;
   ost := tmp div osn;
  end;
 while ost > 0 do
  begin
   inc(res[0]);
   res[res[0]] := ost mod osn;
   ost := ost div osn;
  end;
end;

procedure multlong (var a,b :tlong; var res :tlong);
var i,j :int;
    tmp :tlong;
    t,ost :int;
begin
 fillchar (res,sizeof(res),0);
 res[0] := 0;
 for i := 1 to a[0] do
  begin
   if a[i] = 0 then continue;
   fillchar (tmp,sizeof(tmp),0);
   tmp[0] := b[0] + i - 1;
   ost := 0;
   for j := 1 to b[0] do
    begin
     t := a[i]*b[j] + ost;
     tmp[j+i-1] := t mod osn;
     ost := t div osn;
    end;
   while ost > 0 do
    begin
     inc(tmp[0]);
     tmp[tmp[0]] := ost mod osn;
     ost := ost div osn;
    end;
   summ  (res,tmp);
  end;
end;

procedure solve;
var i,j,k :int;
    t :tlong;
begin
 d[1][0] := 1;
 d[1][1] := 3;

 b[1][0] := 1;
 b[1][1] := 2;

 for k := 2 to n do
  begin

   mult (b[k-1],2,b[k]);

{   b[k] := b[k-1]*2;}

   for j := 1 to k-1 do
    begin
     multlong (b[j],b[k-j],t);
     summ (b[k],t);
{     b[k] := b[k] + b[j]*b[k-j];}
    end;

   {d[k] := 2*d[k-1] + b[k-1];}

   mult (d[k-1],2,d[k]);
   summ (d[k],b[k-1]);

   for j := 1 to k-1 do
    begin
     multlong (d[j],d[k-j],t);
     summ (d[k],t);
{     d[k] := d[k] + d[j]*d[k-j];}

    end;

  end;
 ans := d[n];
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.