#include <stdio.h>
#include <string.h>

FILE*fi,*fo;

#define INF ((long)0x3FFFFF00)

struct TInfo {
  short s;
  long k;
  long c;
};

typedef TInfo TSol[4][2];

long n,N;
char*a;
TSol*D,**d;

void printch(long);
void printl(void); void printr(void);
void printl(long); void printr(long);

long solve(long v,long w,short t,short tt) {
  if (d[v][w][t][tt].s>=0) return(d[v][w][t][tt].c);
  if (v>=w) {
    d[v][w][t][tt].s=0; d[v][w][t][tt].k=0;
    switch(t) {
      case 1: d[v][w][t][tt].c=1; break;
      case 2: d[v][w][t][tt].c=2; break;
      case 3: d[v][w][t][tt].c=3; break;
      default: d[v][w][t][tt].c=1;
    }
    return(d[v][w][t][tt].c);
  }
  long c,i;
  d[v][w][t][tt].c=INF;
  if (!tt) {
    for (i=v+1; i<=w; i++) {
      if (a[i]!=a[i-1]) {
        c=solve(v,i-1,1,0)+solve(i,w,t,0);
        if (t==2) c+=i-v;
        if (c<d[v][w][t][tt].c) { d[v][w][t][tt].s=0; d[v][w][t][tt].k=i; d[v][w][t][tt].c=c; }
      } else {
        c=solve(v,i-1,3,0)+solve(i,w,t,0);
        if (t==2) c+=i-v;
        if (c<d[v][w][t][tt].c) { d[v][w][t][tt].s=2; d[v][w][t][tt].k=i; d[v][w][t][tt].c=c; }
       if (i<w) {
        c=solve(v,i-1,1,0)+solve(i,w,t,1);
        if (t==2) c+=i-v;
        if (c<d[v][w][t][tt].c) { d[v][w][t][tt].s=3; d[v][w][t][tt].k=i; d[v][w][t][tt].c=c; }
       }
      }
      c=solve(i,w,2,0)+solve(v,i-1,(t<3)?t:1,0);
      if (t&1) c+=w-i+1;
      if (c<d[v][w][t][tt].c) { d[v][w][t][tt].s=1; d[v][w][t][tt].k=i; d[v][w][t][tt].c=c; }
    }
  } else {
    for (i=v+1; i<=w; i++) {
     if (a[v]!=a[v-1]) {
      if (a[i]!=a[i-1]) {
        c=solve(v,i-1,1,1)+solve(i,w,t,0);
        if (t==2) c+=i-v;
        if (c<d[v][w][t][tt].c) { d[v][w][t][tt].s=0; d[v][w][t][tt].k=i; d[v][w][t][tt].c=c; }
      } else {
        c=solve(v,i-1,3,1)+solve(i,w,t,0);
        if (t==2) c+=i-v;
        if (c<d[v][w][t][tt].c) { d[v][w][t][tt].s=2; d[v][w][t][tt].k=i; d[v][w][t][tt].c=c; }
       if (i<w) {
        c=solve(v,i-1,1,1)+solve(i,w,t,1);
        if (t==2) c+=i-v;
        if (c<d[v][w][t][tt].c) { d[v][w][t][tt].s=3; d[v][w][t][tt].k=i; d[v][w][t][tt].c=c; }
       }
      }
     }
     if (a[i]!=a[v-1]) {
      c=solve(i,w,2,0)+solve(v,i-1,(t<3)?t:1,0);
      if (t&1) c+=w-i+1;
      if (c<d[v][w][t][tt].c) { d[v][w][t][tt].s=1; d[v][w][t][tt].k=i; d[v][w][t][tt].c=c; }
     }
    }
  }
  return(d[v][w][t][tt].c);
}
void printout(long v,long w,short t,short tt) {
  if (v>=w) {
    switch(t) {
      case 1: printch(v); break;
      case 2: printch(v); printl(); break;
      case 3: printch(v); printl(); printr(); break;
      default: printch(v);
    }
    return;
  }
  if (d[v][w][t][tt].s<0) solve(v,w,t,tt);
  long i=d[v][w][t][tt].k;
  if (!tt) {
    switch (d[v][w][t][tt].s) {
      case 0: {
        printout(v,i-1,1,0); printout(i,w,t,0);
        if (t==2) printl(i-v);
      } break;
      case 1: {
        printout(i,w,2,0); printout(v,i-1,(t<3)?t:1,0);
        if (t&1) printr(w-i+1);
      } break;
      case 2: {
        printout(v,i-1,3,0); printout(i,w,t,0);
        if (t==2) printl(i-v);
      } break;
      case 3: {
        printout(v,i-1,1,0); printout(i,w,t,1);
        if (t==2) printl(i-v);
      } break;
    }
  } else {
    switch (d[v][w][t][tt].s) {
      case 0: {
        printout(v,i-1,1,1); printout(i,w,t,0);
        if (t==2) printl(i-v);
      } break;
      case 1: {
        printout(i,w,2,0); printout(v,i-1,(t<3)?t:1,0);
        if (t&1) printr(w-i+1);
      } break;
      case 2: {
        printout(v,i-1,3,1); printout(i,w,t,0);
        if (t==2) printl(i-v);
      } break;
      case 3: {
        printout(v,i-1,1,1); printout(i,w,t,1);
        if (t==2) printl(i-v);
      } break;
    }
  }
}

int main(void) {
  char st[512];
  fi=fopen("keyboard.in","rt");
  fscanf(fi,"%s",st);
  fclose(fi);
  long i,j;
  n=strlen(st);
  a=new char[n];
  for (i=0; i<n; i++) a[i]=st[i]-'a'+1;
  N=n*n;
  D=new TSol[N]; d=new TSol*[n];
  for (i=0,j=0; i<n; i++,j+=n) d[i]=&D[j];
  memset(D,-1,N*sizeof(TSol));
  fo=fopen("keyboard.out","wt");
  printout(0,n-1,0,0);
  fclose(fo);
  delete[]D; delete[]d;
  delete[]a;
  return(0);
}


void printch(long k) {
  fprintf(fo,"%c",a[k]+'a'-1);
}
void printl(void) {
  fprintf(fo,"<");
}
void printr(void) {
  fprintf(fo,">");
}
void printl(long c) {
  long i;
  for (i=0; i<c; i++) fprintf(fo,"<");
}
void printr(long c) {
  long i;
  for (i=0; i<c; i++) fprintf(fo,">");
}

