{$I-,Q-,R-,S-}
Const
  FOut='output.txt';
  FIn='input.txt';
Var
  input,output:text;
Procedure Init;
begin
  Assign(input,FIn);
  Assign(output,FOut);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
  Halt(0);
end;
{---------------------------------------------------------------------------}
Const
  MaxP=10000;
  MaxQ=25;
  MaxM=30;
  MaxN=30;
Type
  TPole=array[1..MaxN]of Record
    R:array['A'..'D'] of Boolean;
    Nap:array[1..4,0..15]of LongInt;
    {0,90,180,270}
  end;
Var
  M,N,P,Q,K,X0,Y0,A0:LongInt;
  {M-X-gorizont N-Y-vertic}
  Mas:array[1..MaxQ] of Record
    X,Y:LongInt;
    F:String;
  end;
  Regs:array['A'..'D'] of Boolean;
  Pole:array[1..MaxM] of ^TPole;
{}
Function UpString(St:String):String;
Var R:Byte;
begin
  For R:=1 to Length(St) do St[R]:=UpCase(St[R]);
  UpString:=St;
end;
{}
Var
  St:String;
  C:Byte;
  Ch:Char;

Function Level3:Boolean; Forward;

Function Level1:Boolean;
Var F:Boolean;
begin
  While St[C]=' ' do C:=C+1;
  If St[C]='(' then
  begin
    C:=C+1;
    F:=Level3;
    Level1:=F;
  end else
  If St[C]='A' then Level1:=Regs['A'] else
  If St[C]='B' then Level1:=Regs['B'] else
  If St[C]='C' then Level1:=Regs['C'] else
  If St[C]='D' then Level1:=Regs['D'] else
  If St[C]='F' then
  begin
    C:=C+4; {FALSE}
    Level1:=False;
  end else
  If St[C]='T' then
  begin
    C:=C+3; {TRUE}
    Level1:=True;
  end;
  C:=C+1;
  If St[C]=' ' then
  begin
    While St[C]=' ' do C:=C+1;
  end;
end;

Function Level2:Boolean;
Var F:Boolean;
begin
  F:=False;
  While St[C]='N' do
  begin
    C:=C+3; {NOT}
    F:=Not F;
  end;
  If F then Level2:=Not Level1 else Level2:=Level1;
end;

Function Level3:Boolean;
Var F,F2:Boolean;
begin
  F:=Level2;
  While St[C] in ['A','O','X'] do
  begin
    Ch:=St[C];
    If Ch='A' then
    begin
      C:=C+4; {AND }
      F2:=Level2;
      F:=F and F2;
    end else
    If Ch='O' then
    begin
      C:=C+3; {OR }
      F2:=Level2;
      F:=F or F2;
    end else
    If Ch='X' then
    begin
      C:=C+4; {XOR }
      F2:=Level2;
      F:=F xor F2;
    end;
  end;
  Level3:=F;
end;

Function Calculate(S:String):Boolean;
begin
  St:=S;
  C:=1;
  Calculate:=Level3;
end;
{}
Var
  F:Boolean;
  Sost,Step,A,X,Y,R:LongInt;
  Ans:Boolean;

begin
  Init;
  Ans:=False;
  For R:=1 to MaxM do
  begin
    New(Pole[R]);
    FillChar(Pole[R]^,SizeOf(Pole[R]^),0);
  end;
  {}
  ReadLn(Input,M,N,P,Q,K,X0,Y0,A0);
  For R:=1 to P do
  begin
    ReadLn(Input,X,Y,Ch,Ch);
    Ch:=UpCase(Ch);
    Pole[X]^[Y].R[Ch]:=Not Pole[X]^[Y].R[Ch];
  end;
  For R:=1 to Q do
    With Mas[R] do
    begin
      ReadLn(Input,X,Y,Ch,F);
      F:=UpString(F);
    end;
  {Go}
  Step:=0;
  A:=A0;
  X:=X0;
  Y:=Y0;

  While True do
  begin
    {One step}
    Step:=Step+1;
    For Ch:='A' to 'D' do
      If Pole[X]^[Y].R[Ch] then Regs[Ch]:=Not Regs[Ch];
    For R:=1 to Q do
      If (Mas[R].X=X)and(Mas[R].Y=Y) then
      begin
        F:=Calculate(Mas[R].F);
        If F then
        begin
          A:=A+90;
          If A=360 then A:=0;
        end else
        begin
          A:=A-90;
          If A=-90 then A:=270;
        end;
        Break;
      end;
    {}
    If Regs['A'] then Sost:=1 else Sost:=0;
    If Regs['B'] then Sost:=Sost*2+1 else Sost:=Sost*2;
    If Regs['C'] then Sost:=Sost*2+1 else Sost:=Sost*2;
    If Regs['D'] then Sost:=Sost*2+1 else Sost:=Sost*2;
    {}
    Case A of
      0: begin
        If Pole[X]^[Y].Nap[1,Sost]<>0 then K:=K mod (Step-Pole[X]^[Y].Nap[1,Sost]);
        Pole[X]^[Y].Nap[1,Sost]:=Step;
        Y:=Y-1;
      end;
      90: begin
        If Pole[X]^[Y].Nap[2,Sost]<>0 then K:=K mod (Step-Pole[X]^[Y].Nap[2,Sost]);
        Pole[X]^[Y].Nap[2,Sost]:=Step;
        X:=X+1;
      end;
      180: begin
        If Pole[X]^[Y].Nap[3,Sost]<>0 then K:=K mod (Step-Pole[X]^[Y].Nap[3,Sost]);
        Pole[X]^[Y].Nap[3,Sost]:=Step;
        Y:=Y+1;
      end;
      270: begin
        If Pole[X]^[Y].Nap[4,Sost]<>0 then K:=K mod (Step-Pole[X]^[Y].Nap[4,Sost]);
        Pole[X]^[Y].Nap[4,Sost]:=Step;
        X:=X-1;
      end;
    end;
    K:=K-1;
    If K=0 then
    begin
      Ans:=True;
      Break;
    end;
    {}
    If (X=0)or(Y=0)or(X>M)or(Y>N) then
    begin
      Ans:=False;
      Break;
    end;
  end;
  {}
  If Ans then WriteLn(Output,X,' ',Y) else WriteLn(Output,-1);
  For R:=1 to MaxM do Dispose(Pole[R]);
  {}
  Done;
end.
