{$I-,Q-,R-,S-}
const
  inputfile = 'input.txt';
  outputfile = 'output.txt';
  maxn = 111;
  maxk = 111;

type
  int = longint;
  bool = boolean;

var
  n, m, k, i, j, h, x, t, max, mi, mj: int;
  s: array[1..maxk]of string[maxn];
  f: array[1..maxk]of int;
  a, l, p: array[1..maxk, 1..maxk]of int;
  ans, alph: string;

procedure readchar(var c: char);
begin
  read(c);
  while(not(c in ['a'..'z']))do
    read(c);
end;

procedure readword(var s: string);
var
  c: char;
begin
  s := '';
  read(c);
  while(not(c in ['a'..'z']))do
    read(c);
  while(c in ['a'..'z'])do begin
    s := s + c;
    read(c);
  end;
end;

procedure quicksort(l, r: int);
var
  i, j, t: int;
  x, w: string;
begin
  i := l;
  j := r;
  x := s[(i + j)div 2];
  repeat
    while(length(s[i]) < length(x))do
      inc(i);
    while(length(s[j]) > length(x))do
      dec(j);
    if(i <= j)then begin
      w := s[i];
      s[i] := s[j];
      s[j] := w;

      t := f[i];
      f[i] := f[j];
      f[j] := t;

      inc(i);
      dec(j);
    end;
  until i > j;
  if(i < r)then
    quicksort(i, r);
  if(l < j)then
    quicksort(l, j);
end;

function kmp(var t, p: string): int;
var
  i, k, count: int;
  pr: array[1..maxn]of int;

begin

  k := 0;
  pr[1] := 0;
  for i := 2 to length(p) do begin
    while(k > 0)and(p[k + 1] <> p[i])do
      k := pr[k];
    if(p[k + 1] = t[i])then
      inc(k);
    pr[i] := k;
  end;

  k := 0;
  count := 0;
  for i := 1 to length(t) do begin
    while(k > 0)and(p[k + 1] <> t[i])do
      k := pr[k];
    if(p[k + 1] = t[i])then
      inc(k);
    if(k = length(p))then begin
      inc(count);
      k := pr[k];
    end;
    pr[i] := k;
  end;
  kmp := count;
end;

procedure check;
var
  i, j: int;
begin
  for i := k downto 2 do
    for j := 1 to i - 1 do
      if(j = 41)then
        f[i] := f[i] + f[j] * kmp(s[i], s[j])
      else
        f[i] := f[i] + f[j] * kmp(s[i], s[j]);
end;

function min(a, b: int): int;
begin
  if(a < b)then
    min := a
  else
    min := b;
end;

function getcommonlen(a, b: string): int;
var
  i, j, l: int;
  c: string;
begin
  getcommonlen := 0;
  l := min(length(a), length(b)) - 1;
  for i := l downto 1 do begin
    c := copy(a, length(a) - i + 1, i);
    if(c = copy(b, 1, i))then begin
      getcommonlen := i;
      exit;
    end;
  end;
end;

procedure getans;
var
  i, j, ni, nj, h, g: int;
begin
  i := mi;
  j := mj;
  g := 0;

  while(p[i, j] > 0)do begin
    nj := p[i, j];
    ni := i + l[nj, j] - length(s[j]);
    for h := length(s[j]) - g downto 1 do
      ans := s[j, h] + ans;
    g := l[nj, j];

    i := ni;
    j := nj;
  end;

  for h := length(s[j]) - g downto 1 do
    ans := s[j, h] + ans;

  for i := mi + 1 to n do
    ans := ans + alph[1];
end;

begin
  assign(input, inputfile);
  reset(input);
  assign(output, outputfile);
  rewrite(output);

  read(n, m, k);
  readword(alph);
  for i := 1 to k do begin
    readword(s[i]);
    read(f[i]);
  end;

  if(k > 1)then begin
    quicksort(1, k);

    check;

    for i := 1 to k do
      for j := 1 to k do
        l[i, j] := getcommonlen(s[i], s[j]);

    for i := 1 to k do
      a[length(s[i]), i] := f[i];

    for i := 1 to n do begin
      for j := 1 to k do begin
        for h := 1 to k do begin
          x := i + length(s[h]) - l[j, h];
          t := a[i, j] + f[h];
          if(x <= n)and(a[x, h] < t)then begin
            a[x, h] := t;
            p[x, h] := j;
          end;
        end;
      end;
    end;

    mi := 1;
    mj := 1;
    for i := 1 to n do
      for j := 1 to k do
        if(a[i, j] > max)then begin
          max := a[i, j];
          mi := i;
          mj := j
        end;

    getans;

    writeln(max);
    writeln(ans);
  end else begin
    writeln(0);
    for i := 1 to n do
      write(alph[1]);
  end;

  close(output);
  close(input);
end.