program Color;

const
  maxn = 250002; {250000}

var
  n : longint;
  l : longint;
  cc : array [0..maxn] of longint;
  gut : boolean;
  num : array [0..maxn] of longint;
  h : array [0..maxn] of longint;
  m : longint;

procedure Inp;
var
  i : longint;
begin
  assign(input,'color.in'); reset(input);
  assign(output,'color.out'); rewrite(output);
  read(n);
  gut := true;
  for i:=1 to n do
  begin
    read(num[i]);
    if (i>1) and (num[i-1]<num[i]) then
      gut := false;
  end;
end;

procedure Swap(X,Y : Integer);
var
  T : Longint;
begin
  T := H[X];
  H[X] := H[Y];
  H[Y] := T;
end;

procedure Heapify(X:Integer);
var
  Y : integer;
begin
  Y := X;
  if (2*X<=M) and (Num[H[2*X]]>Num[H[Y]]) then
    Y := 2*X;
  if (2*X+1<=M) and (Num[H[2*X+1]]>Num[H[Y]]) then
    Y := 2*X+1;
  if X<>Y then
  begin
    Swap(X,Y);
    Heapify(Y);
  end;
end;

procedure Build_Heap;
var
  I : integer;
begin
  for I:=N downto 1 do
    Heapify(I);
end;

procedure SSort;
var
  i : integer;
begin
  M := N;
  for i:=1 to n do h[i]:=i;
  Build_Heap;
  while M>1 do
  begin
    Swap(1,M);
    Dec(M);
    Heapify(1);
  end;
end;

var
  izend : array [0..maxn] of longint;
  obr : array [1..maxn] of longint;
  endz : array [1..maxn] of longint;

procedure Heristic;
var
  endzn : longint;
  i,j,cur : longint;
begin
  Ssort;
  for i:=1 to n do
    obr[h[i]] := i;
  fillchar(izend,sizeof(izend),0);
  endzn := 0;
  for i:=1 to n do
  begin
    cur := 0;

    for j:=1 to endzn do
    begin
      if num[endz[j]]>=num[i] then continue;
      if (cur=0) or (num[endz[cur]]<num[endz[j]]) then cur:=j;
    end;
    if cur=0 then
    begin
      inc(endzn);
      endz[endzn] := i;
      inc(l);
      cc[i] := l;
    end else
    begin
      endz[cur] := i;
      cc[i] := cur;
    end;
  end;
end;

procedure Run;
var
  i : longint;
  t : array [0..maxn+1] of longint;
  e : array [0..maxn+1] of boolean;
  left : longint;
  cur : longint;
begin
  if gut then exit;
  if n>=500 then
  begin
    Heristic;
    exit;
  end;
  left := n;
  fillchar(e,sizeof(e),1);
  fillchar(t,sizeof(t),0);
  l := 0;
  while left>0 do
  begin
    fillchar(t,sizeof(t),0);
    for i:=n downto 1 do
    begin
      if (e[i]) and ((t[i+1]=0) or (num[t[i+1]]>num[i])) then
        t[i] := i
      else
        t[i] := t[i+1];
    end;
    e[0] := e[1];
    cur := 0;
    inc(l);
    repeat
      cc[cur] := l;
      e[cur] := false;
      if cur>0 then dec(left);
      cur := t[cur+1];
    until cur=0;
  end;
end;

procedure Outp;
var
  i : longint;
begin
  if gut then
  begin
    writeln(n);
    for i:=1 to n do
      write(i,' ');
    writeln;
  end
  else
  begin
    writeln(l);
    for i:=1 to n do
      write(cc[i],' ');
    writeln;
  end;
  close(input); close(output);
end;

begin
  Inp;
  Run;
  Outp;
end.
