program taskD;

const
  MaxN = 20000;  {20000}
  MaxM = 200000; {200000}

type TConn = record
A,B,C,T : Longint;
end;

var
  N,M,oldn : Longint;
  GA,GL,ga2,gl2 : array [1 .. MaxN] of Longint;
  GB,gb2 : array [1 .. MaxM] of TConn;
  gc,gc2 : longint;
  V,oldv : array [1 .. MaxN] of Longint;
  rotate : boolean;
  P,p2 : array [1..MaxN] of Longint;
  PSize,psize2 : Longint;
  Cur : longint;
  gut : array [1..maxn] of boolean;
  por : array [1..maxn] of longint;

procedure con_add(a,b : longint);
begin
  if a=b then exit;
  inc(gc);
  gb[gc].a := b;
  gb[gc].b := 0;
  gb[gc].t := a;
  if ga[a]=0 then
  begin
    gb[gc].c := 0;
    ga[a] := gc;
    gl[a] := gc;
  end else
  begin
    gb[gc].c := gl[a];
    gb[gl[a]].b := gc;
    gl[a] := gc;
  end;
end;

procedure con_delete(a,b : longint);
var
  t1,t2 : longint;
begin
  if b=ga[a] then
  begin
    if b=gl[a] then
    begin
      ga[a] := 0;
      gl[a] := 0;
    end
    else
      ga[a] := gb[b].b;
  end else
  if b=gl[a] then
  begin
    gl[a] := gb[b].c;
  end else
  begin
    t1 := gb[b].c;
    t2 := gb[b].b;
    gb[t1].b := t2;
    gb[t2].c := t1;
  end;
end;

procedure DFS_Work(A : Longint);
var
  B : Longint;
begin
  V[A] := Cur;
  B := GA[A];
  while B<>0 do
  begin
    if V[GB[B].A]=0 then
    begin
      DFS_Work(GB[B].A);
    end;
    B := GB[B].B;
  end;
  Inc(PSize);
  P[PSize] := A;
end;

procedure workit(a,b : longint);
var
  t : longint;
begin
  t := ga2[b];
  while t<>0 do
  begin
    con_add(a,v[gb2[t].a]);
    t := gb2[t].b;
  end;
end;

procedure DFS;
var
  A : Longint;
  i : longint;
begin
  FillChar(V,sizeof(V),0);
  Cur := 1;
  for A:=1 to N do
    if V[A]=0 then
      DFS_Work(A);
  ga2 := ga;
  gb2 := gb;
  gc2 := gc;
  gl2 := gl;
  gc := 0;
  fillchar(ga,sizeof(ga),0);
  for A:=1 to gc2 do
    con_add(gb2[A].a,gb2[A].t);
  psize2 := psize;
  p2 := p;
  fillchar(v,sizeof(v),0);
  cur := 0;
  fillchar(gut,sizeof(gut),0);
  for a:=psize2 downto 1 do
  begin
    if v[p2[a]]=0 then
    begin
      inc(cur);
      dfs_work(p2[a]);
      gut[a] := true;
    end;
  end;
  ga2 := ga;
  gb2 := gb;
  gc2 := gc;
  gl2 := gl;
  oldn := n;
  n := cur;
  m := 0;
  gc := 0;
  oldv := v;
  fillchar(ga,sizeof(ga),0);
  for i:=1 to oldn do
  begin
    workit(v[i],i);
  end;
  fillchar(v,sizeof(v),0);
  psize:=0;
  for i:=1 to n do
    if v[i]=0 then
    begin
      dfs_work(i);
    end;
  for i:=1 to n do
  begin
    por[p[i]] := i;
  end;
  writeln(n);
  for i:=1 to oldn do
  begin
    write(por[oldv[i]],' ');
  end;
end;

procedure Inp;
var
  i : longint;
  a,b : longint;
begin
  assign(input,'g.in'); reset(input);
  assign(output,'g.out'); rewrite(output);
  read(N,M);
  gc := 0;
  fillchar(ga,sizeof(ga),0);
  for i:=1 to m do
  begin
    read(a,b);
    con_add(a,b);
  end;
end;

procedure Outp;
var
  i : longint;
  b : longint;
begin
  close(input); close(output);
end;

begin
  Inp;
  DFS;
  Outp;
end.