#include <stdio.h>
#include <stdlib.h>

#define NN 20100
#define MM 200100

struct REB {
  int a;
  REB *p;
  REB *t;
};

struct PP {
  int x,y;
};

FILE *fi, *fo;
int used[NN];
int e[NN];
int ee;
PP a[MM];
REB *g[NN];
int n;
long m;

void AddReb(int a, int b)
{
  REB *t;
  if(g[a]==NULL)
  {
    g[a]=new REB;
    g[a]->a=b;
    g[a]->p=NULL;
    g[a]->t=NULL;
  }
  else
  {
    for(t=g[a];t->p!=NULL;t=t->p) ;
    t->p=new REB;
    t->p->t=t;
    t=t->p;
    t->a=b;
    t->p=NULL;
  }
}

/*void DelReb(int a, int b)
{
  REB *t;
  REB *p;
  if(g[q]==NULL) return ;
  if(g[a]->a==b)
  {
    g[a]=g[a]->p;
  }
  if(g[a]->p->a==b)
  {
    g[a]->p=g[a]->p->p;
  }
  for(t=g[a];(t->p->a!=b)&&(t->p->p!=NULL);t=t->p) ;
  if(t->p->a==b)
  {
    t->p=t->p->p;
  }
} */

void glub(int b, int q)
{
  REB *t;
  used[b]=q;
  for(t=g[b];t!=NULL;t=t->p)
  {
    if(!used[t->a])
    {
      glub(t->a,q);
    }
  }
}

void DellReb(REB *t,int q)
{
  if(t->t==NULL)
  {
    t->p->t=NULL;
    g[q]=g[q]->p;
  }
  else
  {
    t->t->p=t->p;
    if(t->p!=NULL)
    {
      t->p->t=t->t;
    }
  }
}

void glub1(int b, int q)
{
  REB *t;
  used[b]=q;
  e[ee]=b;
  ee++;
  for(t=g[b];t!=NULL;t=t->p)
  {
    if(!used[t->a])
    {
      DellReb(t,b);
      glub1(t->a,q);
    }
  }
}

int main()
{
  int i,j;
  long ii;
  int q;
  fi=fopen("e.in","rt");
  fo=fopen("e.out","wt");

  fscanf(fi,"%i%li",&n,&m);
  for(i=0;i<n;i++)
  {
    g[i]=NULL;
    used[i]=0;
  }
  for(ii=0;ii<m;ii++)
  {
    fscanf(fi,"%i%i",&i,&j);
    a[ii].x=i-1;
    a[ii].y=j-1;
    AddReb(i-1,j-1);
    AddReb(j-1,i-1);
  }
  q=1;
  ee=0;
  for(i=0;i<n;i++)
  {
    if(!used[i])
    {
      glub1(i,q);
    }
  }
  for(i=0;i<n;i++) used[i]=0;
  q=0;
  for(i=0;i<n;i++)
  {
    if(!used[e[i]])
    {
      q++;
      glub(e[i],q);
    }
  }

  q=0;
  for(ii=0;ii<m;ii++)
  {
    if(used[a[ii].x]!=used[a[ii].y]) q++;
  }
  fprintf(fo,"%i\n",q);
  for(ii=0;ii<m;ii++)
  {
    if(used[a[ii].x]!=used[a[ii].y]) fprintf(fo,"%li ",ii+1);
  }
  fprintf(fo,"\n");

  fclose(fi);
  fclose(fo);
  return 0;
}
