#include <stdio.h>
#include <stdlib.h>

#define NN 20100
#define MM 200100

struct REB {
  int a;
  REB *p;
  REB *t;
};

struct PP {
  int x,y;
};

FILE *fi, *fo;
int used[NN];
int v[NN];
int e[NN];
int ff[NN];
int ee;
PP a[MM];
REB *g[NN];
int n;
long m;

void AddReb(int a, int b)
{
  REB *t;
  if(g[a]==NULL)
  {
    g[a]=new REB;
    g[a]->a=b;
    g[a]->p=NULL;
    g[a]->t=NULL;
  }
  else
  {
    for(t=g[a];t->p!=NULL;t=t->p) ;
    t->p=new REB;
    t->p->t=t;
    t=t->p;
    t->a=b;
    t->p=NULL;
  }
}

void glub(int b, int q)
{
  REB *t;
  used[b]=q;
  for(t=g[b];t!=NULL;t=t->p)
  {
    if(!used[t->a])
    {
      glub(t->a,q);
    }
  }
}

void glub1(int b, int q, int fl)
{
  REB *t;
  int qq;
  used[b]=q;
  e[b]=ee;
  v[b]=ee;
  ee++;
  ff[b]=0;
  qq=0;
  for(t=g[b];t!=NULL;t=t->p)
  {
    if(!used[t->a])
    {
      qq++;
      glub1(t->a,q,0);
      if(v[b]>v[t->a]) v[b]=v[t->a];
      if((v[t->a]>=e[b])&&(!fl)) ff[b]=1;
    }
    if(v[b]>e[t->a]) v[b]=e[t->a];
  }
  if((fl)&&(qq>1)) ff[b]=1;
}

int main()
{
  int i,j;
  long ii;
  int q;
  fi=fopen("f.in","rt");
  fo=fopen("f.out","wt");

  fscanf(fi,"%i%li",&n,&m);
  for(i=0;i<n;i++)
  {
    g[i]=NULL;
    used[i]=0;
  }
  for(ii=0;ii<m;ii++)
  {
    fscanf(fi,"%i%i",&i,&j);
    a[ii].x=i-1;
    a[ii].y=j-1;
    AddReb(i-1,j-1);
    AddReb(j-1,i-1);
  }

  for(i=0;i<n;i++)
  {
    if(!used[i])
    {
      glub1(i,1,1);
    }
  }
  q=0;
  for(i=0;i<n;i++)
  {
    if(ff[i]) q++;
  }
  fprintf(fo,"%i\n",q);
  for(i=0;i<n;i++)
  {
    if(ff[i])
      fprintf(fo,"%i ",i+1);
  }

  fclose(fi);
  fclose(fo);
  return 0;
}
