{$I+,Q+,R+,S+}
program         Template;

type
  TField        = array[1..100, 1..5] of Boolean;

var
  N             : string;
  M, P, TTL, NN : LongInt;
  Field         : TField;

procedure       OpenFiles;
begin
  Assign(Input, 'nice.in');
  Reset(Input);
  Assign(Output, 'nice.out');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  Ch            : Char;
begin
  N := '';
  repeat
    Read(Ch);
    if Ch <> ' ' then
      N := N + Ch;
  until Ch = ' ';
  Val(N, NN);

  ReadLn(M, P);
end;

function        Check(X, Y: Integer; var Force: Boolean): Boolean;
begin
  Check := False;
  if (X < 2) or (Y < 2) then
    Exit;

  if (Field[X - 1, Y - 1] = Field[X - 1, Y]) and (Field[X - 1, Y] = Field[X, Y - 1]) then begin
    Check := True;
    Force := not Field[X - 1, Y - 1];
  end;
end;

procedure       Rec(X, Y: Integer);
var
  Clr           : Boolean;
begin
  if Y > M then begin
    Inc(TTL);
    Exit;
  end;

  if Check(X, Y, Clr) then begin
    Field[X, Y] := Clr;

    if X < NN then
      Rec(X + 1, Y)
    else
      Rec(1, Y + 1)
  end else begin
    Field[X, Y] := True;

    if X < NN then
      Rec(X + 1, Y)
    else
      Rec(1, Y + 1);

    Field[X, Y] := False;

    if X < NN then
      Rec(X + 1, Y)
    else
      Rec(1, Y + 1);
  end;
end;

procedure       Solve;
var
  I             : LongInt;
begin
  if NN > 1 then begin
    TTL := 0;
    Rec(1, 1);
  end else begin
    TTL := 1;
    for I := 1 to NN do
      TTL := (TTL * 2) mod P;
  end;

  WriteLn(TTL mod P);
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
