{$I+,Q+,R+,S+}
program         Template;

type
  TEdge         = record
    F, T        : Integer;
  end;

var
  N, M, T, C    : LongInt;
  Edges, Tree   : array[1..200000] of TEdge;
  Visited       : array[1..20000] of Boolean;
  Ent, Ext      : array[1..20000] of LongInt;
  PP            : array[1..20000] of Integer;

procedure       OpenFiles;
begin
  Assign(Input, 'f.in');
  Reset(Input);
  Assign(Output, 'f.out');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I             : LongInt;
begin
  ReadLn(N, M);
  for I := 1 to M do
    ReadLn(Edges[I].F, Edges[I].T);
end;

procedure       DFS(V: Integer; var Time: LongInt);
var
  I             : LongInt;
begin
  Visited[V] := True; Inc(Time); Ent[V] := Time;

  for I := 1 to M do begin
    if (Edges[I].F = V) and not Visited[Edges[I].T] then begin
      Inc(T);

      Tree[T].F := Edges[I].T;
      Tree[T].T := Edges[I].F;

      DFS(Edges[I].T, Time);
    end;
    if (Edges[I].T = V) and not Visited[Edges[I].F] then begin
      Inc(T);

      Tree[T].F := Edges[I].F;
      Tree[T].T := Edges[I].T;

      DFS(Edges[I].F, Time);
    end;
  end;

  Ext[V] := Time;
end;

procedure       Solve;
var
  Time          : LongInt;
begin
  T := 0; Time := 0; FillChar(Visited, SizeOf(Visited), False);

  writeln(0);
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
