{$IFDEF NORMAL}
  {$I-,Q-,R-,S-}
  {$MMX+}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I-,Q-,R-,S-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-}
{$ENDIF RELEASE}
program p17_14_e;

const
  max = 20000;

var
  all : array[1..max * 20, 1..2] of longint;
  sons, brid : array[1..max * 20] of longint;
  no, time, sns, start, insons : array[1..max] of longint;
  used : array[1..max] of boolean;
  inbrid, intime, i, j, k, n, m, nc : longint;

procedure rec(x : longint);
var
  ps : longint;
begin
  inc(intime);
  time[x] := intime;
  used[x] := true;
  if insons[x] <> 0 then
    for ps := start[x] to start[x] + insons[x] - 1 do
    if (sons[ps] <> 0) and (not used[sons[ps]]) then begin
      rec(sons[ps]);
      sons[ps] := 0;
    end;
end;

procedure rec2(x : longint);
var
  ps : longint;
begin
  used[x] := true;
  no[x] := nc;
  if insons[x] <> 0 then for ps := start[x] to start[x] + insons[x] - 1 do
    if (sons[ps] <> 0) and (not used[sons[ps]]) then rec2(sons[ps]);
end;


begin
  assign(input, 'e.in');
  reset(input);
  assign(output, 'e.out');
  rewrite(output);
  fillchar(used, sizeof(used), 0);
  read(n, m);
  for i := 1 to m do begin
    read(j, k);
    inc(insons[j]);
    inc(insons[k]);
    all[i * 2 - 1, 1] := j;
    all[i * 2 - 1, 2] := k;
    all[i * 2, 1] := k;
    all[i * 2, 2] := j;
  end;
  start[1] := 1;
  for i := 2 to n do
    start[i] := start[i - 1] + insons[i - 1];
  fillchar(sns, sizeof(sns), 0);
  for i := 1 to m * 2 do begin
    j := all[i, 1];
    sons[start[j] + sns[j]] := all[i, 2];
    inc(sns[j]);
  end;

  intime := 0;
  for i := 1 to n do begin
    if not used[i] then begin
      rec(i);
    end;
  end;

  nc := 0;
  fillchar(used, sizeof(used), false);
  for i := 1 to n do begin
    if not used[time[i]] then begin
      inc(nc);
      rec2(time[i]);
    end;
  end;
  inbrid := 0;
  for i := 1 to m do begin
    if no[all[i * 2, 1]] <> no[all[i * 2, 2]] then begin
      inc(inbrid);
      brid[inbrid] := i;
    end;
  end;
  writeln(inbrid);
  for i := 1 to inbrid do write(brid[i], ' ');
  close(output);
end.
