{$IFDEF NORMAL}
  {$I-,Q-,R-,S-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I-,Q-,R-,S-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-}
{$ENDIF RELEASE}
program p17_14_g;

const
  max = 20000;

var
  all : array[1..max * 10, 1..2] of longint;
  sons : array[1..max * 10] of longint;
  start, insons : array[1..max] of longint;
  intime, i, cn, j, k, m, n : longint;
  sns, time, ink : array[1..max] of longint;
  used : array[1..max] of boolean;

procedure getcomp(x : longint);
var
  ps : longint;
begin
  used[x] := true;
  ink[x] := cn;
  if insons[x] <> 0 then for ps := start[x] to start[x] + insons[x] - 1 do
    if (sons[ps] <> 0) and (not used[sons[ps]]) then getcomp(sons[ps]);
end;

procedure rec(x : longint);
var
  ps : longint;
begin
  used[x] := true;
  if insons[x] <> 0 then for ps := start[x] to start[x] + insons[x] - 1 do
    if (sons[ps] <> 0) and (not used[sons[ps]]) then rec(sons[ps]);
  inc(intime);
  time[intime] := x;
end;

begin
  assign(input, 'g.in');
  reset(input);
  assign(output, 'g.out');
  rewrite(output);
  read(n, m);
  fillchar(insons, sizeof(insons), 0);
  for i := 1 to m do begin
    read(j, k);
    inc(insons[j]);
    all[i, 1] := j;
    all[i, 2] := k;
  end;
  start[1] := 1;
  for i := 2 to n do
    start[i] := start[i - 1] + insons[i - 1];
  fillchar(sns, sizeof(sns), 0);
  for i := 1 to m do begin
    j := all[i, 1];
    sons[start[j] + sns[j]] := all[i, 2];
    inc(sns[j]);
  end;
  intime := 0;
  fillchar(used, sizeof(used), false);
  for i := 1 to n do if not used[i] then rec(i);
  fillchar(insons, sizeof(insons), false);
  for i := 1 to m do begin
    k := all[i, 1]; all[i, 1] := all[i, 2]; all[i, 2] := k;
    inc(insons[all[i, 1]]);
  end;
  start[1] := 1;
  for i := 2 to n do
    start[i] := start[i - 1] + insons[i - 1];
  fillchar(sns, sizeof(sns), 0);
  for i := 1 to m do begin
    j := all[i, 1];
    sons[start[j] + sns[j]] := all[i, 2];
    inc(sns[j]);
  end;
  cn := 0;
  fillchar(used, sizeof(used), false);
  for i := n downto 1 do begin
    if not used[time[i]] then begin
      inc(cn);
      getcomp(time[i]);
    end;
  end;
  writeln(cn);
  for i := 1 to n do write(ink[i], ' ');
  close(output);
end.
