{$I-,Q-,R-,S-}
const
  inputfile = 'e.in';
  outputfile = 'e.out';
  maxn = 20000;

type
  int = longint;
  bool = boolean;
  pnode = ^tnode;
  tnode = record
    v: word;
    next: pnode;
  end;
  tgraph = array[1..maxn]of pnode;

var
  n, m, i, x, y, count, km: longint;
  k, p, br, used, por: array[1..maxn]of int;
  c: array[1..maxn, 1..maxn]of int;
  a: tgraph;

procedure dfs(v: int);
var
  d: pnode;
begin
  inc(km);
  por[km] := v;
  used[v] := 1;
  d := a[v];
  while(d <> nil)do begin
    if(used[d^.v] = 0)then begin
      p[d^.v] := v;
      dfs(d^.v);
    end;
    d := d^.next;
  end;
end;

procedure dfs2(v: int);
var
  d: pnode;
begin
  used[v] := 1;
  d := a[v];
  while(d <> nil)do begin
    if(used[d^.v] = 0)and(p[d^.v] <> v)then
      dfs2(d^.v);
    d := d^.next;
  end;
end;

procedure add(var p: pnode; v: int);
var
  d: pnode;
begin
  new(d);
  d^.next := p;
  d^.v := v;
  p := d;
end;

begin
  assign(input, inputfile);
  reset(input);
  assign(output, outputfile);
  rewrite(output);
  read(n, m);
  for i := 1 to m do begin
    read(x, y);
    add(a[x], y);
    add(a[y], x);
    c[x, y] := i;
    c[y, x] := i;
  end;

  dfs(1);
  fillchar(used, sizeof(used), 0);
  dfs2(1);
  for i := 2 to km do begin
    if(used[por[i]] = 0)then begin
      inc(count);
      br[count] := c[por[i], p[por[i]]];

      dfs2(por[i]);
    end;
  end;

  writeln(count);
  for i := 1 to count do
    write(br[i], ' ');

  close(output);
  close(input);
end.