const
     FileIn='e.in';
     FileOut='e.out';
     MaxN=20000;
     MaxM=200000;
type
    TStick=record
                 Node1, Node2: Integer;
                 Vector: Byte;
                 IsBridge: Boolean;
           end;
var
   Sticks: array [1..MaxM] of TStick;
   M, N, L: LongInt;
   Nodes: array [1..MaxN] of LongInt;
   Time: LongInt;
   LeaveNodes: array [1..MaxN] of Integer;
   Answer: LongInt;
   Stack: array [1..MaxN] of Integer;
   StackLen: LongInt;

procedure ReadData;
var
   F: Text;
   NStick: Integer;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N, M);
     for NStick:=1 to M
         do begin
            Readln (F, Sticks [NStick].Node1, Sticks [NStick].Node2);
            Sticks [NStick].Vector:=0;
         end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NStick: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, Answer);
     for NStick:=1 to M
         do if Nodes [Sticks [NStick].Node1]<>Nodes [Sticks [NStick].Node2]
               then Write (F, NStick, #32);
     Close (F);
end;

procedure DFSVisit (aNNode: Integer);
var
   NStick: LongInt;
begin
     Nodes [aNNode]:=L;
     StackLen:=1;
     for NStick:=1 to M
         do if (Sticks [NStick].Node1=aNNode) and (Nodes [Sticks [NStick].Node2]=0) and (Sticks [NStick].Vector in [0, 1])
               then begin
                    DFSVisit (Sticks [NStick].Node2);
                    Sticks [NStick].Vector:=2;
               end
               else if (Sticks [NStick].Node2=aNNode) and (Nodes [Sticks [NStick].Node1]=0) and (Sticks [NStick].Vector in [0, 2])
                       then begin
                            DFSVisit (Sticks [NStick].Node1);
                            Sticks [NStick].Vector:=1;
                       end;
     LeaveNodes [Time]:=aNNode;
     Inc (Time);
end;

procedure Solve;
var
   NNode, NStick: LongInt;
begin
     FillChar (Nodes, SizeOf (Nodes), 0);
     Time:=1;
     L:=1;
     DFSVisit (1);
     FillChar (Nodes, SizeOf (Nodes), 0);
     L:=0;
     for NNode:=1 to N
         do if Nodes [NNode]=0
               then begin
                    Inc (L);
                    DFSVisit (NNode);
               end;
     Answer:=0;
     for NStick:=1 to M
         do if Nodes [Sticks [NStick].Node1]<>Nodes [Sticks [NStick].Node2]
               then Inc (Answer);
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
