{$R-,S-,Q-,D-}
{.$define debug}

program template;
const
 h = 5000;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'print.in';
 coutfile = 'print.out';
 {$endif}
type
 int = integer;
var
 n :int;
 ans :int;
 s :array [1..h] of char;
 b :array [0..h,0..h] of int;
 a :array [0..h] of int;
 prev :array [1..h] of int;
 d :array [1..h] of int;
 k :int;


procedure init;
begin
 ans := 0;
 n := 0;
 fillchar (s,sizeof(s),0);
 fillchar (b,sizeof(b),0);
 fillchar (a,sizeof(a),0);
 fillchar (prev,sizeof(prev),0);
 fillchar (d,sizeof(d),0);
 k := 0;
end;

procedure readdata;
var i,j :int;
    c :char;
begin
 assign (input,cinfile);
 reset (input);
 while not eoln do
  begin
   read (c);
   inc (n);
   s[n] := c;
  end;
 close (input);
end;

function letter (c :char):string;
begin
 letter := 'Letter('''+c+''');';
end;

function rep (num :int):string;
var r :string;
begin
 str (num,r);
 rep := 'Repeat('+r+');';
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans+1);
 writeln (letter(s[1]));
 for i := k-1 downto 1 do
  if d[i] - d[i+1] = 1 then
   writeln (letter(s[d[i]]))
  else
   writeln (rep(d[i]-d[i+1]));
 writeln ('End.');
 close (output);
end;

procedure solve;
var i,j :int;
    cur :int;
begin
 for i := 1 to n-1 do
  for j := i+1 to n do
   if s[i] = s[j] then
    b[i,j] := b[i-1,j-1] + 1;
 for i := 1 to n do
  begin
   a[i] := a[i-1] + 1;
   prev[i] := i-1;
   for j := 1 to i-1 do
    if b[j,i] >= i-j then
     if a[j]+1 < a[i] then
      begin
       a[i] := a[j] + 1;
       prev[i] := j;
      end;
  end;
 ans := a[n];
 cur := n;
 while not (cur = 0) do
  begin
   inc (k);
   d[k] := cur;
   cur := prev[cur];
  end;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.