{$I+,Q-,R-,S+}
program         Template;

var
  A, B, Temp    : array[1..100000] of Char;
  NA, NB        : LongInt;
  Delta         : array[0..100000] of LongInt;

procedure       OpenFiles;
begin
  Assign(Input, '2strings.in');
  Reset(Input);
  Assign(Output, '2strings.out');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
begin
  NA := 0;
  while not SeekEoln do begin
    Inc(NA);
    Read(A[NA]);
  end;
  ReadLn;

  NB := 0;
  while not SeekEoln do begin
    Inc(NB);
    Read(B[NB]);
  end;
  ReadLn;
end;

procedure       Solve;
var
  I, Q, K, Pos  : LongInt;
begin
  if NA < NB then begin
    I := NA;
    NA := NB;
    NB := I;

    Move(A, Temp, NB);
    Move(B, A, NA);
    Move(Temp, B, NB);
  end;

  Delta[0] := 0; Delta[1] := 0;
  for Q := 2 to NB do begin
    K := Delta[Q - 1];
    while (B[Q] <> B[K + 1]) and (K > 0) do
      K := Delta[K];

    if K > 0 then
      Delta[Q] := K + 1
    else
      if B[Q] = B[1] then
        Delta[Q] := 1
      else
        Delta[Q] := 0;
  end;

  Q := 0; Pos := 0;
  for I := 1 to NA do begin
    if A[I] = B[Q + 1] then
      Inc(Q)
    else begin
      while (Q > 0) and (B[Q + 1] <> A[I]) do
        Q := Delta[Q];

      if B[Q + 1] = A[I] then
        Inc(Q);
    end;

    if Q = NB then begin
      Pos := I - NB + 1;
      Break;
    end;
  end;

  if Pos > 0 then begin
    Delta[0] := 0; Delta[1] := 0;
    for Q := 2 to NA do begin
      K := Delta[Q - 1];
      while (A[Q] <> A[K + 1]) and (K > 0) do
        K := Delta[K];

      if K > 0 then
        Delta[Q] := K + 1
      else
        if A[Q] = A[1] then
          Delta[Q] := 1
        else
          Delta[Q] := 0;
    end;

    Q := NA; K := 0;
    if Delta[Q] > 0 then begin
      while (Delta[Q] > Delta[Q - 1]) and (Delta[Q - 1] > 0) do begin
        Dec(Q);
        Inc(K);
      end;
      Dec(Q); Inc(K);
    end;

    for I := 1 to Q do
      Write(A[I]);
    WriteLn;
  end else begin
    for I := 1 to NB do
      A[I + NA] := B[I];

    Delta[0] := 0; Delta[1] := 0;
    for Q := 2 to NA + NB do begin
      K := Delta[Q - 1];
      while (A[Q] <> A[K + 1]) and (K > 0) do
        K := Delta[K];

      if K > 0 then
        Delta[Q] := K + 1
      else
        if A[Q] = A[1] then
          Delta[Q] := 1
        else
          Delta[Q] := 0;
    end;

    Q := NA + NB; K := 0;
    if Delta[Q] > 0 then begin
      while (Delta[Q] > Delta[Q - 1]) and (Delta[Q - 1] > 0) do begin
        Dec(Q);
        Inc(K);
      end;
      Dec(Q); Inc(K);
    end;
    Pos := K;

    for I := 1 to NA do
      B[I + NB] := A[I];

    Delta[0] := 0; Delta[1] := 0;
    for Q := 2 to NA + NB do begin
      K := Delta[Q - 1];
      while (B[Q] <> B[K + 1]) and (K > 0) do
        K := Delta[K];

      if K > 0 then
        Delta[Q] := K + 1
      else
        if B[Q] = B[1] then
          Delta[Q] := 1
        else
          Delta[Q] := 0;
    end;

    Q := NA + NB; K := 0;
    if Delta[Q] > 0 then begin
      while (Delta[Q] > Delta[Q - 1]) and (Delta[Q - 1] > 0) do begin
        Dec(Q);
        Inc(K);
      end;
      Dec(Q); Inc(K);
    end;

    if Pos > K then begin
      for I := 1 to NA + NB - Pos do
        Write(A[I]);
      WriteLn;
    end else begin
      for I := 1 to NA + NB - K do
        Write(B[I]);
      WriteLn;
    end;
  end;
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
