program SmoothNumbers;
{$N+}
var
  n : comp;
  sol : array [0 .. 100,0 .. 10] of comp;
  deg : longint;

procedure Inp;
begin
  assign(input,'smooth.in'); reset(input);
  assign(output,'smooth.out'); rewrite(output);
  read(n);
end;

procedure FillSol;
var
  i,j,k : longint;
begin
  fillchar(sol,sizeof(sol),0);
  sol[0,9] := 1;
  for i:=1 to 1000 do
  begin
    sol[i,10] := -1;
    for j:=0 to 9 do
    begin
      for k:=j to 9 do
        sol[i,j] := sol[i,j] + sol[i-1,k];
      sol[i,10] := sol[i,10] + sol[i,j];
    end;
    if sol[i,10] >= n then
      break;
  end;
  deg := i;
  n := n - sol[deg-1,10];
end;

procedure Run;
var
  i,j : longint;
  sj : longint;
begin
  FillSol;
  sj := 1;
  for i:=deg downto 1 do
  begin
    for j:=sj to 9 do
      if sol[i,j] >= n then
        break
      else
        n := n - sol[i,j];
    write(j);
    sj := j;
  end;
end;

procedure Outp;
begin
  close(input); close(output);
end;

begin
  Inp;
  Run;
  Outp;
end.