{$I+,Q-,R-,S+}
program         Template;

var
  N, M, B       : Integer;
  R, C          : array[1..100] of LongInt;
  Z             : array[1..100, 1..100] of LongInt;

procedure       OpenFiles;
begin
  Assign(Input, 'nice.in');
  Reset(Input);
  Assign(Output, 'nice.out');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
var
  I, J          : LongInt;
begin
  ReadLn(M, N);

  for I := 1 to M do
    Read(R[I]);
  ReadLn;

  for I := 1 to N do
    Read(C[I]);
  ReadLn;

  for I := 1 to M do begin
    for J := 1 to N do
      Read(Z[I, J]);
    ReadLn;
  end;
end;

procedure       Solve;
var
  I, J, K       : Integer;
  Sum           : LongInt;
begin
  Sum := 0;
  for I := 1 to M do begin
    Sum := Sum + R[I];
    for J := 1 to N do
      if Z[I, J] > 0 then
        Sum := Sum - Z[I, J];
  end;
  for I := 1 to N do begin
    Sum := Sum + C[I];
    for J := 1 to M do
      if Z[J, I] > 0 then
        Sum := Sum - Z[J, I];
  end;
  Sum := Sum div 2;

  WriteLn('-1');
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
