{$IFDEF NORMAL}
  {$I-,Q-,R-,S-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I-,Q-,R-,S-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-}
{$ENDIF RELEASE}
program p19_14_d;

const
  max = 200;

var
  rebs : array[1..max*max] of longint;
  f, no, c : array[1..max, 1..max] of longint;
  l : array[1..max, 1..max] of longint;
  pm, pp, h, exc : array[1..max] of longint;
  min, nomin, i, j, k, m, n : longint;
  flag : boolean;

function minn(x, y : longint) : longint;
begin
  if x < y then minn := x
  else minn := y;
end;

procedure push(x : longint);
var
  ps, pw : longint;
begin
  for ps := 1 to n do begin
    if (c[x, ps] > 0) and (h[x] = h[ps] + 1) then begin
      exc[ps] := exc[ps] + minn(c[x, ps], exc[x]);
      f[x, ps] := f[x, ps] + minn(c[x, ps], exc[x]);
      f[ps, x] := f[ps, x] - minn(c[x, ps], exc[x]);
      rebs[no[x, ps]] := f[x, ps];
      exc[x] := exc[x] - minn(c[x, ps], exc[x]);
      c[x, ps] := c[x, ps] - minn(c[x, ps], exc[x]);
      c[ps, x] := c[ps, x] + minn(c[x, ps], exc[x]);
      if exc[x] = 0 then exit;
    end;
  end;
end;

procedure lift(x : longint);
var
  ps, pw : longint;
begin
  pw := maxlongint;
  for ps := 1 to n do
    if (c[x, ps] > 0) and (h[ps] < pw) then
      pw := h[ps];
  if pw = maxlongint then begin
    writeln('NO');
    close(output);
    halt;

  end;
  h[x] := pw + 1;
end;

begin
  assign(input, 'cooling.in');
  reset(input);
  assign(output, 'cooling.out');
  rewrite(output);
  fillchar(c, sizeof(c), 0);
  fillchar(no, sizeof(no), 0);
  fillchar(l, sizeof(l), 0);
  fillchar(f, sizeof(f), 0);
  read(n, m);
  for i := 1 to m do begin
    read(k, j);
    read(l[k, j]);
    l[j, k] := -l[k, j];
    f[k, j] := l[k, j];
    read(c[k, j]);
    c[j, k] := -c[k, j];
    no[k, j] := i;
  end;
  fillchar(exc, sizeof(exc), 0);
  fillchar(pm, sizeof(pm), 0);
  fillchar(pp, sizeof(pp), 0);
  for i := 1 to n do
    for j := 1 to n do begin
      rebs[no[i, j]] := f[i, j];
      exc[i] := exc[i] + l[j, i];
      c[i, j] := c[i, j] - l[i, j];
      if c[i, j] > 0 then pm[i] := pm[i] + c[i, j];
      if c[i, j] < 0 then pp[i] := pp[i] - c[i, j];
    end;
  k := 0;
  fillchar(h, sizeof(h), 0);
  repeat
    flag := false;
    min := maxlongint;
    for i := 1 to n do begin
      if (h[i] < min) and (exc[i] > 0) then begin
        min := h[i];
        nomin := i;
        flag := true;
      end;
    end;
    if flag then begin
      while exc[nomin] <> 0 do begin
        push(nomin);
        if exc[nomin] <> 0 then lift(nomin);
        if h[nomin] > n + 1 then begin
          writeln('NO');
          close(output);
          halt;
        end;
      end;
    end;
  until not flag;
  fillchar(rebs, sizeof(rebs), 0);
  for i := 1 to n do
    for j := 1 to n do
      if f[i, j] > 0 then
        rebs[no[i, j]] := f[i, j];
  writeln('YES');
  for i := 1 to m do writeln(rebs[i], ' ');
  close(output);
end.
