type int = longint;
var l, h: array [1..600] of int;
var llen, hlen: int;
var one: boolean;

function lhcmp: boolean;  { l < h }
var i: int;
begin
  while (llen > 0) and (l[llen] = 0) do dec(llen);
  while (hlen > 0) and (h[hlen] = 0) do dec(hlen);

  if llen > hlen then
    begin
      lhcmp:=false;
      exit;
    end;
  if llen < hlen then
    begin
      lhcmp:=true;
      exit;
    end;
  i:=llen;
  while (l[i] = h[i]) and (i > 0) do dec(i);
  if i = 0 then
    begin
      lhcmp:=false;
      exit;
    end;
  if (i = 1) and (h[i] = l[i] + 1) then one:=true;
  if l[i] < h[i] then
    begin
      lhcmp:=true;
      exit;
    end;
  lhcmp:=false;
end;

var x, xx: array [1..600] of int;
var xlen, xxlen: int;

procedure xdiv2;
var c, i: int;
begin
  while (xlen > 0) and (x[xlen] = 0) do dec(xlen);
  c:=0;
  for i:=xlen downto 1 do
    begin
      c:=x[i] + c;
      x[i]:=c div 2;
      if c mod 2 = 1 then c:=10000 else c:=0;
    end;
  while (xlen > 0) and (x[xlen] = 0) do dec(xlen);
end;


procedure sqrx;
var i, j, c: int;
begin
  while (xlen > 0) and (x[xlen] = 0) do dec(xlen);
  for i:=1 to 2 * xlen + 2 do xx[i]:=0;
  for i:=1 to xlen do
    begin
      c:=0;
      for j:=1 to xlen do
        begin
          c:=c + xx[i + j - 1] + x[i] * x[j];
          xx[i + j - 1]:=c mod 10000;
          c:=c div 10000;
        end;
      xx[i + xlen]:=xx[i + xlen] + c;
    end;
  xxlen:=2 * xlen + 2;
  while (xxlen > 0) and (xx[xxlen] = 0) do dec(xxlen);
end;

var t: array [1..600] of int;
var n: int;
var eq: boolean;
function txcmp: boolean; { t < xx }
var i: int;
begin
  while (t[n] = 0) and (n > 0) do dec(n);
  while (xxlen > 0) and (xx[xxlen] = 0) do dec(xxlen);

  if n > xxlen then
    begin
      txcmp:=false;
      exit;
    end;
  if n < xxlen then
    begin
      txcmp:=true;
      exit;
    end;
  i:=n;
  while (i > 0) and (t[i] = xx[i]) do dec(i);
  if i = 0 then
    begin
      eq:=true;
      txcmp:=false;
      exit;
    end;
  if t[i] < xx[i] then
    begin
      txcmp:=true;
      exit;
    end;
  txcmp:=false;
end;

var ch: char;
var i, j: int;
var tt: array [1..600] of int;

begin
  assign(input, 'square.in');
  assign(output, 'square.out');
  reset(input);
  rewrite(output);
  read(ch);
  while (ch < ' ') do read(ch);
  n:=0;
  while (ch > ' ') do
    begin
      inc(n);
      t[n]:=ord(ch) - ord('0');
      read(ch);
    end;
  for i:=1 to n do
    tt[n + 1 - i]:=t[i];
  for i:=1 to n do
    t[i]:=tt[i];
  for i:=1 to n + 1 do
    tt[i]:=0;
  t[n + 1]:=0;
  t[n + 2]:=0;
  t[n + 3]:=0;
  t[n + 4]:=0;
  for i:=1 to n div 4 + 1 do
    tt[i]:=t[4 * i - 3] + t[4 * i - 2] * 10 + t[4 * i - 1] * 100 + t[4 * i] * 1000;
  for i:=1 to n div 4 + 1 do
    t[i]:=tt[i];
  n:=n div 4 + 1;
  while (t[n] = 0) and (n > 0) do dec(n);
  if n = 0 then
    begin
      writeln(0);
      close(input);
      close(output);
      exit;
    end;

  if n mod 2 = 0 then llen:=n div 2 else llen:=n div 2 + 1;
  for i:=1 to llen do
    l[i]:=0;
  l[llen]:=1;

  hlen:=llen + 1;
  for i:=1 to hlen do
    h[i]:=0;
  h[hlen]:=1;
  hlen:=hlen + 1;

  one:=false;
  eq:=false;
  while lhcmp do  {while l < h}
    begin
      if one then
        begin
          writeln(-1);
          close(input);
          close(output);
          exit;
        end;
      j:=0;
      for i:=1 to hlen do
        begin
          j:=j + l[i] + h[i];
          x[i]:=j mod 10000;
          j:=j div 10000;
        end;
      xlen:=hlen + 1;
      xdiv2;
      sqrx;
      if txcmp then {if t < xx }
        begin
          hlen:=xlen;
          for i:=1 to xlen do
            h[i]:=x[i];
          continue;
        end
      else
        begin
          llen:=xlen;
          for i:=1 to xlen do
            l[i]:=x[i];
          if eq then break;
          continue;
        end;
    end;
  write(l[llen]);
  for i:=llen - 1 downto 1 do
    begin
      if l[i] < 10 then
        write('000', l[i]);
      if (10 <= l[i]) and (l[i] < 100) then
        write('00', l[i]);
      if (100 <= l[i]) and (l[i] < 1000) then
        write('0', l[i]);
      if (1000 <= l[i]) and (l[i] < 10000) then
        write(l[i]);
    end;
  writeln;

  close(input);
  close(output);
end.
