program ChessTest;

var
  cc : array [1..12,1..12] of byte;
  sc : longint;
  n,q,c : integer;
  fillx,filly : array [1..12] of boolean;

procedure Inp;
begin
  assign(input,'chess.in'); reset(input);
  assign(output,'chess.out'); rewrite(output);
  read(n,q,c);
end;

procedure work2(a,b : integer);
var
  t,tt,i : integer;
  good : boolean;
begin
  if (a=0) then
  begin
    inc(sc);
    exit;
  end;
  if a+b>n+1 then exit;
  if b>=n+1 then exit;
  work2(a,b+1);
  for t:=1 to n do
  begin
    if fillx[b] then break;
    if filly[t] then continue;
    good := true;
    for tt:=1 to n do
    begin
      if (b-tt<1) or (t-tt<1) then
        break;
      if cc[b-tt,t-tt]=1 then
        good := false;
    end;
    if not good then continue;
    for tt:=1 to n do
    begin
      if (b-tt<1) or (t+tt>n) then
        break;
      if cc[b-tt,t+tt]=1 then
        good := false;
    end;
    if not good then continue;
    for tt:=1 to n do
    begin
      if (b+tt>n) or (t-tt<1) then
        break;
      if cc[b+tt,t-tt]=1 then
        good := false;
    end;
    if not good then continue;
    for tt:=1 to n do
    begin
      if (b+tt>n) or (t+tt>n) then
        break;
      if cc[b+tt,t+tt]=1 then
        good := false;
    end;
    if not good then continue;
    cc[b,t] := 2;
    fillx[b] := true;
    filly[t] := true;
    work2(a-1,b+1);
    cc[b,t] := 0;
    fillx[b] := false;
    filly[t] := false;
  end;
end;

procedure work(a,b : integer);
var
  t,tt : integer;
  good : boolean;
begin
  if (a=0) then
  begin
    work2(c,1);
    exit;
  end;
  if a+b>n+1 then exit;
  if b=n+1 then exit;
  work(a,b+1);
  for t:=1 to n do
  begin
    if filly[t] then continue;
    good := true;
    for tt:=1 to n do
    begin
      if (b-tt<1) or (t-tt<1) then
        break;
      if cc[b-tt,t-tt]=1 then
        good := false;
    end;
    if not good then continue;
    for tt:=1 to n do
    begin
      if (b-tt<1) or (t+tt>n) then
        break;
      if cc[b-tt,t+tt]=1 then
        good := false;
    end;
    if not good then continue;
    for tt:=1 to n do
    begin
      if (b+tt>n) or (t-tt<1) then
        break;
      if cc[b+tt,t-tt]=1 then
        good := false;
    end;
    if not good then continue;
    for tt:=1 to n do
    begin
      if (b+tt>n) or (t+tt>n) then
        break;
      if cc[b+tt,t+tt]=1 then
        good := false;
    end;
    if not good then continue;
    cc[b,t] := 1;
    fillx[b] := true;
    filly[t] := true;
    work(a-1,b+1);
    cc[b,t] := 0;
    fillx[b] := false;
    filly[t] := false;
  end;
end;

procedure Run;
begin
  fillchar(cc,sizeof(cc),0);
  fillchar(fillx,sizeof(fillx),0);
  fillchar(filly,sizeof(filly),0);
  sc := 0;
  if (c+q>n) then writeln(0) else
    work(q,1);
end;

procedure Outp;
begin
  writeln(sc);
  close(input); close(output);
end;

begin
  Inp;
  Run;
  Outp;
end.