{.$define debug}

program template;
const
 h = 100;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'bc.in';
 coutfile = 'bc.out';
 {$endif}
type
 int = integer;
 tq = record
  t :array [1..10] of int;
  b :int;
  w :int;
 end;
var
 n,c,m :int;
 ans :int;
 q :array [1..h] of tq;
 choose :array [1..10] of int;
 bad :array [1..10] of int;

procedure init;
begin
 ans := 0;
 fillchar (q,sizeof(q),0);
 fillchar (choose,sizeof(choose),0);
 fillchar (bad,sizeof(bad),0);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 for i := 1 to n do
  write (choose[i],' ');
 close (output);
 halt;
end;

procedure readdata;
var i,j :int;
    a :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (n,c,m);
 for i := 1 to m do
  begin
   for j := 1 to n do
    begin
     read (a);
     q[i].t[j] := a;
    end;
   readln;
   readln (q[i].w,q[i].b);
   if q[i].w = n then
    begin
     for j := 1 to n do
      choose[j] := q[i].t[j];
     outdata;
    end;
   if q[i].w + q[i].b = 0 then
    for j := 1 to n do
     bad[q[i].t[j]] := 1;
  end;
 close (input);
end;

function good(v :int):boolean;
var i,j :int;
    have :array [1..h] of int;
    hv :array [1..h] of int;
begin
 fillchar (have,sizeof(have),0);
 for i := 1 to n do
  inc (have[choose[i]]);
 good := false;
 for i := 1 to m do
  begin
   j := 1;
   while q[i].t[j] = choose[j] do
    inc (j);
   if j-1 > q[i].w then
    exit;
   fillchar(hv,sizeof(hv),0);
   for j := 1 to n do
    inc (hv[q[i].t[j]]);
   for j := 1 to c do
    if have[j] - hv[j] >  n - (q[i].w+q[i].b) then
     exit;
  end;
 good := true;
end;

function verygood :boolean;
var i,j :int;
    have :array [1..h] of int;
    hv :array [1..h] of int;
    b :int;
    w :int;
begin
 verygood := false;
 fillchar (have,sizeof(have),0);
 for i := 1 to n do
  inc (have[choose[i]]);
 for i := 1 to m do
  begin
   fillchar (hv,sizeof(hv),0);
   b := 0;
   w := 0;
   for j := 1 to n do
    if choose[j] = q[i].t[j] then
     inc (w)
    else
     if have[q[i].t[j]] > hv[q[i].t[j]] then
      begin
       inc (hv[q[i].t[j]]);
       inc (b);
      end;
   if not (b = q[i].b) or not (w = q[i].w) then
    exit;
  end;
 verygood := true;
end;

procedure rec (num :int);
var i :int;
begin
 if num = n+1 then
  if verygood then
   outdata
  else
   exit;
 for i := 1 to c do
  begin
   if bad[i] > 0 then
    continue;
   choose[num] := i;
   if good (num) then
    rec (num+1);
   choose[num] := 0;
  end;
end;

procedure solve;
var i,j :int;
begin
 rec (1);
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.