#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define NN 5100
#define MM (2*NN)

struct POINT {
  long x, y;
};

struct PP {
  int a;
  PP *p;
};

FILE *fi, *fo;
POINT v[MM];
int color[MM];
bool cc[7];
bool used[MM];
int si;
PP *b[MM];
int q[MM];
int st[MM];
int qi;
int m,n;

void AddReb(int g, int a)
{
  PP *t;
  t=new PP;
  t->a=a;
  t->p=b[g];
  b[g]=t;
  st[g]++;
//  st[a]++;
}

void DellV(int g)
{
  PP *t;
  used[g]=false;
  for(t=b[g];t!=NULL;t=t->p)
  {
    st[t->a]--;
    if((st[t->a]<=1)&&(used[t->a])) DellV(t->a);
  }
}

int cmp(POINT a, POINT b)
{
/*  if(a.x>b.x) return 1;
  if(a.x<b.x) return -1;
  if(a.y>b.y) return 1;
  if(a.y<b.y) return -1;*/
  if((a.x==b.x)&&(a.y==b.y)) return 0;
  else
    return 1;
}

double obhod(int g)
{
  PP *t;
  double s;
  s=0;
  s+=((double)v[g].x+v[b[g]->a].x)/2.0*(v[g].y-v[b[g]->a].y);
  s+=((double)v[b[g]->p->a].x+v[g].x)/2.0*(v[b[g]->p->a].y-v[g].y);
  used[g]=false;
  for(g=b[g]->p->a;g>0;)
  {
    used[g]=false;
    if(used[b[g]->a])
    {
      s+=((double)v[g].x+v[b[g]->a].x)/2.0*(v[b[g]->a].y-v[g].y);
      g=b[g]->a;
    }
    else
    {
      if(used[b[g]->p->a])
      {
        s+=((double)v[b[g]->p->a].x+v[g].x)/2.0*(v[b[g]->p->a].y-v[g].y);
        g=b[g]->p->a;
      }
      else
      {
        g=-1;
      }
    }
  }
  return fabs(s);
}

int main()
{
  int l;
  int i,j;
  long xx1,xx2,yy1,yy2;
  int aa,bb;
  bool f;
  bool ff;
  POINT p1,p2;
  double s;
  PP *t;
  fi=fopen("input.txt","rt");
  fo=fopen("output.txt","wt");

  for(i=0;i<MM;i++)
  {
    b[i]=NULL;
    used[i]=true;
  }

  fscanf(fi,"%i",&n);
  m=0;
  for(l=0;l<n;l++)
  {
    fscanf(fi,"%li%li%li%li",&xx1,&yy1,&xx2,&yy2);
    p1.x=xx1;
    p1.y=yy1;
    p2.x=xx2;
    p2.y=yy2;
    aa=-1;
    bb=-1;
    for(i=0;i<m;i++)
    {
      if(cmp(p1,v[i])==0) aa=i;
      if(cmp(p2,v[i])==0) bb=i;
    }
    if(aa<0)
    {
      aa=m;
      v[aa]=p1;
      m++;
    }
    if(bb<0)
    {
      bb=m;
      v[bb]=p2;
      m++;
    }
    AddReb(aa,bb);
    AddReb(bb,aa);
  }

  for(i=0;i<m;i++)
  {
    if(used[i])
    {
      if(st[i]<=1)
      {
        DellV(i);
      }
    }
  }
  j=0;
  l=0;
  for(i=0;i<m;i++)
  {
    if(used[i])
    {
      j++;
      if(st[i]==2)
      {
        l++;
      }
    }
  }
  if(j==0)
  {
    fprintf(fo,"0\n");
  }
  else
  {
    if(l==j)
    {
      for(i=0;i<m;i++)
      {
        if(used[i])
        {
          s=obhod(i);
          i=m+1;
        }
      }
      fprintf(fo,"1\n%0.5lf",s);
    }
    else
    {
      fprintf(fo,"2\n1.00000\n0.50000\n");
    }
  }

  fclose(fi);
  fclose(fo);
  return 0;
}
