Const
  FIn='input.txt';
  FOut='output.txt';
Var
  input,output:text;
Procedure Init;
begin
  Assign(input,FIn);
  Assign(output,FOut);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
  Halt(0);
end;
{---------------------------------------------------------------------------}
Const
  MaxN=5000;
  MaxV=MaxN*2;
  MaxE=MaxN*2;
  Eps=1E-10;
Type
  TV=Record
    Start,X,Y:Integer;
  end;
  TE=Record
    V1,V2:Integer;
    F:Boolean;
  end;
Var
  N,ColE,ColV:Integer;
  E:array[1..MaxE]of TE;
  V:array[1..MaxV]of TV;
  {}
  F:Boolean;
  Ver,Reb,R,X1,Y1,X2,Y2:Integer;
  {}
  Res:Integer;
  Temp,Ans:array[1..MaxV]of Real;
  ColTemp:Integer;

Function Find(X,Y:Integer):Integer;
Var F:Boolean; R:Integer;
begin
  F:=False;
  For R:=1 to ColV do
    If (V[R].X=X)and(V[R].Y=Y) then
    begin
      F:=True;
      Break;
    end;
  If F then Find:=R else
  begin
    ColV:=ColV+1;
    V[ColV].X:=X;
    V[ColV].Y:=Y;
    Find:=ColV;
  end;
end;

Procedure QSort2(l,r:Integer);
var
  i,j:Integer;
  y,x:Real;
begin
  i:=l; j:=r; x:=Temp[(l+r) DIV 2];
  repeat
    while Temp[i]<x do i:=i+1;
    while x<Temp[j] do j:=j-1;
    if i<=j then
    begin
      y:=Temp[i]; Temp[i]:=Temp[j]; Temp[j]:=y;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then QSort2(l,j);
  if i<r then QSort2(i,r);
end;

Procedure QSort1(l,r:Integer);
var
  x,i,j:Integer;
  Y:TE;
begin
  i:=l; j:=r; x:=E[(l+r) DIV 2].V1;
  repeat
    while E[i].V1<x do i:=i+1;
    while x<E[j].V1 do j:=j-1;
    if i<=j then
    begin
      y:=E[i]; E[i]:=E[j]; E[j]:=y;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then QSort1(l, j);
  if i<r then QSort1(i, r);
end;

Function Plo(X1,Y1,X2,Y2,X3,Y3:Real):Real;
begin
  Plo:=1/2*(x1*(y3-y2)+x2*(y3-y1)+x3*(y1-y2));
end;

Function Cmp(A,B:Real):Boolean;
begin
  Cmp:=abs(A-B)<=Eps;
end;

Var
  Mark:array[1..MaxV]of Record
    F,Be:Boolean;
    P:Real;
  end;

Procedure AddAns(A:Real);
begin
  ColTemp:=ColTemp+1;
  Temp[ColTemp]:=A;
end;

Procedure Go(Num:Integer; P:Real);
Var R:Byte;
begin
  If Not Mark[Num].Be then Ver:=Ver+1;
  If Mark[Num].F then
  begin
    P:=P-Mark[Num].P;
    If Not Cmp(abs(P),0) then AddAns(abs(P));
    Exit;
  end;
  Mark[Num].Be:=True;
  Mark[Num].P:=P;
  Mark[Num].F:=True;
  {}
  R:=V[Num].Start;
  While E[R].V1=Num do
  begin
    Go(E[R].V2,P+Plo(0,0,V[Num].X,V[Num].Y,V[E[R].V2].X,V[E[R].V2].Y));
    If Not E[R].F then
    begin
      E[R].F:=True;
      Reb:=Reb+1;
    end;
    R:=R+1;
  end;
  Mark[Num].F:=False;
end;

begin
  Init;
  FillChar(Mark,SizeOf(Mark),0);
  Res:=0;
  {}
  Read(Input,N);
  ColV:=0;
  ColE:=0;
  For R:=1 to N do
  begin
    Read(Input,X1,Y1,X2,Y2);
    ColE:=ColE+1;
    E[ColE].V1:=Find(X1,Y1);
    V[E[ColE].V1].X:=X1;
    V[E[ColE].V1].Y:=Y1;
    E[ColE].V2:=Find(X2,Y2);
    V[E[ColE].V2].X:=X2;
    V[E[ColE].V2].Y:=Y2;
    ColE:=ColE+1;
    E[ColE].V1:=E[ColE-1].V2;
    E[ColE].V2:=E[ColE-1].V1;
  end;
  QSort1(1,ColE);
  X1:=0;
  R:=1;
  While R<=ColE do
  begin
    While E[R].V1<>X1 do X1:=X1+1;
    V[X1].Start:=R;
    While E[R].V1=X1 do R:=R+1;
  end;
  {}
  F:=True; R:=1;
  While F do
  begin
    Ver:=0;
    Reb:=0;
    ColTemp:=0;
    Go(R,0);
    {}
    QSort2(1,ColTemp);
    For R:=1 to 1-Ver+Reb div 2 do
    begin
      Res:=Res+1;
      Ans[Res]:=Temp[R*2-1];
    end;
    {}
    F:=False;
    For R:=1 to ColV do
      If Not Mark[R].Be then
      begin
        F:=True;
        Break;
      end;
  end;
  WriteLn(Output,Res);
  For R:=1 to Res do WriteLn(Output,Ans[R]:0:5);
  {}
  Done;
end.