{$I-,Q-,R-,S-}
Const
  FIn='input.txt';
  FOut='output.txt';
Var
  input,output:text;
Procedure Init;
begin
  Assign(input,FIn);
  Assign(output,FOut);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
  Halt(0);
end;
{---------------------------------------------------------------------------}
Const
  MaxN=5000;
  MaxE=MaxN*2;
  MaxV=MaxN*2;
Type
  TMas=Record
    V1,V2:Integer;
  end;
  TSV=Record
    S,V:Integer;
  end;
Var
  ColE,ColV,N:Integer;
  Mas:array[1..MaxE]of TMas; {10000*2}
  V:array[1..MaxV]of Record {10000*(3*2+1)}
    C:Byte;
    Start:Integer;
    X,Y:Integer;
  end;
  SV3,SV2,SV:array[1..MaxV]of TSV; {3*10000*2}
  {}
  X1,Y1,X2,Y2:Integer;

Function Find(X,Y:Integer):Integer;
Var F:Boolean; R:Integer;
begin
  F:=False;
  For R:=1 to ColV do
    If (V[R].X=X)and(V[R].Y=Y) then
    begin
      F:=True;
      Break;
    end;
  If F then Find:=R else
  begin
    ColV:=ColV+1;
    V[ColV].X:=X;
    V[ColV].Y:=Y;
    Find:=ColV;
  end;
end;

Procedure QSort1(l,r:Integer);
var
  i,j,x:Integer;
  Y:TMas;
begin
  i:=l; j:=r; x:=Mas[(l+r) DIV 2].V1;
  repeat
    while Mas[i].V1<x do i:=i+1;
    while x<Mas[j].V1 do j:=j-1;
    if i<=j then
    begin
      y:=Mas[i]; Mas[i]:=Mas[j]; Mas[j]:=y;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then QSort1(l, j);
  if i<r then QSort1(i, r);
end;

Procedure QSort2(l,r:Integer);
var
  i,j,x:Integer;
  Y:TSV;
begin
  i:=l; j:=r; x:=SV[(l+r) DIV 2].S;
  repeat
    while SV[i].S<x do i := i + 1;
    while x<SV[j].S do j := j - 1;
    if i <= j then
    begin
      y:=SV[i]; SV[i]:=SV[j]; SV[j]:=y;
      i:=i+1; j:=j-1;
    end;
  until i > j;
  if l < j then QSort2(l, j);
  if i < r then QSort2(i, r);
end;

Var
  Color:Integer;
  F:Boolean;
  Num,R,R1:Integer;

begin
  Init;
  FillChar(V,SizeOf(V),0);
  FillChar(SV2,SizeOf(SV2),0);
  FillChar(Mas,SizeOf(Mas),0);
  {}
  ColV:=0;
  ColE:=0;
  Read(Input,N);
  For R:=1 to N do
  begin
    Read(Input,X1,Y1,X2,Y2);
    ColE:=ColE+1;
    Mas[ColE].V1:=Find(X1,Y1);
    Mas[ColE].V2:=Find(X2,Y2);
    Inc(SV2[Mas[ColE].V1].S);
    Inc(SV2[Mas[ColE].V2].S);
    ColE:=ColE+1;
    Mas[ColE].V1:=Mas[ColE-1].V2;
    Mas[ColE].V2:=Mas[ColE-1].V1;
  end;
  For R:=1 to ColV do SV2[R].V:=R;
  {}
  QSort1(1,ColE);
  X1:=0;
  R:=1;
  While R<=ColE do
  begin
    While Mas[R].V1<>X1 do X1:=X1+1;
    V[X1].Start:=R;
    While Mas[R].V1=X1 do R:=R+1;
  end;
  {Go}
  For Color:=1 to 5 do
  begin
    SV:=SV2;
    QSort2(1,ColV);
    SV3:=SV2;
    For R:=ColV downto 1 do
    begin
      Num:=SV[R].V;
      If V[Num].C=0 then
      begin
        F:=True;
        R1:=V[Num].Start;
        While Mas[R1].V1=Num do
        begin
          Dec(SV3[Mas[R1].V2].S);
          If V[Mas[R1].V2].C=Color then
          begin
            F:=False;
            Break;
          end;
          R1:=R1+1;
        end;
        If F then
        begin
          V[Num].C:=Color;
          SV2:=SV3;
        end else SV3:=SV2;
      end;
    end;
  end;
  {Output}
  For R:=1 to ColV do
    WriteLn(Output,V[R].X,' ',V[R].Y,' ',V[R].C);
  Done;
end.
