const maxvnum = 10005;
type Tvert = record
       id: integer;
       eind: integer;
       pow: integer;
       color: integer;
       x,y: integer;
     end;

var eln: array[1..maxvnum] of integer;
    egs: array[1..10005,1..2] of integer;
    vrs: array[1..maxvnum] of Tvert;
    vnum,enum: integer;
    count,k: integer;

procedure SortPws(l, r: Integer);
var
  i, j, x, y: integer;
  v: Tvert;
begin
  i := l; j := r; x := vrs[(l+r) DIV 2].pow;
  repeat
    while vrs[i].pow > x do i := i + 1;
    while x > vrs[j].pow do j := j - 1;
    if i <= j then
    begin
      eln[vrs[i].id]:=j;
      eln[vrs[j].id]:=i;
      v := vrs[i]; vrs[i] := vrs[j]; vrs[j] := v;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then SortPws(l, j);
  if i < r then SortPws(i, r);
end;

procedure Solve;
var i,j: integer;
    flag: boolean;
begin
  For i:=1 to vnum do
    eln[i]:=i;
  SortPws(1,vnum);
  k:=1;
  count:=0;
  while (count<vnum) and (k<=5) do begin
    For i:=1 to vnum do
      if vrs[i].color=0 then begin
        flag:=true;
        For j:=vrs[i].eind to vrs[i].eind+vrs[i].pow-1 do
          if vrs[eln[egs[j,2]]].color=k then begin
            flag:=false; break;
          end;
        if flag then begin
          vrs[i].color:=k;
          inc(count);
        end;
      end;
    inc(k);
  end;
end;

procedure Save;
var f: text;
    i: integer;
begin
  Assign(f,'output.txt');
  Rewrite(f);
  if count<vnum then WriteLn(f,'IMPOSSIBLE') else
    For i:=1 to vnum do
      WriteLn(f,vrs[eln[i]].x,' ',vrs[eln[i]].y,' ',vrs[eln[i]].color);
  Close(f);
end;


procedure SortEgs(l, r: Integer);
var
  i, j, x, y: integer;
begin
  i := l; j := r; x := egs[(l+r) DIV 2,1];
  repeat
    while egs[i,1] < x do i := i + 1;
    while x < egs[j,1] do j := j - 1;
    if i <= j then
    begin
      y := egs[i,1]; egs[i,1] := egs[j,1]; egs[j,1] := y;
      y := egs[i,2]; egs[i,2] := egs[j,2]; egs[j,2] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then SortEgs(l, j);
  if i < r then SortEgs(i, r);
end;

procedure Load;
var f: text;
    i,j,en: integer;
    x1,y1,x2,y2,v1,v2: integer;
begin
  Assign(f,'input.txt');
  reset(f);
  Read(f,en);
  For i:=1 to en do begin
    Read(f,x1,y1,x2,y2);

    v1:=0;
    For j:=1 to vnum do
      if (vrs[j].x=x1) and (vrs[j].y=y1) then begin
        v1:=j; break;
      end;
    if v1=0 then begin
      inc(vnum);
      vrs[vnum].x:=x1; vrs[vnum].y:=y1;
      vrs[vnum].id:=vnum;
      v1:=vnum;
    end;

    v2:=0;
    For j:=1 to vnum do
      if (vrs[j].x=x2) and (vrs[j].y=y2) then begin
        v2:=j; break;
      end;
    if v2=0 then begin
      inc(vnum);
      vrs[vnum].x:=x2; vrs[vnum].y:=y2;
      vrs[vnum].id:=vnum;
      v2:=vnum;
    end;

    inc(enum);
    egs[enum,1]:=v1; egs[enum,2]:=v2;
    inc(enum);
    egs[enum,1]:=v2; egs[enum,2]:=v1;
  end;
  Close(f);

  SortEgs(1,enum);

  For i:=1 to enum do begin
    if vrs[egs[i,1]].eind=0 then vrs[egs[i,1]].eind:=i;
    inc(vrs[egs[i,1]].pow);
  end;
end;

Begin
  Load;
  Solve;
  Save;
End.
