type
  tp=^treb;
  treb=record
    c:char;
    k:extended;
    v:integer;
    next:tp;
  end;

var
  n:integer;
  a,ao:array[1..300] of extended;
  mark,inf:array[1..300] of boolean;
  r:array[1..300] of tp;

procedure OpenFiles;
begin
  assign(input,'math.in');
  assign(output,'math.out');
  reset(input);
  rewrite(output);
end;

procedure CloseFiles;
begin
  close(input);
  close(output);
end;

procedure relax(i:integer;c:char;k:extended;l:integer);
var
  k1,k2:extended;

begin
  k2:=1;
  if c='/' then
  begin
    k1:=a[i]/k;
    if ao[i]<>1 then
      k2:=ao[i]/k;
  end
  else
  begin
    k1:=a[i]*k;
    if ao[i]<>1 then
      k2:=ao[i]*k;
  end;
  if mark[l] then
  begin
    if a[l]<k1 then
      a[l]:=k1;
    if a[l]<k2 then
      a[l]:=k2;
    if ao[l]>k1 then
      ao[l]:=k1;
    if ao[l]>k2 then
      ao[l]:=k2;
  end
  else
  begin
    mark[l]:=true;
    a[l]:=k1;
    ao[l]:=k1;
  end;
end;

procedure Solve;
var
  x,i,i1:longint;
  k:extended;
  q,qdmin,qdmax,qumin,qumax:tp;

begin
  read(n);
  for i:=1 to n do
  begin
    readln(x);
    if x<>0 then
    begin
      new(r[i]);
      readln(r[i]^.c,r[i]^.k,r[i]^.v);
      r[i]^.next:=nil;
      q:=r[i];
      for i1:=2 to x do
      begin
        new(q^.next);
        q:=q^.next;
        readln(q^.c,q^.k,q^.v);
        q^.next:=nil;
      end;
    end;
  end;
  fillchar(mark,sizeof(mark),false);
  fillchar(inf,sizeof(inf),false);
  fillchar(ao,sizeof(ao),1);
  a[1]:=1;
  ao[1]:=1;
  mark[1]:=true;
  for i:=1 to n do
  begin
    for i1:=1 to n do
      if mark[i1] then
      begin
        q:=r[i1];
        while q<>nil do
        begin
          relax(i1,q^.c,q^.k,q^.v);
          q:=q^.next;
        end;
      end;
  end;
  if (a[1]>1) then
    inf[1]:=true;
  for i:=1 to n do
  begin
    q:=r[i];
    while q<>nil do
    begin
      k:=a[q^.v];
      if inf[i] then
        inf[q^.v]:=true
      else
      begin
        relax(i,q^.c,q^.k,q^.v);
        if a[q^.v]>k then
          inf[q^.v]:=true;
        relax(i,q^.c,q^.k,q^.v);
        if a[q^.v]>k then
          inf[q^.v]:=true;
      end;
      q:=q^.next;
    end;
  end;
  for i:=1 to n do
  begin
    q:=r[i];
    while q<>nil do
    begin
      k:=a[q^.v];
      if inf[i] then
        inf[q^.v]:=true;
      q:=q^.next;
    end;
  end;
  for i:=1 to n do
    if not mark[i] then
      writeln('NONE')
    else
    if inf[i] then
      writeln('INF')
    else
      writeln(a[i]);
end;

begin
  OpenFiles;
  Solve;
  CloseFiles;
end.
