{$A+,B-,D-,E+,F-,G-,I+,L-,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
Program pr_e;
const
  inpfile='math.in';
  outfile='math.out';
  nm=305;
  eps=1e-7;
var
  a,b,c,d : array [1..nm,1..nm] of Extended;
  a1,b1,c1,d1,a0,b0,c0,d0 : array [1..nm,1..nm] of Boolean;
  n : Longint;
{}
Procedure Inp;
var
  i,j,k : LongInt;
  arr : LongInt;
  num : Extended;
  ch : Char;
begin
  assign(input,inpfile);
  reset(input);
  read(n);
  a0[1,1]:=true;
  a[1,1]:=1; b[1,1]:=1;
  for i:=1 to n do
  begin
    readln(k);
    for j:=1 to k do
    begin
      read(ch); readln(num,arr);
      case ch of
      '/':
        begin
          if i=1 then a0[i,arr]:=true;
          if num>-eps then
          begin
            if a[i,arr]<1/num then begin a[i,arr]:=1/num; a0[i,arr]:=true; end;
            if b[i,arr]>1/num then begin b[i,arr]:=1/num; b0[i,arr]:=true; end;
          end else
          begin
            if c[i,arr]>1/num then begin  c[i,arr]:=1/num; c0[i,arr]:=true; end;
            if d[i,arr]<1/num then begin  d[i,arr]:=1/num; d0[i,arr]:=true; end;
          end;
        end;
      '*':
        begin
          if i=1 then a0[i,arr]:=true;
          if num>-eps then
          begin
            if a[i,arr]<num then begin  a[i,arr]:=num; a0[i,arr]:=true; end;
            if b[i,arr]>num then begin  b[i,arr]:=num; b0[i,arr]:=true; end;
          end else
          begin
            if c[i,arr]>num then begin  c[i,arr]:=num; c0[i,arr]:=true; end;
            if d[i,arr]<num then begin  d[i,arr]:=num; d0[i,arr]:=true; end;
          end;
        end;
      end;
    end;
  end;
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  if a1[1,1] then writeln('INF') else writeln(a[1,1]:0:6);
  for i:=2 to n do
  begin
    if (not a0[1,i]) and (not d0[1,i]) then writeln('NONE')
    else if a1[1,i] then writeln('INF')
    else begin
      if a0[1,i] then writeln(a[1,i]:0:6) else writeln(d[1,i]:0:6);
    end;
  end;
  close(output);
  halt;
end;
{}
Procedure Init;
var
  i,j : Longint;
begin
  fillchar(a1,sizeof(a1),0);
  fillchar(b1,sizeof(b1),0);
  fillchar(c1,sizeof(c1),0);
  fillchar(d1,sizeof(d1),0);
  fillchar(a0,sizeof(a0),0);
  fillchar(b0,sizeof(b0),0);
  fillchar(c0,sizeof(c0),0);
  fillchar(d0,sizeof(d0),0);
  {for i:=1 to nm do
  begin
    a0[i,i]:=true;
    b0[i,i]:=true;
    c0[i,i]:=true;
    d0[i,i]:=true;
    a1[i,i]:=true;
    b1[i,i]:=true;
    c1[i,i]:=true;
    d1[i,i]:=true;
  end;}
  fillchar(a,sizeof(a),0);
  fillchar(c,sizeof(c),0);
  for i:=1 to nm do
  for j:=1 to nm do
  begin
    b[i,j]:=1e80;
    d[i,j]:=-1e80;
  end;
end;
{}
Procedure Solve;
var
  i,j,k : LongInt;
  absold,old : Boolean;
begin
  {}
  for k:=1 to n do
  for i:=1 to n do
  for j:=1 to n do
  begin
    if ((a[i,k]*a[k,j]>a[i,j]) or not (a0[i,j]))
    and (a0[i,k]) and (a0[k,j]) then begin a[i,j]:=a[i,k]*a[k,j]; a0[i,j]:=true; end;

    if ((c[i,k]*c[k,j]>a[i,j]) or not (a0[i,j]))
    and (c0[i,k]) and (c0[k,j]) then begin a[i,j]:=c[i,k]*c[k,j]; a0[i,j]:=true; end;

    if ((b[i,k]*b[k,j]<b[i,j]) or not (b0[i,j]))
    and (b0[i,k]) and (b0[k,j]) then begin b[i,j]:=b[i,k]*b[k,j]; b0[i,j]:=true; end;

    if ((d[i,k]*d[k,j]<b[i,j]) or not (b0[i,j]))
    and (d0[i,k]) and (d0[k,j]) then begin b[i,j]:=d[i,k]*d[k,j]; b0[i,j]:=true; end;

    if ((c[i,k]*a[k,j]<c[i,j]) or not (c0[i,j]))
    and (c0[i,k]) and (a0[k,j])then begin c[i,j]:=c[i,k]*a[k,j]; c0[i,j]:=true; end;

    if ((a[i,k]*c[k,j]<c[i,j]) or not (c0[i,j]))
    and (a0[i,k]) and (c0[k,j])then begin c[i,j]:=a[i,k]*c[k,j]; c0[i,j]:=true; end;

    if ((d[i,k]*b[k,j]>d[i,j]) or not (d0[i,j]))
    and (d0[i,k]) and (b0[k,j])then begin d[i,j]:=d[i,k]*b[k,j]; d0[i,j]:=true; end;

    if ((b[i,k]*d[k,j]>d[i,j]) or not (d0[i,j]))
    and (b0[i,k]) and (d0[k,j])then begin d[i,j]:=b[i,k]*d[k,j]; d0[i,j]:=true; end;
  end;
  {}
  for k:=1 to n do
  for i:=1 to n do
  for j:=1 to n do
  begin
    if ((a[i,k]*a[k,j]>a[i,j]) or not (a0[i,j]))
    and (a0[i,k]) and (a0[k,j]) then begin a[i,j]:=a[i,k]*a[k,j]; a0[i,j]:=true; end;

    if ((c[i,k]*c[k,j]>a[i,j]) or not (a0[i,j]))
    and (c0[i,k]) and (c0[k,j]) then begin a[i,j]:=c[i,k]*c[k,j]; a0[i,j]:=true; end;

    if ((b[i,k]*b[k,j]<b[i,j]) or not (b0[i,j]))
    and (b0[i,k]) and (b0[k,j]) then begin b[i,j]:=b[i,k]*b[k,j]; b0[i,j]:=true; end;

    if ((d[i,k]*d[k,j]<b[i,j]) or not (b0[i,j]))
    and (d0[i,k]) and (d0[k,j]) then begin b[i,j]:=d[i,k]*d[k,j]; b0[i,j]:=true; end;

    if ((c[i,k]*a[k,j]<c[i,j]) or not (c0[i,j]))
    and (c0[i,k]) and (a0[k,j])then begin c[i,j]:=c[i,k]*a[k,j]; c0[i,j]:=true; end;

    if ((a[i,k]*c[k,j]<c[i,j]) or not (c0[i,j]))
    and (a0[i,k]) and (c0[k,j])then begin c[i,j]:=a[i,k]*c[k,j]; c0[i,j]:=true; end;

    if ((d[i,k]*b[k,j]>d[i,j]) or not (d0[i,j]))
    and (d0[i,k]) and (b0[k,j])then begin d[i,j]:=d[i,k]*b[k,j]; d0[i,j]:=true; end;

    if ((b[i,k]*d[k,j]>d[i,j]) or not (d0[i,j]))
    and (b0[i,k]) and (d0[k,j])then begin d[i,j]:=b[i,k]*d[k,j]; d0[i,j]:=true; end;
  end;
  {}
  for k:=1 to n do
  for i:=1 to n do
  for j:=1 to n do
  begin
    if (a[i,k]*a[k,j]>a[i,j]) and (a0[i,k]) and (a0[k,j])then begin a[i,j]:=a[i,k]*a[k,j]; a1[i,j]:=true; end;
    if (c[i,k]*c[k,j]>a[i,j]) and (c0[i,k]) and (c0[k,j])then begin a[i,j]:=c[i,k]*c[k,j]; a1[i,j]:=true; end;
    if (b[i,k]*b[k,j]<b[i,j]) and (b0[i,k]) and (b0[k,j])then begin b[i,j]:=b[i,k]*b[k,j]; b1[i,j]:=true; end;
    if (d[i,k]*d[k,j]<b[i,j]) and (d0[i,k]) and (d0[k,j])then begin b[i,j]:=d[i,k]*d[k,j]; b1[i,j]:=true; end;

    if (c[i,k]*a[k,j]<c[i,j]) and (c0[i,k]) and (a0[k,j])then begin c[i,j]:=c[i,k]*a[k,j]; c1[i,j]:=true; end;
    if (a[i,k]*c[k,j]<c[i,j]) and (a0[i,k]) and (c0[k,j])then begin c[i,j]:=a[i,k]*c[k,j]; c1[i,j]:=true; end;
    if (d[i,k]*b[k,j]>d[i,j]) and (d0[i,k]) and (b0[k,j])then begin d[i,j]:=d[i,k]*b[k,j]; d1[i,j]:=true; end;
    if (b[i,k]*d[k,j]>d[i,j]) and (b0[i,k]) and (d0[k,j])then begin d[i,j]:=b[i,k]*d[k,j]; d1[i,j]:=true; end;
  end;
  {}
  for k:=1 to n do
  for i:=1 to n do
  for j:=1 to n do
  begin
    if (a[i,k]*a[k,j]>a[i,j]) and (a0[i,k]) and (a0[k,j])then begin a[i,j]:=a[i,k]*a[k,j]; a1[i,j]:=true; end;
    if (c[i,k]*c[k,j]>a[i,j]) and (c0[i,k]) and (c0[k,j])then begin a[i,j]:=c[i,k]*c[k,j]; a1[i,j]:=true; end;
    if (b[i,k]*b[k,j]<b[i,j]) and (b0[i,k]) and (b0[k,j])then begin b[i,j]:=b[i,k]*b[k,j]; b1[i,j]:=true; end;
    if (d[i,k]*d[k,j]<b[i,j]) and (d0[i,k]) and (d0[k,j])then begin b[i,j]:=d[i,k]*d[k,j]; b1[i,j]:=true; end;

    if (c[i,k]*a[k,j]<c[i,j]) and (c0[i,k]) and (a0[k,j])then begin c[i,j]:=c[i,k]*a[k,j]; c1[i,j]:=true; end;
    if (a[i,k]*c[k,j]<c[i,j]) and (a0[i,k]) and (c0[k,j])then begin c[i,j]:=a[i,k]*c[k,j]; c1[i,j]:=true; end;
    if (d[i,k]*b[k,j]>d[i,j]) and (d0[i,k]) and (b0[k,j])then begin d[i,j]:=d[i,k]*b[k,j]; d1[i,j]:=true; end;
    if (b[i,k]*d[k,j]>d[i,j]) and (b0[i,k]) and (d0[k,j])then begin d[i,j]:=b[i,k]*d[k,j]; d1[i,j]:=true; end;
  end;

end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
