const inf = 1.7e300;

var a: array[1..300,1..300] of double;
    vnum: integer;

procedure Solve;
var i,j,k: integer;
begin
  For k:=1 to vnum do
    For i:=1 to vnum do
      For j:=1 to vnum do
        if (a[i,k]<inf) and (a[k,j]<inf) then
          if a[i,k]*a[k,j]<a[i,j] then a[i,j]:=a[i,k]*a[k,j];
end;

procedure Save;
var f: text;
    i: integer;
begin
  Assign(f,'math.out');
  Rewrite(f);
  For i:=1 to vnum do begin
    if a[1,i]>=Inf then writeLn(f,'NONE') else
      if a[i,i]<0 then writeLn(f,'INF') else
        WriteLn(f,a[1,i]:6:6);
  end;
  Close(f);
end;

procedure Load;
var f: text;
    i,j,t1,t2: integer;
    ch: char;
begin
  Assign(f,'math.in');
  reset(f);
  Read(f,vnum);
  For i:=1 to vnum do
    For j:=1 to vnum do
      a[i,j]:=inf;
  For i:=1 to vnum do begin
    ReadLn(f,j);
    while j>0 do begin
      read(f,ch);
      ReadLn(f,t1,t2);
      if ch='*' then begin
        if a[i,t2]>t1 then a[i,t2]:=t1;
      end else begin
        if a[i,t2]>1/t1 then a[i,t2]:=1/t1;
      end;
      dec(j);
    end;
  end;
  Close(f);
end;

Begin
  Load;
  Solve;
  Save;
End.
