const
     FileIn='parket.in';
     FileOut='parket.out';
     MaxM=300;
     MaxN=300;
     NormalCh='.';
     DamagedCh='*';
var
   M, N: LongInt;
   A, B: LongInt;
   Floor: array [1..MaxM, 1..MaxN] of Char;
   Answer: LongInt;

procedure ReadData;
var
   F: Text;
   X, Y: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N, M, A, B);
     for Y:=1 to N
         do begin
            for X:=1 to M
               do Read (F, Floor [X, Y]);
            Readln (F);
         end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, Answer);
     Close (F);
end;

function CountOfDamaged: LongInt;
var
   X, Y: LongInt;
   DamagedCount: LongInt;
begin
     DamagedCount:=0;
     for X:=1 to M
         do for Y:=1 to N
                do if Floor [X, Y]=DamagedCh
                      then Inc (DamagedCount);
     CountOfDamaged:=DamagedCount;
end;

procedure CommonSolve;
var
   X, Y: LongInt;
   ACount: LongInt;
begin
     for X:=1 to M-1
         do for Y:=1 to N
                do if (Floor [X, Y]=DamagedCh) and (Floor [X+1, Y]=DamagedCh)
                      then begin
                           Floor [X, Y]:=NormalCh;
                           Floor [X+1, Y]:=NormalCh;
                           Inc (ACount);
                      end;
     for X:=1 to M
         do for Y:=1 to N-1
                do if (Floor [X, Y]=DamagedCh) and (Floor [X, Y+1]=DamagedCh)
                      then begin
                           Floor [X, Y]:=NormalCh;
                           Floor [X, Y+1]:=NormalCh;
                           Inc (ACount);
                      end;
     Answer:=ACount*A+CountOfDamaged*B;
end;

procedure Solve;
begin
     if A>2*B
        then Answer:=CountOfDamaged*B
        else CommonSolve;
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
