{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
const infile = 'input.txt'; outfile = 'output.txt'; max = 100005;
var n,m,ans: longint;
    a,b: array [1..max] of longint;
    f: array [1..max] of longint;
    k: extended;

procedure init;
var i: longint;
begin
     assign(input,infile);
     reset(input);
     read(n);
     for i:=1 to n do read(a[i]);
     read(m);
     for i:=1 to m do read(b[i]);
     read(k);
     close(input);
end;

procedure sort_a(l,r: longint);
var i,j,y,x: longint;
begin
     i:=l; j:=r; x:=a[(l+r) div 2];
     repeat
           while a[i] < x do i:=i+1;
           while x < a[j] do j:=j-1;
           if i <= j then
           begin
                y:=a[i]; a[i]:=a[j]; a[j]:=y;
                i:=i+1; j:=j-1;
           end;
     until i > j;
     if l < j then sort_a(l,j);
     if i < r then sort_a(i,r);
end;

procedure sort_b(l,r: longint);
var i,j,y,x: longint;
begin
     i:=l; j:=r; x:=b[(l+r) div 2];
     repeat
           while b[i] < x do i:=i+1;
           while x < b[j] do j:=j-1;
           if i <= j then
           begin
                y:=b[i]; b[i]:=b[j]; b[j]:=y;
                i:=i+1; j:=j-1;
           end;
     until i > j;
     if l < j then sort_b(l,j);
     if i < r then sort_b(i,r);
end;

procedure solve;
var num: extended;
    min,min2,i,up,down: longint;
begin
     sort_a(1,n);  sort_b(1,m);
     for i:=1 to n do f[i]:=1;
     num:=0;
     while (num < k) do begin
           min:=0;
           for i:=1 to n do
               if (f[i] <= m)and((min = 0)or(a[i]+b[f[i]] < a[min]+b[f[min]])) then min:=i;
           min2:=0;
           for i:=1 to n do
               if (i <> min)and(f[i] <= m)and((min2 = 0)or(a[i]+b[f[i]] < a[min2]+b[f[min2]])) then min2:=i;
           down:=f[min]; up:=m;
           repeat
                 if (a[min]+b[(up+down) div 2] > a[min2]+b[f[min2]]) then up:=(up+down) div 2
                    else down:=(up+down) div 2;
           until up-down <= 1;
           num:=num+(up+down) div 2-f[min]+1;
           if num > k then begin
              num:=num-(up+down) div 2;
              break;
           end;
           f[min]:=(up+down) div 2+1;
           ans:=a[min]+b[f[min]-1];
     end;
     if num = k then exit;
     up:=m; down:=f[min];
     repeat
           if (num+(up+down) div 2) < k then down:=(up+down) div 2
              else up:=(up+down) div 2;
     until num+(up+down) div 2 = k;
     ans:=a[min]+b[(up+down) div 2];
end;

procedure done;
begin
     assign(output,outfile);
     rewrite(output);
     write(ans);
     close(output);
end;

begin
     init;
     solve;
     done;
end.