const MAXS = 110000;

type int = longint;
var a, b, aa: array [0..MAXS + 10] of int;
procedure merge(l, h: int);
var x, y, z, j: int;
begin
  if l = h then exit;
  y:=(l + h) div 2;
  merge(l, y);
  merge(y + 1, h);
  x:=l;
  z:=y + 1;
  j:=l;
  while (x <= y) and (z <= h) do
    if a[x] <= a[z] then
      begin
        aa[j]:=a[x];
        inc(x);
        inc(j);
      end
    else
      begin
        aa[j]:=a[z];
        inc(z);
        inc(j);
      end;
  while (x <= y) do
    begin
      aa[j]:=a[x];
      inc(x);
      inc(j);
    end;
  while (z <= h) do
    begin
      aa[j]:=a[z];
      inc(z);
      inc(j);
    end;
  for j:=l to h do
    a[j]:=aa[j];
end;

procedure merge1(l, h: int);
var x, y, z, j: int;
begin
  if l = h then exit;
  y:=(l + h) div 2;
  merge1(l, y);
  merge1(y + 1, h);
  x:=l;
  z:=y + 1;
  j:=l;
  while (x <= y) and (z <= h) do
    if b[x] <= b[z] then
      begin
        aa[j]:=b[x];
        inc(x);
        inc(j);
      end
    else
      begin
        aa[j]:=b[z];
        inc(z);
        inc(j);
      end;
  while (x <= y) do
    begin
      aa[j]:=b[x];
      inc(x);
      inc(j);
    end;
  while (z <= h) do
    begin
      aa[j]:=b[z];
      inc(z);
      inc(j);
    end;
  for j:=l to h do
    b[j]:=aa[j];
end;

var m: int;
function count(u: int {!!!} ): int; {!!!}
var l, h, t: int;
begin
  if u < 0 then
    begin
      count:=0;
      exit;
    end;
  b[0]:=-1;
  b[m + 1]:=maxlongint;
  l:=0;
  h:=m + 1;

  while (l < h) do
    begin
      if l + 1 = h then break;
      t:=(l + h) div 2;
      if b[t] > u then h:=t else l:=t;
    end;
  count:=h - 1;
end;

function count1(u: int64 ): int64;
var l, h, t: int;
begin
  if u < 0 then
    begin
      count1:=0;
      exit;
    end;
  b[0]:=-1;
  b[m + 1]:=maxlongint;
  l:=0;
  h:=m + 1;

  while (l < h) do
    begin
      if l + 1 = h then break;
      t:=(l + h) div 2;
      if b[t] >= u then h:=t else l:=t;
    end;
  count1:=h - 1;
end;

var n, l, h, u, i: int;

var k, t1, t2: int64;  {!!!}
begin
  assign(input, 'input.txt');
  assign(output, 'output.txt');
  reset(input);
  rewrite(output);
  read(n);
  for i:=1 to n do
    read(a[i]);
  merge(1, n);
  read(m);
  for i:=1 to m do
    read(b[i]);
  merge1(1, m);
  read(k);

  if k = int64(n) * int64(m) then
    begin
      writeln(a[n] + b[m]);
      close(input);
      close(output);
      exit;
    end;

  l:=0;
  h:=maxlongint;
  while (l < h) do
    begin
      u:=(l + h) div 2;
      if h <= 6 then
        h:=h;
      t1:=0;
      for i:=1 to n do
        t1:=t1 + count1(u - a[i]);

      t2:=0;
      for i:=1 to n do
        t2:=t2 + count(u - a[i]);

      if (t1 < t2) and (t1 + 1 <= k) and (k <= t2) then
        begin
          writeln(u);
          close(input);
          close(output);
          exit;
        end;
      if t2 <= k - 1 then l:=u else h:=u;
    end;
end.
