#include <stdio.h>
#include <math.h>
#define max 100001L
long size,n,m,a[max],b[max];
double k;
long parent(long i)
{
  return i/2;
}
long left(long i)
{
  return 2*i;
}

long right(long i)
{
  return 2*i+1;
}

void sift_down(long i)
{
  while (1)
  {
	long smallest=i;
	long l,r;
	long x;
	l=left(i);
	if((l<=size)&&(b[smallest]<b[l]))
	  smallest=l;
	r=right(i);
	if((r<=size)&&(b[smallest]<b[r]))
	  smallest=r;
	if(i==smallest)
	  break;
	x=b[i];
	b[i]=b[smallest];
	b[smallest]=x;
	i=smallest;
  }
}
long get_min(void)
{
  return b[1];
}

long extract_min(void)
{
  long x=get_min();
  b[1]=b[size];
  size--;
  sift_down(1);
  return x;
}
void build( void )
{
  long i;
  for (i=size;i>0;i--)
	sift_down(i);
}
void sort(void)
{
  long i;
  build();
  for (i=size;i>0;i--)
	b[i]=extract_min();
}
void read(void)
{
  long t,i,*p;
  scanf("%ld",&n);
  for(i=1;i<=n;i++)
	scanf("%ld",&a[i]);
  scanf("%ld",&m);
  for(i=1;i<=m;i++)
	scanf("%ld",&b[i]);
  if(m<n)
  {
	t=m;m=n;n=t;
	for(i=1;i<=m;i++)
	{
	  t=a[i];a[i]=b[i];b[i]=t;
	}
  }
  scanf("%lf",&k);
}
long calc1(long c)
{
  long l=1,r=m,mid;
  while(1)
  {
	mid=(l+r)/2;
	if(mid==0||r==0)
	  return 0;
	if(b[mid]<=c)
	{
	  if(mid==m||b[mid+1]>c)
		return mid;
	  l=mid+1;
	}
	else
	  r=mid-1;
  }
}
double count1(long c)
{
  long i;
  double x=0;
  for(i=1;i<=n;i++)
	x+=calc1(c-a[i]);
  return x;
}
long calc2(long c)
{
  long l=1,r=m,mid;
  while(1)
  {
	mid=(l+r)/2;
	if(mid==0||r==0)
	  return 0;
	if(b[mid]<c)
	{
	  if(mid==m||b[mid+1]>=c)
		return mid;
	  l=mid+1;
	}
	else
	  r=mid-1;
  }
}
double count2(long c)
{
  long i;
  double x=0;
  for(i=1;i<=n;i++)
	x+=calc2(c-a[i]);
  return x;
}
void solve(void)
{
  long l=a[1]+b[1],r=a[n]+b[m],mid;
  double x1,x2;
  size=m;
  sort();
  while(1)
  {
	mid=floor(((double)l+r)/2);
	x1=count1(mid);
	x2=count2(mid);
	if(x2<k&&x1>=k)
	{
	  printf("%ld",mid);
	  return;
	}
	if(x2>=k)
	  r=mid-1;
	else
	  l=mid+1;
  }
}
int main(void)
{
  freopen("input.txt","rt",stdin);
  freopen("output.txt","wt",stdout);
  read();
  solve();
  return 0;
}

