#include<cstdio>
#include<cstdlib>
#include<cmath>
#include<cstring>
#include<string>
#include<complex>
#include<algorithm>
#include<set>
#include<map>
#include<vector>
#include<queue>

using namespace std;
#define REP(i,n) for(int i=0;i<(int)(n);i++)
#define FOR(i,a,b) for(int i=(int)(a);i<=(int)(b);i++)
#define FORE(i,c) for(__typeof(c.begin()) i=(c).begin();i!=(c).end();i++)

#define FORI(p,q) for(int i = p; i < q; ++i)
#define FORJ(p,q) for(int j = p; j < q; ++j)
#define FORK(p,q) for(int k = p; k < q; ++k)
#define FORL(p,q) for(int l = p; l < q; ++l)

#define PI pair<int,int>
#define X first
#define Y second
#define VI vector<int>

#define S size()
#define PB push_back

int tab[1027][1027];
int tab2[1027][1027];

int n;

long long nwd(long long a, long long b)
{
    if(b == 0) return a;
    return nwd(b, a%b);
}


long long nww(long long a, long long b)
{
    if(b == 1) return a;
    return a*b/nwd(a,b);
}

inline void cop()
{
    for(int i=0; i<n; i++)
    for(int j=0; j<n; j++)
	tab[i][j] = tab2[i][j];
}

void id(int min)
{
    
}

void rot(int min)
{
    for(int i=0; i<n; i++)
    for(int j=0; j<n; j++)
    {
	if(min == 0)
	    tab2[n-1-j][i] = tab[i][j];
	else
	    tab2[i][j] = tab[n-1-j][i];
    }
    cop();
}

void sym(int min)
{
    for(int i=0; i<n; i++)
    for(int j=0; j<n; j++)
    {
	tab2[i][n-1-j] = tab[i][j];
    }
    cop();
}

void bhsym(int min)
{
    for(int i=0; i<n/2; i++)
    for(int j=0; j<n; j++)
	tab2[i][j] = tab[i][j];
    for(int i=n/2; i<n; i++)
    for(int j=0; j<n; j++)
    {
	tab2[i][n-1-j] = tab[i][j];
    }
    cop();
}

void bvsym(int min)
{
    for(int i=0; i<n/2; i++)
    for(int j=0; j<n; j++)
	tab2[i][j] = tab[i][j];
    for(int i=n/2; i<n; i++)
    for(int j=0; j<n; j++)
    {
	if(min == 0)
	    tab2[n-1-i+n/2][j] = tab[i][j];
	else
	    tab2[i][j] = tab[n-1-i+n/2][j];	    
    }
    cop();
}

void div(int min)
{
    for(int i=0; i<n; i++)
    for(int j=0; j<n; j++)
    {
	if(min == 0)
	{
	    if(i % 2 == 0)
		tab2[i/2][j] = tab[i][j];
	    else
		tab2[i/2+n/2][j] = tab[i][j];
	}
	else
	{
	    if(i % 2 == 0)
		tab2[i][j] = tab[i/2][j];
	    else
		tab2[i][j] = tab[i/2+n/2][j];
	}
    }
    cop();
}

void mix(int min)
{
    for(int i=0; i<n; i++)
    for(int j=0; j<n; j++)
    {
	if(min == 0)
	{
	    if(i % 2 == 0)
		tab2[i][j] = tab[i+(j%2)][j/2];
	    else
		tab2[i][j] = tab[i-1+(j%2)][j/2+n/2];
	}
	else
	{
	    if(i % 2 == 0)
		tab2[i+(j%2)][j/2] = tab[i][j];
	    else
		tab2[i-1+(j%2)][j/2+n/2] = tab[i][j];
	}
    }
    cop();
}

void rott()
{
    char line[2000];
    char out[100];
    char cmd[20][32];
    fgets(line, 1999, stdin);
    stringstream ss;
    ss << line;
    int ilec;
//    printf("%d\n", n);
    ilec = 0;
    while(ss)
    {
	ss >> cmd[ilec];
	if(!ss) break;
	ilec ++;
    }
    for(int i=0; i<n; i++)
    for(int j=0; j<n; j++)
    {
	tab[i][j] = j + i*n;
    }
    for(int i=ilec-1; i>=0; i--)
    {
	if(strcmp(cmd[i], "id") == 0)
	    id(0);
	else if(strcmp(cmd[i], "id-") == 0)
	    id(1);
	else if(strcmp(cmd[i], "rot") == 0)
	    rot(0);
	else if(strcmp(cmd[i], "rot-") == 0)
	    rot(1);
	else if(strcmp(cmd[i], "sym") == 0)
	    sym(0);
	else if(strcmp(cmd[i], "sym-") == 0)
	    sym(1);
	else if(strcmp(cmd[i], "bhsym") == 0)
	    bhsym(0);
	else if(strcmp(cmd[i], "bhsym-") == 0)
	    bhsym(1);
	else if(strcmp(cmd[i], "bvsym") == 0)
	    bvsym(0);
	else if(strcmp(cmd[i], "bvsym-") == 0)
	    bvsym(1);
	else if(strcmp(cmd[i], "div") == 0)
	    div(0);
	else if(strcmp(cmd[i], "div-") == 0)
	    div(1);
	else if(strcmp(cmd[i], "mix") == 0)
	    mix(0);
	else if(strcmp(cmd[i], "mix-") == 0)
	    mix(1);
    }
    long long wyn;
    wyn = 1;
    int dlc, akt, a2;
/*    for(int i=0; i<n; i++)
    {
	for(int j=0; j<n; j++)
	{
	    printf("%d ", tab[i][j]);
	}
	printf("\n");
    }*/
    for(int i=0; i<n; i++)
    for(int j=0; j<n; j++)
    {
	if(tab[i][j] == -1) continue;
	akt = i*n+j;
	dlc = 0;
	while(akt>=0)
	{
	    dlc ++;
//	    printf("w %d\n", akt);
	    a2 = tab[akt/n][akt%n];
	    tab[akt/n][akt%n] = -1;
	    akt = a2;
	}
	dlc --;
//	printf("%d\n", dlc);
	wyn = nww(wyn, (long long) dlc);
    }
    printf("%lld\n", wyn);
}

int main()
{
    while(scanf("%d\n", &n) && n)
	rott();
	return 0;
}
