#include <cstdio>

typedef unsigned int uint;

int len;

typedef uint zbior[12];

bool podzbior(uint* a,uint* b)
{
  for (int i=0;i<len;i++) if ((a[i]|b[i])!=b[i]) return false;
  return true;
}

void clear(uint* a)
{
  for (int i=0;i<len;i++) a[i]=0;
}

void add(uint* a,uint* b)
{
  for (int i=0;i<len;i++) b[i]=a[i]|b[i];
}

bool cmp(uint* a,uint* b)
{
  for (int i=0;i<len;i++) if (a[i]!=b[i]) return false;
  return true;
}

int solve()
{
  int n,m,cnt=0;
  scanf("%d%d",&n,&m);
  if (!n) return 0;
  len=1+(n/32);
  bool active[500];
  zbior z[500];
  for (int i=0;i<m;i++)
  {
    clear(z[i]);
    int c;
    scanf("%d",&c);
    while (c--)
    {
      int a;
      scanf("%d",&a);
      a--;
      z[i][a>>5]|=(uint(1)<<(a&31));
    }
    active[i]=true;
  }
  for (int i=0;i<m;i++)
  {
    zbior x;
    clear(x);
    for (int j=0;j<m;j++) if (j!=i&&active[j]&&podzbior(z[j],z[i]))
      add(z[j],x);
    if (cmp(x,z[i]))
    {
      active[i]=false;
      cnt++;
    } 
  }
  printf("%d\n",cnt);
  return 1;
}

int main()
{
  while (solve());
  return 0;
}
