#include<cstdio>
#include<vector>
#include<map>
#include<string>
using namespace std;
int inv[8]={-1,1,4,5,2,3,6,-1};
int days[8]={7,8,9,3,4,5,6};
map<string ,int> de;
void solve(int n,int m){
  
  vector<vector<int> > u(m, vector<int>(n+1,0));
  for(int i=0;i<m;i++){
    int k;
    char a[10];
    char b[10];
    scanf("%d %s %s",&k,a,b);
    int ai=de[a];
    int bi=de[b];
    u[i][0]= (bi-ai+8)%7;
    for(int j=0;j<k;j++){
      int x;
      scanf("%d",&x);
      u[i][x]++;
      if(u[i][x]==7)u[i][x]=0;
    }
  }
  int cols=n;
  int rows=m;
  for(;true;cols--){/*
     for(int r=0;r<rows;r++){
       printf("%d=",u[r][0]);
       for(int c=1;c<=cols;c++){
         printf("%c * %d + ", 'a'+c-1, u[r][c]);
       }
       puts("");
     }
     puts("");*/
    if(rows<=0){
      if(cols>0){
        puts("Multiple solutions.");
	return;
      }else
        break;
    }
    if(cols<=0){
      for(int r=0;r<rows;r++){
        if(u[r][0]){
	  puts("Inconsistent data.");
	  return;
	}
      }
      break;
    }
    int br=-1;
    for(int r=0;r<rows;r++){
      if(u[r][cols]){
        br=r;
        break;
      }
    }
    if(br<0){
//      puts("br<0");
      int bc=-1;
      for(int r=0;r<rows;r++)
        for(int c=1;c<=cols;c++)
	  if(u[r][c]){
	    br=r;
	    bc=c;
	    break;
	  }
      if(bc<0){
        for(int r=0;r<rows;r++){
	  if(u[r][0]){
	    puts("Inconsistent data.");
	    return ;
	  }
	}
	puts("Multiple solutions.");
	return;
      }
      for(int r=0;r<rows;r++)
        swap(u[r][bc],u[r][cols]);
    }
    swap(u[rows-1],u[br]);
    for(int r=0;r<rows-1;r++){
      int f=(u[r][cols]*inv[u[rows-1][cols]])%7;
      for(int c=0;c<=cols;c++){
        u[r][c]= (7+(u[r][c]-u[rows-1][c]*f)%7)%7;
      }
    }
    rows--;
  }
  vector<int> rozw(n+1,0);
//  printf("r=%d c=%d\n",rows,cols);
  while(cols<=n){
    int w=u[rows-1][0];
    for(int c=1;c<cols;c++)
      w-=rozw[c]*u[rows-1][c];
    w=((w%7)+7)%7;
    rozw[cols]=(w*inv[u[rows-1][cols]])%7;    
    cols++;
    rows++;
  }
  for(int c=1;c<=n;c++){
    printf("%d ",days[rozw[c]]);
  }
  puts("");
}
int main(){
  int n,m;
  de["MON"]=0;
  de["TUE"]=1;
  de["WED"]=2;
  de["THU"]=3;
  de["FRI"]=4;
  de["SAT"]=5;
  de["SUN"]=6;
  while(1){
    scanf("%d %d",&n,&m);
    if(!n && !m)return 0;
    solve(n,m);
  }    
}
