#include <cmath>
#include <cstdio>

double sqr(double x)
{
  return x*x;
}

double otworz(double y1,double y2,double rx,double ry,double r)
{
  double x1=rx-sqrt(sqr(r)-sqr(ry-y1));
  double x2=rx-sqrt(sqr(r)-sqr(ry-y2));
  double u1x,u1y,u2x,u2y;
  u1x=x1-rx;
  u1y=y1-ry;
  u2x=x2-rx;
  u2y=y2-ry;
  double c=(u1x*u2x+u1y*u2y)/sqrt((sqr(u1x)+sqr(u1y))*(sqr(u2x)+sqr(u2y)));
  double alpha=acos(c);
  double p=alpha*r*r*0.5;
  p+=0.5*(ry-y1)*(rx-x1);
  p-=0.5*(ry-y2)*(rx-x2);
  p-=rx*(y2-y1);
  return p;
}


double zamknij(double y1,double y2,double rx,double ry,double r)
{
  double x1=rx+sqrt(sqr(r)-sqr(ry-y1));
  double x2=rx+sqrt(sqr(r)-sqr(ry-y2));
  double u1x,u1y,u2x,u2y;
  u1x=x1-rx;//koljenosc
  u1y=y1-ry;
  u2x=x2-rx;
  u2y=y2-ry;
  double c=(u1x*u2x+u1y*u2y)/sqrt((sqr(u1x)+sqr(u1y))*(sqr(u2x)+sqr(u2y)));
  double alpha=acos(c);
  double p=-alpha*r*r*0.5;
  p-=0.5*(ry-y1)*(rx-x1);
  p+=0.5*(ry-y2)*(rx-x2);
  p+=rx*(y2-y1);
  return p;
}

double rzx[2];
double rzy[2];

int rozw(double p1x,double p1y,double r1,double p2x,double p2y,double
r2)
{
  double ux,uy;
  ux=p2x-p1x;
  uy=p2y-p1y;
  double l=sqrt(sqr(ux)+sqr(uy));
  if (l>r1+r2) return 0;
  double a=(sqr(r1)-sqr(r2)+sqr(l))/(2.0*l);
  double h=sqrt(sqr(r1)-sqr(a));
  double aax,aay,bbx,bby;
  aax=ux*a/l;
  aay=uy*a/l;
  bbx=uy*h/l;
  bby=-ux*h/l;
  
  rzx[0]=p1x+aax+bbx;
  rzy[0]=p1y+aay-bby;
  rzx[0]=p1x+aax+bbx;
  rzy[0]=p1y+aay-bby;
  return 2;
}

int cnt;
double x[300],y[300],r[300];
#define EPS (1e-7)

int main() {
  int n,m,ks,kl,i,j;
  
  while (scanf("%d %d %d %d",&n,&m,&ks,&kl),n) {
    set<double> possible_y;
    cnt=0;
    while (ks--) {
      scanf("%d %d",x+cnt,y+cnt);
      r[cnt++]=0.58;
    }
    while (kl--) {
      scanf("%d %d",x+cnt,y+cnt);
      r[cnt++]=1.31;
    }
    for (i=0; i<cnt; i++) for (k=0; k<i; k++)
      for (j=rozw(x[i],y[i],r[i],x[k],y[k],r[k])-1; j>=0; j--)
        if (rzy[j]>0 && rzy[j]<n)
          possible_y.insert(rzy[j]);
    double ans=0.0;
    for (set<double>::iterator iter2,iter=s.begin(); iter!=s.end(); iter++) {
      iter2=iter; iter2++;
      for (i=0; i<cnt; i++) {
      }
    }
    pritnf("%.2lf\n",ans);
  }
  return 0;
}
