program circular_defence;

{$APPTYPE CONSOLE}
{$O-}

const
  st_max = 300;
  t_max = 1010;

var
  st: array[0..t_max, 0..st_max] of boolean;
  prev: array[0..t_max, 0..st_max] of integer;
  i, j, t, n, k, s, z1, z2, z3, s1, s2, s3, s4, mt, sptr: integer;
  vect2num: array[0..10, 0..10, 0..10] of integer;
  num2vect1, num2vect2, num2vect3: array[0..st_max] of integer;
  a: array[0..t_max, 0..4] of integer;
  flag: boolean;
  r: array[0..st_max, 0..st_max] of boolean;
  stck: array[0..t_max] of integer;


function fl(apar: integer): integer;
begin
  if apar > 0 then result := apar else result := 0;
end;

begin
  assign (input, 'input.txt'); reset (input);
  assign (output, 'output.txt'); rewrite (output);

  read (n, mt);
  for i := 1 to mt do
    for j := 0 to 3 do read(a[i, j]);

  s := 0;
  for i := 0 to n do
    for j := 0 to n do
      for k := 0 to n do
        if (i + j + k <= n) then
        begin
          inc(s);
          vect2num[i, j, k] := s;
          num2vect1[s] := i;
          num2vect2[s] := j;
          num2vect3[s] := k;
        end;


  for i := 1 to s do
    for j := 1 to s do
      for s4 := -n to n do
      begin
        s3 := s4 + num2vect3[j] - num2vect3[i];
        s2 := s3 + num2vect2[j] - num2vect2[i];
        s1 := s2 + num2vect1[j] - num2vect1[i];

        r[i, j] := r[i, j] or
          ((fl(s2) + fl(-s1) <= num2vect1[i]) and
           (fl(s3) + fl(-s2) <= num2vect2[i]) and
           (fl(s4) + fl(-s3) <= num2vect3[i]) and
           (fl(s1) + fl(-s4) <= (n - num2vect1[i] - num2vect2[i] - num2vect3[i])));
      end;


  for i := 1 to s do st[0, i] := true;

  t := 0;
  while t < mt do
  begin
    for i := 1 to s do
      st[t, i] := st[t, i] and ((num2vect1[i] >= a[t+1, 0]) and (num2vect2[i] >= a[t+1, 1]) and (num2vect3[i] >= a[t+1, 2]) and
        (n - num2vect1[i] - num2vect2[i] - num2vect3[i] >= a[t+1, 3]));

    flag := false;
    for i := 1 to s do flag := flag or st[t, i];
    if not flag then break;
    inc(t);


    for i := 1 to s do
      if st[t - 1, i] then
        for j := 1 to s do
          if r[i, j] then
          begin
            st[t, j] := true;
            prev[t, j] := i;
          end;
  end;
  
  i := 1;
  writeln(t);
  dec(t);
  while not st[t, i] do inc(i);
  while t >= 0 do
  begin
    inc(sptr);
    stck[sptr] := i;
    i := prev[t, i];
    dec(t);
  end;

  for i := sptr downto 1 do
    writeln(num2vect1[stck[i]], ' ', num2vect2[stck[i]], ' ', num2vect3[stck[i]], ' ',
            n - num2vect1[stck[i]] - num2vect2[stck[i]] - num2vect3[stck[i]]);


  close (input); close (output);
end.