/*---------------------------------------------------------------*/
/* ACM ICPC 2005-2006, NEERC                                     */
/* Northern Subregional Contest                                  */
/* St Petersburg, October 29, 2005                               */
/*---------------------------------------------------------------*/
/* Problem C. Cutting a Block                                    */
/*                                                               */
/* Original idea         Georgiy Korneev                         */
/* Problem statement     Georgiy Korneev                         */
/* Testset               Georgiy Korneev                         */
/*---------------------------------------------------------------*/
/* Model solution (Java)                                         */
/*                                                               */
/* Author:               Georgiy Korneev                         */
/*---------------------------------------------------------------*/

import java.io.*;
import java.util.*;

class cutting_gk {
    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);

        Scanner scanner = new Scanner(new File("cutting.in"));
        PrintWriter writer = new PrintWriter(new FileOutputStream("cutting.out"));

        double x = scanner.nextInt();
        double y = scanner.nextInt();
        double z = scanner.nextInt();
        double n = scanner.nextInt();

        for (int i = 0; i < n; i++) {
            writer.println(String.format(
                "%.8f %.8f %.8f %.8f %.8f %.8f",
                0.0, 0.0, z / n * i, x, y, z / n * (i + 1)
            ));
        }

        writer.close();
    }
}