{---------------------------------------------------------------}
{ ACM ICPC 2005-2006, NEERC                                     }
{ Northern Subregional Contest                                  }
{ St Petersburg, October 29, 2005                               }
{---------------------------------------------------------------}
{ Problem D. Drying                                             }
{                                                               }
{ Original idea         Pavel Mavrin                            }
{ Problem statement     Andrew Lopatin                          }
{ Testset               Andrew Lopatin                          }
{---------------------------------------------------------------}
{ Model solution (Delphi)                                       }
{                                                               }
{ Author                Andrew Lopatin                          }
{---------------------------------------------------------------}

{$O-,Q+,R+}
uses SysUtils;
const MaxN=100000;
      MaxA=1000000000;
      MaxK=1000000000;

procedure readr (var x:integer; a, b:integer);
begin
  assert (not seekeoln); read (x); assert ((a<=x) and (x<=b));
end;


procedure readl;
begin
  assert (seekeoln); assert (not eof); readln
end;


var i, j, n, l, r, x, Z, k:integer;
    a:array [1..MaxN] of integer;

begin
  reset (input, 'drying.in'); rewrite (output, 'drying.out');
  readr (n, 1, MaxN); readl;
  for i:=1 to n do readr (a[i], 1, MaxA);
  readl;
  readr (k, 1, MaxK); readl; dec (k);
  assert (eof);
  r:=0; for i:=1 to n do if A[i]>r then r:=A[i];
  if k=0 then begin writeln (r); halt end;
  l:=1; 
  repeat
    x:=(l+r) shr 1; Z:=0;
    for j:=1 to N do 
      if A[j]>x then begin
        inc (Z, (A[j]-x+K-1) div K);
        if Z>x then break
      end;
    if Z>x then l:=x else r:=x;
  until r-l<=1;
  writeln (r);
end.