{---------------------------------------------------------------}
{ ACM ICPC 2005-2006, NEERC                                     }
{ Northern Subregional Contest                                  }
{ St Petersburg, October 29, 2005                               }
{---------------------------------------------------------------}
{ Problem G. Godfather                                          }
{                                                               }
{ Original idea         Dmitry Pavlov                           }
{ Problem statement     Andrew Stankevich                       }
{ Testset               Andrew Stankevich                       }
{---------------------------------------------------------------}
{ Solution                                                      }
{                                                               }
{ Author                Pavel Mavrin                            }
{---------------------------------------------------------------}

{$o-,q+,r+}
uses
  sysutils;

const
  MAX_N = 50000;

var
  h: array[1..MAX_N] of integer;
  nx: array[1..MAX_N] of integer;
  q, s, d: array[1..MAX_N] of integer;
  a, b, i, j, n, nn, max: integer;

procedure add(i, j: integer);
begin
  nx[j] := h[i];
  h[i] := j;
end;

begin
  reset(input, 'godfather.in');
  rewrite(output, 'godfather.out');

  read(n);

  for i := 1 to n-1 do begin
    read(a, b);
    inc(d[a]);
    inc(d[b]);
    s[a] := s[a] xor b;
    s[b] := s[b] xor a;
  end;

  for i := 1 to n do q[i] := 1;

  nn := n;

  for i := 1 to n do if d[i] = 1 then add(1, i);

  max := 1;

  for i := 1 to n do begin

    if nn <= 2 then begin
      for j := 1 to n do if q[j] = max then writeln(j);
      exit;
    end;

    j := h[i];
    while j <> 0 do begin
      q[s[j]] := q[s[j]] + q[j];
      if q[s[j]] > max then max := q[s[j]];
      d[s[j]] := d[s[j]] - 1;
      s[s[j]] := s[s[j]] xor j;
      if d[s[j]] = 1 then begin
        add(q[s[j]], s[j]);
      end;
      j := nx[j];
      dec(nn);
    end;
  end;

end.