{ XV ᨩ᪠  誮쭨  ଠ⨪       }
{  ""                                            }
{ : .. 娭, .. ९                        }
{ 襭:  ਭ, ३ ⠭                    }

program russia;

type
    tcmp = function(i, j: longint): boolean;

const
    maxn = 1000;

var
    a: array [1..maxn, 1..maxn] of boolean;
    cn: array [1..maxn] of boolean;
    fail: boolean;
    mark: array [0..maxn, 1..2] of longint;
    x, y, r, ys: array [0..maxn] of longint;
    ind: array [1..maxn] of longint;
    i, j, k, m, n, c, hd, tl: longint;
    train: array [-maxn..maxn] of longint;
    tail, next: array [1..maxn] of longint;
    savesta: longint;

procedure go(sta: longint);
begin
end;

procedure dfs(x, sd, col: longint);
var
    i: longint;
begin
    if mark[x][sd] = -col then
        fail := true;
    if fail then
        exit;

    mark[x][sd] := col;
    if sd = 1 then
    begin
        for i := 1 to m do
        begin
            if a[i][x] and (mark[i][2] <> -col) then
                dfs(i, 2, -col);
        end;
    end else begin
        for i := 1 to m do
        begin
            if a[x][i] and (mark[i][1] <> -col) then
                dfs(i, 1, -col);
        end;
    end;
    
    if cn[x] and (mark[x][3 - sd] <> col) then
        dfs(x, 3 - sd, col);
end;   

function lexcmp(i, j: longint): boolean;
begin
    lexcmp := (x[i] < x[j]) or ((x[i] = x[j]) and (y[i] < y[j]));
end;

function lencmp(i, j: longint): boolean;
begin
    lencmp := (y[i] - x[i]) < (y[j] - x[j]);
end;

function rnkcmp(i, j: longint): boolean;
begin
    rnkcmp := (x[i] < x[j]) or ((x[i] = x[j]) and (r[i] < r[j]));
end;

procedure sort(lt, rt: longint; f: tcmp);
var
    i, j, t: longint;
begin
    i := lt + random(rt - lt + 1);
    x[0] := x[i];
    y[0] := y[i];
    r[0] := r[i];
    i := lt;
    j := rt;
    while i <= j do
    begin
        while f(i, 0) do inc(i);
        while f(0, j) do dec(j);
        
        if i <= j then
        begin
            t := x[i]; x[i] := x[j]; x[j] := t;
            t := y[i]; y[i] := y[j]; y[j] := t;
            t := r[i]; r[i] := r[j]; r[j] := t;
            mark[0] := mark[i]; mark[i] := mark[j]; mark[j] := mark[0];
            t := ind[i]; ind[i] := ind[j]; ind[j] := t;
            inc(i);
            dec(j);
        end;
    end;
    
    if lt < j then sort(lt, j, f);
    if i < rt then sort(i, rt, f);
end;

var
 oops: integer;

procedure outp(act: string; sta, car: longint);
begin
    if savesta <> sta then
    begin
        go(sta);
    end;
    writeln(act, ' ', car);
    savesta := sta;
end;

procedure link(k, sta: longint; var p: longint; dp: longint);
var
    j, last: longint;
begin
    j := ind[k];
    last := tail[j];
    while true do
    begin
        p := p + dp;
        train[p] := j;
        if mark[k][1] > 0 then
            outp('1', sta, j)
        else
            outp('2', sta, j);
        if next[j] <> 0 then
            j := next[j]
        else
            break;
    end;
end;

procedure join(c: longint);
var
    i, j, col: longint;
begin
    col := mark[c][2];
    for i := 1 to n do
    begin
        for j := 1 to 2 do
        begin
            if mark[i][j] = col then
                mark[i][j] := mark[c][1];
            if mark[i][j] = -col then
                mark[i][j] := -mark[c][1];
        end;
    end;
end;

begin
    assign(input, 'russia.in');
    reset(input);
    assign(output, 'russia.out');
    rewrite(output);

    read(c);
    read(m);
    for i := 1 to m do
    begin
        read(x[i], y[i]);
        ind[i] := i;
    end;

    ys := y;

    sort(1, m, @lexcmp);

    n := 0;
    for i := 1 to m do
    begin
        if (n > 0) and (x[i] = x[n]) and (y[i] = y[n]) then
        begin
            next[tail[n]] := ind[i];
            tail[n] := ind[i];
        end else begin
            inc(n);
            x[n] := x[i];
            y[n] := y[i];
            ind[n] := ind[i];
            tail[n] := ind[i];
        end;
    end;

    sort(1, n, @lencmp);

    fillchar(cn, sizeof(cn), false);
    fillchar(a, sizeof(a), false);
    for i := 1 to n do
        for j := 1 to n do
        begin
            if (x[i] < x[j]) and (y[i] > y[j]) then
                cn[j] := true;
            if (x[i] < x[j]) and (x[j] < y[i]) and (y[i] < y[j]) then
                a[i][j] := true;
        end;
        
    fail := false;
    k := 0;
    for i := 1 to n do
    begin
        if mark[i][1] = 0 then
        begin
            inc(k);
            dfs(i, 1, k);
        end;
        if mark[i][2] = 0 then
        begin
            inc(k);
            dfs(i, 2, k);
        end;
    end;    
    
    if fail then
    begin
        writeln(0);
        close(output);
        exit;
    end;
    
    k := n;
    oops:=0;
    for i := 1 to n do
    begin
        if mark[i][1] = -mark[i][2] then
        begin
            inc(oops);
{            if oops=1 then writeln('First OOPS ',ind[i]);}
        end;
    end;

    for i := 1 to n do
    begin
        if mark[i][1] = -mark[i][2] then
        begin
            r[i] := -k;
            dec(k);
        end else begin
            r[i] := k;
            dec(k);
            join(i);
        end;
    end;

    for i := 1 to n do
    begin
        if mark[i][1] = -mark[i][2] then
        begin
            dec(oops);
            if oops<0 then begin
{              writeln('OOPS ',ind[i]);
              halt;}
            end;
        end;
    end;

    
    sort(1, n, @rnkcmp);
    
    k := 1;
    hd := 1;
    tl := 0;
    savesta := 1;
    for j := 1 to c do
    begin
        while hd <= tl do
        begin
            if ys[train[hd]] = j then
            begin
                outp('3', j, train[hd]);
                inc(hd);
            end else if ys[train[tl]] = j then begin
                outp('3', j, train[tl]);
                dec(tl);
            end else begin
                break;
            end;
        end;
        
        while (k <= n) and (x[k] = j) do
        begin
            if mark[k][1] > 0 then
            begin
                link(k, j, tl, +1);
            end else begin
                link(k, j, hd, -1);
            end;
            inc(k);
        end;
    end;
    
    if savesta < c then    
        go(c);
    
    close(input);
    close(output);
end.