{ XV ᨩ᪠  誮쭨  ଠ⨪       }
{  "⥪"                                            }
{ : ..                                           }
{ 襭: ३ ⠭,  ९               }

program ice;

const
    maxn = 6000;

type
    tarr = array [0..2] of longint; 

function sec(x, y: longint): longint;
begin
    if (x >= 0) and (y >= 0) then
        sec := 1
    else if (x < 0) and (y > 0) then
        sec := 2
    else if (x <= 0) and (y <= 0) then
        sec := 3
    else
        sec := 4;
end;

function le(x1, y1, x2, y2: longint): boolean;
var
    s1, s2: longint;
begin
    s1 := sec(x1, y1);
    s2 := sec(x2, y2);

    if s1 <> s2 then
    begin
        le := s1 < s2;
        exit;
    end;

    le := (x1 * y2 - x2 * y1) > 0;
end;

var
    x, y, x2, y2, x3, y3: array [0..maxn + 1] of tarr;
    can: array [1..maxn, 0..2] of boolean;
    sq, n: longint;
    shift:array[1..maxn]of integer;

procedure sort(lt, rt: longint);
var
    i, j: longint;
    t: tarr;
begin
    i := lt + random(rt - lt + 1);
    x3[0] := x3[i];
    y3[0] := y3[i];
    i := lt;
    j := rt;
    while i <= j do
    begin
        while le(x3[i][1], y3[i][1], x3[0][1], y3[0][1]) do inc(i);
        while le(x3[0][1], y3[0][1], x3[j][1], y3[j][1]) do dec(j);

        if i <= j then
        begin
            t := x3[i]; x3[i] := x3[j]; x3[j] := t;
            t := y3[i]; y3[i] := y3[j]; y3[j] := t;
            inc(i);
            dec(j);
        end;
    end;

    if lt < j then sort(lt, j);
    if i < rt then sort(i, rt);
end;

function check: boolean;
var
    i, j, t: longint;
    minx, maxx, miny, maxy: longint;
begin
    check := false;

    x3 := x2;
    y3 := y2;

    minx := maxlongint;
    miny := maxlongint;
    maxx := -maxlongint;
    maxy := -maxlongint;
    for i := 1 to n do
    begin
        if (x3[i][2] * y3[i][1] - x3[i][1] * y3[i][2]) > 0  then
        begin
            t := x3[i][2]; x3[i][2] := x3[i][1]; x3[i][1] := t;
            t := y3[i][2]; y3[i][2] := y3[i][1]; y3[i][1] := t;
        end;
        for j := 1 to 2 do
        begin
            if x3[i][j] < minx then minx := x3[i][j];
            if x3[i][j] > maxx then maxx := x3[i][j];
            if y3[i][j] < miny then miny := y3[i][j];
            if y3[i][j] > maxy then maxy := y3[i][j];
        end;
    end;

    if 2 * (maxx - minx) * (maxy - miny) <> sq then
        exit;

    sort(1, n);
    x3[n + 1] := x3[1];
    y3[n + 1] := y3[1];

    for i := 1 to n do
    begin
        if not ((x3[i][2] = x3[i + 1][1]) and (y3[i][2] = y3[i + 1][1])) then
            exit;
    end;

    check := true;
end;

procedure saveok;
var
  i,j,minx,miny:integer;
begin
  minx:=0;
  miny:=0;
  for i:=1 to n do
    for j:=0 to 2 do begin
      if x2[i][j]<minx then minx:=x2[i][j];
      if y2[i][j]<miny then miny:=y2[i][j];
    end;
          for i:=1 to n do begin
            for j:=0 to 2 do begin
              if j>0 then write(' ');
              write(x2[i][(j-shift[i]+3) mod 3]-minx,' ',y2[i][(j-shift[i]+3) mod 3]-miny);
            end;
            writeln;
          end;    
          Close(Input);
          Close(Output);
          Halt;
end;

procedure rec(t: longint);
var
    i, j: longint;
begin
    if t > n then
    begin
        if check then
        begin
          saveok;
        end;
    end;

    for i := 0 to 2 do
        if can[t][i] then
        begin
            for j := 0 to 2 do
            begin
                x2[t][(j - i + 3) mod 3] := x[t][j] - x[t][i];
                y2[t][(j - i + 3) mod 3] := y[t][j] - y[t][i];
                shift[t]:=i;
            end;
            rec(t + 1);
        end;
end;

var
    i, j: longint;
    sum: longint;

begin
    assign(input, 'glass.in');
    reset(input);
    assign(output, 'glass.out');
    rewrite(output);

    read(n);
    sq := 0;
    for i := 1 to n do
    begin
        for j := 0 to 2 do
            read(x[i][j], y[i][j]);
        sq := sq +
            abs(
            (x[i][0] - x[i][1]) * (y[i][0] + y[i][1]) +
            (x[i][1] - x[i][2]) * (y[i][1] + y[i][2]) +
            (x[i][2] - x[i][0]) * (y[i][2] + y[i][0]));
    end;

    sum := 0;
    for i := 1 to n do
        for j := 0 to 2 do
        begin
            can[i][j] :=
                (x[i][(j + 1) mod 3] = x[i][(j + 2) mod 3]) or
                (y[i][(j + 1) mod 3] = y[i][(j + 2) mod 3]);
            sum := sum + ord(can[i][j]);
        end;

    if sum > n + 8 then
    begin
        writeln('NO');
        close(output);
        exit;
    end;

    rec(1);

    WriteLn('NO');

    close(input);
    close(output);
end.
