type Tpoint = record
       x,y: longint;
       id: byte;
     end;

type Ttri = array[1..3] of Tpoint;

const MaxTri = 2000;

var n: integer;
    trs: array[1..MaxTri] of Ttri;

procedure Swap(var a,b: longint);
var c: longint;
begin
  c:=a; a:=b; b:=c;
end;

procedure SwapP(var a,b: TPoint);
var c: TPoint;
begin
  c:=a; a:=b; b:=c;
end;


function IsT(var tr: Ttri):boolean;
begin
  if (tr[1].y=tr[2].y) and (tr[1].y>tr[3].y) then begin
    if tr[1].x>tr[2].x then SwapP(tr[1],tr[2]);
    IsT:=true;
    exit;
  end;

  if (tr[1].y=tr[3].y) and (tr[1].y>tr[2].y) then begin
    SwapP(tr[2],tr[3]);
    if tr[1].x>tr[2].x then SwapP(tr[1],tr[2]);
    IsT:=true;
    exit;
  end;

  if (tr[2].y=tr[3].y) and (tr[2].y>tr[1].y) then begin
    SwapP(tr[1],tr[3]);
    if tr[1].x>tr[2].x then SwapP(tr[1],tr[2]);
    IsT:=true;
    exit;
  end;

  IsT:=false;
end;

function IsB(var tr: Ttri):boolean;
begin
  if (tr[1].y=tr[2].y) and (tr[1].y<tr[3].y) then begin
    if tr[1].x>tr[2].x then SwapP(tr[1],tr[2]);
    IsB:=true;
    exit;
  end;

  if (tr[1].y=tr[3].y) and (tr[1].y<tr[2].y) then begin
    SwapP(tr[2],tr[3]);
    if tr[1].x>tr[2].x then SwapP(tr[1],tr[2]);
    IsB:=true;
    exit;
  end;

  if (tr[2].y=tr[3].y) and (tr[2].y<tr[1].y) then begin
    SwapP(tr[1],tr[3]);
    if tr[1].x>tr[2].x then SwapP(tr[1],tr[2]);
    IsB:=true;
    exit;
  end;

  IsB:=false;
end;

function IsR(var tr: Ttri):boolean;
begin
  if (tr[1].x=tr[2].x) and (tr[1].x>tr[3].x) then begin
    if tr[1].y>tr[2].y then SwapP(tr[1],tr[2]);
    IsR:=true;
    exit;
  end;

  if (tr[1].x=tr[3].x) and (tr[1].x>tr[2].x) then begin
    SwapP(tr[2],tr[3]);
    if tr[1].y>tr[2].y then SwapP(tr[1],tr[2]);
    IsR:=true;
    exit;
  end;

  if (tr[2].x=tr[3].x) and (tr[2].x>tr[1].x) then begin
    SwapP(tr[1],tr[3]);
    if tr[1].y>tr[2].y then SwapP(tr[1],tr[2]);
    IsR:=true;
    exit;
  end;

  IsR:=false;
end;

function IsL(var tr: Ttri):boolean;
begin
  if (tr[1].x=tr[2].x) and (tr[1].x<tr[3].x) then begin
    if tr[1].y>tr[2].y then SwapP(tr[1],tr[2]);
    IsL:=true;
    exit;
  end;

  if (tr[1].x=tr[3].x) and (tr[1].x<tr[2].x) then begin
    SwapP(tr[2],tr[3]);
    if tr[1].y>tr[2].y then SwapP(tr[1],tr[2]);
    IsL:=true;
    exit;
  end;

  if (tr[2].x=tr[3].x) and (tr[2].x<tr[1].x) then begin
    SwapP(tr[1],tr[3]);
    if tr[1].y>tr[2].y then SwapP(tr[1],tr[2]);
    IsL:=true;
    exit;
  end;

  IsL:=false;
end;

var ts,bs,ls,rs: array[1..MaxTri] of longint;
    tn,bn,ln,rn: integer;
    res: boolean;


function TrT(i:integer):longint;
begin
  TrT:=trs[ts[i],1].x-trs[ts[i],3].x;
end;

function TrB(i:integer):longint;
begin
  Trb:=trs[ts[i],1].x-trs[ts[i],3].x;
end;

function TrR(i:integer):longint;
begin
  TrR:=trs[ts[i],1].y-trs[ts[i],3].y;
end;

function TrL(i:integer):longint;
begin
  TrL:=trs[ts[i],1].y-trs[ts[i],3].y;
end;

procedure sortT(l,r: integer);
var
  i,j,y: integer;
  x: longint;
begin
  i:=l; j:=r; x:=TrT((l+r) DIV 2);
  repeat
    while TrT(i)<x do i:=i+1;
    while x<TrT(j) do j:=j-1;
    if i<=j then
    begin
      swap(ts[i],ts[j]);
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sortT(l,j);
  if i<r then sortT(i,r);
end;

procedure sortB(l,r: integer);
var
  i,j,y: integer;
  x: longint;
begin
  i:=l; j:=r; x:=TrB((l+r) DIV 2);
  repeat
    while TrB(i)<x do i:=i+1;
    while x<TrB(j) do j:=j-1;
    if i<=j then
    begin
      swap(bs[i],bs[j]);
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sortB(l,j);
  if i<r then sortB(i,r);
end;

procedure sortR(l,r: integer);
var
  i,j,y: integer;
  x: longint;
begin
  i:=l; j:=r; x:=TrR((l+r) DIV 2);
  repeat
    while TrR(i)<x do i:=i+1;
    while x<TrR(j) do j:=j-1;
    if i<=j then
    begin
      swap(rs[i],rs[j]);
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sortR(l,j);
  if i<r then sortR(i,r);
end;

procedure sortL(l,r: integer);
var
  i,j,y: integer;
  x: longint;
begin
  i:=l; j:=r; x:=TrL((l+r) DIV 2);
  repeat
    while TrL(i)<x do i:=i+1;
    while x<TrL(j) do j:=j-1;
    if i<=j then
    begin
      swap(ls[i],ls[j]);
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sortL(l,j);
  if i<r then sortL(i,r);
end;

procedure movetr(var tr: Ttri; p:Tpoint);
var i,xs,ys: longint;
begin
  xs:=tr[3].x-p.x;
  ys:=tr[3].y-p.y;
  for i:=1 to 3 do begin
    tr[i].x:=tr[i].x-xs;
    tr[i].y:=tr[i].y-ys;
  end;
end;

procedure Solve;
var i,rfs: integer;
    cp: Tpoint;
begin
  res:=true;
  For i:=1 to n do begin
    rfs:=0;
    if IsT(trs[i]) then begin
      inc(rfs);
      inc(tn); ts[tn]:=i;
    end;
    if IsB(trs[i]) then begin
      inc(rfs);
      inc(bn); bs[bn]:=i;
    end;
    if IsR(trs[i]) then begin
      inc(rfs);
      inc(rn); rs[rn]:=i;
    end;
    if IsL(trs[i]) then begin
      inc(rfs);
      inc(ln); ls[ln]:=i;
    end;
    if rfs<>1 then begin
      res:=false;
      exit;
    end;
  end;
  SortT(1,tn);
  SortB(1,bn);
  SortR(1,rn);
  SortL(1,ln);
  cp.x:=trs[bs[1]][3].x-trs[bs[1]][1].x;
  cp.y:=trs[bs[1]][3].y-trs[bs[1]][1].y;
  For i:=1 to n do movetr(trs[i],cp);
end;

procedure Save;
var f: text;
    i: integer;
begin
  Assign(f,'glass.out');
  Rewrite(f);
  if res and (n>4) then
  for i:=1 to n do begin
    if (trs[i,1].id=2) then swapP(trs[i,1],trs[i,2]);
    if (trs[i,3].id=2) then swapP(trs[i,3],trs[i,2]);
    if (trs[i,3].id=1) then swapP(trs[i,1],trs[i,3]);
    WriteLn(f,trs[i,1].x,' ',trs[i,1].y,' ',trs[i,2].x,' ',trs[i,2].y,' ',trs[i,3].x,' ',trs[i,3].y);
  end
  else WriteLn(f,'NO');

  Close(f);
end;

procedure Load;
var f: text;
    i,j: integer;
begin
  Assign(f,'glass.in');
  Reset(f);
  Read(f,n);
  For i:=1 to n do
    For j:=1 to 3 do
      with trs[i,j] do begin
        Read(f,x,y);
        id:=j;
      end;
  Close(f);
end;


Begin
  Load;
  Solve;
  Save;
End.