Program p0702_6;

Const InFile = 'chain.in';
      OutFile = 'chain.out';
      MaxLen = 251;
      MaxN = 1001;

Var fin, fout : Text;
    L : Array[0..MaxN]of Integer;
    B : Array[1..MaxN, 1..MaxN]of Byte;
    A : Array[0..MaxLen, 0..MaxN]of Record
                                      Yes : Byte;
                                      L, P1, P2 : Integer;
                                    End;
    S : Array[1..MaxN]of String[11];
    Ans : Array[0..MaxLen]of Integer;
    Lng : String;
    N : Integer;

Procedure Init;
Var i : Integer;
  begin
    Assign(fin, InFile);
    Reset(fin);
    Readln(fin, Lng);
    Readln(fin, N);
    L[0] := Length(Lng);
    for i := 1 to N do begin
      Readln(fin, S[i]);
      L[i] := Length(S[i]);
    end;
    Close(fin);
  end;

Procedure FillB;
Var i, j : Integer;
  begin
    FillChar(B, SizeOf(B), 0);
    for i := 1 to N do
      for j := 1 to N do
        if S[i, Length(S[i])] = S[j, 1] then
          B[i, j] := 1;
  end;

Procedure Solve;
Var i, j, k, t, q, e, rpt : Integer;
    Ex : Boolean;
  begin
    FillChar(A, SizeOf(A), 0);
    FillB;
    A[0, 0].Yes := 1;
    for i := 0 to L[0] do
      While true do begin
        Ex := true;
        for j := 0 to N do
          if A[i, j].Yes = 1 then begin
            for k := 1 to N do
              if (j = 0) or (B[j, k] = 1) then begin
                t := i;
                if j = 0 then e := 1 else e := 2;
                for q := e to L[k] do
                  if S[k, q] = Lng[t + 1] then t := t + 1;
                if (t <> 0) and
                   (A[t, k].Yes = 0) or (A[t, k].L > A[i, j].L + L[k]) then begin
                  A[t, k].L := A[i, j].L + L[k];
                  A[t, k].Yes := 1;
                  A[t, k].P1 := i;
                  A[t, k].P2 := j;
                  Ex := false;
                end;
              end;
          end;
        if Ex then break;
      end;
  end;

Procedure MakeAns;
Var i, P1, P2, t1, t2 : Integer;
  begin
    Ans[0] := 0;
    P2 := -1;
    for i := 1 to N do
      if (A[L[0], i].Yes = 1) and
         ((P2 = -1) or (A[L[0], i]. L < A[L[0], P2]. L)) then P2 := i;
    if P2 <> -1 then begin
      P1 := L[0];
      While P1 > 0 do begin
        Ans[0] := Ans[0] + 1;
        Ans[Ans[0]] := P2;
        t1 := A[P1, P2].P1;
        t2 := A[P1, P2].P2;
        P1 := t1;
        P2 := t2;
      end;
    end;
  end;

Procedure WriteIt;
Var i : Integer;
  begin
    Assign(fout, OutFile);
    Rewrite(fout);
    if Ans[0] = 0 then
      Writeln(fout, '?')
    else
      for i := Ans[0] downto 1 do
        Writeln(fout, S[Ans[i]]);
    Close(fout);
  end;

begin
  Init;
  Solve;
  MakeAns;
  WriteIt;
end.
