{$M 65535,28000000,28000000}
{$S-} {$Q-} {$R-}
program chain;
const
 maxN=1000;
 maxP=32767;
 maxLos=251;
var
 wlist:array[1..maxN] of string;
 lastchar:array[1..maxN] of char;
 los:string;
 letitlos:array[1..maxLos,1..maxN] of integer;

 path:array[1..maxN] of integer;
 pPath:integer;

 losL,N:integer;
 solvefound:boolean;

procedure load;
var
 fin:text;
 i:integer;
begin
 assign(fin,'chain.in');
 reset(fin);
 readln(fin,los);
 losL:=length(los);
 readln(fin,N);
 for i:=1 to N do readln(fin,wlist[i]);
 close(fin);
end;

procedure makeletitlos;
var
 i,j,k:integer;
 lw:integer;
 c:char;
begin
 for i:=1 to N do begin
  lw:=length(wlist[i]);
  for j:=1 to losL do begin
   c:=los[j];
   letitlos[j,i]:=0;
   for k:=1 to lw do if (wlist[i][k]=c) then begin letitlos[j,i]:=k; break; end;
  end;
 end;
 for i:=1 to N do lastchar[i]:=wlist[i][length(wlist[i])];

end;

procedure fixsolve;
var
 fout:text;
 i:integer;
begin
 solvefound:=true;
 assign(fout,'chain.out');
 rewrite(fout);
 for i:=1 to pPath do writeln(fout,wlist[path[i]]);
 close(fout);
 halt;
end;

procedure solveA(pos:integer; lc:char);
var
 i,j,nn:integer;
 clos:char;
 pos0:integer;
begin
 if (pos>losL) then begin
  fixsolve;
  exit;
 end;

 pos0:=pos;
 for i:=1 to N do begin
  nn:=letitlos[pos,i];
  if ((wlist[i][1]=lc) and (nn>0)) then begin
   inc(pPath);
   path[pPath]:=i;
   inc(pos);
   while ((pos<=LosL) and (letitlos[pos,i]>nn)) do inc(pos);
   solveA(pos,lastchar[i]);
   if solvefound then exit;
   dec(pPath);
   pos:=pos0;
  end;
 end;
 for i:=1 to N do begin
  nn:=letitlos[pos,i];
  if ((wlist[i][1]=lc) and (nn=0)) then begin
   inc(pPath);
   path[pPath]:=i;
   solveA(pos,lastchar[i]);
   if solvefound then exit;
   dec(pPath);
  end;
 end;
end;

procedure solve;
var
 i,j,nn:integer;
 clos:char;
 pos:integer;
begin
 solvefound:=false;
 for i:=1 to N do begin
  nn:=letitlos[1,i];
  if (nn>0) then begin
   inc(pPath);
   path[pPath]:=i;
   pos:=2;
   while ((pos<=LosL) and (letitlos[pos,i]>nn)) do inc(pos);
   solveA(pos,lastchar[i]);
   if solvefound then exit;
   dec(pPath);
   pos:=1;
  end;
 end;
end;

procedure answerNo;
var
 fout:text;
begin
 assign(fout,'chain.out');
 rewrite(fout);
 writeln(fout,'?');
 close(fout);
end;

begin
 load;
 makeletitlos;
 solve;
 if not solvefound then answerNo;
end.
