{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}


uses crt;


const
   input = 'glass.in';
   output = 'glass.out';
   max = 2000;

type
   TTri = array [1..4] of record x, y: integer;end;

   TTriData = record
                 p, newp: TTri;
              end;
   TTriDataArray = array [1..max] of TTriData;


function HorLine(t: TTri): integer;
var
   i: integer;
begin
   HorLine:=0;
   for i:=1 to 3 do
      if t[i].y=t[i+1].y then begin HorLine:=i;Break;end;
end;

function VertLine(t: TTri): integer;
var
   i: integer;
begin
   VertLine:=0;
   for i:=1 to 3 do
      if t[i].x=t[i+1].x then begin VertLine:=i;Break;end;
end;

function Square(t: TTri): longint;
begin
   Square:=Abs(t[1].x*(t[2].y-t[3].y)+
               t[2].x*(t[3].y-t[1].y)+
               t[3].x*(t[1].y-t[2].y));
end;

var
   Tri : TTriDataArray;
   N: integer;
   fin, fout: Text;

   minx, miny, maxx, maxy: integer;

procedure GameOver;
begin
   WriteLn(fout, 'NO');
   Close(fout);
   Halt;
end;

var
   a, i, j: integer;
   mp: integer;
   s: longint;

begin
   Assign(fin, input);
   Reset(fin);
   ReadLn(fin, N);
   for i:=1 to N do
   with Tri[i] do
   begin
      for j:=1 to 3 do
         Read(fin, p[j].x, p[j].y);
      p[4]:=p[1];
      ReadLn(fin);
   end;
   Close(fin);

      {Obrabotka}
   Assign(fout, output);
   Rewrite(fout);

   minx:=0;miny:=0;s:=0;
   for i:=1 to N do
   with Tri[i] do
   begin
      a:=VertLine(Tri[i].p);
      if a=0 then a:=HorLine(Tri[i].p);
      if a=0 then GameOver;
      mp:=(a+1) mod 3 + 1;

      newp:=p;
      for j:=1 to 3 do
      begin
         Dec(newp[j].x, p[mp].x);
         Dec(newp[j].y, p[mp].y);
         if newp[j].x<minx then
            minx:=newp[j].x;
         if newp[j].y<miny then
            miny:=newp[j].y;
         if newp[j].x>maxx then
            maxx:=newp[j].x;
         if newp[j].y>maxy then
            maxy:=newp[j].y;
      end;

      Inc(s, Square(Tri[i].p));
   end;

   if s<>2*(maxx-minx)*(maxy-miny) then GameOver;

   for i:=1 to N do
   begin
      for j:=1 to 3 do
          Write(fout, tri[i].newp[j].x-minx, ' ', tri[i].newp[j].y-miny, ' ');
      WriteLn(fout);
   end;
   close(fout);
end.