{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 30000000,0,655360}
  Const Inp='fishes.in';
        Out='fishes.out';
        MaxN=100000;
  Type Tip=LongInt;
       _Tip=Array [1..MaxN] Of Byte;
       Groyp=Record Pol,Len : Tip End;
       __Tip=Array [1..MaxN] Of Groyp;
  Var N,K,LenBlack,LenWhite,LenAns : Tip;
      LenNW,LenNB,Perebor,What,Pol,Kolvo,PB,PW : Tip;
      Map : _Tip;
      Black,White : __Tip;
      NB,NW : __Tip;
      Answer : Array [1..MaxN Div 2,0..MaxN Div 3] Of Tip;
      Z : Groyp;

Procedure OpenFiles;
Begin
  Assign(Input,Inp);
  ReSet(Input);
  Assign(Output,Out);
  ReWrite(Output);
End;

Procedure ReadFile;
  Var Perebor : Tip;
Begin
  Read(N,K);
  For Perebor :=1 To N Do
    Read(Map[Perebor]);
End;

Function Ok : Boolean;
Begin
  If LenBlack+LenWhite<=2 Then
    Ok :=True
  Else Ok :=False;
End;

Procedure Del(Const Pol : Tip;Var Len : Tip;A : __Tip);
  Var Perebor : Tip;
Begin
  For Perebor :=Pol+1 To Len Do
    A[Perebor-1] :=A[Perebor];
  Dec(Len);
End;

Function Min(Const A,B : Tip) : Tip;
Begin
  If A<B Then Min :=A
  Else Min :=B;
End;

Procedure Add(Var Len,Pol,L : Tip; A : __Tip);
Begin
  If (L>=1) And (A[L].Pol+A[L].Len=Pol) Then
    Inc(A[L].Len,Len)
  Else
    Begin
      Inc(L);
      A[L].Len :=Len;
      A[L].Pol :=Pol;
    End;
End;

Procedure GetMap;
  Var Perebor,Per : Tip;
Begin
  FillChar(Map,SizeOf(Map),0);
  For Perebor :=1 To LenWhite Do
    For Per :=White[Perebor].Pol To White[Perebor].Pol+White[Perebor].Len-1 Do
      Map[Per] :=1;
End;

Procedure Solve;
  Var LastMap : _Tip;
      Per : Tip;

Procedure GetNew(Const X,Y : Tip);
  Var A : Tip;
Begin
  If Black[X].Pol>White[Y].Pol Then
    Begin
      Inc(LenNW);
      NW[LenNW].Pol :=Black[X].Pol+Black[X].Len-White[Y].Len;
      NW[LenNW].Len :=White[Y].Len;
      Inc(LenNB);
      NB[LenNB].Pol :=White[Y].Pol;
      NB[LenNB].Len :=Black[X].Len;
    End
  Else
    Begin
      Inc(LenNW);
      NW[LenNW].Pol :=Black[X].Pol;
      NW[LenNW].Len :=White[Y].Len;
      Inc(LenNB);
      NB[LenNB].Pol :=White[Y].Pol+White[X].Len-Black[Y].Len;
      NB[LenNB].Len :=Black[X].Len;
    End;
  If (LenNB>1) And (NB[LenNB].Pol=NB[LenNB-1].Pol+NB[LenNB-1].Len) Then
    Begin
      Inc(NB[LenNB-1].Len,NB[LenNB].Len);
      Del(LenNB-1,LenNB,NB);
    End;
  If (LenNW>1) And (NW[LenNW].Pol=NW[LenNW-1].Pol+NW[LenNW-1].Len) Then
    Begin
      Inc(NW[LenNW-1].Len,NW[LenNW].Len);
      Del(LenNW-1,LenNW,NW);
    End;
End;

Begin
  LenAns :=0;
  LenBlack :=0;
  LenWhite :=0;
  If Map[1]=0 Then
    Begin
      Inc(LenBlack);
      Black[1].Pol :=1
    End
  Else
    Begin
      Inc(LenWhite);
      White[1].Pol :=1
    End;
  For Perebor :=2 To N Do
    If Map[Perebor]<>Map[Perebor-1] Then
      Case Map[Perebor] Of
        0 : Begin
              Inc(LenBlack);
              Black[LenBlack].Pol :=Perebor;
              White[LenWhite].Len :=Perebor-White[LenWhite].Pol;
            End;
        1 : Begin
              Inc(LenWhite);
              White[LenWhite].Pol :=Perebor;
              Black[LenBlack].Len :=Perebor-Black[LenBlack].Pol;
            End;
      End;
  If Map[N]=0 Then
    Black[LenBlack].Len :=N+1-Black[LenBlack].Pol
  Else White[LenWhite].Len :=N+1-White[LenWhite].Pol;
  While Not Ok Do
    Begin
      Inc(LenAns);
      LenNW :=0;
      LenNB :=0;
      FillChar(NB,SizeOf(NB),0);
      FillChar(NW,SizeOf(NW),0);
      Pol :=1;
      Kolvo :=1;
{      PB :=0;
      PW :=0;}
      If Map[1]=0 Then
        While (Pol<=LenBlack) And (Kolvo<=K) Do
          Begin
            If (LenBlack-Pol>=2) And (K-Kolvo>=1) Then
              Begin
                GetNew(Pol,Pol);
                Inc(Answer[LenAns,0]);
                Answer[LenAns,Answer[LenAns,0]] :=Black[Pol].Pol;
                If (LenNB>=1) And (NB[LenNB].Pol+NB[LenNB].Len=Black[Pol+1].Pol) Then
                  Inc(NB[LenNB].Len,Black[Pol+1].Len)
                Else
                  Begin
                    Inc(LenNB);
                    NB[LenNB].Len :=Black[Pol+1].Len;
                    NB[LenNB].Pol :=Black[Pol+1].Pol;
                  End;
                If (LenWhite>=Pol+2) And (K-Kolvo>1) Then
                  Begin
                    GetNew(Pol+2,Pol+1);
                    If (LenNW>=1) And (NW[LenNW].Pol+NW[LenNW].Len=White[Pol+2].Pol) Then
                      Inc(NW[LenNW].Len,White[Pol+2].Len)
                    Else
                      Begin
                        Inc(LenNW);
                        NW[LenNW].Len :=White[Pol+2].Len;
                        NW[LenNW].Pol :=White[Pol+2].Pol;
                      End;
                    Inc(Answer[LenAns,0]);
                    Answer[LenAns,Answer[LenAns,0]] :=White[Pol+1].Pol;
                  End
                Else If (LenNB>=1) And (NB[LenNB].Pol+NB[LenNB].Len=Black[Pol+2].Pol) Then
                       Inc(NB[LenNB].Len,Black[Pol+2].Len)
                     Else
                       Begin
                         Inc(LenNB);
                         NB[LenNB].Len :=Black[Pol+2].Len;
                         NB[LenNB].Pol :=Black[Pol+2].Pol;
                       End;
                Inc(Pol,3);
                Inc(Kolvo,2);
              End;
            If (LenBlack-Pol=1) And (K-Kolvo>=0) Then
              Begin
                GetNew(Pol,Pol);
                Inc(Answer[LenAns,0]);
                Answer[LenAns,Answer[LenAns,0]] :=Black[Pol].Pol;
                If (LenNB>=1) And (NB[LenNB].Pol+NB[LenNB].Len=Black[Pol+1].Pol) Then
                  Inc(NB[LenNB].Len,Black[Pol+1].Len)
                Else
                  Begin
                    Inc(LenNB);
                    NB[LenNB].Len :=Black[Pol+1].Len;
                    NB[LenNB].Pol :=Black[Pol+1].Pol;
                  End;
                If LenWhite-Pol-1>=0 Then
                  If (LenNW>=1) And (NW[LenNW].Pol+NW[LenNW].Len=White[Pol+1].Pol) Then
                    Inc(NW[LenNW].Len,White[Pol+1].Len)
                  Else
                    Begin
                      Inc(LenNW);
                      NW[LenNW].Len :=White[Pol+1].Len;
                      NW[LenNW].Pol :=White[Pol+1].Pol;
                    End;
                Inc(Pol,2);
                Inc(Kolvo);
              End;
            If (LenBlack-Pol=0) Then
              Begin
                If (LenNB>=1) And (NB[LenNB].Pol+NB[LenNB].Len=Black[Pol].Pol) Then
                  Inc(NB[LenNB].Len,Black[Pol].Len)
                Else
                  Begin
                    Inc(LenNB);
                    NB[LenNB].Len :=Black[Pol].Len;
                    NB[LenNB].Pol :=Black[Pol].Pol;
                  End;
                If LenWhite-Pol>=0 Then
                  If (LenNW>=1) And (NW[LenNW].Pol+NW[LenNW].Len=White[Pol].Pol) Then
                    Inc(NW[LenNW].Len,White[Pol].Len)
                  Else
                    Begin
                      Inc(LenNW);
                      NW[LenNW].Len :=White[Pol].Len;
                      NW[LenNW].Pol :=White[Pol].Pol;
                    End;
                Inc(Pol,1);
              End;
          End
      Else
        While (Pol<=LenWhite) And (Kolvo<K) Do
          Begin
            If (LenWhite-Pol>=2) And (K-Kolvo>=1) Then
              Begin
                GetNew(Pol,Pol);
                Inc(Answer[LenAns,0]);
                Answer[LenAns,Answer[LenAns,0]] :=White[Pol].Pol;
                If (LenNW>=1) And (NW[LenNW].Pol+NW[LenNW].Len=White[Pol+1].Pol) Then
                  Inc(NW[LenNW].Len,White[Pol+1].Len)
                Else
                  Begin
                    Inc(LenNW);
                    NW[LenNW].Len :=White[Pol+1].Len;
                    NW[LenNW].Pol :=White[Pol+1].Pol;
                  End;
                If (LenBlack>=Pol+2) And (K-Kolvo>1) Then
                  Begin
                    GetNew(Pol+1,Pol+2);
                    If (LenNB>=1) And (NB[LenNB].Pol+NB[LenNB].Len=Black[Pol+2].Pol) Then
                      Inc(NB[LenNB].Len,Black[Pol+2].Len)
                    Else
                      Begin
                        Inc(LenNB);
                        NB[LenNB].Len :=Black[Pol+2].Len;
                        NB[LenNB].Pol :=Black[Pol+2].Pol;
                      End;
                    Inc(Answer[LenAns,0]);
                    Answer[LenAns,Answer[LenAns,0]] :=Black[Pol+1].Pol;
                  End
                Else
                  If (LenNW>=1) And (NW[LenNW].Pol+NW[LenNW].Len=White[Pol+2].Pol) Then
                    Inc(NW[LenNW].Len,White[Pol+2].Len)
                  Else
                    Begin
                      Inc(LenNW);
                      NW[LenNW].Len :=White[Pol+2].Len;
                      NW[LenNW].Pol :=White[Pol+2].Pol;
                    End;
                Inc(Pol,3);
                Inc(Kolvo,2);
              End;
            If (LenWhite-Pol=1) And (K-Kolvo>=0) Then
              Begin
                GetNew(Pol,Pol);
                Inc(Answer[LenAns,0]);
                Answer[LenAns,Answer[LenAns,0]] :=White[Pol].Pol;
                If (LenNW>=1) And (NW[LenNW].Pol+NW[LenNW].Len=White[Pol+1].Pol) Then
                  Inc(NW[LenNW].Len,White[Pol+1].Len)
                Else
                  Begin
                    Inc(LenNW);
                    NW[LenNW].Len :=White[Pol+1].Len;
                    NW[LenNW].Pol :=White[Pol+1].Pol;
                  End;
                If LenBlack-Pol-1>=0 Then
                  If (LenNB>=1) And (NB[LenNB].Pol+NB[LenNB].Len=Black[Pol+1].Pol) Then
                    Inc(NB[LenNB].Len,Black[Pol+1].Len)
                  Else
                    Begin
                      Inc(LenNB);
                      NB[LenNB].Len :=Black[Pol+1].Len;
                      NB[LenNB].Pol :=Black[Pol+1].Pol;
                    End;
                Inc(Pol,2);
                Inc(Kolvo);
              End;
            If (LenWhite-Pol)=0 Then
              Begin
                If (LenNW>=1) And (NW[LenNW].Pol+NW[LenNW].Len=White[Pol].Pol) Then
                  Inc(NW[LenNW].Len,White[Pol].Len)
                Else
                  Begin
                    Inc(LenNW);
                    NW[LenNW].Len :=White[Pol].Len;
                    NW[LenNW].Pol :=White[Pol].Pol;
                  End;
                If LenBlack-Pol>=0 Then
                  If (LenNB>=1) And (NB[LenNB].Pol+NB[LenNB].Len=Black[Pol+1].Pol) Then
                    Inc(NB[LenNB].Len,Black[Pol+1].Len)
                  Else
                    Begin
                      Inc(LenNB);
                      NB[LenNB].Len :=Black[Pol].Len;
                      NB[LenNB].Pol :=Black[Pol].Pol;
                    End;
                Inc(Pol,1);
              End;
          End;
      Black :=NB;
      White :=NW;
      LenBlack :=LenNB;
      LenWhite :=LenNW;
      GetMap;
    End;
  For Perebor :=1 To LenAns Do
    If Answer[Perebor,0]>0 Then
    Begin
      For Per :=0 To Answer[Perebor,0] Do
        Write(Answer[Perebor,Per],' ');
      Writeln;
    End;
  WriteLn('0');
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  ReadFile;
  Solve;
  CloseFiles;
End.
