{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 63840,0,655360}
const
 Max = 1000;

var
 T: String[250];
 qb, qe, N, i, j: LongInt;
 A: array [1..Max] of String[10];
 G: array [1..Max, 1..Max] of Byte;
 W: array [1..Max*Max+Max] of Integer;

procedure Merge(L, M, R: Integer);
var
 i, j, k, q: Integer;
 D: array [1..Max] of String[10];
begin
 i:=L;
 j:=M+1;
 k:=0;
 While (i <= M) and (j <= R) do
  begin
   inc(k);
   If Length(A[i]) < Length(A[j])
    then begin D[k]:=A[i]; inc(i); end
    else begin D[k]:=A[j]; inc(j); end;
  end;
  While i <= M do
   begin
    inc(k);
    D[k]:=A[i];
    inc(i);
   end;
  While j <= R do
   begin
    inc(k);
    D[k]:=A[j];
    inc(j);
   end;
 For i:=1 to k do
  A[L+i-1]:=D[i];
end;

procedure MergeSort(L, R: Integer);
var
 M: Integer;
begin
 If L < R then
  begin
   M:=(L+R) div 2;
   MergeSort(L, M);
   MergeSort(M+1, R);
   Merge(L, M, R);
  end;
end;

procedure Out(D: LongInt);
var
 L, q, k, j: LongInt;
begin
 q:=Length(T);
 L:=1;
 For k:=D downto 1 do
  begin
   For j:=Length(A[W[k]]) downto 1 do
    begin
     If A[W[k], j] = T[q] then dec(q);
     If q = 0 then Break;
    end;
   If q = 0 then
    begin
     L:=k;
     Break;
    end;
  end;
 For k:=L to D do
  WriteLn(A[W[k]]);
 Close(Input);
 Close(Output);
 Halt(0);
end;

procedure DFS(V, Q: Byte; D: LongInt);
var
 k: Byte;
 j: Integer;
begin
 W[D]:=V;
 k:=q;
 For j:=1 to Length(A[V]) do
  If A[V, j] = T[k+1] then inc(k);
 If k = Length(T) then Out(D);
 For j:=1 to N do
  If (G[V, j] > 0) and (G[V, j] < 20) then
   begin
    inc(G[V, j]);
    DFS(j, k, D+1);
    dec(G[V, j]);
   end;
end;

begin
 Assign(Input, 'Chain.in');
 Reset(Input);
 Assign(Output, 'Chain.out');
 ReWrite(Output);
 ReadLn(T);
 ReadLn(N);
 For i:=1 to N do
  ReadLn(A[i]);
 MergeSort(1, N);
 FillChar(G, SizeOf(G), 0);
 For i:=1 to N do
  For j:=1 to N do
   G[i, j]:=Byte(A[i, Length(A[i])] = A[j, 1]);
 For i:=1 to N do
  DFS(i, 0, 1);
 WriteLn('?');
 Close(Input);
 Close(Output);
end.
