{$I+,Q-,R-,S-}
const
  inputfile = 'fishes.in';
  outputfile = 'fishes.out';
  maxn = 100100;

type
  int = longint;
  bool = boolean;
  real = extended;
  pnode = ^tnode;
  tnode = record
    c, k, l: int;
    next, prev: pnode;
  end;

var
  n, k, i, j, count, d: int;
  a: array[1..maxn]of int;
  p, x, y, z: pnode;

procedure add(var p: pnode; c, k, l: int);
var
  d: pnode;
begin
  new(d);
  d^.next := nil;
  d^.prev := p;
  if(p <> nil)then
    p^.next := d;
  d^.c := c;
  d^.k := k;
  d^.l := l;
  p := d;
  inc(count);
end;

procedure exchange(var x, y, z: pnode);
var
  px, ny: pnode;
begin
  px := x^.prev;
  ny := y^.next;
  if(ny <> nil)then begin
    px^.next := ny;
    px^.k := px^.k + y^.k;

    ny^.prev := px;
    ny^.l := ny^.l - x^.k;
    ny^.k := ny^.k + x^.k;
    z := ny^.next;
    dec(count, 2);
  end else begin
    px^.next := y;
    px^.k := px^.k + y^.k;

    y^.prev := px;
    y^.l := y^.l - x^.k + y^.k;
    y^.c := x^.c;
    dec(count);
  end;
end;

function min(a, b: int): int;
begin
  if(a < b)then
    min := a
  else
    min := b;
end;

begin
  assign(input, inputfile);
  reset(input);
  assign(output, outputfile);
  rewrite(output);
  read(n, k);
  for i := 1 to n do
    read(a[i]);
  a[n + 1] := 2;
  i := 1;
  j := 1;

  while(j <= n)do begin
    while(i <= n)and(a[i] = a[j])do
      inc(i);
    add(p, a[j], i - j, j);
    j := i;
  end;

  while(p^.prev <> nil)do
    p := p^.prev;

  p := p;

  while(count > 2)do begin
    d := count div 3;
    if(d > k)then
      d := k;
    write(d, ' ');
    x := p^.next;
    for i := 1 to d do begin
      y := x^.next;
      write(min(x^.l, y^.l), ' ');
      exchange(x, y, z);
      x := z;
    end;
    writeln;
  end;
  write(0);
  close(output);
  close(input);
end.