PROGRAM GLASS;
{$N+,R-,I-,S-}
function Sim(a,b: Extended): Boolean;
begin
	Sim:=abs(a-b)<0.00000001;
end;
const MaxSize=2003;
type TPoint=record
	x,y,z: Longint;
end;
type Treug=array [1..3] of TPoint;

procedure sortx(var a: Treug; l,r: integer);
var
  i,j: integer;
  x,y: TPoint;
begin
  i:=l; j:=r; x:=a[(l+r) DIV 2];
  repeat
    while (a[i].x<x.x) or ((a[i].x=x.x) and (a[i].y<x.y)) do i:=i+1;
    while (x.x<a[j].x) or ((x.x=a[j].x) and (a[j].y>x.y)) do j:=j-1;
    if i<=j then
    begin
      y:=a[i]; a[i]:=a[j]; a[j]:=y;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sortx(a,l,j);
  if i<r then sortx(a,i,r);
end;

procedure sorty(var a: Treug; l,r: integer);
var
  i,j: integer;
  x,y: TPoint;
begin
  i:=l; j:=r; x:=a[(l+r) DIV 2];
  repeat
    while (a[i].y<x.y) or ((a[i].y=x.y) and (a[i].x<x.x)) do i:=i+1;
    while (x.y<a[j].y) or ((x.y=a[j].y) and (a[j].x>x.x)) do j:=j-1;
    if i<=j then
    begin
      y:=a[i]; a[i]:=a[j]; a[j]:=y;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sorty(a,l,j);
  if i<r then sorty(a,i,r);
end;


function r2(p1,p2: TPoint): Extended;
begin
	r2:=sqr(p1.x-p2.x)+sqr(p1.y-p2.y);
end;

function Ori(var x: Treug; var st,h: Longint; var l,m: Extended): Longint;
var
	a,b,c,ab,ac,bc: Extended;
  orient: Longint;
begin
	Sortx(x,1,3);
	Orient:=0;
  a:=r2(x[1],x[2]);
  b:=r2(x[1],x[3]);
  c:=r2(x[2],x[3]);
  if ((x[1].y=x[2].y) and (x[3].y<x[1].y)) then begin
  	Orient:=1;
  end else if ((x[1].y=x[3].y) and (x[2].y<x[1].y)) then begin
  	Orient:=1;
	end else if ((x[2].y=x[3].y) and (x[1].y<x[2].y)) then begin
  	Orient:=1;
  end else if ((x[1].y=x[2].y) and (x[3].y>x[1].y)) then begin
  	Orient:=3;
  end else if ((x[1].y=x[3].y) and (x[2].y>x[1].y)) then begin
  	Orient:=3;
	end else if ((x[2].y=x[3].y) and (x[1].y>x[2].y)) then begin
  	Orient:=3;
  end else if ((x[1].x=x[2].x) and (x[3].x<x[1].x)) then begin
  	Orient:=4;
  end else if ((x[1].x=x[3].x) and (x[2].x<x[1].x)) then begin
  	Orient:=4;
	end else if ((x[2].x=x[3].x) and (x[1].x<x[2].x)) then begin
  	Orient:=4;
  end else if ((x[1].x=x[2].x) and (x[3].x>x[1].x)) then begin
  	Orient:=2;
	end else if ((x[1].x=x[3].x) and (x[2].x>x[1].x)) then begin
  	Orient:=2;
	end else if ((x[2].x=x[3].x) and (x[1].x>x[2].x)) then begin
  	Orient:=2;
  end;
  {AERTHWRTHJWRJYWTJYW
	qbrbrrrrrrrrrrrrrrrrrre}
  case orient of
	3: begin
  	Sorty(x,1,3);
    sT:=abs(x[1].x-x[2].x);
    h:=abs(x[2].y-x[3].y);
    a:=r2(x[1],x[2]);
	  b:=r2(x[1],x[3]);
  	c:=r2(x[2],x[3]);
    ab:=(a+b-c)/(2*sqrt(a)*sqrt(b));
    ac:=(a+c-b)/(2*sqrt(c)*sqrt(a));
    l:=ab;
    m:=ac;
  end;
	1: begin
    Sorty(x,1,3);
    sT:=abs(x[3].x-x[2].x);
    h:=abs(x[1].y-x[3].y);
    a:=r2(x[1],x[2]);
	  b:=r2(x[1],x[3]);
  	c:=r2(x[2],x[3]);
    bc:=(b+c-a)/(2*sqrt(c)*sqrt(b));
    ac:=(a+c-b)/(2*sqrt(c)*sqrt(a));
    l:=ac;
    m:=bc;
  end;
	4: begin
  	Orient:=4;
    sT:=abs(x[2].y-x[3].y);
    h:=abs(x[2].x-x[1].x);
    l:=(b+c-a)/(2*sqrt(c)*sqrt(b));
    m:=(a+c-b)/(2*sqrt(c)*sqrt(a));
  end;
	2: begin
  	Orient:=2;
    sT:=abs(x[1].y-x[2].y);
    h:=abs(x[3].x-x[1].x);
    l:=(a+b-c)/(2*sqrt(a)*sqrt(b));
    m:=(a+c-b)/(2*sqrt(c)*sqrt(a));
	end;
  end;
  ori:=orient;
end;
procedure Mov(var T: Treug; dy,dx: Longint);
var
	i: Longint;
begin
	for i:=1 to 3 do begin
  	t[i].x:=t[i].x+dx;
    t[i].y:=t[i].y+dy;
  end;
end;
var
	a: array [1..4,1..MaxSize] of Treug;
  fin: array [1..MaxSize] of Treug;
  rn: array [1..4,1..MaxSize] of Longint;
  la: array [1..4] of Longint;
  o,s,h: array [1..MaxSize] of Longint;
  l,m: array [1..4,1..MaxSize] of Extended;
  len: Array [1..4] of Longint;
  u: array [1..4,1..MaxSize] of Boolean;
	N: Longint;
  order,Shift: array [1..4,0..MaxSize] of Longint;
  Kl,Km: array [1..4] of Extended;
function Check(ornt: Longint): boolean;
var
	r: Boolean;
  i: Longint;
begin
	r:=True;
  for i:=1 to la[ornt] do begin
  	if not u[ornt,i] then begin
    	r:=False;
      Break;
    end;
  end;
  Check:=r;
end;
var
	fi,fo: Text;
  i,x,k,j: Longint;
  f: Boolean;
  ll,mm,ang: Extended;
  t: Treug;
  He,Wi: Longint;
  Y: Longint;
procedure NoNo;
begin
	Writeln(fo,'NO');
  Close(fi);
  Close(fo);
  Halt(0);
end;
function arccos(a: Extended): Extended;
begin
	if a<>0 then begin
		arccos:=arctan(sqrt(1-a*a)/a);
  end else begin
  	ArcCos:=90;
  end;
end;
BEGIN
	Assign(fi,'glass.in');
  Assign(fo,'glass.out');
  Rewrite(fo);
  Reset(fi);
  Readln(fi,N);
  FillChar(a,SizeOf(A),0);
  FillChar(la,SizeOf(la),0);
  for i:=1 to N do begin
  	Readln(fi,t[1].x,t[1].y,t[2].x,t[2].y,t[3].x,t[3].y);
    t[1].z:=1;
    t[2].z:=2;
    t[3].z:=3;
    o[i]:=Ori(t,s[i],h[i],ll,mm);
    if o[i]=0 then begin
    	Nono;
    end;
    inc(la[o[i]]);
    a[o[i],la[o[i]]]:=t;
    rn[o[i],la[o[i]]]:=i;
    l[o[i],la[o[i]]]:=ll;
    m[o[i],la[o[i]]]:=mm;
  end;
  FillChar(len,SizeOf(len),0);
  for i:=1 to N do begin
  	inc(len[o[i]],s[i]);
  end;
  if (len[1]<>len[3])or(len[2]<>len[4]) then begin
  	NoNo;
  end else begin
  	He:=len[2];
    Wi:=len[1];
		f:=true;
    for i:=1 to N do begin
    	len[o[i]]:=h[i];
    end;
    for i:=1 to N do begin
      if len[o[i]]<>h[i] then begin
      	f:=False;
        Break;
      end;
    end;
    Y:=len[3];
    X:=len[2];
    if not f then begin
    	NoNo;
    end else begin
      {RETRWT}
      for k:=1 to 4 do begin
	      FillChar(u,sizeOf(u),0);
        ang:=m[k,1];
        i:=1;
        for j:=2 to la[k] do begin
        	if ang>m[k,j] then begin
            i:=j;
            ang:=m[k,j];
          end;
        end;
        FillChar(shift,SizeOf(Shift),0);
        u[k,i]:=True;
        order[k,0]:=1;
        order[k,1]:=i;
        kl[k]:=l[k,i];
        km[k]:=ang;
        f:=False;
  	    while not check(k) do begin
        	f:=false;
        	for j:=1 to la[k] do begin
						if not u[k,j] and Sim(ang+l[k,j],0) then begin
            	f:=True;
              Break;
            end;
          end;
          if f then begin
          	inc(order[k,0]);
            order[k,order[k,0]]:=j;
						shift[k,order[k,0]]:=shift[k,order[k,0]-1]+s[rn[k,j]];
          	ang:=m[k,j];
            km[k]:=ang;
            u[k,j]:=True;
          end else begin
        		NoNo;
          end;
        end;
{	      for j:=1 to Order[k,0] do begin
  	    	i:=order[k,j];
    	  	case k of
	    	    1: Mov(a[k,i], He-a[k,i,1].y, shift[k,i]-a[k,i,1].x);
        	  2: Mov(a[k,i],shift[k,i]-a[k,i,1].y,-a[k,i,1].x);
	          3: Mov(a[k,i],-a[k,i,1].y,shift[k,i]-a[k,i,1].x);
  	        4: Mov(a[k,i],shift[k,i]-a[k,i,1].y,Wi-a[k,i,1].x);
    	    end;
      	  fin[rn[k,i]]:=a[k,i];
        end;}
        for i:=1 to la[k] do begin
        	case k of
          	1 : Mov(a[k,i],Y-a[k,i,1].y,X-a[k,i,1].x);
        	  2 : Mov(a[k,i],Y-a[k,i,3].y,X-a[k,i,3].x);
            3 : Mov(a[k,i],Y-a[k,i,3].y,X-a[k,i,3].x);
  	        4 : Mov(a[k,i],Y-a[k,i,1].y,X-a[k,i,1].x);
          end;
          fin[rn[k,i]]:=a[k,i];
        end;
      end;
    end;
    {FINAL CHECK}
       f:=true;
        for i:=1 to 3 do begin
        	f:=sim(arccos(kl[i])+arccos(km[i+1]),pi/2);
          if not f then begin
          	break;
          end;
        end;
        if f then begin
        	f:=sim(arccos(kl[4])+arccos(km[1]),pi/2);
        end;
        if not f then
        	Nono;

    {OutPUUUUT}
    for i:=1 to N do begin
    	t:=fin[i];
    	j:=1;
    	while t[j].z<>1 do j:=j+1;
      Write(fo,t[j].x,' ',t[j].y,' ');
      j:=1;
    	while t[j].z<>2 do j:=j+1;
      Write(fo,t[j].x,' ',t[j].y,' ');
      j:=1;
    	while t[j].z<>3 do j:=j+1;
      Write(fo,t[j].x,' ',t[j].y);
      Writeln(fo);
    end;
  end;
  Close(fi);
  Close(Fo);
END.