program Fishes;

var     N, K : LongInt;
        Fish : array[1..100000] of LongInt;
        Temp1 : LongInt;
        Temp2 : array[1..100000] of LongInt;
        Temp3 : LongInt;

function Min(A, B : LongInt): LongInt;
begin
        if A < B then
                Min := A
        else
                Min := B;
end;

function Beg(A : LongInt) : LongInt;
var     Temp : LongInt;
        Ans : LongInt;
begin
        Ans := 1;
        for Temp := 1 to A - 1 do
                Inc(Ans, Temp2[Temp]);
        Beg := Ans;
end;

procedure Update;
var     Temp1 : LongInt;
begin
        Temp3 := 1;
        Temp1 := 1;
        while (Temp1 < N) and (Fish[Temp1 + 1] <> -1) do
        begin
                Temp2[Temp3] := 1;
                while (Fish[Temp1] = Fish[Temp1 + 1]) and (Temp1 < N) do
                begin
                        Inc(Temp2[Temp3]);
                        Inc(Temp1);
                end;
                Inc(Temp3);
                Inc(Temp1);
        end;

        if Fish[Temp1] = Fish[Temp1 - 1] then
                Inc(Temp2[Temp3])
        else
        begin
                Temp2[Temp3] := 1;
        end;
end;

procedure SwapFish(B : LongInt; Type1, Type2 : LongInt);
var     Temp : LongInt;
        No1 : LongInt;
        No2 : LongInt;
begin
        Temp := B;
        No1 := 1;
        No2 := 1;
        while Fish[Temp] = Fish[Temp + 1] do
        begin
                Inc(No1);
                Inc(Temp);
        end;
        Inc(Temp);
        while Fish[Temp] = Fish[Temp + 1] do
        begin
                Inc(No2);
                Inc(Temp);
        end;

        for Temp := B to B + No2 - 1 do
                Fish[Temp] := Type2;

        for Temp := B + No2 to B + No2 + No1 do
                Fish[Temp] := Type1;
end;

begin
        Assign(input, 'fishes.in');
        Assign(output, 'fishes.out');
        ReSet(input);
        ReWrite(output);

        ReadLn(N, K);

        for Temp1 := 1 to N do
                Read(Fish[Temp1]);
        Fish[Temp1 + 1] := -1;

        Update;

        while Temp3 > 2 do
        begin
                Write(Min(K, Temp3 div 3), ' ');
                for Temp1 := 1 to Min(K, Temp3 div 3) do
                begin
                        Write(Beg((Temp1 * 3) - 2), ' ');
                        if Fish[Beg(Temp1 * 3) - 2] = 0 then
                                SwapFish(Beg((Temp1 * 3) - 2), 1, 0)
                        else
                                SwapFish(Beg((Temp1 * 3) - 2), 0, 1);
                end;
                WriteLn;
                Update;
                Dec(Temp3);
        end;

        WriteLn(0);

        Close(input);
        Close(output);
end.
