#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define LL 256
#define NN 1024

struct WORD {
  char s[LL];
  int l;
  int g[LL];
};

struct POINT {
  int x,y;
};

FILE *fi, *fo;
int n;
WORD los;
WORD a[NN];
int m[LL][32];
int d[LL][32];
POINT p[LL][32];

void GetWord(WORD *w)
{
  char c;
  int q;
  q=0;
  c=getc(fi);
  while(!isalpha(c)) c=getc(fi);
  while(isalpha(c))
  {
    w->s[q]=c-'a';
    q++;
    c=getc(fi);
  }
  w->s[q]='\0';
  w->l=q;
}

void wr(int x, int y)
{
  int i;
  if(d[x][y]>=0)
  {
     wr(p[x][y].x,p[x][y].y);
     for(i=0;i<a[d[x][y]].l;i++)
       fprintf(fo,"%c",a[d[x][y]].s[i]+'a');
     fprintf(fo,"\n");
  }
}

int main()
{
  int i,j,k;
  int min;
  fi=fopen("chain.in","rt");
  fo=fopen("chain.out","wt");

  GetWord(&los);
  fscanf(fi,"%i",&n);
  for(i=0;i<n;i++)
  {
    GetWord(&a[i]);
    for(j=0;j<los.l;j++)
    {
      a[i].g[j]=0;
      for(k=1;k<a[i].l;k++)
        if(los.s[j+a[i].g[j]]==a[i].s[k])
          a[i].g[j]++;
    }
  }

  if(los.l==1)
  {
    min=1000000;
    k=-1;
    for(i=0;i<n;i++)
    {
      if((a[i].l<min)&&((a[i].s[0]==los.s[0])||(a[i].g[0]>=1)))
      {
        k=i;
        min=a[i].l;
      }
    }
    if(k<0)
    {
      fprintf(fo,"?");
    }
    else
    {
      for(i=0;i<a[k].l;i++)
        fprintf(fo,"%c",a[k].s[i]+'a');
      fprintf(fo,"\n");
    }
    fclose(fi);
    fclose(fo);
    return 0;
  }

  for(i=1;i<=los.l;i++)
  {
    for(j=0;j<30;j++)
    {
      m[i][j]=1000000;
      d[i][j]=-1;
    }
  }
  for(j=0;j<30;j++)
  {
    m[0][j]=1;
    d[0][j]=-1;
  }
  m[1][los.s[0]]=1;
  d[1][los.s[0]]=-1;

  for(i=0;i<=los.l;i++)
  {
    for(j=0;j<'z'-'a';j++)
    {
      for(k=0;k<n;k++)
      {
        if(a[k].s[0]==j)
        {
          if(m[i+a[k].g[i]][a[k].s[a[k].l-1]]>(m[i][j]+a[k].l-1))
          {
            m[i+a[k].g[i]][a[k].s[a[k].l-1]]=m[i][j]+a[k].l-1;
            d[i+a[k].g[i]][a[k].s[a[k].l-1]]=k;
            p[i+a[k].g[i]][a[k].s[a[k].l-1]].x=i;
            p[i+a[k].g[i]][a[k].s[a[k].l-1]].y=j;
          }
        }
      }
    }
    for(j=0;j<'z'-'a';j++)
    {
      for(k=0;k<n;k++)
      {
        if(a[k].s[0]==j)
        {
          if(m[i+a[k].g[i]][a[k].s[a[k].l-1]]>(m[i][j]+a[k].l-1))
          {
            m[i+a[k].g[i]][a[k].s[a[k].l-1]]=m[i][j]+a[k].l-1;
            d[i+a[k].g[i]][a[k].s[a[k].l-1]]=k;
            p[i+a[k].g[i]][a[k].s[a[k].l-1]].x=i;
            p[i+a[k].g[i]][a[k].s[a[k].l-1]].y=j;
          }
        }
      }
    }
  }

  min=1000000;
  k=-1;
  for(i=0;i<'z'-'a';i++)
  {
    if(m[los.l][i]<min)
    {
      min=m[los.l][i];
      k=i;
    }
  }
  if(k<0)
    fprintf(fo,"?");
  else
    if(d[los.l][k]<0)
      fprintf(fo,"?");
    else
      wr(los.l,k);

  fclose(fi);
  fclose(fo);
  return 0;
}

