{$D-,E+,I-,L-,P-,Q-,R-,S+,T+,V+,X+,Y+}
uses math;
type real=extended;
label next;
type point=record
n:byte;
x,y:integer;
end;
type ugol=record
numer:integer;
a1,a2:real;
end;
tre=array[1..3]of point;
const maxn=2000;
eps:real=1e-7;
maxbad=8;
fun:array[0..maxbad]of integer=(0,1,3,7,15,31,63,127,255);
var t:array[1..maxn]of tre;
bad:array[1..maxn]of boolean;
gdebad:array[1..maxbad]of integer;
ang:array[1..maxn]of ugol;
numbad:byte;
a,n,i,j,J1,J2,qwe:integer;
x12,y12,x13,y13,x23,y23:boolean;
le,ri,ve,ni:integer;
code:integer;
savele,saveri,saveni,saveve:integer;
savecode:integer;
buf:real;
good:boolean;
last,first,plusx,plusy:integer;

procedure writeno;
begin
write('NO');
close(output);
halt;
end;

procedure readpoint(var a:point);
begin
read(a.x,a.y);
end;

FUNCTION peq(a1,a2,b1,b2:point):boolean;
begin
peq:=((a2.x-a1.x=b2.x-b1.x)and(a2.y-a1.y=b2.y-b1.y));
end;

procedure readtre(var a:tre);
begin
a[1].n:=1;
a[2].n:=2;
a[3].n:=3;
readpoint(a[1]);
readpoint(a[2]);
readpoint(a[3]);
end;

procedure swappoints(var a,b:point);
var c:point;
begin
c:=a;
a:=b;
b:=c;
end;

procedure asklr(a:integer);
begin
if a>0 then
 begin
 if ri=0 then ri:=a else if ri<>a then writeno;
 end
  else
 begin
 a:=abs(a);
 if le=0 then le:=a else if le<>A then writeno;
 end;
end;

procedure askvn(a:integer);
begin
if a>0 then
 begin
 if ve=0 then ve:=a else if ve<>a then writeno
 end
  else
 begin
 a:=abs(A);
 if ni=0 then ni:=a else if ni<>A then writeno;
 end;
end;

function eq(a,b:real):boolean;
begin
eq:=(abs(a-b)<eps);
end;

procedure heapsort(n:longint);
var l,r:longint;buf:ugol;
function bol(a,b:ugol):boolean;
begin
bol:=(a.a1<b.a1)or((eq(a.a1,b.a1))and(a.a2>b.a2));
end;
procedure sift;
var i,j:longint;
begin
i:=l;
j:=l*2;
buf:=ang[i];
if (j<r)and bol(ang[j],ang[j+1])then inc(j);
while (j<=r)and bol(buf,ang[j])do
 begin
 ang[i]:=ang[j];
 i:=j;
 inc(j,j);
 if (j<r)and bol(ang[j],ang[j+1]) then inc(j);
 end;
ang[i]:=buf;
end;

begin
r:=n;
for l:=n div 2 downto 1 do sift;
l:=1;
while r>l do
begin
buf:=ang[l];
ang[l]:=ang[r];
ang[r]:=buf;
dec(r);
sift;
end;
end;

begin
assign(input,'glass.in');reset(input);
assign(output,'glass.out');rewrite(output);
read(n);
fillchar(t,sizeof(t),0);
for i:=1 to n do
  begin
  readtre(t[i]);
  if t[i][1].x=t[i][2].x then x12:=true else x12:=false;
  if t[i][1].y=t[i][2].y then y12:=true else y12:=false;
  if t[i][1].x=t[i][3].x then x13:=true else x13:=false;
  if t[i][1].y=t[i][3].y then y13:=true else y13:=false;
  if t[i][3].x=t[i][2].x then x23:=true else x23:=false;
  if t[i][3].y=t[i][2].y then y23:=true else y23:=false;
  if not(x12 or y12 or x23 or y23 or x13 or y13)then writeno;
  if x12 then
   begin
   swappoints(t[i][1],t[i][3]);
   if (y13 or y23)and not bad[i]then
   begin
    inc(numbad);
    bad[i]:=true;
    gdebad[numbad]:=i;
    if y23 then swappoints(t[i][2],t[i][3]);
   end;
   end;
  if y12 then
   begin
   swappoints(t[i][1],t[i][3]);
   if (x13 or x23)and not bad[i]then
   begin
    inc(numbad);
    bad[i]:=true;
    gdebad[numbad]:=i;
    if x23 then swappoints(t[i][2],t[i][3]);
   end;
   end;

  if x13 then
   begin
   swappoints(t[i][1],t[i][2]);
   if (y23 or y12)and not bad[i]then
   begin
    inc(numbad);
    bad[i]:=true;
    gdebad[numbad]:=i;
    if y12 then swappoints(t[i][2],t[i][3]);
   end;
   end;
  if y13 then
   begin
   swappoints(t[i][1],t[i][2]);
   if (x23 or x12)and not bad[i]then
   begin
    inc(numbad);
    bad[i]:=true;
    gdebad[numbad]:=i;
    if x12 then swappoints(t[i][2],t[i][3]);
   end;
   end;

  if x23 then
   begin
   if (y13 or y12)and not bad[i]then
   begin
    inc(numbad);
    bad[i]:=true;
    gdebad[numbad]:=i;
    if y12 then swappoints(t[i][2],t[i][3]);
   end;
   end;
  if y23 then
   begin
   if (x13 or x12)and not bad[i]then
   begin
    inc(numbad);
    bad[i]:=true;
    gdebad[numbad]:=i;
    if x12 then swappoints(t[i][2],t[i][3]);
   end;
   end;
if bad[i] and (t[i][1].y<>t[i][3].y) then swappoints(t[i][1],t[i][2]);
end;
close(input);

le:=0;
ri:=0;
ve:=0;
ni:=0;
for i:=1 to n do if not bad[i]then
begin
 if t[i][2].x=t[i][3].x then asklr(t[i][2].x-t[i][1].x)else
 askvn(t[i][2].y-t[i][1].y);
end;

for code:=0 to fun[numbad] do
begin
savele:=le;saveri:=ri;saveve:=ve;saveni:=ni;
savecode:=code;
for j:=1 to numbad do
begin
if code mod 2=1 then
 begin
 i:=gdebad[j];
 swappoints(t[i][1],t[i][2]);
 end;
code:=code div 2;
end;
code:=savecode;
{proverka}
for j:=1 to numbad do
begin
 i:=gdebad[j];
 if t[i][2].x=t[i][3].x then
 begin
  a:=t[i][2].x-t[i][1].x;
if a>0 then
 begin
 if ri=0 then ri:=a else if ri<>a then goto next;
 end
  else
 begin
 a:=abs(a);
 if le=0 then le:=a else if le<>A then goto next;
 end;
 end else
 begin
  a:=t[i][2].y-t[i][1].y;
if a>0 then
 begin
 if ve=0 then ve:=a else if ve<>a then goto next;
 end
  else
 begin
 a:=abs(A);
 if ni=0 then ni:=a else if ni<>A then goto next;
 end;
 end;
end;

if (le=0)or(ri=0)or(ni=0)or(ve=0)then goto next;
for i:=1 to n do
begin
ang[i].numer:=i;
ang[i].a1:=arctan2(t[i][2].y-t[i][1].y,t[i][2].x-t[i][1].x);
ang[i].a2:=arctan2(t[i][3].y-t[i][1].y,t[i][3].x-t[i][1].x);
{ang[i].a1:=arctan((t[i][2].y-t[i][1].y)/(t[i][2].x-t[i][1].x));
ang[i].a2:=arctan((t[i][3].y-t[i][1].y)/(t[i][3].x-t[i][1].x));}
with ang[i] do if a1>a2 then begin buf:=a1;a1:=a2;a2:=buf;end;
end;
heapsort(n);
for i:=2 to n-1 do
 begin
 if not eq(ang[i].a2,ang[i+1].a1)then goto next;
 end;
if ang[1].a1<>ang[2].a1 then goto next;
if ang[n].a2<>ang[1].a2 then goto next;
j1:=ang[1].numer;
j2:=ang[2].numer;
good:=false;
if peq(t[j1][1],T[J1][2],T[J2][1],T[J2][2])THEN
 BEGIN
 good:=true;
 FIRST:=3;
 last:=3;
 END;
if peq(t[j1][1],T[J1][2],T[J2][1],T[J2][3])THEN
 BEGIN
 good:=true;
 FIRST:=3;
 last:=2;
 END;
if peq(t[j1][1],T[J1][3],T[J2][1],T[J2][3])THEN
 BEGIN
 good:=true;
 FIRST:=2;
 last:=2;
 END;
if peq(t[j1][1],T[J1][3],T[J2][1],T[J2][2])THEN
 BEGIN
 good:=true;
 FIRST:=2;
 last:=3;
 END;
if not good then goto next;
for i:=2 to n-1 do
 begin
 j1:=j2;
 j2:=ang[i+1].numer;
 good:=false;
 if peq(t[j1][1],T[J1][last],T[J2][1],T[J2][2])THEN
 BEGIN
 good:=true;
 last:=3;
 END;
 if peq(t[j1][1],T[J1][last],T[J2][1],T[J2][3])THEN
 BEGIN
 good:=true;
 last:=2;
 END;
 if not good then goto next;
 end;
j1:=j2;
j2:=ang[1].numer;
if not peq(t[j1][1],t[j1][last],t[j2][1],t[j2][first])then goto next;

for i:=1 to n do
begin
plusx:=le-t[i][1].x;
plusy:=ni-t[i][1].y;
for j:=1 to 3 do
 begin inc(t[i][j].x,plusx);
 inc(t[i][j].y,plusy);
 end;
end;

for i:=1 to n do
begin
for j:=1 to 3 do for qwe:=1 to 3 do
begin
if t[i][qwe].n=j then
 begin
 write(t[i][qwe].x,' ',t[i][qwe].y,' ');
 break;
 end;
end;
writeln;
end;
close(output);
halt;
{endofprov}
next:
le:=savele;ri:=saveri;ve:=saveve;ni:=saveni;
for j:=1 to numbad do
begin
if code mod 2=1 then
 begin
 i:=gdebad[j];
 swappoints(t[i][1],t[i][2]);
 end;
code:=code div 2;
end;
code:=savecode;
end;

writeno;
end.
