{$N+}
Const eps=1e-10;
      M=100;
Type TPoint=record
             x,y:extended;
            end;
     TTriangle=record
                A,B,C:TPoint;
               end;
     TTrs=array[1..M] of TTriangle;
     TMatr=array[1..M,1..M] of boolean;
     TVis=array[1..M] of boolean;
Function Rast(A,B:TPoint):extended;
 Begin
  Rast:=sqrt(sqr(A.x-B.x)+sqr(A.y-B.y));
 End;
Function SqTr(A,B,C:TPoint):extended;
 Var x,y,z,p:extended;
 Begin
  x:=Rast(A,B);y:=Rast(B,C);z:=Rast(C,A);p:=(x+y+z)/2;
  SqTr:=sqrt(p*(p-x)*(p-y)*(p-z));
 End;
Function InTr(A,B,C,D:TPoint):boolean;
 Begin
  InTr:=(SqTr(A,B,D)+SqTr(B,C,D)+SqTr(A,C,D)-SqTr(A,B,C))<eps;
 End;
Function PerOtr(A,B,C,D:TPoint):boolean;
 Var zn,xp,yp:extended;
 Begin
  zn:=(B.y-A.y)*(C.x-D.x)-(D.y-C.y)*(A.x-B.x);
  if zn=0 then begin PerOtr:=false;exit; end;
  xp:=((B.y*A.x-B.x*A.y)*(C.x-D.x)-(D.y*C.x-D.x*C.y)*(A.x-B.x))/zn;
  yp:=((B.x*A.y-B.y*A.x)*(C.y-D.y)-(D.x*C.y-D.y*C.x)*(A.y-B.y))/-zn;
  PerOtr:=(((xp-A.x)*(xp-B.x)<=0) and ((xp-C.x)*(xp-D.x)<=0)) and
          (((yp-A.y)*(yp-B.y)<=0) and ((yp-C.y)*(yp-D.y)<=0));
 End;
Function El(A,B:TTriangle):boolean;{A|>|>B}
 Begin
  if InTr(B.A,B.B,B.C,A.A) and ((not InTr(B.A,B.B,B.C,A.B)) and (not InTr(B.A,B.B,B.C,A.C)))
  then El:=((PerOtr(A.A,A.B,B.A,B.B) and PerOtr(A.A,A.C,B.A,B.B)) or
           (PerOtr(A.A,A.B,B.B,B.C) and PerOtr(A.A,A.C,B.B,B.C))) or
           (PerOtr(A.A,A.B,B.C,B.A) and PerOtr(A.A,A.C,B.C,B.A))
  else if InTr(B.A,B.B,B.C,A.B) and ((not InTr(B.A,B.B,B.C,A.A)) and (not InTr(B.A,B.B,B.C,A.C)))
  then El:=((PerOtr(A.B,A.A,B.A,B.B) and PerOtr(A.B,A.C,B.A,B.B)) or
           (PerOtr(A.B,A.A,B.B,B.C) and PerOtr(A.B,A.C,B.B,B.C))) or
           (PerOtr(A.B,A.A,B.C,B.A) and PerOtr(A.B,A.C,B.C,B.A))
  else if InTr(B.A,B.B,B.C,A.C) and ((not InTr(B.A,B.B,B.C,A.B)) and (not InTr(B.A,B.B,B.C,A.A)))
  then El:=((PerOtr(A.C,A.B,B.A,B.B) and PerOtr(A.C,A.A,B.A,B.B)) or
           (PerOtr(A.C,A.B,B.B,B.C) and PerOtr(A.C,A.A,B.B,B.C))) or
           (PerOtr(A.C,A.B,B.C,B.A) and PerOtr(A.C,A.A,B.C,B.A))
  else El:=false;
 End;
Var N,i,y,k,l:byte;
    Trs:TTrs;
    Matr:TMatr;
    MaxP:longint;
    flag:boolean;
    Vis:TVis;
Procedure Rec(a:byte;p:longint);
 Var i:byte;
 Begin
  inc(p);if p>MaxP then MaxP:=p;
  Vis[a]:=true;
  for i:=1 to N do
   if Matr[a,i]
   then
    begin
     if Vis[i] then begin write(-1);close(input);close(output);halt(0) end;
     Rec(i,p);
    end;
  Vis[a]:=false
 End;
BEGIN
 assign(input,'travel.in');reset(input);
 assign(output,'travel.out');rewrite(output);
 MaxP:=0;
 read(N);
 for i:=1 to N do with Trs[i] do read(A.x,A.y,B.x,B.y,C.x,C.y);
 for i:=1 to N do
  for y:=1 to N do
   if i<>y then Matr[i,y]:=El(Trs[y],Trs[i]) else Matr[i,y]:=false;
 for i:=1 to N do
  begin
   flag:=true;
   for y:=1 to N do
    if Matr[y,i] then begin flag:=false;break end;
   if flag
   then
    begin
     for k:=1 to N do Vis[k]:=false;
     Rec(i,0);
    end;
  end;
 dec(MaxP,2);
 if MaxP<=0 then write(-1) else write(MaxP);
 close(input);close(output);
END.