program problemE;

procedure readInput(var inputFile: text; var N: word; var M: word;
                    var sequence: string);

    begin
        reset(inputFile);
        read(inputFile, N);
        read(inputFile, M);
        readln(inputFile, sequence);
        close(inputFile);
    end;{readInput}

function possible(N, M, i: word; sequence: string): boolean;
    var
        answer: boolean;
        j: word;
    begin
        answer:=true;
        for j:=1 to i do
        begin
            answer:=answer and (sequence[j]=sequence[2*i+1-j]);
        end;
        possible:=answer;
    end;{posible}

procedure findAnswer(N, M: word; sequence: string; var outputFile: text);
    var i: word;
    begin
        rewrite(outputFile);
        for i:=0 to round(N/2) do
        begin
            if possible(N, M, i, sequence)
                then write(outputFile, N-i);
        end;
        close(outputFile);
    end;{findAnswer}

var
    sequence: string;
    N, M: word;
    inputFile, outputFile: text;

begin
    assign(inputFile, 'cubes.in');
    assign(outputFile, 'cubes.out');
    readInput(inputFile, N, M, sequence);
    findAnswer(N, M, sequence, outputFile);
end.{problemE}
