program problemE;

type sequenceType=array[1..100000] of longint;

procedure readInput(var inputFile: text; var N: longint; var M: longint;
                    var sequence: sequenceType);
    var i: longint;
    begin
        reset(inputFile);
        read(inputFile, N);
        read(inputFile, M);
        for i:=1 to N do
        begin
            read(inputFile, sequence[i]);
        end;
        close(inputFile);
    end;{readInput}

function possible(N, M, i: longint; sequence: sequenceType): boolean;
    var
        answer: boolean;
        j: longint;
    begin
        answer:=true;
        for j:=1 to i do
        begin
            if (2*i+1-j<=N) then
            answer:=(answer and (sequence[j]=sequence[2*i+1-j]));
        end;
        possible:=answer;
    end;{posible}

procedure findAnswer(N, M: longint; sequence: sequenceType;
                                            var outputFile: text);
    var i: longint;
    begin
        rewrite(outputFile);
        for i:=0 to round(N/2) do
        begin
            if possible(N, M, i, sequence)
                then write(outputFile, N-i);
        end;
        close(outputFile);
    end;{findAnswer}

var
    sequence: sequenceType;
    N, M: longint;
    inputFile, outputFile: text;

begin
    assign(inputFile, 'cubes.in');
    assign(outputFile, 'cubes.out');
    readInput(inputFile, N, M, sequence);
    findAnswer(N, M, sequence, outputFile);
end.{problemE}
