#include <stdio.h>
#include <math.h>
#include <stdlib.h>

int main() {
	FILE *in=fopen("squares.in","r");
	FILE *out=fopen("squares.out","w");

	long n,k;
	long i;
	long t;

	fscanf(in, "%ld %ld", &n,&k);

	if(n%2==1) {
		fprintf(out,"NO\n");
		fcloseall();
		return 0;
	}
	t=n/2;

	if(k==0) {
		if(n==2) {
			fprintf(out,"YES\n");
			fprintf(out,"0 0\n");
			fprintf(out,"0 1\n");
			fcloseall();
			return 0;
		}
		if(n<4) {
			fprintf(out,"NO\n");
			fcloseall();
			return 0;
		}
		fprintf(out,"YES\n");
		fprintf(out,"0 0\n");
		for(i=0; i<t; i++)
			fprintf(out,"%ld 1\n", i);
		for(i=t-1; i>0; i--)
			fprintf(out,"%ld 0\n",i);
		fcloseall();
		return 0;
	}

	long a=floor(sqrt(k));
	long b=k/a;
	long d=k-b*a;

	long delta;

	delta=n-2*a-2*b-4;
	if(d!=0) delta-=2;
	if(delta<0) {
		fprintf(out,"NO\n");
		fcloseall();
		return 0;
	}

	fprintf(out,"YES\n");
	for(i=0; i<=a+1; i++) {
		fprintf(out,"0 %ld\n",i);
	}
	for(i=1; i<=b+1; i++) {
		fprintf(out,"%ld %ld\n", i,a+1);
	}
	if(d!=0) {
		for(i=a; i>=d+1; i--) {
			fprintf(out,"%ld %ld\n", b+1,i);
		}
		for(i=d+1; i>=0; i--) {
			fprintf(out,"%ld %ld\n", b+2, i);
		}
		for(i=b+1; i>=2; i--) {
			fprintf(out,"%ld 0\n", i);
		}
	} else {
		for(i=a; i>=0; i--) {
			fprintf(out,"%ld %ld\n", b+1,i);
		}
		for(i=b; i>=2; i--) {
			fprintf(out,"%ld 0\n", i);
		}
	}
	for(i=-1; i>=-delta/2; i--) {
		fprintf(out,"2 %ld\n", i);
	}
	i=-delta/2;

	while(1) {
		fprintf(out,"1 %ld\n", i);
		i++;
		if(i>0) break;
	}

	fcloseall();
	return 0;
}