{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O-,P+,Q+,R+,S+,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE CONSOLE}

{

  Sample solution for the task ""
  Copyright(c) by Michael Mirzayanov

  Last revision date : ??.06.2003

}

program Shablon;

  uses
    SysUtils;

  const
    inFile = 'matrix.in';
    outFile = 'matrix.out';

    nmax = 1000;

  type
    int = longint;

  var
    n : int;
    ans : int;
    a : array [1..nmax] of int;
    data : array [1..nmax, 1..nmax] of int;
    isZero : boolean;
    lim : int;

  procedure OutData;
    var
      i, j : int;
  begin
    assign(output,outFile);
    rewrite(output);

    if n = 0 then
      lim := 1
    else
      lim := a[n] + 1 + ord(isZero);

    writeln(lim);  

    for i := 1 to lim do begin
      for j := 1 to lim do
        write(data[i, j], ' ');
      writeln;
    end;

    close(output);
  end;

  procedure Rec(lo, hi : int; sub : int; start : int);
    var
      i, j : int;
  begin
    if lo > hi then exit;

    if lo = hi then begin
      for i := start to start + a[lo] - sub do
        for j := start to start + a[lo] - sub do
          if i <> j then data[i, j] := 1 else data[i, j] := 0;
      exit;
    end;

    if lo = hi - 1 then begin
      for i := start to start + a[lo] - sub - 1 do
        for j := start to start + a[lo] - sub - 1 do
          if i <> j then data[i, j] := 1 else data[i, j] := 0;
      for i := start + a[lo] - sub to start + a[hi] - sub do
        for j := start to start + a[lo] - sub - 1 do begin
          data[i, j] := 1;
          data[j, i] := 1;
        end;
      exit;
    end;

    Rec(lo + 1, hi - 1, a[lo], start);

    for i := a[hi - 1] - a[lo] + 2 to a[hi - 1] - a[lo] + 1 + a[lo] - sub do begin
      for j := a[hi - 1] - a[lo] + 2 to a[hi - 1] - a[lo] + 1 + a[lo] - sub do
        if i = j then data[i, j] := 0 else data[i, j] := 1;
      for j := 1 to a[hi - 1] - a[lo] + 1 do begin
        data[i, j] := 1;
        data[j, i] := 1;
      end;
    end;

    for i := a[hi - 1] - a[lo] + 2 + a[lo] - sub to a[hi - 1] - a[lo] + 1 + a[lo] + a[hi] - a[hi - 1] - sub do
      for j := a[hi - 1] - a[lo] + 2 to a[hi - 1] - a[lo] + 1 + a[lo] - sub do begin
        if i = j then begin
          write;
        end;
        data[i, j] := 1;
        data[j, i] := 1;
      end;
  end;

  procedure Solve;
    var
      i, j : int;
      t : int;
  begin
    fillchar(data, SizeOf(data), 0);
    for i := 1 to n - 1 do
      for j := i + 1 to n do
        if a[i] > a[j] then begin
          t := a[i];
          a[i] := a[j];
          a[j] := t;
        end;
    if a[1] = 0 then begin
      isZero := true;
      move(a[2], a[1], (n - 1) * SizeOf(a[1]));
      dec(n);
    end;
    Rec(1, n, 0, 1);
  end;

  procedure ReadData;
    var
      i, j : int;
  begin
    assign(input,inFile);
    reset(input);

    read(n);
    for i := 1 to n do
      read(a[i]);

    close(input);
  end;

begin
  ReadData;
  Solve;
  OutData;
end.
