Program AKindOfSynchronizedStructureBasedOnGraphIdeasButSpoiledWithConceptsOfPetriNetworks;
Const
  TaskID='synchro';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxN=1002;
Type
  Integer=LongInt;
  PList=^TList;
  TList=Record
    Item:Integer;
    Weight:Integer;
    Next:PList;
  End;
Var
  N,M:Integer;
  Out:Array[1..MaxN]Of PList;
  Zero:Array[1..MaxN]Of Boolean;
  Mark:Array[1..MaxN]Of Integer;
  Res:Array[1..MaxN]Of Integer;
  CMark:Integer;
Procedure Load;
Var
  I,A,B,W:Integer;
  P:PList;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  FillChar(Out,SizeOf(Out),0);
  Read(N,M);
  For I:=1 To M Do Begin
    Read(A,B,W);
    New(P);
    P^.Next:=Out[A];
    P^.Item:=B;
    P^.Weight:=W;
    Out[A]:=P;
  End;
  Close(Input);
End;
Procedure DFS(Start:Integer);
Var
  P:PList;
Begin
  If Mark[Start]<>0 Then Begin
    If Mark[Start]=CMark Then
      Zero[Start]:=True;
    Exit;
  End;
  Mark[Start]:=CMark;
  P:=Out[Start];
  While P<>Nil Do Begin
    If P^.Weight=0 Then
      DFS(P^.Item);
    P:=P^.Next;
  End;
{  Mark[Start]:=-CMark;}
End;
Procedure DFS2(Start:Integer);
Var
  P:PList;
Begin
  If Mark[Start]<>0 Then Exit;
  Res[Start]:=0;
  Mark[Start]:=1;
  P:=Out[Start];
  While P<>Nil Do Begin
    DFS2(P^.Item);
    P:=P^.Next;
  End;
End;
Procedure Solve;
Var
  I:Integer;
Begin
  FillChar(Mark,SizeOf(Mark),0);
  FillChar(Zero,SizeOf(Zero),False);
  CMark:=0;
  For I:=1 To N Do If Mark[I]=0 Then Begin
    Inc(CMark);
    DFS(I);
  End;
  FillChar(Mark,SizeOf(Mark),0);
  For I:=1 To N Do Res[I]:=1;
  For I:=1 To N Do If Zero[I] And (Mark[I]=0) Then
    DFS2(I);
End;
Procedure Save;
Var
  I:Integer;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  For I:=1 To N Do
    WriteLn(Res[I]);
  Close(Output);
End;
Begin
  Load;
  Solve;
  Save;
End.
