{$I-,S-,Q-,R-}
const max=100;
var n,m:longint;
    r,ox,oy,dx,dy:array[0..max]of extended;

    oln,out:array[0..max]of longint;
    mr:array[0..max,0..max]of extended;
    mf:array[0..max,0..max]of longint;

    s:array[0..max,0..max,0..max]of extended;
    gd:array[0..max,0..max,0..max]of boolean;

procedure init;
var i:longint;
begin
  assign(input,'birds.in');
  reset(input);
  read(n);
  for i:=0 to n-1 do
    read(ox[i],oy[i]);
  read(m);
  for i:=1 to m do
    read(dx[i],dy[i]);
  close(input);
end;

function ang(x,y:extended):extended;
var a:extended;
begin
  if (x=0)and(y=0) then
    ang:=0
  else
    begin
      if x=0 then
        begin
          if y>0 then
            a:=pi/2
          else
            a:=-pi/2;
        end
      else
        a:=arctan(y/x);
      if x<0 then
        a:=a+pi;
      if (x>0)and(y<0) then
        a:=a+2*pi;
      ang:=a;
    end;
end;

procedure Sort;
var cx,cy,c:extended;
    k,i,j:longint;
begin
  cx:=0;
  cy:=0;
  for i:=0 to n-1 do
    begin
      cx:=cx+ox[i];
      cy:=cy+oy[i];
    end;
  cx:=cx/n;
  cy:=cy/n;
  for i:=0 to n-1 do
    begin
      r[i]:=ang(ox[i]-cx,oy[i]-cy);
      oln[i]:=i;
    end;
  for i:=0 to n-2 do
    for j:=i+1 to n-1 do
      if r[i]<r[j] then
        begin
          k:=oln[i];
          oln[i]:=oln[j];
          oln[j]:=k;
          c:=ox[i];
          ox[i]:=ox[j];
          ox[j]:=c;
          c:=oy[i];
          oy[i]:=oy[j];
          oy[j]:=c;
          c:=r[i];
          r[i]:=r[j];
          r[j]:=c;
        end;
end;

function sqtr(x1,y1,x2,y2,x3,y3:extended):extended;
begin
  sqtr:=abs(x1*y2-x2*y1+x2*y3-x3*y2+x3*y1-x1*y3)/2;
end;

function intr(x1,y1,x2,y2,x3,y3,x,y:extended):boolean;
begin
  intr:=abs(sqtr(x1,y1,x2,y2,x3,y3)-sqtr(x1,y1,x,y,x3,y3)-
            sqtr(x,y,x2,y2,x3,y3)-sqtr(x1,y1,x2,y2,x,y))<0.00001;
end;

function good(i,j,k:longint):boolean;
var l:longint;
    ok:boolean;
begin
  ok:=true;
  for l:=1 to m do
    if intr(ox[i],oy[i],ox[j],oy[j],ox[k],oy[k],dx[l],dy[l]) then
      ok:=false;
  good:=ok;
end;

procedure rec(i,j:longint);
begin
  if mr[i,j]=0 then
    begin
{      inc(out[0]);
      out[out[0]]:=i;}
      exit;
    end;
  rec(i,(i+mf[i,j])mod n);
  inc(out[0]);
  out[out[0]]:=(i+mf[i,j])mod n;
  rec((i+mf[i,j])mod n,j);
end;

procedure run;
var mi,i,j,l,k:longint;
    ms:extended;
begin
  Sort;
  for i:=0 to n-1 do
    for j:=0 to n-1 do
      for k:=0 to n-1 do
        s[i,j,k]:=sqtr(ox[i],oy[i],ox[j],oy[j],ox[k],oy[k]);
  for i:=0 to n-1 do
    for j:=0 to n-1 do
      for k:=0 to n-1 do
        gd[i,j,k]:=good(i,j,k);
  for i:=0 to n-1 do
    for j:=0 to n-1 do
      mr[i,j]:=0;
  for l:=2 to n do
    for i:=0 to n-1 do
      begin
        j:=(l+i)mod n;
        mr[i,j]:=0;
        mf[i,j]:=0;
        for k:=1 to l-1 do
          if gd[i,j,(i+k)mod n] then
            if mr[i,(i+k)mod n]+mr[(i+k)mod n,j]+s[i,j,(i+k)mod n]>mr[i,j] then
              begin
                mr[i,j]:=mr[i,(i+k)mod n]+mr[(i+k)mod n,j]+s[i,j,(i+k)mod n];
                mf[i,j]:=k;
              end;
      end;
  ms:=0;
  for i:=0 to n-1 do
    if mr[i,i]>ms then
      begin
        ms:=mr[i,i];
        mi:=i;
      end;
  out[0]:=0;
  if ms>0 then
    begin
      rec(i,i);
      inc(out[0]);
      out[out[0]]:=i;
    end;
end;

procedure done;
var i:longint;
begin
  assign(output,'birds.out');
  rewrite(output);
  writeln(out[0]);
  for i:=1 to out[0] do
    write(oln[out[i]]+1,' ');
  close(output);
end;

begin
  init;
  run;
  done;
end.
