const MaxN = 100+5;

type Tpoint = record
       x,y: longint;
       id: integer;
     end;

var en,dn: integer;
    es,ds: array[1..100] of Tpoint;


function IsLess(var pt,a,b: Tpoint):boolean;
var x1,y1,x2,y2: longint;
begin
  x1:=a.x-pt.x;
  y1:=a.y-pt.y;
  x2:=b.x-pt.x;
  y2:=b.y-pt.y;
  if x1*y2-x2*y1>0 then IsLess:=true else IsLess:=false;
end;

function IsEq(var pt,a,b:Tpoint):boolean;
var x1,y1,x2,y2: longint;
begin
  x1:=a.x-pt.x;
  y1:=a.y-pt.y;
  x2:=b.x-pt.x;
  y2:=b.y-pt.y;
  if x1*y2-x2*y1=0 then IsEq:=true else IsEq:=false;
end;

procedure polsort(l,r: longint;var a: array of Tpoint;var pt: Tpoint);
var
  i,j,x: longint;
  y: Tpoint;
begin
  i:=l;
  j:=r;
  x:=(l+r) div 2;
  repeat
    while IsLess(pt,a[i],a[x]){es[i].y<x} do
     inc(i);
    while IsLess(pt,a[x],a[j]){x<es[j].y} do
     dec(j);
    if not(i>j) then
      begin
        y:=a[i];
        a[i]:=a[j];
        a[j]:=y;
        inc(i);
        j:=j-1;
      end;
  until i>j;
  if l<j then
    polsort(l,j,a,pt);
  if i<r then
    polsort(i,r,a,pt);
end;

procedure GetH(n: integer;var rn:integer;a: array of Tpoint;var b:array of Tpoint);
var i,j: integer;
    pt: Tpoint;
begin
  j:=0;
  For i:=1 to n-1 do
    if a[i].y<a[j].y then j:=i;
  pt:=a[j];
  a[j]:=a[n-1];
  a[n-1]:=pt;
  PolSort(0,n-2,a,a[n-1]);
  rn:=1;
  b[0]:=a[n-1];
  b[1]:=a[0];
  For i:=1 to n-1 do begin
    while IsLess(b[rn-1],a[i],b[rn]) do
      dec(rn);
    inc(rn);
    b[rn]:=a[i]
  end;
end;

Function GetSq(n:integer;var a: array of Tpoint):longint;
var i: integer;
    res: longint;
begin
  res:=0;
  For i:=0 to n-2 do
    res:=res+a[i].x*a[i+1].y-a[i].y*a[i+1].x;
  res:=res+a[n-1].x*a[0].y-a[n-1].y*a[0].x;
  GetSq:=abs(res);
end;

Function IsInside(n:integer;var a: array of Tpoint; pt: Tpoint):boolean;
var sq: longint;
    i: integer;
    tmp: array[0..2] of Tpoint;
begin
  sq:=GetSq(n,a);
  tmp[0]:=pt;
  For i:=0 to n-2 do begin
    tmp[1]:=a[i]; tmp[2]:=a[i+1];
    sq:=sq-GetSq(3,tmp);
  end;
  tmp[1]:=a[n-1]; tmp[2]:=a[0];
  sq:=sq-GetSq(3,tmp);
  if sq=0 then IsInside:=true else IsInside:=false;
end;

var bconv,bestc: array[1..MaxN] of Tpoint;
    bn,bestn,pn: integer;
    bsq: longint;
    Pts: array[1..MaxN*2] of Tpoint;

procedure Solve;
var i,j,k,t,l: integer;
    tp: Tpoint;
    flag: boolean;
    tmp: array[1..MaxN] of Tpoint;
    tn: integer;
begin
  GetH(en,bn,es,bconv);
  i:=1;
  while i<=dn do
    if IsInside(bn,bconv,ds[i]) then
      inc(i)
    else begin
      ds[i]:=ds[dn];
      dec(dn);
    end;
  pn:=0;
  For i:=1 to en do begin
    inc(pn);
    pts[pn]:=es[i];
  end;
  For i:=1 to dn do begin
    inc(pn);
    pts[pn]:=ds[i];
  end;
  For k:=1 to bn do begin
    For j:=1 to pn do
      if bconv[k].id=pts[j].id then break;
    tp:=pts[j];
    pts[j]:=pts[pn];
    pts[pn]:=tp;
    PolSort(0,pn-2,pts,pts[pn]);
    i:=1;
    while i<pn-1 do begin
      flag:=false;
      j:=i;
      while (pts[j].id>0) and (j<pn) do begin
        inc(j);
      end;
      t:=j;
      if j=pn then begin
        dec(j);
      end else begin
        while IsEq(pts[pn],pts[j],pts[t]) and (i<j) do
          dec(j);
      end;
      if i<j then flag:=true;
      if flag then begin
        tn:=0;
        For l:=i to j do begin
          inc(tn);
          tmp[tn]:=pts[l];
        end;
        inc(tn); tmp[tn]:=pts[pn];
        GetH(tn,tn,tmp,tmp);
        if getsq(tn,tmp)>bsq then begin
          bsq:=getsq(tn,tmp);
          bestn:=tn;
          For j:=1 to tn do
            bestc[j]:=tmp[j];
        end;
      end;
      i:=t;
      while IsEq(pts[pn],pts[i],pts[t]) and (i<pn) do
        inc(i);
    end;
  end;

end;

procedure Save;
var f: text;
    i: integer;
begin
  Assign(f,'birds.out');
  Rewrite(f);
  if bsq=0 then begin
    writeLn(f,0);
  end else begin
    WriteLn(f,bestn);
    For i:=1 to bestn do
      Write(f,bestc[i].id,' ');
  end;
  Close(f);
end;

procedure Load;
var f: text;
    i: integer;
begin
  Assign(f,'birds.in');
  Reset(f);
  Read(f,en);
  For i:=1 to en do
    with es[i] do begin
      Read(f,x,y);
      id:=i;
    end;
  Read(f,dn);
  For i:=1 to dn do
    with ds[i] do begin
      Read(f,x,y);
      id:=0;
    end;
  Close(f);
end;


Begin
  Load;
  Solve;
  Save;
End.
