program Involutions;

const
  MAXN = 100; {100}

var
  n : integer;
  equ : boolean;
  p, pp, px : array [1..MAXN] of longint;
  pfix, used : array [1..MAXN] of boolean;

procedure Load(infile, outfile : string);
var
  i : integer;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(n);
  for i:=1 to n do
    read(p[i]);
end;

procedure Go(a : integer); {Go-Go-Go!}
var
  oldequ : boolean;
  i : integer;
begin
  if px[1]<>0 then
    exit;
  if a=n+1 then
  begin
    if not equ then
      px := pp;
    exit;
  end;
  if pfix[a] then
  begin
    if equ and (pp[a]<p[a]) then
      exit;
    oldequ := equ;
    equ := equ and (pp[a]=p[a]);
    go(a+1);
    equ := oldequ;
  end
  else
    for i:=a to n do
      if not used[i] then
      begin
        pp[a] := i;
        pp[i] := a;
        if equ and (pp[a]<p[a]) then
          continue;
        pfix[a] := true;
        pfix[i] := true;
        used[a] := true;
        used[i] := true;
        oldequ := equ;
        equ := equ and (pp[a]=p[a]);
        go(a+1);
        equ := oldequ;
        pfix[a] := false;
        pfix[i] := false;
        used[a] := false;
        used[i] := false;
      end;
end;

procedure Solve;
begin
  fillchar(px,sizeof(px),0);
  fillchar(used,sizeof(used),0);
  fillchar(pfix,sizeof(pfix),0);
  equ := true;
  go(1);
end;

procedure Save;
var
  i : integer;
begin
  if px[1]=0 then
    writeln(0)
  else
  begin
    writeln(n);
    for i:=1 to n do
      write(px[i],' ');
  end;
  close(input);
  close(output);
end;

begin
  Load('in.in','in.out');
  Solve;
  Save;
end.