program Cows;

{$M 5000000, 5000000}

const vert = 100000;

type pEd = ^Ed;
     Ed = record
       ver: cardinal;
       len: cardinal;
       next: pEd;
     end;

var f: text;
    i, a, b, n: cardinal;
    bro, maxo, maxt: array [1..vert] of cardinal;
    lin, lino, lint: array [1..vert] of cardinal;
    lw, rw, way, brn, num: array [-vert..vert] of cardinal;
    mark: array [1..vert] of boolean;
    head: array [1..vert] of pEd;
    maxlen, mver, get, len, old, min: cardinal;
    temp: pEd;
    cur, bst, lef, rig, bst1, bst2: longint;

function max (a, b: cardinal): cardinal;
begin
  if (a >= b) then max := a else max := b;
end;

procedure getmax (a: cardinal);
var t: pEd;
    b, n, c: cardinal;
    bl, nl: cardinal;

begin
  mark [a] := true;
  t := head [a];
  b := 0;
  n := 0;
  bl := 0;
  nl := 0;
  while (t <> nil) do
  begin
    if not mark [t ^ . ver] then
    begin
      getmax (t ^ . ver);
      c := maxo [t ^ . ver];
      c := c + t ^ . len;
      if (c > b) then
      begin
        n := b;
        nl := bl;
        b := c;
        bl := t ^ . ver;
      end
      else if (c > n) then
      begin
        n := c;
        nl := t ^ . ver;
      end;
    end;
    t := t ^ . next;
  end;
  maxo [a] := b;
  maxt [a] := n;
  lino [a] := bl;
  lint [a] := nl;
  if (b + n > maxlen) then
  begin
    maxlen := b + n;
    mver := a;
  end;
end;

procedure getm (a: cardinal);
var t: pEd;
    b, c: cardinal;

begin
  mark [a] := false;
  t := head [a];
  b := 0;
  while (t <> nil) do
  begin
    if mark [t ^ . ver] then
    begin
      getm (t ^ . ver);
      c := bro [t ^ . ver];
      c := c + t ^ . len;
      if (c > b) then
      begin
        b := c;
      end;
    end;
    t := t ^ . next;
  end;
  bro [a] := b;
end;

procedure getmat (a: cardinal; ind: integer);
var b, c: cardinal;
    t: pEd;
begin
  mark [a] := false;
  t := head [a];
  b := 0;
  while (t <> nil) do
  begin
    if (mark [t ^ . ver]) and
       (t ^ . ver <> lino [a]) and
       ((ind <> 0) or (t ^ . ver <> lint [a])) then
    begin
      getm (t ^ . ver);
      c := bro [t ^ . ver];
      c := c + t ^ . len;
      if (c > b) then
      begin
        b := c;
      end;
    end;
    t := t ^ . next;
  end;
  brn [ind] := b;
  num [ind] := a;
  if (ind > 0) then
  begin
    rig := ind;
    if (lino [a] > 0) then
    begin
      way [ind] := maxo [a] - maxo [lino [a]];
      getmat (lino [a], ind + 1);
    end;
  end
  else if (ind < 0) then
  begin
    lef := ind;
    if (lino [a] > 0) then
    begin
      way [ind - 1] := maxo [a] - maxo [lino [a]];
      getmat (lino [a], ind - 1);
    end;
  end
  else
  begin
    if (lino [a] > 0) then
    begin
      way [0] := maxo [a] - maxo [lino [a]];
      getmat (lino [a], 1);
    end;
    if (lint [a] > 0) then
    begin
      way [-1] := maxt [a] - maxo [lint [a]];
      getmat (lint [a], -1);
    end;
  end;
end;

begin
  assign (f, 'cows.in');
  reset (f);
  readln (f, n);
  for i := 2 to n do
  begin
    read (f, a, b);
    readln (f, len);
    temp := head [a];
    new (head [a]);
    head [a] ^ . ver := b;
    head [a] ^ . len := len;
    head [a] ^ . next := temp;
    temp := head [b];
    new (head [b]);
    head [b] ^ . ver := a;
    head [b] ^ . len := len;
    head [b] ^ . next := temp;
  end;
  close (f);
  maxlen := 0;
  mver := 0;
  getmax (1);
  lef := 0;
  rig := 0;
  getmat (mver, 0);
  len := 0;
  for cur := lef + 1 to rig - 1 do
  begin
    inc (len, way [cur - 1]);
    lw [cur] := max (lw [cur - 1], len + brn [cur]);
  end;
  len := 0;
  for cur := rig - 1 downto lef + 1 do
  begin
    inc (len, way [cur]);
    rw [cur] := max (rw [cur + 1], len + brn [cur]);
  end;
  min := 0;
  for cur := lef to rig - 1 do
  begin
    if (min = 0) or (max (lw [cur], rw [cur + 1]) < min) then
    begin
      min := max (lw [cur], rw [cur + 1]);
      bst := cur;
    end;
  end;
  get := lw [bst];
  cur := lef;
  len := 0;
  old := 0;
  while (len shl 1 < get) do
  begin
    old := len;
    inc (len, way [cur]);
    inc (cur);
  end;
  bst1 := cur;
  if (len + old > get) then dec (bst1);
  get := rw [bst + 1];
  cur := rig;
  len := 0;
  old := 0;
  while (len shl 1 < get) do
  begin
    old := len;
    dec (cur);
    inc (len, way [cur]);
  end;
  bst2 := cur;
  if (len + old > get) then inc (bst2);
  if (bst1 = bst2) then
  begin
    bst2 := bst1 + 1;
    if (bst2 > rig) then
    begin
      bst2 := bst1 - 1;
    end;
  end;
  assign (f, 'cows.out');
  rewrite (f);
  writeln (f, num [bst1], ' ', num [bst2]);
  close (f);
end.
