{$A+,B-,D+,E+,F-,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
{$M 65520,0,655360}
Const maxn = 100005;

Type Edge = Record
             a, b: Longint;
             w: Integer;
            End;

Var i, j, n, m, tmin, u, v: Longint;
    r: array[1..maxn * 2] of Edge;
    p: array[1..maxn] of Longint;
    d: array[1..maxn] of Record
                          r: Longint;
                          d: Byte;
                         End;
    use: array[1..maxn] of Boolean;
    min: array[1..2] of Record
                         r, n: Longint;
                        End;

Procedure Alternative;
 Begin
  For i := 1 to m do
   If r[i].w > d[r[i].a].r Then d[r[i].a].r := r[i].w;
  u := 1;
  For i := 1 to n do
   If d[i].r > d[u].r Then u := i;
  v := 1;
  For i := 1 to n do
   If (d[i].r > d[v].r) and (i <> u) Then v := i;
  Write(u, ' ', v);
  Close(input);
  Close(output);
 End;

Procedure Swap(var a, b: Edge);
 Var c: Edge;
 Begin
  c := a;
  a := b;
  b := c;
 End;

Procedure Hoar(left, right: Longint);
 Var i, j, c: Longint;
 Begin
  i := left;
  j := right;
  c := r[Random(j - i + 1) + i].a;
  While i < j do
   Begin
    While r[i].a < c do Inc(i);
    While r[j].a > c do Dec(j);
    If i <= j Then
     Begin
      Swap(r[i], r[j]);
      Inc(i);
      Dec(j);
     End;
   End;
  If j > left Then Hoar(left, j);
  If i < right Then Hoar(i, right);
 End;

Function Poisk(x: Longint): Longint;
 Var k, max, l: Longint;
 Begin
  use[x] := True;
  max := 0;
  For k := p[x] to p[x + 1] - 1 do
   If not (((r[k].a = r[i].a) and (r[k].b = r[i].b))
      or ((r[k].b = r[i].a) and (r[k].a = r[i].b)))
      and not use[r[k].b] Then
    Begin
     l := Poisk(r[k].b) + r[k].w;
     If l > max Then max := l;
    End;
  Poisk := max;
 End;

Function Max(a, b: Longint): Longint;
 Begin
  If a > b Then Max := a
           Else Max := b;
 End;

Begin
 Assign(input, 'cows.in');
 Assign(output, 'cows.out');
 Reset(input);
 Rewrite(output);
 Read(n);
 For i := 1 to n - 1 do
  Begin
   Read(r[i shl 1 - 1].a, r[i shl 1 - 1].b, r[i shl 1 - 1].w);
   r[i shl 1].a := r[i shl 1 - 1].b;
   r[i shl 1].b := r[i shl 1 - 1].a;
   r[i shl 1].w := r[i shl 1 - 1].w;
  End;
 m := (n - 1) shl 1;
 Hoar(1, m);
 For i := 1 to m do
  If (i = 1) or (r[i].a <> r[i - 1].a) Then p[r[i].a] := i;
 p[n + 1] := m + 1;
 If n > 100 Then Alternative;
 tmin := MaxLongint;
 For i := 1 to m do
  Begin
   For j := 1 to n do
    Begin
     FillChar(use, SizeOf(use), False);
     d[j].r := Poisk(j);
     If use[r[i].a] Then d[j].d := 1
                    Else d[j].d := 2;
    End;
   For j := 1 to 2 do
    min[j].r := MaxLongint;
   For j := 1 to n do
    If min[d[j].d].r > d[j].r Then
     Begin
      min[d[j].d].r := d[j].r;
      min[d[j].d].n := j;
     End;
   If Max(min[1].r, min[2].r) < tmin Then
    Begin
     u := min[1].n;
     v := min[2].n;
     tmin := Max(min[1].r, min[2].r);
    End;
  End;
 Write(u, ' ', v);
 Close(input);
 Close(output);
End.
