program Colored_Permutations;

const
  MAXN = 100000; {100000}
  colorchars : string = 'RGB';

var
  p, t1, t2, c, e, c2 : array [1..MAXN] of longint;
  n, m : longint;

procedure Load(infile, outfile : string);
var
  i, t : longint;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(n);
  for i:=1 to n do
    read(t1[i]);
  for i:=1 to n do
  begin
    read(t);
    t2[t] := i;
  end;
  for i:=1 to n do
    p[i] := t2[t1[i]];
end;

procedure Solve;
var
  i, j : longint;
begin
  m := 1;
  c[1] := 1;
  e[1] := 1;
  for i:=2 to n do
  begin
    if m>3 then
      break;
    if p[i]<p[e[m]] then
    begin
      inc(m);
      c[i] := m;
      e[m] := i;
    end
    else
    begin
      for j:=1 to m do
        if p[i] > p[e[j]] then
          break;
      c[i] := j;
      e[j] := i;
    end;
  end;
end;

procedure Save;
var
  i : longint;
begin
  for i:=1 to n do
    c2[t1[i]] := c[i];
  if m>3 then
    writeln('NO')
  else
    for i:=1 to n do
      write(colorchars[c2[i]]);
  close(input);
  close(output);
end;

begin
  Load('perm.in','perm.out');
  Solve;
  Save;
end.