{$D-,L-,Q-,R-,I-,S-,N+}
Program pr_c;
const
  inpfile='nice.in';
  outfile='nice.out';
  nm=1005;
type
  Coord=record
    x,y : Integer;
  end;
var
  a,b,u : array [0..nm,0..nm] of Boolean;
  r : array [1..5*nm*nm] of Coord;
  m,n,rn : LongInt;
{}
Procedure Inp;
var
  i,j,k : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(m,n);
  for i:=1 to n do
    for j:=1 to m do begin
      read(k);
      if k=1 then a[i,j]:=true;
    end;
  for i:=1 to n do
    for j:=1 to m do begin
      read(k);
      if k=1 then b[i,j]:=true;
    end;
end;
{}
Procedure Out(ok : Boolean);
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  if ok then begin
    writeln(rn);
    for i:=1 to rn do writeln(r[i].x,' ',r[i].y)
  end else writeln(-1);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(u,sizeof(u),0);
end;
{}
Procedure Rec(i,j : Integer);
begin
  u[i,j]:=true;
  {1}
  if (i>1) and (j>1) then
  if (a[i,j] xor a[i-1,j]) and (a[i,j] xor a[i,j-1]) and (a[i,j] xor a[i-1,j-1]) then
  begin
    if (a[i-1,j] xor b[i-1,j]) and not u[i-1,j] then Rec(i-1,j)
    else if (a[i,j-1] xor b[i,j-1]) and not u[i,j-1] then Rec(i,j-1)
    else if (a[i-1,j-1] xor b[i-1,j-1]) and not u[i-1,j-1] then Rec(i-1,j-1)
    else Out(false);
  end;
  {2}
  if (i<n) and (j>1) then
  if (a[i,j] xor a[i+1,j]) and (a[i,j] xor a[i,j-1]) and (a[i,j] xor a[i+1,j-1]) then
  begin
    if (a[i+1,j] xor b[i+1,j]) and not u[i+1,j] then Rec(i+1,j)
    else if (a[i,j-1] xor b[i,j-1]) and not u[i,j-1] then Rec(i,j-1)
    else if (a[i+1,j-1] xor b[i+1,j-1]) and not u[i+1,j-1] then Rec(i+1,j-1)
    else Out(false);
  end;
  {3}
  if (i>1) and (j<m) then
  if (a[i,j] xor a[i-1,j]) and (a[i,j] xor a[i,j+1]) and (a[i,j] xor a[i-1,j+1]) then
  begin
    if (a[i-1,j] xor b[i-1,j]) and not u[i-1,j] then Rec(i-1,j)
    else if (a[i,j+1] xor b[i,j+1]) and not u[i,j+1] then Rec(i,j+1)
    else if (a[i-1,j+1] xor b[i-1,j+1]) and not u[i-1,j+1] then Rec(i-1,j+1)
    else Out(false);
  end;
  {4}
  if (i<n) and (j<m) then
  if (a[i,j] xor a[i+1,j]) and (a[i,j] xor a[i,j+1]) and (a[i,j] xor a[i+1,j+1]) then
  begin
    if (a[i+1,j] xor b[i+1,j]) and not u[i+1,j] then Rec(i+1,j)
    else if (a[i,j+1] xor b[i,j+1]) and not u[i,j+1] then Rec(i,j+1)
    else if (a[i+1,j+1] xor b[i+1,j+1]) and not u[i+1,j+1] then Rec(i+1,j+1)
    else Out(false);
  end;
  inc(rn); r[rn].x:=i; r[rn].y:=j;
  a[i,j]:=not a[i,j];
end;
{}
Procedure Solve;
var
  i,j : LongInt;
begin
  rn:=0;
  for i:=1 to n do
    for j:=1 to m do
      if a[i,j] xor b[i,j] then Rec(i,j);
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out(true);
End.
