const max=3000;
var k,m,n:longint;
    sp,sp2:array[1..max,0..max]of word;
    x,y:array[1..max]of longint;

    out:array[1..max,1..2]of longint;

    size,c:longint;
    col:array[1..max]of longint;

    ms,ms2:array[1..max]of longint;
    key:array[1..max]of extended;

procedure init;
var i,u,v:longint;
begin
  assign(input,'road.in');
  reset(input);
  read(n,m);
  for i:=1 to n do
    begin
      read(x[i],y[i]);
      sp[i,0]:=0;
    end;
  for i:=1 to m do
    begin
      read(u,v);
      inc(sp[u,0]);
      sp[u,sp[u,0]]:=v;
      inc(sp[v,0]);
      sp[v,sp[v,0]]:=u;
    end;
  close(input);
end;

procedure dfs(i:longint);
var j:longint;
begin
  for j:=1 to sp[i,0] do
    if col[sp[i,j]]=0 then
      begin
        col[sp[i,j]]:=col[i];
        dfs(sp[i,j]);
      end;
end;

function rst(i,j:longint):extended;
begin
  rst:=sqrt(sqr(1.0*x[i]-1.0*x[j])+sqr(1.0*y[i]-1.0*y[j]));
end;

procedure up(num:longint);
var i,x:longint;
    j:extended;
begin
  i:=num;
  while (i>1)and(key[i div 2]>key[i]) do
    begin
      j:=key[i div 2];
      key[i div 2]:=key[i];
      key[i]:=j;
      x:=ms[i div 2];
      ms[i div 2]:=ms[i];
      ms[i]:=x;
      x:=ms2[i div 2];
      ms2[i div 2]:=ms2[i];
      ms2[i]:=x;
    end;
end;

procedure add(x,y:longint;j:extended);
begin
  inc(size);
  ms[size]:=x;
  ms2[size]:=y;
  key[size]:=j;
  up(size);
end;

procedure heapify(i:longint);
var m,x:longint;
    j:extended;
begin
  m:=i;
  if 2*i<=size then
    if key[2*i]<key[m] then
      m:=2*i;
  if 2*i+1<=size then
    if key[2*i+1]<key[m] then
      m:=2*i+1;
  if m<>i then
    begin
      j:=key[m];
      key[m]:=key[i];
      key[i]:=j;
      x:=ms[m];
      ms[m]:=ms[i];
      ms[i]:=x;
      x:=ms2[m];
      ms2[m]:=ms2[i];
      ms2[i]:=x;
      heapify(m);
    end;
end;

procedure edit(num:longint;newt:extended;newms2:longint);
begin
  if newt<key[num] then
    begin
      key[num]:=newt;
      ms2[num]:=newms2;
      up(num);
    end
  else
    begin
      key[num]:=newt;
      ms2[num]:=newms2;
      heapify(num);
    end;
end;

procedure extractmin(var mst,ms2t:longint);
begin
  mst:=ms[1];
  ms2t:=ms2[1];
  ms[1]:=ms[size];
  ms2[1]:=ms2[size];
  key[1]:=key[size];
  dec(size);
  heapify(1);
end;

procedure run;
var i,j,i1,j1,io,jo:longint;
begin
  for i:=1 to n do
    col[i]:=0;
  c:=0;
  for i:=1 to n do
    if col[i]=0 then
      begin
        inc(c);
        col[i]:=c;
        dfs(i);
      end;
  for i:=1 to c do
    for j:=0 to c do
      begin
        sp[i,j]:=0;
        sp2[i,j]:=0;
      end;
  for i:=1 to n-1 do
    for j:=i+1 to n do
      if col[i]<>col[j] then
        if (sp[col[i],col[j]]=0)or(rst(i,j)<rst(sp[col[i],col[j]],sp2[col[i],col[j]])) then
          begin
            sp[col[i],col[j]]:=i;
            sp2[col[i],col[j]]:=j;
            sp[col[j],col[i]]:=i;
            sp2[col[j],col[i]]:=j;
          end;
  k:=c-1;
  fillchar(col,sizeof(col),0);
  for i:=2 to c do
    col[i]:=2;
  col[1]:=1;
  size:=0;
  for i:=2 to c do
    add(i,1,rst(sp[1,i],sp2[1,i]));
  for i:=1 to c-1 do
    begin
      extractmin(jo,io);
      col[jo]:=1;
      out[i,1]:=sp[io,jo];
      out[i,2]:=sp2[io,jo];
      for j:=1 to size do
        if key[j]>rst(sp[jo,ms[j]],sp2[jo,ms[j]]) then
          edit(j,rst(sp[jo,ms[j]],sp2[jo,ms[j]]),jo);
    end;
end;

procedure done;
var i:longint;
begin
  assign(output,'road.out');
  rewrite(output);
  writeln(k);
  for i:=1 to k do
    writeln(out[i,1],' ',out[i,2]);
  close(output);
end;

begin
  init;
  run;
  done;
end.
