{
  Dmitry Orlov
    SARATOV
    id = 33
}


{.$define debug}

{$R+,Q+,S+,I+,N+}


program template;
const
 nmax = 1000;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'nice.in';
 coutfile= 'nice.out';
 {$endif}
type
 int = longint;
 real = extended;
 tp = record
  u,v :integer;
 end;
var
 a,b :array [1..nmax,1..nmax] of byte;
 c :array [1..nmax,1..nmax] of byte;
 p :array [1..7*nmax*nmax] of tp;
 k :int;
 n,m :int;

procedure init;
begin
 k := 0;
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (n,m);
 for i := 1 to n do
  for j := 1 to m do
   read (a[i,j]);
 for i := 1 to n do
  for j := 1 to m do
   read (b[i,j]);
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (k);
 for i := 1 to k do
  writeln (p[i].u,' ',p[i].v);
 close (output);
end;

function ok (u,v :int):boolean;
begin
 ok := true;
 if (u < 1) or (v < 1) then
  exit;
 if (u = n) or (v = m) then
  exit;
 ok := not ((a[u,v] = a[u+1,v]) and (a[u,v] = a[u,v+1]) and
              (a[u,v] = a[u+1,v+1]));
end;

function can (u,v :int):boolean;
begin
 can := false;
 if (u > n) or (v > m) or (u < 1) or (v < 1) then
  exit;
 a[u,v] := 1 - a[u,v];
 can := ok(u-1,v-1) and ok(u-1,v) and
          ok(u,v-1) and ok(u,v);
 a[u,v] := 1 - a[u,v];
end;

procedure doit (i,j :int);
begin
 a[i,j] := 1 - a[i,j];
 c[i,j] := 1 - c[i,j];
 inc(k);
 p[k].u := i;
 p[k].v := j;
end;

procedure rec (u,v :int; i1,i2 :int);
begin
 if i1 > 1 then
  exit;
 if can (u+i1,v+i2) then
  begin
   doit (u+i1,v+i2);
   if not ((i1 = 0) and (i2 = 0)) then
   if can (u,v) then
    begin
     doit(u,v);
     exit;
    end;
   doit (u+i1,v+i2);
   if i2 = 1 then
    rec (u,v,i1+1,-1)
   else
    rec (u,v,i1,i2+1);
  end
 else
  begin
   if i2 = 1 then
    rec (u,v,i1+1,-1)
   else
    rec (u,v,i1,i2+1);
  end;
end;

procedure solve;
var i,j :int;
    d,z :int;
begin
 for i := 1 to n do
  for j := 1 to m do
   c[i,j] := a[i,j] xor b[i,j];
 while true do
  begin
   z := 0;
   for i := 1 to n do
    for j := 1 to m do
     if (c[i,j] = 1) then
      begin
       if can (i,j) then
        doit(i,j)
       else
        rec (i,j,-1,-1);
       inc(z);
      end;
   if z = 0 then
    break;
  end;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.