program Building_The_Graph;

const
  MAXN = 40; {40}

var
  n, m : longint;
  q,g : array [1..MAXN,1..MAXN] of integer;

procedure Load(infile, outfile : string);
var
  i, j : integer;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(n,m);
  for i:=1 to n do
    for j:=1 to n do
      q[i,j] := -ord(i<>j);
  fillchar(g,sizeof(g),0);
end;

procedure Solve;
var
  i, k, v1, v2, l, x, y : longint;
begin
  for i:=1 to m do
  begin
    read(k);
    if k=1 then
    begin
      read(v1,v2,l);
      if (g[v1,v2]<>0) and (g[v1,v2]<=l) then
        continue;
      g[v1,v2] := l;
      for x:=1 to n do
        if q[x,v1]<>-1 then
          for y:=1 to n do
            if (q[v2,y]<>-1) and ((q[x,y]=-1) or (q[x,y]>q[x,v1]+q[v2,y]+l)) then
              q[x,y] := q[x,v1]+q[v2,y]+l;
    end
    else
    begin
      read(v1,v2);
      writeln(q[v1,v2]);
    end;
  end;
end;

procedure Save;
begin
  close(input);
  close(output);
end;

begin
  Load('graph.in','graph.out');
  Solve;
  Save;
end.