type teg = array[1..2] of integer;
     tvert = record
       el,en: integer;
       d: integer;
     end;

var n,m: integer;
    es: array[1..4000] of teg;
    vs: array[1..2000] of tvert;
    mark,md: array[1..2000] of integer;
    min,count: integer;

procedure scan(sv: integer);
var q: array[0..1999] of integer;
    qb,qe,v,cd,i: integer;
begin
  qb:=0; qe:=1;
  q[0]:=sv;
  vs[sv].d:=0;
  mark[sv]:=sv;
  while qb<>qe do begin
    v:=q[qb]; qb:=(qb+1) mod 2000;
    cd:=vs[v].d;
    For i:=vs[v].el to vs[v].el+vs[v].en-1 do
      if mark[es[i,2]]<>sv then begin
        mark[es[i,2]]:=sv;
        vs[es[i,2]].d:=cd+1;
        q[qe]:=es[i,2]; qe:=(qe+1) mod 2000;
      end;
  end;
  md[sv]:=cd;
end;

procedure Solve;
var i: integer;
begin
  For i:=1 to n do begin
    scan(i);
  end;
  min:=md[1];
  For i:=2 to n do
    if min>md[i] then min:=md[i];
  count:=0;
  for i:=1 to n do
    if md[i]=min then inc(count);
end;

procedure Save;
var f: text;
    i: integer;
begin
  Assign(f,'tree.out');
  Rewrite(f);
  WriteLn(f,count);
  For i:=1 to n do
    if min=md[i] then write(f,i,' ');
  Close(f);
end;

procedure sort(l,r: longint);
  var
     i,j: longint;
     x: integer;
     y: Teg;
  begin
     i:=l;
     j:=r;
     x:=es[(l+r) div 2,1];
     repeat
       while es[i,1]<x do
        inc(i);
       while x<es[j,1] do
        dec(j);
       if not(i>j) then
         begin
            y:=es[i];
            es[i]:=es[j];
            es[j]:=y;
            inc(i);
            j:=j-1;
         end;
     until i>j;
     if l<j then
       sort(l,j);
     if i<r then
       sort(i,r);
  end;


procedure Load;
var f: text;
    i,a,b: integer;
begin
  Assign(f,'tree.in');
  Reset(f);
  Read(f,n);
  For i:=1 to n-1 do begin
    Read(f,a,b);
    inc(M);
    es[M,1]:=a; es[M,2]:=b;
    inc(M);
    es[M,1]:=b; es[M,2]:=a;
  end;
  Close(f);
  sort(1,M);
  For i:=1 to M do begin
    if vs[es[i,1]].el=0 then vs[es[i,1]].el:=i;
    inc(vs[es[i,1]].en);
  end;
end;


Begin
  Load;
  Solve;
  Save;
End.
