{
  Dmitry Orlov
    SARATOV
    id = 33
}


{.$define debug}

{$R-,Q-,S-,I-,N+}


program template;
const
 nmax = 101000;
 eps = 1e-12;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'game.in';
 coutfile= 'game.out';
 {$endif}
type
 int = longint;
 real = extended;
var
 start,finish :int;
 n :int;
 ans :int;
 q :array [1..nmax] of int;
 w,t :int;
 used :array [0..nmax] of boolean;
 prev :array [0..nmax] of int;
 path :array [1..nmax] of int;

procedure init;
begin
 ans := 0;
 fillchar (q,sizeof(q),0);
 fillchar (used,sizeof(used),0);
 fillchar (prev,sizeof(prev),0);
 fillchar (path,sizeof(path),0);
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 read (n,start,finish);
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans-1);
 for i := ans downto 1 do
  write (path[i],' ');
 close (output);
end;

procedure outno;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (-1);
 close (output);
 halt;
end;

function int_ (x :real):real;
begin
 int_ := x - frac(x);
end;

procedure add (b :real; from :int);
var v :int;
begin
 v := round(b - int_(b/n + eps)*n);
 if used[v] then
  exit;
 used[v] := true;
 inc(t);
 q[t] := v;
 prev[v] := from;
end;

procedure solve;
var i,j :int;
    cur :int;
begin
 q[1] := start;
 w := 1;
 t := 1;
 used[start] := true;
 prev[start] := -1;
 while w <= t do
  begin
   cur := q[w];
   if cur = finish then
    break;
   inc(w);
   add (1.0*cur+1,cur);
   add (1.0*cur*cur+1,cur);
   add (1.0*cur*cur*cur+1,cur);
  end;
 if not used[finish] then
  outno;
 cur := finish;
 while (cur >= 0) do
  begin
   inc(ans);
   path[ans] := cur;
   cur := prev[cur];
  end;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.