program ConvexMembraneArea;

var f: text;
    qq, xxs, o, i, j, n: word;
    x1, x2, y1, y2: array [1..2000] of longint;
    k, b: array [1..2000] of real;
    xs, ys, xr, yr: array [1..4000] of real;
    q, w: array [1..4000] of word;
    ar, x, xll, xrr: real;
    nn: boolean;
    oo: smallint;

function ori (a, b, c: word): smallint;
var t: real;
begin
  t := xr [a] * yr [b] - yr [a] * xr [b] +
       xr [b] * yr [c] - yr [b] * xr [c] +
       xr [c] * yr [a] - yr [c] * xr [a];
  if (t > 0) then
    ori := 1
  else if (t < 0) then
    ori := -1
  else
    ori := 0;
end;

procedure sort (a, b: word);
var i, j: word;
    x, y, xx, yy: real;
begin
  i := a;
  j := b;
  x := xs [(a + b) shr 1] + 0.000001 * ys [(a + b) shr 1];
  repeat
    while (xs [i] + 0.000001 * ys [i] + 0.00000001 < x) do inc (i);
    while (xs [j] + 0.000001 * ys [j] > x + 0.00000001) do dec (j);
    if (i < j) then
    begin
      xx := xs [i];
      yy := ys [i];
      xs [i] := xs [j];
      ys [i] := ys [j];
      xs [j] := xx;
      ys [j] := yy;
    inc (i);
    dec (j);
     end;
  until (i >= j);
  if (i +1< b) then sort (i, b);
  if (a +1< j) then sort (a, j);
end;

begin
  assign (f, 'convexh.in');
  reset (f);
  readln (f, n);
  for i := 1 to n do
  begin
    readln (f, x1 [i], y1 [i], x2 [i], y2 [i]);
  end;
  close (f);
  for i := 1 to n do
  begin
    if (x1 [i] <> x2 [i]) then
    begin
      k [i] := (y1 [i] - y2 [i]) / (x1 [i] - x2 [i]);
      b [i] := y1 [i] - k [i] * x1 [i];
    end
    else
    begin
      o := i;
    end;
  end;
  xxs := 0;
  for i := 1 to n do if (i <> o) then
  begin
    nn := true;
    for j := 1 to n do if (j <> o) and (j <> i) then
    begin
      x := (b [i] - b [j]) / (k [j] - k [i]);
      if (x < xll) or nn then
      begin
        xll := x;
      end;
      if (x > xrr) or nn then
      begin
        xrr := x;
      end;
      nn := false;
    end;
    inc (xxs);
    xs [xxs] := xll;
    ys [xxs] := k [i] * xll + b [i];
    inc (xxs);
    xs [xxs] := xrr;
    ys [xxs] := k [i] * xrr + b [i];
  end;
  sort (1, xxs);
  j := 0;
  for i := 1 to xxs do
  begin
    if (i = 1) or (abs (xs[i]-xs[i-1])+abs(ys[i]-ys[i-1]) > 0.00001) then
    begin
      inc (j);
      xr [j] := xs [i];
      yr [j] := ys [i];
    end;
  end;
  ar := xr [j] * yr [1] - xr [1] * yr [j];
  for i := 1 to j-1 do
  begin
    ar := ar + xr [i] * yr [i + 1] - xr [i + 1] * yr [i];
  end;
  assign (f, 'convexh.out');
  rewrite (f);
  writeln (f, (abs (ar) * 0.5):0:7);
  close (f);
end.
