{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 9000000,0,655360}
Const maxn = 1930;
      vert = 1e6;

Type line = Record
             k, b: Extended;
            End;
     point = Record
              x, y: Comp;
             End;

Var i, j, k, g, n, x1, y1, x2, y2, min: Integer;
    s: extended;
    a: array[1..maxn] of line;
    x: array[1..maxn*(maxn - 1) shr 1] of Point;
    p: array[1..maxn*(maxn - 1) shr 1] of Integer;

Procedure Swap(var a, b: Point);
 Var c: Point;
 Begin
  c := a;
  a := b;
  b := c;
 End;

Function Angle(p: Point): Extended;
 Var r: Extended;
 Begin
  If p.x = x[1].x
   Then Angle := 0
   Else
    Begin
     r := (p.y - x[1].y) / (p.x - x[1].x);
     If r = 0
      Then
       If p.x > x[1].x
        Then Angle := - vert
        Else Angle := vert
      Else
       If r > 0 Then Angle := r - vert
                Else Angle := r + vert;
    End;
 End;

Procedure Hoar(left, right: Longint);
 Var i, j: Longint;
     c: Extended;
 Begin
  i := left;
  j := right;
  c := Angle(x[Random(j - i + 1) + i]);
  While i < j do
   Begin
    While Angle(x[i]) < c do Inc(i);
    While Angle(x[j]) > c do Dec(j);
    If i <= j Then
     Begin
      Swap(x[i], x[j]);
      Inc(i);
      Dec(j);
     End;
   End;
  If j > left Then Hoar(left, j);
  If i < right Then Hoar(i, right);
 End;

Function VectMul(x1, y1, x2, y2: Extended): Extended;
 Begin
  VectMul := x1 * y2 - x2 * y1;
 End;

Function Djarvis(h: Integer): Boolean;
 Var i: Integer;
 Begin
  Djarvis := false;
  If p[h - 1] < k
   Then
    For i := p[h - 1] + 1 to k do
    If VectMul(x[i].x - x[p[h - 1]].x, x[i].y - x[p[h - 1]].y,
               x[p[h - 1]].x - x[p[h - 2]].x, x[p[h - 1]].y - x[p[h - 2]].y) <= 0
     Then
      Begin
       p[h] := i;
       If Djarvis(h + 1) Then
        Begin
         Djarvis := True;
         Break;
        End;
      End
     Else Break
   Else
    Begin
     Djarvis := True;
     p[h] := 1;
     g := h;
    End;
 End;

Begin
 Assign(input, 'convexh.in');
 Assign(output, 'convexh.out');
 Reset(input);
 Rewrite(output);
 Read(n);
 For i := 1 to n do
  Begin
   Read(x1, y1, x2, y2);
   If x1 = x2
    Then
     Begin
      a[i].k := vert;
      a[i].b := x1;
     End
    Else
     Begin
      a[i].k := (y2 - y1) / (x2 - x1);
      a[i].b := y1 - x1 * a[i].k;
     End;
  End;
 min := 1;
 For i := 1 to n - 1 do
  For j := i + 1 to n do
   Begin
    Inc(k);
    If (a[i].k = vert) or (a[j].k = vert)
     Then
      Begin
       If a[i].k = vert
        Then
         Begin
          x[k].x := a[i].b;
          x[k].y := a[j].k * x[k].x + a[j].b;
         End
        Else
         Begin
          x[k].x := a[j].b;
          x[k].y := a[i].k * x[k].x + a[i].b;
         End;
      End
     Else
      Begin
       x[k].x := (a[j].b - a[i].b) / (a[i].k - a[j].k);
       x[k].y := a[i].k * x[k].x + a[i].b;
      End;
    If x[k].y < x[min].y Then min := k;
   End;
 Swap(x[1], x[min]);
 Hoar(2, k);
 p[1] := 1;
 p[2] := 2;
 Djarvis(3);
 For i := 1 to g - 1 do
  s := s + x[p[i + 1]].x * x[p[i]].y - x[p[i]].x * x[p[i + 1]].y;
 Write(Abs(s) / 2:0:2);
 Close(input);
 Close(output);
End.
