{$D-,L-,Q-,R-,S-,I-,N+}
Program pr_a;
const
  inpfile='move.in';
  outfile='move.out';
  nm=305;
var
  a,step,r,numb : array [1..nm,1..nm] of Integer;
  u : array [1..nm,1..nm] of Boolean;
  v : array [1..nm] of Boolean;
  s : array [1..nm] of Integer;
  res,res1 : array [1..nm] of Integer;
  c,b,p,p1 : array [1..nm] of Integer;
  reb,t,pn,pn1 : LongInt;
  n,m : LongInt;
{}
Procedure Inp;
var
  i,j : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n,m); reb:=0;
  for i:=1 to n do begin
    read(b[i]); inc(reb,b[i]);
    for j:=1 to b[i] do begin
      read(a[i,j]);
      inc(step[i,a[i,j]]);
    end;
  end;
end;
{}
Procedure Out;
var
  i,j : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  for i:=1 to n do begin
    for j:=1 to b[i] do write(r[i,j],' ');
    writeln;
  end;
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(res,sizeof(res),0);
  fillchar(res1,sizeof(res1),0);
  fillchar(v,sizeof(v),0);
  fillchar(r,sizeof(r),0);
  fillchar(s,sizeof(s),0);
  fillchar(u,sizeof(u),0);
end;
{}
Function Try(x : Integer) : Boolean;
var
  i : Integer;
begin
  Try:=false;
  if v[x] then exit;
  v[x]:=true;
  for i:=1 to b[x] do
    if not u[x,i] and ((res[a[x,i]]=0) or Try(res[a[x,i]])) then begin
      Try:=true;
      res[a[x,i]]:=x; s[x]:=i;
      r[x,i]:=t;
      exit;
    end;
end;
{}
Procedure Swap(var q,w : Integer);
var
  bak : Integer;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
var
  z : Integer;

Procedure Sort(l,r: LongInt);
var
  i,j,x : LongInt;
begin
  i:=l; j:=r; x:=step[z,a[z,(l+r) div 2]];
  repeat
    while step[z,a[z,i]]<x do inc(i);
    while x<step[z,a[z,j]] do dec(j);
    if not(i>j) then begin
      Swap(a[z,i],a[z,j]);
      inc(i); dec(j);
    end;
  until i>j;
  if l<j then Sort(l,j);
  if i<r then Sort(i,r);
end;
{}
Procedure SortQ(lt,rt: LongInt);
var
  i,j,x : LongInt;
begin
  i:=lt; j:=rt; x:=numb[z,a[z,(lt+rt) div 2]];
  repeat
    while numb[z,a[z,i]]<x do inc(i);
    while x<numb[z,a[z,j]] do dec(j);
    if not(i>j) then begin
      Swap(a[z,i],a[z,j]);
      Swap(r[z,i],r[z,j]);
      inc(i); dec(j);
    end;
  until i>j;
  if lt<j then SortQ(lt,j);
  if i<rt then SortQ(i,rt);
end;

{}
Procedure Solve;
var
  i,j,h : LongInt;
begin
  for i:=1 to n do
    for j:=1 to b[i] do numb[i,a[i,j]]:=j;

  for z:=1 to n do Sort(1,b[z]);

  t:=-1; c:=b; pn:=n;
  for i:=1 to n do p[i]:=i;
  while reb>0 do begin
    inc(t);
    fillchar(s,sizeof(s),0);
    fillchar(res,sizeof(res),0);

    if odd(t) then begin
      pn:=0;
      for i:=1 to pn1 do begin
        fillchar(v,sizeof(v),0);
        if Try(p1[i]) then begin
          dec(reb);
          dec(c[p1[i]]);
        end;

        if c[p1[i]]>0 then begin
          inc(pn); p[pn]:=p1[i];
        end;
      end;

      for i:=1 to pn1 do
        if s[p1[i]]>0 then u[p1[i],s[p1[i]]]:=true;
    end else begin
      pn1:=0;
      for i:=1 to pn do begin
        fillchar(v,sizeof(v),0);
        if Try(p[i]) then begin
          dec(reb);
          dec(c[p[i]]);
        end;

        if c[p[i]]>0 then begin
          inc(pn1); p1[pn1]:=p[i];
        end;
      end;

      for i:=1 to pn do
        if s[p[i]]>0 then u[p[i],s[p[i]]]:=true;
    end;
  end;

  for z:=1 to n do SortQ(1,b[z]);
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
