{
  Dmitry Orlov
    SARATOV
    id = 33
}


{.$define debug}

{$R-,Q-,S-,I-,N+}


program template;
const
 nmax = 350;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'party.in';
 coutfile= 'party.out';
 {$endif}
type
 int = longint;
 real = extended;
var
 n,m :int;
 gr :array [1..nmax,1..nmax] of boolean;
 f :array [1..nmax] of boolean;
 p :array [1..nmax] of int;
 inv :array [1..nmax] of int;
 used :array [1..nmax] of boolean;
 ans :int;

procedure init;
begin
 ans := 0;
 fillchar (gr,sizeof(gr),0);
 fillchar (p,sizeof(p),0);
 fillchar (inv,sizeof(inv),0);
 fillchar (used,sizeof(used),0);
end;

procedure readdata;
var i,j :int;
    d,u :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (n,m);
 for i := 1 to n do
  begin
   read (d);
   for j := 1 to d do
    begin
     read (u);
     gr[i,u] := true;
    end;
  end;
 close (input);
end;

procedure calculate;
var na :array [1..nmax] of boolean;
    i,j :int;
    res :int;
begin
 fillchar (na,sizeof(na),0);
 for i := 1 to n do
  if used[i] then
   for j := 1 to m do
    na[j] := na[j] or gr[i,j];
 res := 0;
 for i := 1 to m do
  if na[i] then
   inc(res);
 writeln (ans - res);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 {$ifdef debug}
 calculate;
 {$endif}
 writeln (ans);
 for i := 1 to n do
  if used[i] then
   write (i,' ');
 close (output);
end;

function rec (v :int):boolean;
var i :int;
begin
 rec := false;
 if f[v] then
  exit;
 f[v] := true;
 for i := 1 to n do
  if gr[i,v] and ((p[i] = 0) or rec(p[i])) then
   begin
    p[i] := v;
    rec := true;
    exit;
   end;
end;

procedure dfs (v :int);
var i :int;
begin
 if used[v] then
  exit;
 used[v] := true;
 for i := 1 to m do
  if gr[v,i] then
   if inv[i] > 0 then
    dfs(inv[i])
   {$ifdef debug}
   else
    writeln('Jopa');
   {$endif}
end;

procedure solve;
var i,j :int;
begin
 for i := 1 to m do
  begin
   fillchar (f,sizeof(f),0);
   rec(i);
  end;
 for i := 1 to n do
  if p[i] > 0 then
   inv[p[i]] := i;
 for i := 1 to n do
  if p[i] = 0 then
   if not used[i] then
    dfs(i);
 for i := 1 to n do
  if used[i] then
   inc(ans);
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.