{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}

const infile = 'poly.in'; outfile = 'poly.out'; max = 100005;
type pt = record x,y: longint; end;
type sc = record p1,p2: pt; end;
var p,q: array [1..max] of sc;
    r,g: array [1..max] of longint;
    nwr: array [1..max,1..2] of longint;
    np,nq,nw,n,ans: longint;

procedure init;
var i: longint;
    t,tr: pt;
begin
     assign(input,infile);
     reset(input);
     read(n);
     fillchar(p,sizeOf(p),0);
     fillchar(q,sizeOf(q),0);
     fillchar(r,sizeOf(r),0);
     fillchar(g,sizeOf(g),0);
     np:=0; nq:=0; read(tr.x,tr.y);
     for i:=1 to n-1 do begin
         read(t.x,t.y);
         if t.x-t.y = tr.x-tr.y then begin
            inc(np);
            if (t.y > tr.y) then begin p[np].p1:=tr; p[np].p2:=t; end
               else begin p[np].p1:=t; p[np].p2:=tr; end;
            g[np]:=p[np].p1.x-p[np].p1.y;
         end
            else begin
            inc(nq);
            if (t.y > tr.y) then begin q[nq].p1:=tr; q[nq].p2:=t; end
               else begin q[nq].p1:=t; q[nq].p2:=tr; end;
            r[nq]:=q[nq].p1.x+q[nq].p1.y;
         end;
         tr:=t;
     end;
     close(input);
end;

procedure swap(q1,q2: longint);
var c: longint;
    tmp: pt;
begin
     c:=r[q1]; r[q1]:=r[q2]; r[q2]:=c;
     tmp:=q[q1].p1; q[q1].p1:=q[q2].p1; q[q2].p1:=tmp;
     tmp:=q[q1].p2; q[q1].p2:=q[q2].p2; q[q2].p2:=tmp;
end;

procedure sort_r(l,t: longint);
var i,j,v,u: longint;
begin
     i:=l; j:=t; v:=r[(l+t) div 2]; u:=q[(l+t) div 2].p2.x;
     repeat
           while (r[i] < v)or((r[i] = v)and(q[i].p2.x < u)) do inc(i);
           while (r[j] > v)or((r[j] = v)and(q[j].p2.x > u)) do dec(j);
           if i <= j then begin
              swap(i,j); inc(i); dec(j);
           end;
     until i > j;
     if i < t then sort_r(i,t);
     if j > l then sort_r(l,j);
end;

procedure create_nwr;
var i: longint;
begin
     nw:=1; nwr[1,1]:=1;
     for i:=2 to nq do
         if r[i] <> r[i-1] then begin
            inc(nw); nwr[nw-1,2]:=i-1; nwr[nw,1]:=i;
         end;
     nwr[nw,2]:=nq;
end;

procedure find_bin_pl(v: longint; var n1,n2: longint);
var down,up,mid: longint;
begin
     down:=1; up:=nw;
     while up-1 > down do begin
           mid:=(up+down) div 2;
           if r[nwr[mid,1]] > p[v].p1.x+p[v].p1.y then up:=mid else down:=mid;
     end;
     if r[nwr[down,1]] > p[v].p1.x+p[v].p1.y then mid:=down else mid:=up;
     n1:=mid;
     down:=1; up:=nw;
     while up-1 > down do begin
           mid:=(up+down) div 2;
           if r[nwr[mid,1]] >= p[v].p2.x+p[v].p2.y then up:=mid else down:=mid;
     end;
     if r[nwr[up,1]] < p[v].p2.x+p[v].p2.y then mid:=up else mid:=down;
     n2:=mid;
end;

function peres(v1,v2: longint): boolean;
begin
     peres:=(q[v2].p1.x-q[v2].p1.y > g[v1])and(q[v2].p2.x-q[v2].p2.y < g[v1]);
end;

function is_left(v1,v2: longint): boolean;
begin
     is_left:=(q[v2].p1.x-q[v2].p1.y < g[v1])and(q[v2].p2.x-q[v2].p2.y < g[v1]);
end;

procedure find_bin_sc(v,n1,n2: longint);
var down,up,mid: longint;
begin
     if n1 = n2 then begin
        if peres(v,n1) then inc(ans);
        exit;
     end;
     down:=n1; up:=n2; mid:=(up+down) div 2;
     while up-1 > down do begin
           mid:=(up+down) div 2;
           if peres(v,mid) then break;
           if is_left(v,mid) then down:=mid else up:=mid;
     end;
     if peres(v,mid) then begin inc(ans); exit; end;
     if peres(v,down) then begin inc(ans); exit; end;
     if peres(v,up) then begin inc(ans); exit; end;
end;

procedure solve;
var n1,n2,i,j: longint;
begin
     sort_r(1,nq);
     create_nwr;
     ans:=0;
     for i:=1 to np do begin
         find_bin_pl(i,n1,n2);
         for j:=n1 to n2 do begin
             find_bin_sc(i,nwr[j,1],nwr[j,2]);
         end;
     end;
end;

procedure done;
begin
     assign(output,outfile);
     rewrite(output);
     write(ans);
     close(output);
end;

begin
     init;
     solve;
     done;
end.
