#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <string.h>

#define NN 110000

struct REB {
  int x1,y1;
  int x2,y2;
  int k;
};

int _stklen = 4000000;

FILE *fi, *fo;
int n;
REB a[NN/2+100];
int s_a;
REB b[NN/2+100];
int s_b;
int res;

bool peres(REB a, REB b)
{
  if(((b.x1+b.y1>a.k)&&(b.x2+b.y2<a.k))||((b.x1+b.y1<a.k)&&(b.x2+b.y2>a.k)))
    if(((a.x1-a.y1>b.k)&&(a.x2-a.y2<b.k))||((a.x1-a.y1<b.k)&&(a.x2-a.y2>b.k)))
      return true;
  return false;
}

void sift(int p, int q, REB *t)
{
  int i,j;
  REB x;
  i=p;
  j=2*i+1;
  x=t[i];
  if(j<q-1) if(t[j+1].k>t[j].k) j++;
  if(j<q) if(t[j].k<x.k) j=q+1;
  while(j<q)
  {
    t[i]=t[j];
    i=j;
    j=2*j+1;
    if(j<q-1) if(t[j+1].k>t[j].k) j++;
    if(j<q) if(t[j].k<x.k) j=q+1;
  }
  t[i]=x;
}

void Sort(REB *t,int m)
{
  REB x;
  int i,j;
  j=m;
  for(i=m/2+1;i>=0;i--)
    sift(i,j,t);
  i=0;
  while(j>1)
  {
    j--;
    x=t[j];
    t[j]=t[0];
    t[0]=x;
    sift(i,j,t);
  }
}

int bsearch(int c,REB *a,int s_a)
{
  int b,e;
  int t;
  b=0;
  e=s_a-1;
  if(a[b].k>=c)
    return b;
  if(a[e].k<c)
    return b;
  while((e-b)>1)
  {
    t=(b+e)/2;
    if(a[t].k>=c)
      e=t;
    else
      b=t;
  }
  return e;
}

int main()
{
  int xo,yo;
  int xn,yn;
  int i,j;
  int xx,yy;
  fi=fopen("poly.in","rt");
  fo=fopen("poly.out","wt");

  fscanf(fi,"%i",&n);
  fscanf(fi,"%i%i",&xo,&yo);
  s_a=0;
  s_b=0;
  for(i=1;i<n;i++)
  {
    fscanf(fi,"%i%i",&xn,&yn);
    if(xo+yo==xn+yn)
    {
      a[s_a].x1=xo;
      a[s_a].y1=yo;
      a[s_a].x2=xn;
      a[s_a].y2=yn;
      a[s_a].k=xo+yo;
      s_a++;
    }
    else
    {
      b[s_b].x1=xo;
      b[s_b].y1=yo;
      b[s_b].x2=xn;
      b[s_b].y2=yn;
      b[s_b].k=xo-yo;
      s_b++;
    }
    xo=xn;
    yo=yn;
  }

  Sort(a,s_a);
  
  res=0;
  for(i=0;i<s_b;i++)
  {
    if(b[i].x1+b[i].y1>b[i].x2+b[i].y2)
    {
      xx=bsearch(b[i].x2+b[i].y2,a,s_a);
      yy=bsearch(b[i].x1+b[i].y1,a,s_a);
    }
    else
    {
      yy=bsearch(b[i].x2+b[i].y2,a,s_a);
      xx=bsearch(b[i].x1+b[i].y1,a,s_a);
    }
    for(j=xx;j<yy;j++)
      if(peres(a[j],b[i]))
        res++;
  }

  fprintf(fo,"%i\n",res);

  fclose(fi);
  fclose(fo);
  return 0;
}
