{$D-,L-,Q-,R-,S-,I-,N-}
Program pr_b;
const
  inpfile='mayors.in';
  outfile='mayors.out';
  nm=20005;
type
  May=record
    c,n : LongInt;
  end;
var
  x,y : array [1..nm] of May;
  r : array [1..nm] of Integer;
  n : LongInt;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n);
  for i:=1 to n do begin
    read(x[i].c,y[i].c);
    x[i].n:=i; y[i].n:=i;
  end;
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  for i:=1 to n do writeln(r[i]);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(x,sizeof(x),0);
  fillchar(y,sizeof(y),0);
  fillchar(r,sizeof(r),0);
end;
{}
Procedure Swap(var q,w : May);
var
  bak : May;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure SortX(l,r: LongInt);
var
  i,j,b : LongInt;
begin
  i:=l; j:=r; b:=x[(l+r) div 2].c;
  repeat
    while x[i].c<b do inc(i);
    while b<x[j].c do dec(j);
    if not(i>j) then begin
      Swap(x[i],x[j]);
      inc(i); dec(j);
    end;
  until i>j;
  if l<j then SortX(l,j);
  if i<r then SortX(i,r);
end;
{}
Procedure SortY(l,r: LongInt);
var
  i,j,b : LongInt;
begin
  i:=l; j:=r; b:=y[(l+r) div 2].c;
  repeat
    while y[i].c<b do inc(i);
    while b<y[j].c do dec(j);
    if not(i>j) then begin
      Swap(y[i],y[j]);
      inc(i); dec(j);
    end;
  until i>j;
  if l<j then SortX(l,j);
  if i<r then SortX(i,r);
end;
{}
Procedure Solve;
var
  i,j,k : LongInt;
begin
  SortX(1,n); SortY(1,n); k:=0; i:=0;
  while i<n do begin
    inc(i); r[x[i].n]:=(r[x[i].n]+k) mod 2;
    while x[i+1].c=x[i].c do begin
      inc(i); r[x[i].n]:=(r[x[i].n]+k) mod 2;
    end;
    k:=(k+1) mod 2;
  end;

  k:=0; i:=0;
  while i<n do begin
    inc(i); r[y[i].n]:=(r[y[i].n]+k) mod 2;
    while y[i+1].c=y[i].c do begin
      inc(i); r[y[i].n]:=(r[y[i].n]+k) mod 2;
    end;
    k:=(k+1) mod 2;
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
