{$D-,L-,Q-,R-,S-,I-,N+}
Program pr_c;
const
  inpfile='poly.in';
  outfile='poly.out';
  eps=1e-5;
  nm=100005;
var
  x1,y1,x2,y2,x01,x02,num : array [0..nm] of LongInt;
  tip : array [0..nm] of Boolean;
  res : Extended;
  n : LongInt;

{}
Procedure Swap(var q,w : LongInt);
var
  bak : LongInt;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n);
  for i:=1 to n do begin
    num[i]:=i;
    read(x1[i],y1[i]); x01[i]:=x1[i];
    x2[i-1]:=x1[i];    x02[i-1]:=x2[i-1];
    y2[i-1]:=y1[i];
    if (x1[i-1]-x2[i-1]>0) xor (y1[i-1]-y2[i-1]>0) then tip[i-1]:=true
                                                   else tip[i-1]:=false;
    if x2[i-1]<x1[i-1] then Swap(x1[i-1],x2[i-1]);
  end;
  dec(n);
end;
{}
Procedure Out;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(res:0:0);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(x1,sizeof(x1),0);
  fillchar(y1,sizeof(y1),0);
  fillchar(x2,sizeof(x2),0);
  fillchar(x01,sizeof(x01),0);
  fillchar(x02,sizeof(x02),0);
  fillchar(y2,sizeof(y2),0);
  fillchar(tip,sizeof(tip),0);
end;
{}
var
  x : LongInt;
{}
Procedure Sort(l,r: LongInt);
var
  i,j : LongInt;
begin
  i:=l; j:=r; x:=x1[num[(l+r) div 2]];
  repeat
    while x1[num[i]]<x do inc(i);
    while x<x1[num[j]] do dec(j);
    if not(i>j) then begin
      Swap(num[i],num[j]);
      inc(i); dec(j);
    end;
  until i>j;
  if l<j then Sort(l,j);
  if i<r then Sort(i,r);
end;
{}
var
  resbin,bx : LongInt;
{}
Procedure Bin(l,r : LongInt);
var
  m : LongInt;
begin
  if r-l<2 then begin
    resbin:=l;
    if x1[num[r]]<bx then resbin:=r
                     else resbin:=l;
    exit;
  end;
  m:=(l+r) div 2;
  if x1[num[m]]<bx then Bin(m,r)
                   else Bin(l,m-1);
end;
{}
Function Vc(x1,y1,x2,y2,x3,y3,x4,y4 : Extended) : Extended;
begin
  Vc:=(x1-x2)*(y3-y4)-(x3-x4)*(y1-y2);
end;
{}
Function Cross(i,j : LongInt) : Boolean;
var
  k,b : LongInt;
  ok : Boolean;
begin
  ok:=true;
  if tip[i] then begin k:=-1; b:=y1[i]+x01[i] end
            else begin k:=1; b:=y1[i]-x01[i]; end;
  if not ((k*x01[j]+b<y1[j]) xor (k*x02[j]<y2[j])) then ok:=false;

  if tip[j] then begin k:=-1; b:=y1[j]+x01[j] end
            else begin k:=1; b:=y1[j]-x01[j]; end;
  if not ((k*x01[i]+b<y1[i]) xor (k*x02[i]<y2[i])) then ok:=false;
  Cross:=ok;
end;
{}
Procedure Solve;
var
  i,j : LongInt;
begin
  Sort(1,n);
  res:=0;

  for i:=1 to n-1 do begin
    bx:=x2[num[i]]; Bin(i,n);
    for j:=i+1 to resbin do
      if (tip[num[i]] xor tip[num[j]]) and (abs(num[i]-num[j])>1) then
        if Cross(num[i],num[j]) then res:=res+1;
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
