program FlatlandMayors;

type pPo = ^Po;
     Po = record
       x, y, num: word;
       next: pPo;
     end;

var f: text;
    x2, x3, i, j, n, lef, mid, rig, lx, ly: word;
    j1, s11: word;
    xr, yr, xval, yval, xv, yv: array [1..20000] of longint;
    xcor, x1, y1, xn, yn, xo, yo: array [1..20000] of word;
    so, col: array [1..20000] of boolean;
    t: longint;
    xp, yp: array [1..20000] of pPo;
    temp: pPo;


procedure siftup (a: word);
begin
  if (a > 1) and (xval [a shr 1] < xval [a]) then
  begin
    t := xval [a shr 1];
    xval [a shr 1] := xval [a];
    xval [a] := t;
    siftup (a shr 1);
  end;
end;

procedure sdown (a: word);
begin
  if (a shl 1 + 2 <= i) and (xval [a] < xval [a shl 1 + 1]) and
     (xval [a shl 1] < xval [a shl 1 + 1]) then
  begin
    t := xval [a shl 1 + 1];
    xval [a shl 1 + 1] := xval [a];
    xval [a] := t;
    sdown (a shl 1 + 1);
  end
  else if (a shl 1 + 1 <= i) and (xval [a] < xval [a shl 1]) then
  begin
    t := xval [a shl 1];
    xval [a shl 1] := xval [a];
    xval [a] := t;
    sdown (a shl 1);
  end;
end;

procedure ysiftup (a: word);
begin
  if (a > 1) and (yval [a shr 1] < yval [a]) then
  begin
    t := yval [a shr 1];
    yval [a shr 1] := yval [a];
    yval [a] := t;
    ysiftup (a shr 1);
  end;
end;

procedure ysdown (a: word);
begin
  if (a shl 1 + 2 <= i) and (yval [a] < yval [a shl 1 + 1]) and
     (yval [a shl 1] < yval [a shl 1 + 1]) then
  begin
    t := yval [a shl 1 + 1];
    yval [a shl 1 + 1] := yval [a];
    yval [a] := t;
    sdown (a shl 1 + 1);
  end
  else if (a shl 1 + 1 <= i) and (yval [a] < yval [a shl 1]) then
  begin
    t := yval [a shl 1];
    yval [a shl 1] := yval [a];
    yval [a] := t;
    ysdown (a shl 1);
  end;
end;

begin
  assign (f, 'mayors.in');
  reset (f);
  readln (f, n);
  for i := 1 to n do
  begin
    read (f, xr [i]);
    readln (f, yr [i]);
    xval [i] := xr [i];
    yval [i] := yr [i];
  end;
  close (f);
  for i := 2 to n do
  begin
    siftup (i);
    ysiftup (i);
  end;
  for i := n downto 2 do
  begin
    t := xval [1];
    xval [1] := xval [i];
    xval [i] := t;
    t := yval [1];
    yval [1] := yval [i];
    yval [i] := t;
    sdown (1);
    ysdown (1);
  end;
  lx := 1;
  ly := 1;
  xv [1] := xval [1];
  yv [1] := yval [1];
  for i := 2 to n do
  begin
    if (xval [i - 1] < xval [i]) then
    begin
      inc (lx);
      xv [lx] := xval [i];
    end;
    if (yval [i - 1] < yval [i]) then
    begin
      inc (ly);
      yv [ly] := yval [i];
    end;
  end;
  for i := 1 to n do
  begin
    lef := 1;
    rig := lx;
    while (lef + 3 < rig) do
    begin
      mid := (lef + rig) shr 1;
      if (xr [i] < xv [mid]) then
      begin
        rig := mid - 1;
      end
      else if (xr [i] > xv [mid]) then
      begin
        lef := mid + 1;
      end
      else
      begin
        lef := mid;
        rig := mid;
      end;
    end;
    for j1 := lef to rig do if (xr [i] = xv [j1]) then
    begin
      xo [i] := j1;
    end;
    j1 := xo [i];
    lef := 1;
    rig := ly;
    while (lef + 3 < rig) do
    begin
      mid := (lef + rig) shr 1;
      if (yr [i] < yv [mid]) then
      begin
        rig := mid - 1;
      end
      else if (yr [i] > yv [mid]) then
      begin
        lef := mid + 1;
      end
      else
      begin
        lef := mid;
        rig := mid;
      end;
    end;
    for j := lef to rig do if (yr [i] = yv [j]) then
    begin
      yo [i] := j;
      inc (yn [j]);
      temp := yp [j];
      new (yp [j]);
      yp [j] ^ . num := i;
      yp [j] ^ . x := xo [i];
      yp [j] ^ . y := j;
      yp [j] ^ . next := temp;
    end;
    inc (xn [j1]);
    temp := xp [j1];
    new (xp [j1]);
    xp [j1] ^ . num := i;
    xp [j1] ^ . x := j1;
    xp [j1] ^ . y := yo [i];
    xp [j1] ^ . next := temp;
  end;
  repeat
    repeat
      j := 0;
      for i := 1 to lx do if (xn [i] = 1) then
      begin
        j := 1;
        mid := xp [i] ^ . y;
        xn [i] := 0;
        xp [i] := nil;
        inc (s11);
        x1 [s11] := i;
        y1 [s11] := mid;
        col [s11] := true;
        if (yp [mid] ^ . x = i) then
        begin
          yp [mid] := yp [mid] ^ . next;
        end
        else
        begin
          temp := yp [mid];
          while (temp^.next^.x <> i) do temp := temp^.next;
          temp^.next := temp^.next^.next;
        end;
        dec (yn [mid]);
      end;
      for i := 1 to ly do if (yn [i] = 1) then
      begin
        j := 1;
        mid := yp [i] ^ . x;
        yn [i] := 0;
        yp [i] := nil;
        inc (s11);
        x1 [s11] := mid;
        y1 [s11] := i;
        col [s11] := false;
        if (xp [mid] ^ . y = i) then
        begin
          xp [mid] := xp [mid] ^ . next;
        end
        else
        begin
          temp := xp [mid];
          while (temp^.next^.y <> i) do temp := temp^.next;
          temp^.next := temp^.next^.next;
        end;
        dec (xn [mid]);
      end;
    until (j = 0);
    x2 := 0;
    repeat inc (x2) until (x2 > lx) or (xn [x2] > 0);
    if (x2 <= lx) then
    begin
      for i := 1 to lx do xcor [i] := 0;
      repeat
        xcor [x2] := xp [x2] ^ . y;
        if (yp [xcor [x2]] ^ . x = x2) then
        begin
          x2 := yp [xcor [x2]]^.next^.x;
        end
        else
        begin
          x2 := yp [xcor [x2]] ^ . x;
        end;
      until (xcor [x2] > 0);
      repeat
        if (yp [xcor [x2]] ^ . x = x2) then
        begin
          x3 := yp [xcor [x2]]^.next^.x;
        end
        else
        begin
          x3 := yp [xcor [x2]] ^ . x;
        end;
        if (xp [x2] ^ . y = xcor [x2]) then
        begin
          so [xp [x2] ^ . num] := true;
          xp [x2] := xp [x2] ^ . next;
        end
        else
        begin
          temp := xp [x2];
          while (temp^.next^.y <> xcor [x2]) do temp := temp^.next;
          temp^.next := temp^.next^.next;
          so [xp [x2] ^ . next ^ . num] := true;
        end;
        dec (xn [x2]);
        if (yp [xcor [x2]] ^ . x = x2) then
        begin
          yp [xcor [x2]] := yp [xcor [x2]] ^ . next;
        end
        else
        begin
          temp := yp [xcor [x2]];
          while (temp^.next^.x <> x2) do temp := temp^.next;
          temp^.next := temp^.next^.next;
        end;
        dec (yn [xcor [x2]]);
        if (xp [x3] ^ . y = xcor [x2]) then
        begin
          xp [x3] := xp [x3] ^ . next;
        end
        else
        begin
          temp := xp [x3];
          while (temp^.next^.y <> xcor [x2]) do temp := temp^.next;
          temp^.next := temp^.next^.next;
        end;
        dec (xn [x3]);
        if (yp [xcor [x2]] ^ . x = x3) then
        begin
          yp [xcor [x2]] := yp [xcor [x2]] ^ . next;
        end
        else
        begin
          temp := yp [xcor [x2]];
          while (temp^.next^.x <> x3) do temp := temp^.next;
          temp^.next := temp^.next^.next;
        end;
        dec (yn [xcor [x2]]);
        x2 := x3;
      until (xcor [x2] = 0) or (xcor [x3] = 0);
    end;
  until (x2 > lx);
  assign (f, 'mayors.out');
  rewrite (f);
  for i := 1 to n do
  begin
    writeln (f, ord (so [i]));
  end;
  close (f);
end.
