{
  Dmitry Orlov
    SARATOV
    id = 33
}


{.$define debug}

{$R-,Q-,S-,I-,N+}


program template;
const
 nmax = 101000;
 inf = 100000000;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'parking.in';
 coutfile= 'parking.out';
 {$endif}
type
 int = longint;
 real = extended;
 tnew = record
  time :int;
  d :shortint;
  man :int;
  number :int;
 end;
var
 n,m,k :int;
 ans :int;
 nw :array [1..2*nmax] of tnew;
 b :array [1..4*nmax] of int;
 pos :array [1..nmax] of int;

procedure init;
begin
 randseed := 28313;
 fillchar (nw,sizeof(nw),0);
 fillchar (b,sizeof(b),0);
 fillchar (pos,sizeof(pos),0);
end;

procedure readdata;
var i,j :int;
    t1,t2,c :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (n,m);
 for i := 1 to m do
  begin
   read (t1,t2,c);
   nw[2*i-1].d := 1;
   nw[2*i-1].time := t1;
   nw[2*i-1].man := i;
   nw[2*i-1].number := c;
   nw[2*i].d := -1;
   nw[2*i].time := t2;
   nw[2*i].man := i;
  end;
 close (input);
end;

procedure swapnw (var a,b :tnew);
var tmp :tnew;
begin
 tmp := a;
 a := b;
 b := tmp;
end;

procedure sort (l,r :int);
var i,j :int;
    x :int;
begin
 i := l;
 j := r;
 x := nw[l + random(r-l+1)].time;
 repeat
  while nw[i].time < x do
   inc(i);
  while nw[j].time > x do
   dec(j);
  if i <= j then
   begin
    swapnw (nw[i],nw[j]);
    inc(i);
    dec(j);
   end;
 until i > j;
 if i < r then
  sort (i,r);
 if l < j then
  sort (l,j);
end;

function minimum (a,b :int):int;
begin
 if a < b then
  minimum := a
 else
  minimum := b;
end;

procedure prepare;
var i :int;
begin
 k := 1;
 while k < n do
  k := k*2;
 for i := k to 2*k-1 do
  b[i] := i-k+1;
 for i := k-1 downto 1 do
  b[i] := minimum (b[2*i],b[2*i+1]);
end;

function add (position :int):int;
var min :int;
    cur :int;
    i,j :int;

procedure go;
begin
 while i <= j do
  begin
   if b[i] < min then
    min := b[i];
   if b[j] < min then
    min := b[j];
   i := (i+1) div 2;
   j := (j-1) div 2;
  end;
end;

begin
 i := k + position - 1;
 j := k + n - 1;
 min := inf;
 go;
 if min = inf then
  begin
   i := k;
   j := k + position - 2;
   go;
  end;
 add := min;
 cur := k + min - 1;
 b[cur] := inf;
 cur := cur shr 1;
 while cur > 0 do
  begin
   b[cur] := minimum (b[2*cur],b[2*cur+1]);
   cur := cur shr 1;
  end;
end;

procedure restore (ps :int);
var cur :int;
begin
 cur := k + ps - 1;
 b[cur] := ps;
 cur := cur shr 1;
 while cur > 0 do
  begin
   b[cur] := minimum (b[2*cur],b[2*cur+1]);
   cur := cur shr 1;
  end;
end;

procedure solve;
var i,j :int;
begin
 sort (1,2*m);
 prepare;
 for i := 1 to 2*m do
  if nw[i].d = 1 then
   pos[nw[i].man] :=  add (nw[i].number)
  else
   restore (pos[nw[i].man]);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 for i := 1 to m do
  writeln (pos[i]);
 close (output);
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.