program p25_35_A;

const
  maxn = 100000;
  maxt = 1000000000;

type
  time = 0..1000000001;
  lot = 0..maxn;
  car = record
        t1, t2: time;
        needc: lot;
        end;

var
  n,m: lot;
  cars: array[lot] of car;
  park: array[lot] of boolean;
  place: array[lot] of lot;
  fi, fo: text;

function GetMNum( s: string; const m: integer): integer;
var k, i, j, n, itog: integer;
begin
j := 1;
s := s + ' ';
n := length(s);
while (s[j]<>' ') and ( j <> n ) do inc(j);
i := 1;
if m <> 1 then
  begin
  for k := 1 to m-1 do
    begin
    i := j+1; j := i;
    while (s[j]<>' ') do inc(j);
    end;
  end;
Val( copy(s, i, j-i) ,itog, k);
GetMNum := itog;
end;

procedure Init;
var i: lot;
begin
Assign( fi, 'parking.in' );
Assign( fo, 'parking.out');
Reset( fi );
Rewrite( fo );
for i := 1 to maxn do begin place[i] := 0; park[i] := false end;
end;

procedure input;
var s:  string;
i: lot;
begin
readln( fi, s);
N := getmnum(s,1);
M := getmnum(s,2);
for i := 1 to m do
  begin
  readln(fi,s);
  cars[i].t1 := getmnum(s,1);
  cars[i].t2 := getmnum(s,2);
  cars[i].needc := getmnum(s,3);
  end;
end;

procedure Doit;
  function Next( var CurTime: time ): lot;
  var
    CurCar: lot;
    i: lot;
    t, t1, t2: time;
  begin
  t := maxt;
  for i := m downto 1 do
    begin
    t1 := cars[i].t1;
    t2 := cars[i].t2;
    if t2 < t then if t2 > CurTime then begin t := t2; CurCar := i end;
    if t1 < t then if t1 > CurTime then begin t := t1; CurCar := i end;
    end;
  CurTime := t;
  Next := CurCar;
  end;

  function DoPark( CurCar: lot ): lot;
  var
    i,c: lot;
    done: boolean;
  begin
  c := Cars[CurCar].needc;
  done := false;
  while not done do
    begin
    if not Park[c] then
      begin
      Park[c] := true;
      Place[Curcar] := c;
      done := true;
      end;
    if c < n then inc(c) else c := 1;
    end;
  end;

  procedure DoUnPark( CurCar: lot );
  begin
  Park[ place[CurCar] ]:= false;
  end;

var
  done : boolean;
  TimeNow: time;
  CarNow: lot;
begin
done := false;
timeNow := 0;
while not done do
  begin
  carNow := next( timeNow );
  if timeNow = maxt then begin done := true; Exit end;
  if timeNow = Cars[ carNow ].t1 then DoPark( carNow )
  else if timeNow = cars[ carNow ].t2 then DoUnPark( carNow );
  end;
end;

procedure Output;
var
  s: string;
  i: lot;
begin
for i := 1 to m do
  begin
  Str( place[i], s );
  WriteLn( fo, s );
  end;
end;

procedure Final;
begin
Close(fi);
Close(fo);
end;


BEGIN
Init;
Input;
Doit;
Output;
Final;
END.
