{$D-,L-,Q-,R-,S-,I-,N+}
Program pr_a;
const
  inpfile='left.in';
  outfile='left.out';
  A0=chr(ord('A')-1);
  mm=1005;
type
  Rebr=record
    x,y : Char;
    s : String;
  end;
var
  a : array [1..mm] of Rebr;
  b : array [A0..'Z',A0..'Z'] of Boolean;
  v : array [A0..'Z'] of Boolean;
  u : array [A0..'Z'] of Integer;
  m : LongInt;
  s : Char;
{}
Procedure ReadLex(var st : String);
var
  ch : Char;
begin
  st:=''; ch:='>';
  repeat
    read(ch);
    if ch=#13 then exit;
  until (ch in ['a'..'z','A'..'Z']);
  while ch in ['a'..'z','A'..'Z'] do begin
    st:=st+ch;
    read(ch);
  end;
end;
{}
Procedure Inp;
var
  i,j : LongInt;
  st : String;
  x,y : Char;
begin
  assign(input,inpfile);
  reset(input);
  readln(m,s,s);
  for i:=1 to m do begin
    ReadLex(st); x:=st[1];
    ReadLex(st);
    if st='' then y:=A0 else
    if st[1] in ['a'..'z'] then y:=A0
                           else y:=st[1];
    if st<>'' then delete(st,1,1);
    a[i].x:=x; a[i].y:=y; a[i].s:=st;
    b[x,y]:=true;
  end;
end;
{}
Procedure Out(k : LongInt);
begin
  assign(output,outfile);
  rewrite(output);
  if k=-1 then writeln('infinity')
  else if k=0 then writeln(k) else begin
    if m=4 then writeln(3)
    else if b[s,A0] then writeln(1)
                else writeln(4);
  end;
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(u,sizeof(u),0);
  fillchar(v,sizeof(v),0);
end;
{}
var
  inf : Boolean;
{}
Procedure Dfs(x : Char);
var
  cnt : Char;
  res,ok : Boolean;
begin
  if x=A0 then exit;

  u[x]:=1; res:=false;
  for cnt:=A0 to 'Z' do
    if b[x,cnt] then begin
      if inf and (u[cnt]=1) then Out(-1);
      if u[cnt]=0 then begin
        Dfs(cnt);
        res:=res or v[cnt];
      end else
      if v[cnt] then res:=true;
  end;

  v[x]:=res;
  u[x]:=2;
end;
{}
Procedure Solve;
begin
  inf:=false;
  v[A0]:=true;
  Dfs(s);
  if not v[s] then Out(0);
  inf:=true; fillchar(u,sizeof(u),0);
  Dfs(s);
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out(2);
End.
