{
  Dmitry Orlov
    SARATOV
    id = 33
}


{.$define debug}

{$R-,Q-,S-,I-,N+}


program template;
const
 nmax = 1110;
 lenmax = 2*nmax;
 start = chr(ord('Z')+1);
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'left.in';
 coutfile= 'left.out';
 {$endif}
type
 int = longint;
 real = extended;
 trule = record
  s,f :char;
  m :integer;
  gamma :array [1..lenmax] of char;
 end;
 tbor = record
  m :int;
  e :array [1..lenmax,'a'..'z'] of integer;
  accept :array [1..lenmax] of longint;
 end;
 tptr = ^ttree;
 ttree = record
  accept :boolean;
  next :array ['a'..'z'] of tptr;
 end;
var
 n :int;
 rule :array [1..nmax] of trule;
 ans :int;
 finish :char;
 bors :array ['A'..start] of tbor;
 used :array ['A'..start] of byte;
 tree :tptr;

procedure init;
begin
 ans := 0;
 fillchar (rule,sizeof(rule),0);
 fillchar (bors,sizeof(bors),0);
 fillchar (used,sizeof(used),0);
 tree := nil;
end;

procedure readdata;
var i,j :int;
    c :char;
begin
 assign (input,cinfile);
 reset (input);
 read (n);
 read (c);
 read (finish);
 readln;
 for i := 1 to n do
  begin
   repeat
   read (rule[i].f);
   until not (rule[i].f = ' ');
   repeat
    read (c);
   until c = '>';
   repeat
    read (c);
   until not (c = ' ') or seekeoln;
   if c in ['A'..'Z'] then
    rule[i].s := c
   else
    begin
     rule[i].s := start;
     if c in ['a'..'z'] then
      begin
       inc(rule[i].m);
       rule[i].gamma[rule[i].m] := c;
      end;
    end;
   while not seekeoln do
    begin
     read (c);
     if (c in ['a'..'z']) then
      begin
       inc(rule[i].m);
       rule[i].gamma[rule[i].m] := c;
      end;
    end;
   readln;
  end;
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans);
 close (output);
end;

procedure outinf;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln ('infinity');
 close (output);
 halt;
end;

procedure findcycle (v :char);
var i,j,t :int;
begin
 if used[v] > 0 then
  begin
   if used[v] = 1 then
    outinf;
   exit;
  end;
 used[v] := 1;
 for i := 1 to bors[v].m do
  if not (bors[v].accept[i] = 0) then
   begin
    t := bors[v].accept[i];
    j := 0;
    while not (t = 0) do
     begin
      if t and 1 = 1 then
       findcycle (chr(ord('A')+j));
      t := t shr 1;
      inc(j);
     end;
  end;
 used[v] := 2;
end;

procedure rec (node :tptr; symbol :char);
var i :int;

procedure dfs (node :tptr; v :int);
var c :char;
    i,t :int;
begin
 if bors[symbol].accept[v] <> 0 then
  begin
   t := bors[symbol].accept[v];
   i := 0;
   while not (t = 0) do
    begin
     if t and 1 = 1 then
      rec (node,chr(ord('A')+i));
     t := t shr 1;
     inc(i);
    end;
  end;
 for c := 'a' to 'z' do
  if bors[symbol].e[v,c] > 0 then
   begin
    if node^.next[c] = nil then
     begin
      new(node^.next[c]);
      fillchar (node^.next[c]^,sizeof(node^),0);
     end;
    dfs (node^.next[c],bors[symbol].e[v,c]);
   end;
end;

begin
 if symbol = finish then
  begin
   if not node^.accept then
    inc(ans);
   node^.accept := true;
   exit;
  end;
 dfs (node,1);
end;

procedure solve;
var i,j :int;
    c :char;
    v :int;
    t :longint;
begin
 for c := 'A' to start do
  bors[c].m := 1;
 for i := 1 to n do
  with bors[rule[i].s] do
   begin
    v := 1;
    for j := 1 to rule[i].m do
     begin
      if e[v,rule[i].gamma[j]] = 0 then
       begin
        inc(m);
        e[v,rule[i].gamma[j]] := m;
       end;
      v := e[v,rule[i].gamma[j]];
     end;
    t := ord(rule[i].f) - ord('A');
    accept[v] := accept[v] or (1 shl t);
   end;
 findcycle (start);
 if used[finish] = 0 then
  exit;
 new (tree);
 fillchar (tree^,sizeof(tree^),0);
 rec (tree,start);
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.