{
  Dmitry Orlov
    SARATOV
    id = 33
}


{.$define debug}

{$R-,Q-,S-,I-,N+}


program template;
const
 nmax = 1000;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'synchro.in';
 coutfile= 'synchro.out';
 {$endif}
type
 int = longint;
 real = extended;
var
 n,m :int;
 gr :array [1..nmax,1..nmax] of int;
 bad :array [1..nmax] of boolean;
 used :array [1..nmax] of boolean;
 result :array [1..nmax] of boolean;
 paint :array [1..nmax] of byte;
 ans :int;

procedure init;
begin
 ans := 0;
 fillchar (gr,sizeof(gr),0);
 fillchar (bad,sizeof(bad),0);
 fillchar (used,sizeof(used),0);
 fillchar (result,sizeof(result),0);
 fillchar (paint,sizeof(paint),0);
end;

procedure readdata;
var i,j :int;
    u,v,z :int;
begin
 assign (input,cinfile);
 reset (input);
 read (n,m);
 for i := 1 to n do
  for j := 1 to n do
   gr[i,j] := -1;
 for i := 1 to m do
  begin
   read (u,v,z);
   if (gr[u,v] = -1) or (gr[u,v] > z) then
    gr[u,v] := z;
   if z = 0 then
    bad[v] := true;
  end;
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 for i := 1 to n do
  if result[i] then
   writeln (1)
  else
   writeln (0);
 close (output);
end;

function dfs (v :int):boolean;
var res :boolean;
    i :int;
begin
 if used[v] then
  begin
   dfs := not bad[v];
   exit;
  end;
 used[v] := true;
 if not bad[v] then
  begin
   dfs := true;
   exit;
  end;
 res := true;
 for i := 1 to n do
  if gr[i,v] = 0 then
   res := res and dfs(i);
 bad[v] := not res;
 dfs := res;
end;

function rec (v :int):boolean;
var i :int;
    res :boolean;
begin
 if bad[v] then
  begin
   rec := false;
   exit;
  end;
 if paint[v] > 0 then
  begin
   if paint[v] = 2 then
    rec := result[v]
   else
    rec := true;
   exit;
  end;
 paint[v] := 1;
 res := false;
 for i := 1 to n do
  if gr[v,i] > - 1 then
   begin
    res := true;
    break;
   end;
 for i := 1 to n do
  if gr[i,v] > -1 then
   res := res and rec(i);
 for i := 1 to n do
  if (gr[v,i] > -1) and not bad[i] then
   res := res and rec(i);
 result[v] := res;
 paint[v] := 2;
 rec := res;
end;

procedure solve;
var i,j :int;
begin
 for i := 1 to n do
  if not used[i] then
   dfs (i);
 for i := 1 to n do
  if paint[i] = 0 then
   rec(i);
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.