{
  Dmitry Orlov
    SARATOV
    id = 33
}


{.$define debug}

{$R-,Q-,S-,I-,N+}


program template;
const
 nmax = 250;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'merge.in';
 coutfile= 'merge.out';
 {$endif}
type
 int = longint;
 real = extended;
 tpair = record
  u,v :int;
 end;
var
 n,m,k :int;
 gr :array [1..nmax,1..nmax] of boolean;
 ex :array [1..nmax] of int;
 used :array [1..nmax] of boolean;
 d :int;
 pnt :array [1..nmax] of int;
 ans :int;
 graph :array [1..nmax,1..nmax] of boolean;
 powin,powout :array [1..nmax] of int;
 number :array [1..nmax] of int;
 p :array [1..nmax] of tpair;
 bad1,bad2 :array [1..nmax] of boolean;

procedure init;
begin
 ans := 0;
 fillchar (gr,sizeof(gr),0);
 fillchar (ex,sizeof(ex),0);
 fillchar (used,sizeof(used),0);
 fillchar (pnt,sizeof(pnt),0);
 fillchar (graph,sizeof(graph),0);
 fillchar (powout,sizeof(powout),0);
 fillchar (powin,sizeof(powin),0);
 fillchar (p,sizeof(p),0);
 fillchar (number,sizeof(number),0);
end;

procedure readdata;
var i,j :int;
    u,v :int;
begin
 assign (input,cinfile);
 reset (input);
 readln (n,m);
 for i := 1 to m do
  begin
   read (u,v);
   gr[u,v] := true;
  end;
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans);
 for i := 1 to ans do
  writeln (p[i].u,' ',p[i].v);
 close (output);
end;

procedure dfs (v :int);
var i :int;
begin
 if used[v] then
  exit;
 used[v] := true;
 pnt[v] := d;
 for i := 1 to n do
  if gr[i,v] then
   dfs(i);
 if d = 0 then
  begin
   inc(k);
   ex[k] := v;
  end;
end;

procedure trance;
var i,j :int;
    tmp :boolean;
begin
 for i := 1 to n-1 do
  for j := i+1 to n do
   begin
    tmp := gr[i,j];
    gr[i,j] := gr[j,i];
    gr[j,i] := tmp;
   end;
end;

procedure add (u,v :int);
var uu,vv :int;
    num :int;
    i,j :int;
begin
 for i := 1 to n do
  if pnt[i] = u then
   begin
    uu := i;
    break;
   end;
 for i := 1 to n do
  if pnt[i] = v then
   begin
    vv := i;
    break;
   end;
 inc(ans);
 p[ans].u := number[uu];
 p[ans].v := number[vv];
 if number[uu] < number[vv] then
  num := number[uu]
 else
  num := number[vv];
 number[uu] := num;
 number[vv] := num;
end;

procedure solve;
var i,j,u,v :int;
begin
 d := 0;
 for i := 1 to n do
  if not used[i] then
   dfs(i);
 fillchar (used,sizeof(used),0);
 trance;
 for i := n downto 1 do
  if not used[ex[i]] then
   begin
    inc(d);
    dfs(ex[i]);
   end;
 trance;
 for i := 1 to n do
  for j := 1 to n do
   if gr[i,j] and (pnt[i] <> pnt[j]) then
    graph[pnt[i],pnt[j]] := true;
 for i := 1 to d do
  for j := 1 to d do
   if graph[i,j] then
    begin
     inc(powout[i]);
     inc(powin[j]);
    end;
 for i := 1 to d do
  begin
   bad1[i] := powin[i] = 0;
   bad2[i] := powout[i] = 0;
  end;
 for i := 1 to n do
  number[i] := i;
 for i := 1 to d do
  if bad1[i] and not bad2[i] then
   for j := 1 to d do
    if bad2[j] and not bad1[j] then
     begin
      add (i,j);
      bad1[i] := false;
      bad2[j] := false;
      break;
     end;
 for i := 1 to d do
  if bad1[i] or bad2[i] then
   for j := 1 to d do
    if not (i = j) and (bad1[i] or bad2[i]) then
     begin
      add(i,j);
      bad1[i] := false;
      bad2[i] := false;
      bad1[j] := false;
      bad2[j] := false;
      break;
     end;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.