uses game;

const MaxN = 50;
      MaxStates = 3628799;

type Tstat = array[0..30] of integer;

var n,gn: longint;
    sts: array[0..MaxStates-1] of byte;
    next,prev: array[1..50] of integer;
    mark: array[1..50] of boolean;
    gs,gi: array[0..50] of integer;
    cur: Tstat;
    ci,cj: integer;

procedure Swap(var a,b:integer);
var c: integer;
begin
  c:=a; a:=b; b:=c;
end;

procedure del(i,j: integer);
begin
  prev[next[i]]:=prev[j];
  next[prev[j]]:=next[i];
  next[prev[i]]:=next[j];
  prev[next[j]]:=prev[i];
  prev[i]:=0; next[i]:=0;
  prev[j]:=0; next[j]:=0;
end;

function PosID(var st: Tstat):longint;
var i: integer;
    id: longint;
begin
  id:=0;
  For i:=1 to st[0] do
    id:=(id+st[i]*61) mod maxstates;
  PosID:=id;
end;

function dfs(var s:Tstat;first:boolean):byte;
var tst: Tstat;
    id: longint;
    i,j,k,t: integer;
    flag: boolean;
begin
  id:=PosID(s);
  if sts[id]>0 then begin
    dfs:=sts[id];
    exit;
  end;
  if s[0]=0 then begin
    sts[id]:=2;
    dfs:=sts[id];
    exit;
  end;
  flag:=false;
  For i:=1 to s[0] do
    For j:=0 to (s[i]-2) div 2 do begin
      For k:=0 to s[0] do
        tst[k]:=s[k];
      if (j<=1) and (tst[i]-j-2<=1) then begin
        dec(tst[0]);
        For k:=i to tst[0] do
          tst[k]:=tst[k]+1;
      end else
      if (j<=1) then begin
        tst[i]:=tst[i]-j-2;
        k:=i;
        while (k>1) and (tst[k-1]>tst[k]) do begin
          swap(tst[k],tst[k-1]);
          dec(k);
        end;
      end else begin
        inc(tst[0]);
        tst[tst[0]]:=j;
        tst[i]:=tst[i]-j-2;
        k:=i;
        while (k>1) and (tst[k-1]>tst[k]) do begin
          swap(tst[k],tst[k-1]);
          dec(k);
        end;
        k:=tst[0];
        while (k>1) and (tst[k-1]>tst[k]) do begin
          swap(tst[k],tst[k-1]);
          dec(k);
        end;
      end;
      if dfs(tst,false)=1 then begin
        flag:=true;
        if first then begin
          ci:=i;
          cj:=j;
        end;
      end;
    end;
  if flag then sts[id]:=2 else sts[id]:=1;
  dfs:=sts[id];
end;

var i,j,k: integer;

begin
  n:=init;
  For i:=1 to n-1 do
    next[i]:=i+1;
  next[n]:=1;
  For i:=2 to n do
    prev[i]:=i-1;
  prev[1]:=n;
  repeat
    For i:=1 to n do
      if (next[i]>0) and (not mark[i]) and (next[i]<>i) then begin
        inc(gn);
        gi[gn]:=i; gs[gn]:=1;
        j:=next[i];
        mark[i]:=true;
        while j<>gi[gn] do begin
          inc(gs[gn]);
          mark[j]:=true;
          j:=next[j];
        end;
      end;
    For i:=2 to gn do begin
      j:=i;
      while (gs[j]<gs[j-1]) and (j>1) do begin
        Swap(gs[j],gs[j-1]);
        Swap(gi[j],gi[j-1]);
        dec(j);
      end;
    end;
    fillchar(cur,sizeof(cur),0);
    cur[0]:=gn;
    For i:=1 to gn do
      cur[i]:=gs[i];
    ci:=1; cj:=0;
    dfs(cur,true);
    i:=gi[ci];
    j:=next[i];
    For k:=1 to cj do
      j:=next[j];
    move(i,j,ci,cj);
    del(i,j);
    del(ci,cj);
  until false;
end.
