program Nice2;

var
  n : string;
  mat : array [1..1000] of boolean;
  ms : longint;
  m,p : longint;
  s : longint;
  sol,tmp : array [0..31,0..31] of longint;

procedure Inp;
var
  c : char;
  i : integer;
begin
  assign(input,'nice.in'); reset(input);
  assign(output,'nice.out'); rewrite(output);
  n := '';
  repeat
    read(c);
    if c=' ' then break;
    n := n+c;
  until false;
  read(m,p);
  s := 1;
  for i:=1 to m do
    s:=s*2;
end;

procedure Div2;
var
  ow : integer;
  cur : integer;
  i : integer;
begin
  ow := 0;
  for i:=1 to length(n) do
  begin
    cur := ow*10 + ord(n[i]) - ord('0');
    ow := cur mod 2;
    cur := cur div 2;
    n[i] := chr(cur + ord('0'));
  end;
  if n[1]='0' then delete(n,1,1);
end;

procedure Degenerate;
begin
  ms := 0;
  while n<>'1' do
  begin
    inc(ms);
    case n[length(n)] of
      '1','3','5','7','9':
      begin
        mat[ms] := true;
        dec(n[length(n)]);
        div2;
      end;
      '0','2','4','6','8':
      begin
        mat[ms] := false;
        div2;
      end;
    end;
  end;
end;

function baad(a,b : integer) : boolean;
var
  bitsa,bitsb : array [1..5] of integer;
  i : integer;
begin
  baad := true;
  for i:=1 to m do
  begin
    bitsa[i] := a mod 2;
    bitsb[i] := b mod 2;
    a := a div 2;
    b := b div 2;
    if (i>1) and (bitsa[i]=bitsa[i-1]) and (bitsb[i]=bitsb[i-1])
    and (bitsa[i]=bitsb[i]) then exit;
  end;
  baad := false;
end;

procedure Mul2;
var
  pat1,pat2 : integer;
  i,j : integer;
begin
  tmp := sol;
  fillchar(sol,sizeof(sol),0);
  for pat1:=0 to s-1 do
  for pat2:=0 to s-1 do
  begin
    if baad(pat1,pat2) then continue;
    for i:=0 to s-1 do
    for j:=0 to i do
    begin
      sol[i,j] := (sol[i,j] + tmp[i,pat1]*tmp[pat2,j]) mod p;
    end;
  end;
{  for pat1:=0 to s-1 do
  begin
    pat2 := pat1;
    if baad(pat1,pat2) then continue;
    for i:=0 to s-1 do
    for j:=0 to i do
    begin
      sol[i,j] := (sol[i,j] + tmp[i,pat1]*tmp[pat2,j]) mod p;
    end;
  end;}
  for i:=0 to s-1 do
  for j:=i+1 to s-1 do
    sol[i,j] := sol[j,i];
end;

procedure Inc1;
var
  pat1,pat2,i : integer;
begin
  tmp := sol;
  fillchar(sol,sizeof(sol),0);
  for pat1:=0 to s-1 do
  for pat2:=0 to s-1 do
  begin
    if baad(pat1,pat2) then continue;
    for i:=0 to s-1 do
    begin
      sol[i,pat2] := (sol[i,pat2] + tmp[i,pat1]) mod p;
    end;
  end;
end;

procedure Super;
var
  i,j : integer;
begin
  fillchar(sol,sizeof(sol),0);
  for i:=0 to s-1 do
  for j:=0 to s-1 do
    if baad(i,j) then
      sol[i,j] := 1;
end;

procedure Run;
var
  i : integer;
begin
  Degenerate;
  fillchar(sol,sizeof(sol),0);
  for i:=0 to s-1 do
    sol[i,i] := 1;
  for i:=ms downto 1 do
  begin
    Mul2;
    if mat[i] then
      Inc1;
  end;
end;

procedure Outp;
var
  ss : longint;
  i,j : integer;
begin
  ss := 0;
  for i:=0 to s-1 do
  for j:=0 to s-1 do
    ss := (ss + sol[i,j]) mod p;
  writeln(ss);
  close(input); close(output);
end;

begin
  Inp;
  Run;
  Outp;
end.