program taskD;

const
  MaxN = 20000;  {20000}
  MaxM = 200000; {200000}

type TConn = record
A,B : Longint;
end;

var
  N,M : Longint;
  GA,GL : array [1 .. MaxN] of Longint;
  GB : array [1 .. MaxM] of TConn;
  V : array [1 .. MaxN] of Longint;
  Cur : Longint;

procedure DFS_Work(A : Longint);
var
  B : Longint;
begin
  V[A] := Cur;
  B := GA[A];
  while B<>0 do
  begin
    if V[GB[B].A]=0 then DFS_Work(GB[B].A);
    B := GB[B].B;
  end;
end;

procedure DFS;
var
  A : Longint;
begin
  FillChar(V,sizeof(V),0);
  Cur := 0;
  for A:=1 to N do
    if V[A]=0 then
    begin
      Inc(Cur);
      DFS_Work(A);
    end;
end;

procedure Inp;
var
  i : longint;
  gc : LONGINT;
  a,b : longint;
begin
  assign(input,'d.in'); reset(input);
  assign(output,'d.out'); rewrite(output);
  read(N,M);
  gc := 0;
  fillchar(ga,sizeof(ga),0);
  for i:=1 to m do
  begin
    read(a,b);
    inc(gc);
    gb[gc].a := b;
    gb[gc].b := 0;
    if ga[a]=0 then begin ga[a] := gc; gl[a] := gc; end else
    begin gb[gl[a]].b := gc; gl[a] := gc; end;
    inc(gc);
    gb[gc].a := a;
    gb[gc].b := 0;
    if ga[b]=0 then begin ga[b] := gc; gl[b] := gc; end else
    begin gb[gl[b]].b := gc; gl[b] := gc; end;
  end;
end;

procedure Outp;
var
  i : longint;
begin
  writeln(Cur);
  for i:=1 to N do
    write(v[i],' ');
  close(input); close(output);
end;

begin
  Inp;
  DFS;
  Outp;
end.