program taskD;

const
  MaxN = 20000;  {20000}
  MaxM = 200000; {200000}

type TConn = record
A,B,C,T : Longint;
end;

var
  N,M : Longint;
  GA,GL : array [1 .. MaxN] of Longint;
  GB : array [1 .. MaxM] of TConn;
  gc : longint;
  V : array [1 .. MaxN] of Longint;
  rotate : boolean;
  par : array [1..maxn] of longint;
  P : array [1..MaxN] of Longint;
  PSize : Longint;
  Cur : longint;

procedure con_add(a,b : longint);
begin
  inc(gc);
  gb[gc].a := b;
  gb[gc].b := 0;
  gb[gc].t := a;
  if ga[a]=0 then
  begin
    gb[gc].c := 0;
    ga[a] := gc;
    gl[a] := gc;
  end else
  begin
    gb[gc].c := gl[a];
    gb[gl[a]].b := gc;
    gl[a] := gc;
  end;
end;

procedure con_delete(a,b : longint);
var
  t1,t2 : longint;
begin
  if b=ga[a] then
  begin
    if b=gl[a] then
    begin
      ga[a] := 0;
      gl[a] := 0;
    end
    else
      ga[a] := gb[b].b;
      gb[ga[a]].c := 0;
  end else
  if b=gl[a] then
  begin
    gl[a] := gb[b].c;
    gb[gl[a]].b := 0;
  end else
  begin
    t1 := gb[b].c;
    t2 := gb[b].b;
    gb[t1].b := t2;
    gb[t2].c := t1;
  end;
end;

procedure DFS_Work(A : Longint);
var
  B : Longint;
begin
  V[A] := Cur;
  B := GA[A];
  while B<>0 do
  begin
    if V[GB[B].A]=0 then
    begin
      if rotate then con_delete(a,b);
      par[gb[b].a] := a;
      DFS_Work(GB[B].A);
    end;
    B := GB[B].B;
  end;
  Inc(PSize);
  P[PSize] := A;
end;

procedure DFS;
var
  A : Longint;
begin
  FillChar(V,sizeof(V),0);
  Cur := 1;
  if rotate then
    DFS_Work(1)
  else
  begin
    Cur := 0;
    for A:=PSize downto 1 do
      if V[p[a]]=0 then
      begin
        Inc(Cur);
        DFS_Work(p[a]);
      end;
  end;
end;

procedure Inp;
var
  i : longint;
  a,b : longint;
begin
  assign(input,'e.in'); reset(input);
  assign(output,'e.out'); rewrite(output);
  read(N,M);
  gc := 0;
  fillchar(ga,sizeof(ga),0);
  for i:=1 to m do
  begin
    read(a,b);
    con_add(a,b);
    con_add(b,a);
  end;
end;

procedure Run;
begin
  psize := 0;
  rotate := true;
  dfs;
  rotate := false;
  dfs;
end;

procedure Outp;
var
  i : longint;
  b : longint;
begin
  b := 0;
  for i:=1 to gc div 2 do
  begin
    if v[gb[2*i].a]<>v[gb[2*i].t] then
      inc(b);
  end;
  writeln(b);
  for i:=1 to gc div 2 do
  begin
    if v[gb[2*i].a]<>v[gb[2*i].t] then
      writeln(i);
  end;
  close(input); close(output);
end;

begin
  Inp;
  Run;
  Outp;
end.