Const
  InFileName='nice.in';
  OutFileName='nice.out';
  MaxM=5;
  MaxLen=100;
  MaxKol=32;



Var
  Fail:Text;
  N:Array[1..MaxLen] Of LongInt;
  L:LongInt;
  NN:String;
  M:LongInt;
  P:LongInt;
  K:Integer;
  G:Array[1..MaxKol,1..MaxKol] Of Boolean;
  Otv:LongInt;
  F:Array[0..MaxLen,1..MaxKol,1..MaxKol] Of LongInt;

Procedure Get;
Var
  I:Integer;
  S:String;
  PP:Integer;
  Code:Integer;
  Begin
    Assign(Fail,InFileName);
    ReSet(Fail);
    ReadLn(Fail,S);
    PP:=Pos(' ',S);
    L:=PP-1;
    For I:=1 To PP-1 Do Begin
      Val(S[I],N[I],Code);
    End;
    Delete(S,1,PP);
    Val(S[1],M,Code);
    Delete(S,1,2);
    Val(S,P,Code);

    Close(Fail);
  End;


Function To2(Z:LongInt):String;
Var
  I:Integer;
  X:LongInt;
  S:String;
  Cur:Integer;
  Begin
    X:=Z;
    S:='';
    For I:=1 To M Do Begin
      Cur:=X Mod 2;
      X:=X Div 2;
      If Cur=1 Then S:='1'+S Else S:='0'+S;
    End;
    To2:=S;
  End;

Procedure Save;
  Begin
    Assign(Fail,OutFileName);
    ReWrite(Fail);
    WriteLn(Fail,Otv);
    Close(Fail);
    Halt;
  End;


Function Good(S1,S2:String):Boolean;
Var
  I:Integer;
  GG:Boolean;
  Begin
    GG:=True;
    For I:=1 To K-1 Do Begin
      If (S1[I]=S2[I]) And (S1[I]=S1[I+1]) And (S1[I]=S2[I+1]) Then Begin
        GG:=False;
        Break;
      End;
    End;
    Good:=GG;
  End;

Procedure Solve;
Var
  I,J,Q,II,JJ,QQ:LongInt;
  N1,N2:Array[1..MaxKol,1..MaxKol] Of LongInt;
  Sum:Array[1..MaxKol,1..MaxKol] Of LongInt;

  GG:Boolean;
  S1,S2:String;
  SS:Array[1..MaxKol] Of LongInt;
  Cur:LongInt;
  Fig:Array[1..MaxLen,0..9] Of LongInt;
  Begin
    If M=1 Then Begin
      Otv:=1;
      Cur:=1;
      For I:=0 To 9 Do Begin
        Fig[1,I]:=Cur;
        Cur:=(Cur*2) Mod P;
      End;
      For I:=2 To L Do Begin
        Fig[I,0]:=1;
        Cur:=(Fig[I-1,9]*Fig[I-1,1]) Mod P;
        For J:=1 To 9 Do Begin
          Fig[I,J]:=Cur;
          Cur:=(Cur*Fig[I,1]) Mod P;
        End;
      End;
      For I:=1 To L Do Begin
        Otv:=(Otv*Fig[I,N[L-I+1]]) Mod P;
      End;

        Save;

    End;


    FillChar(G,SizeOf(G),True);
    Case M Of
      1:K:=2;
      2:K:=4;
      3:K:=8;
      4:K:=16;
      5:K:=32;
    End;
    For I:=1 To K Do Begin
      For J:=1 To K Do Begin

        S1:=To2(I-1);
        S2:=To2(J-1);
        GG:=True;
        For II:=1 To M Do Begin
          If (S1[II]=S2[II]) And (S1[II]=S1[II+1]) And (S1[II]=S2[II+1]) Then Begin
            GG:=False;
            Break;
           End;
        End;

        G[I,J]:=GG;{Good(To2(I-1),To2(J-1));}
      End;
    End;

    For I:=1 To K Do Begin
      For J:=1 To K Do Begin
        If I=J Then F[0,I,J]:=1 Else F[0,I,J]:=0;
      End;
    End;
    For I:=1 To L-1 Do Begin
      For J:=1 To K Do Begin
        For Q:=1 To K Do Begin
          N1[J,Q]:=F[I-1,J,Q];
          N2[J,Q]:=0;
        End;
      End;
      For J:=1 To 9 Do Begin
        For II:=1 To K Do Begin
          For JJ:=1 To K Do Begin
            If G[II,JJ] Then Begin
              For Q:=1 To K Do Inc(N2[II,Q],N1[JJ,Q]);
            End;
          End;
        End;
        For II:=1 To K Do Begin
          For Q:=1 To K Do Begin
            N1[II,Q]:=N2[II,Q];
            N2[II,Q]:=0;
          End;
        End;
      End;
      For J:=1 To K Do Begin
        For Q:=1 To K Do F[I,J,Q]:=N1[J,Q] Mod P;
      End;
    End;

    FillChar(Sum,SizeOf(Sum),0);
    For I:=1 To K Do Begin
      For J:=1 To K Do Sum[I,J]:=F[0,I,J];
    End;
    For I:=1 To L Do Begin
      For J:=1 To K Do Begin
        For Q:=1 To K Do Begin
          N1[J,Q]:=Sum[J,Q];
          N2[J,Q]:=0;
        End;
      End;
      For J:=1 To N[L-I+1] Do Begin

{-------------}
        For II:=1 To K Do Begin
          For JJ:=1 To K Do Inc(SS[II],Sum[II,JJ]);
          SS[II]:=SS[II] Mod P;
        End;

        For II:=1 To K Do Begin
          For JJ:=1 To K Do Begin
{            If G[II,JJ] Then Begin}
{              For Q:=1 To K Do Inc(N2[II,Q],N1[JJ,Q]);}
{            End;}
            N2[II,JJ]:=SS[II]*F[L-I+1,II,JJ];
          End;
        End;
        For II:=1 To K Do Begin
          For Q:=1 To K Do Begin
            N1[II,Q]:=N2[II,Q];
            N2[II,Q]:=0;
          End;
        End;
      End;

      If N[L-I+1]<>0 Then Begin
        For J:=1 To K Do Begin
          For Q:=1 To K Do {Sum[J,Q]:=N1[J,Q];}Inc(Sum[J,Q],N1[J,Q]);
        End;
        For J:=1 To K Do Begin
          For Q:=1 To K Do Sum[J,Q]:=Sum[J,Q] Mod P;
        End;
      End;
    End;

    Otv:=0;
    For I:=1 To K Do Begin
      For J:=1 To K Do Inc(Otv,Sum[I,J]);
      Otv:=Otv Mod P;
    End;
  End;

Begin
  Get;
  Solve;
  Save;
End.


























