type
  tReb=record
    X,Y,LastX,LastY:Integer;
  end;

var
  Reb:array[1..200000]of tReb;
  Last:array[1..20000]of Longint;
  Mark:array[1..20000]of Integer;
  Qu,O:array[1..20000]of Integer;
  N,M,N1,L:Longint;

procedure OpenFiles;
begin
  assign(input,'e.in');
  assign(output,'e.out');
  reset(input);
  rewrite(output);
end;

procedure CloseFiles;
begin
  close(input);
  close(output);
end;

procedure DFS(Q:Longint);
var
  K,K1,K2:Longint;

begin
  K:=Last[Q];
  inc(N1);
  Qu[N1]:=Q;
  Mark[Q]:=1;
  while K<>0 do
  begin
    if Reb[K].X = Q then
    begin
      K1:=Reb[K].Y;
      K2:=Reb[K].LastX;
    end
    else
    begin
      K1:=Reb[K].X;
      K2:=Reb[K].LastY;
    end;
    if Mark[K1]=0 then
    begin
      O[K]:=K1;
      DFS(K1);
    end;
    K:=K2;
  end;
end;

procedure DFS2(Q:Longint);
var
  K,K1,K2:Longint;

begin
  K:=Last[Q];
  Mark[Q]:=L;
  while K<>0 do
  begin
    if Reb[K].X = Q then
    begin
      K1:=Reb[K].Y;
      K2:=Reb[K].LastX;
    end
    else
    begin
      K1:=Reb[K].X;
      K2:=Reb[K].LastY;
    end;
    if (Mark[K1]=0)and((O[K]=0)or(O[K]=Q)) then
      DFS2(K1);
    K:=K2;
  end;
end;

procedure Solve;
var
  I:Longint;

begin
  read(N,M);
  fillchar(Last,sizeof(Last),0);
  for I:=1 to M do
  begin
    read(Reb[I].X,Reb[I].Y);
    Reb[I].LastX:=Last[Reb[I].X];
    Reb[I].Lasty:=Last[Reb[I].Y];
    Last[Reb[I].X]:=I;
    Last[Reb[I].Y]:=I;
  end;
  fillchar(mark,sizeof(mark),0);
  fillchar(O,SizeOf(O),0);
  N1:=0;
  DFS(1);
  fillchar(mark,sizeof(mark),0);
  L:=0;
  for I:=1 to N do
    if Mark[Qu[I]]=0 then
    begin
      inc(L);
      DFS2(Qu[I]);
    end;
  writeln(L-1);
  for I:=1 to M do
    if Mark[Reb[I].X]<>Mark[Reb[I].Y] then
      writeln(I);
end;

begin
  OpenFiles;
  Solve;
  CloseFiles;
end.
