#include <stdio.h>

int n, prev[400000L],next[400000L],h[20000],r[400000L],mark[20000],
   s[400000L],queue[20000],size;
long x,m,col;
void add(int x,int y)
{
  if(h[x]!=-1)
    prev[h[x]]=y;
  next[y]=h[x];
  prev[y]=-1;
  h[x]=y;
}
void read(void)
{
  int i,a,b;
  long mm=0;
  scanf("%d%ld",&n,&m);
  for(i=0;i<n;i++)
    h[i]=-1;
  for(i=0;i<m;i++)
  {
    scanf("%d%d",&a,&b);
    a--;
    b--;
    r[mm]=b;
    s[mm]=a;
    mm++;
    r[mm]=a;
    s[mm]=b;
    mm++;
    add(a,mm-2);
    add(b,mm-1);
  }
}
void del(int k,int x)
{
  long nn,p;
  if(x==h[k])
  {
    h[k]=next[x];
  }
  else
  {
    p=prev[x];
    nn=next[x];
    next[p]=next[x];
    prev[nn]=p;
  }
}

void dfs(int v)
{
  long i=h[v];
  if(mark[v]!=0)
	return;
  mark[v]=col;
  x++;
  /*
  num[v]=time;
  time++;
  */
  queue[size++]=v;
  while(i!=-1)
  {
	if(mark[r[i]]==0)
	{
	  dfs(r[i]);
	  del(v,i);
	}
	i=next[i];
  }
}
void solve(void)
{
  long i,j=0;
  for(i=0;i<n;i++)
	mark[i]=0;
  dfs(0);
  for(i=0;i<n;i++)
	mark[i]=0;
  col=1;
  for(;j<n;j++)
	if(mark[queue[j]]==0)
	{
	  dfs(queue[j]);
	  col++;
	}
}
int main(void)
{
  long i,j;
  freopen("e.in","rt",stdin);
  freopen("e.out","wt",stdout);
  read();
  size=0;
  col=1;
  solve();
  printf("%d\n",col-2);
  for(i=0;i<m;i++)
  {
	if(mark[r[i*2]]!=mark[s[i*2]])
	  printf("%ld\n",i+1);
  }
  return 0;
}

