program Print;

const
  MaxL = 5005; {5005}

var
  L : Integer;
  S : array [1 .. MaxL] of Char;
  Shift : Integer;
  Sol : array [0 .. MaxL] of Longint;
  How : array [0 .. MaxL] of Longint;
  P : array [0 .. MaxL] of Longint;
  Suits : array [0 .. MaxL,0 .. MaxL div 2 + 10] of Boolean;

procedure Inp;
var
  c : char;
begin
  assign(input,'print.in'); reset(input);
  assign(output,'print.out'); rewrite(output);
  L := 0;
  while not (eoln or eof) do
  begin
    Read(C);
    Inc(L);
    S[L] := C;
  end;
end;

function T(Ind : Integer) : Char;
begin
  if Ind<=L-Shift then
    T := S[Ind+Shift]
  else
    T := S[Ind+Shift-L];
end;

procedure Find_P;
var
  K : Integer;
  I : Integer;
begin
  P[0] := 0;
  P[1] := 0;
  for I := 2 to L do
  begin
    K := P[I-1];
    while (K>0) and (T(K+1)<>T(I)) do
      K := P[K];
    if T(K+1)=T(I) then Inc(K);
    P[I] := K;
  end;
end;

procedure Count_Suits;
var
  I,J : Integer;
begin
  fillchar(Suits,sizeof(Suits),0);
  for I:=1 to L do
  begin
    Shift := I-1;
    Find_P;
    J := P[L];
    while (J<>0) do
    begin
      if (I+J-1<=L) and (I-J>=1) then
         Suits[I,J] := True;
      J := P[J];
    end;
  end;
end;

procedure Run;
var
  i : integer;
  j : integer;
begin
  Count_Suits;
  Sol[0] := 0;
  for i:=1 to L do
  begin
    Sol[i] := 1+Sol[i-1];
    How[i] := 0;
    for j:=1 to L div 2+1 do
    begin
      if i-2*j<0 then break;
      if not Suits[i-j+1,j] then continue;
      if Sol[i] > Sol[i-j] + 1 then
      begin
        How[i] := j;
        Sol[i] := Sol[i-j] + 1;
      end;
    end;
  end;
end;

procedure Outp;
var
  Res : Longint;
  I : Longint;
  Cur : Longint;
  Curs : array [1 .. MaxL] of Longint;
  Otmot : array [1 .. MaxL] of Longint;
  OtSize : Longint;
begin
  Res := Sol[L];
  writeln(Res+1);
  Cur := L;
  OtSize := 0;
  while Cur>0 do
  begin
    Inc(Otsize);
    Curs[Otsize] := Cur;
    Otmot[Otsize] := How[Cur];
    if How[Cur] = 0 then Dec(Cur) else Cur := Cur - How[Cur];
  end;
  for I:=OtSize downto 1 do
  begin
    if Otmot[I]=0 then
      Writeln('Letter(''',S[Curs[I]],''');')
    else
      Writeln('Repeat(',Otmot[I],');');
  end;
  writeln('End.');
  close(input); close(output);
end;

begin
  Inp;
  Run;
  Outp;
end.