program Common;

const
  maxl = 4002; {4002}

type
  pborelem = ^tborelem;
  tborelem = record
               c : array ['0'..'1'] of pborelem;
               data : longint;
               sb,se : integer;
             end;
  tbor = pborelem;

var
  l1,l2,l3 : longint;
  s1,s2,s3 : array [1 .. maxl] of char;
  k : longint;
  S : longint;
  bor1,bor2 : tbor;

procedure b_empty(var b : tbor);
begin
  new(b);
  b^.c['0'] := nil;
  b^.c['1'] := nil;
  b^.data := 0;
  b^.sb := 0;
  b^.se := 0;
end;

procedure b_addstring(b : tbor;startpos : integer);
var
  t,tt : pborelem;
  c,cc,oc : char;
  k : pborelem;
  good : boolean;
  len1,len2 : integer;
  j : integer;
begin
  if startpos>l3 then exit;
  c := s3[startpos];
  if b^.c[c]=nil then
  begin {add}
    new(t);
    t^.c['0'] := nil;
    t^.c['1'] := nil;
    t^.sb := startpos;
    t^.se := l3;
    b^.c[c] := t;
  end
  else
  begin
    k := b^.c[c];
    len1 := l3 - startpos + 1;
    len2 := k^.se - k^.sb + 1;
    if len1<=len2 then
    begin
      good := true;
      for j:=1 to len1 do
      begin
        if s3[startpos-1+j]<>s3[k^.sb-1+j] then
        begin
          good := false;
          break;
        end;
      end;
      if not good then
      begin
        oc := c;
        c := s3[k^.sb-1+j];
        cc := s3[startpos-1+j];
        new(t);
        t^.c[c] := k;
        t^.c[cc] := nil;
        t^.sb := k^.sb;
        t^.se := k^.sb-2+j;
        k^.sb := t^.se+1;
        b^.c[oc] := t;
        b_addstring(t,startpos-1+j);
      end;
    end
    else
    begin
      good := true;
      for j:=1 to len2 do
      begin
        if s3[startpos-1+j]<>s3[k^.sb-1+j] then
        begin
          good := false;
          break;
        end;
      end;
      if not good then
      begin
        oc := c;
        c := s3[k^.sb-1+j];
        cc := s3[startpos-1+j];
        new(t);
        t^.c[c] := k;
        t^.c[cc] := nil;
        t^.sb := k^.sb;
        t^.se := k^.sb-2+j;
        k^.sb := t^.se+1;
        b^.c[oc] := t;
        b_addstring(t,startpos-1+j);
    end
    else
      b_addstring(k,startpos+len2);
    end;
  end;
end;

function b_maxlen(b : tbor;startpos : integer) : integer;
var
  c,cc,oc : char;
  k : pborelem;
  good : boolean;
  len1,len2 : integer;
  j : integer;
begin
  c := s3[startpos];
  if b^.c[c]=nil then
    b_maxlen := 0
  else
  begin
    k := b^.c[c];
    len1 := l3 - startpos + 1;
    len2 := k^.se - k^.sb + 1;
    if len1<=len2 then
    begin
      good := true;
      for j:=1 to len1 do
      begin
        if s3[startpos-1+j]<>s2[k^.sb-1+j] then
        begin
          good := false;
          break;
        end;
      end;
      if good then
        b_maxlen := len1
      else
        b_maxlen := j-1;
    end
    else
    begin
      good := true;
      for j:=1 to len2 do
      begin
        if s3[startpos-1+j]<>s2[k^.sb-1+j] then
        begin
          good := false;
          break;
        end;
      end;
      if good then
        b_maxlen := len2 + b_maxlen(k,startpos+len2)
      else
        b_maxlen := j-1;
    end;
  end;
end;

procedure Inp;
var
  C : Char;
begin
  assign(input,'common.in'); reset(input);
  assign(output,'common.out'); rewrite(output);
  L1 := 0;
  while not (eoln or eof) do
  begin
    Read(C);
    Inc(L1);
    S1[L1] := C;
  end;
  readln;
  L2 := 0;
  while not (eoln or eof) do
  begin
    Read(C);
    Inc(L2);
    S2[L2] := C;
  end;
  read(k);
end;

procedure find_data(b : tbor);
begin
  b^.data := b^.se - b^.sb + 1;
  if b^.c['0']<>nil then
  begin
    find_data(b^.c['0']);
    b^.data := b^.data + b^.c['0']^.data;
  end;
  if b^.c['1']<>nil then
  begin
    find_data(b^.c['1']);
    b^.data := b^.data + b^.c['1']^.data;
  end;
end;

function span_out(b : tbor) : boolean;
var
  i : integer;
begin
  if k<=b^.se-b^.sb+1 then
  begin
    for i:=1 to k do
      write(s1[i+b^.sb-1]);
    span_out := false;
  end
  else
  begin
    for i:=b^.sb to b^.se do
      write(s1[i]);
    k := k + b^.sb - b^.se - 1;
    span_out := true;
  end;
end;

procedure find(b : tbor);
var
  t : tbor;
begin
  if b^.c['0'] = nil then
  begin
    if span_out(b^.c['1']) then
      find(b^.c['1']);
  end else
  if b^.c['1'] = nil then
  begin
    if span_out(b^.c['0']) then
      find(b^.c['0']);
  end else
  begin
    if k>b^.c['0']^.data then
    begin
      k := k - b^.c['0']^.data;
      if span_out(b^.c['1']) then
        find(b^.c['1']);
    end
    else
    begin
      if span_out(b^.c['0']) then
        find(b^.c['0']);
    end;
  end;
end;

procedure Run;
var
  i,j : integer;
begin
  l3 := l2;
  s3 := s2;
  b_empty(bor2);
  for i:=1 to l2 do
    b_addstring(bor2,i);
  l3 := l1;
  s3 := s1;
  b_empty(bor1);
  for i:=1 to l1 do
  begin
    l3 := l1;
    l3 := b_maxlen(bor2,i) - 1 + i;
    if l3>=i then
      b_addstring(bor1,i);
  end;
  find_data(bor1);
  find(bor1);
  writeln;
end;

procedure Outp;
begin
  close(input); close(output);
end;

begin
  Inp;
  Run;
  Outp;
end.