{.$define debug}

program template;
const
 h = 50000;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = '2strings.in';
 coutfile = '2strings.out';
 {$endif}
type
 int = longint;
 tstr = array [1..h] of char;
 bigstr = array [1..2*h] of char;
var
 a,b :^tstr;
 n,m :int;
 k :int;
 d :bigstr;

procedure init;
begin
 new (a);
 new (b);
 fillchar (a^,sizeof(a^),0);
 fillchar (b^,sizeof(b^),0);
 n := 0;
 m := 0;
end;

procedure readdata;
var i,j :int;
    c :char;
begin
 assign (input,cinfile);
 reset (input);
 while not eoln do
  begin
   read (c);
   inc (n);
   a^[n] := c;
  end;
 readln;
 while not eoln do
  begin
   read (c);
   inc (m);
   b^[m] := c;
  end;
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 for i := 1 to k do
  write (d[i]);
 close (output);
end;

procedure makestring (var a,b :tstr; n,m :int; var res :bigstr;
         var len :int);
var x :bigstr;
    l  :array [1..2*h] of int;
    i,j :int;
    k :int;
begin
 fillchar (res,sizeof(res),0);
 fillchar (x,sizeof(x),0);
 move (b,x,m);
 move (a,x[m+1],n);
 k := m+n;
 fillchar (l,sizeof(l),0);
 for i := 1 to k-1 do
  begin
   len := l[i];
   while not (x[len+1] = x[i+1]) and
    (len > 0) do
     len := l[len];
   if x[len+1] = x[i+1] then
    l[i+1] := len + 1;
  end;
 move (a,res,n);
 len := n;
 for i := 1+l[k] to m do
  begin
   inc (len);
   res[len] := b[i];
  end;
end;

procedure solve;
var i,j :int;
    d1,d2 :bigstr;
    k1,k2 :int;
begin
 fillchar (d1,sizeof(d1),0);
 fillchar (d2,sizeof(d2),0);
 makestring (a^,b^,n,m,d1,k1);
 makestring (b^,a^,m,n,d2,k2);
 if k1 < k2 then
  begin
   d := d1;
   k := k1;
  end
 else
  begin
   d := d2;
   k := k2;
  end;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.