const infile = '2strings.in'; outfile = '2strings.out'; max = 50005;
type mas = array [1..max] of char;
     mas2 = array [1..max*2] of char;
var a,b,tmp_m,ans_m: mas;
    s: mas2;
    n,m,tmp_c,ans_c,cs: longint;
    d: array [1..max] of longint;

procedure init;
var ch: char;
begin
     assign(input,infile);
     reset(input);
     read(ch); n:=0;
     while not seekeoln do begin
           inc(n); a[n]:=ch; read(ch); end;
     inc(n); a[n]:=ch;
     readln;
     read(ch); m:=0;
     while (not seekeoln)and(not seekeof) do begin
           inc(m); b[m]:=ch; read(ch); end;
     inc(m); b[m]:=ch;
     close(input);
end;

procedure calc_suffix;
var i,k: longint;
begin
     fillchar(d,SizeOf(d),0);
     d[1]:=0;
     for i:=2 to m do begin
         k:=d[i-1];
         if b[i] = b[k+1] then d[i]:=d[i-1]+1
            else begin
                 while (k > 0)and(b[i] <> b[k+1]) do k:=d[k];
                 if b[i] = b[k+1] then d[i]:=k+1
                    else d[i]:=0;
            end;
     end;
end;

procedure transf(var q1: mas2; q2: mas; h: longint);
var i: longint;
begin
     fillchar(q1,SizeOf(q1),0);
     for i:=1 to h do q1[i]:=q2[i];
end;

procedure kmp_addon(var ns: mas2; var qq: longint);
var i,k: longint;
begin
     k:=0; transf(ns,a,n); qq:=n;
     for i:=1 to n do begin
         if a[i] = b[k+1] then k:=k+1
            else begin
                 while (k > 0)and(a[i] <> b[k+1]) do k:=d[k];
                 if a[i] = b[k+1] then k:=k+1
                    else k:=0;
            end;
         if k = m then exit;
     end;
     for i:=1 to m-k do
         ns[i+n]:=b[k+i];
     qq:=qq+m-k;
end;

procedure find_string(var r_m: mas; var r_c: longint);
var i,j: longint;
begin
     calc_suffix;
     kmp_addon(s,cs);
     for i:=1 to cs do begin
         for j:=i+1 to cs do
             if not(((j mod i <> 0)and(s[j] = s[j mod i]))or
                ((j mod i = 0)and(s[j] = s[i]))) then break;
         if ((j mod i <> 0)and(s[j] = s[j mod i]))or
            ((j mod i = 0)and(s[j] = s[i])) then begin
            r_c:=i;
            for j:=1 to i do
                r_m[j]:=s[j];
            exit;
         end;
     end;
end;

procedure solve;
begin
     find_string(ans_m,ans_c);
     tmp_m:=a; a:=b; b:=tmp_m;
     tmp_c:=n; n:=m; m:=tmp_c;
     find_string(tmp_m,tmp_c);
     if tmp_c < ans_c then begin
        ans_m:=tmp_m; ans_c:=tmp_c; end;
end;

procedure done;
var i: longint;
begin
     assign(output,outfile);
     rewrite(output);
     for i:=1 to ans_c do
         write(ans_m[i]);
     close(output);
end;

begin
     init;
     solve;
     done;
end.
