{$I-,Q-,R-,S-}
uses
  sysutils;

const
  inputfile = 'print.in';
  outputfile = 'print.out';
  maxn = 5101;
  p = 11111;
  osn = 1003;

type
  int = longint;
  bool = boolean;
  real = double;
  tstring = record
    n: int;
    d: array[1..maxn]of int;
  end;

var
  tm: real;
  i, j, h, nh, st, count: int;
  a: tstring;
  par, l, s: array[1..maxn]of int;
  timelimit: bool;

procedure readstring(var s: tstring);
var
  c: char;
begin
  s.n := 0;
  read(c);
  while(not(ord(c) > 32))do
    read(c);
  while(ord(c) > 32)do begin
    inc(s.n);
    s.d[s.n] := ord(c) - 32;
    read(c);
  end;
end;

function check(r, l: int): bool;
var
  ok : bool;
  i: int;
begin
  ok := true;
  for i := 1 to r - l do
    if(a.d[r - i + 1] <> a.d[l - i + 1])then begin
      ok := false;
      break;
    end;
  check := ok;
end;

begin
  assign(input, inputfile);
  reset(input);
  assign(output, outputfile);
  rewrite(output);
  readstring(a);
  tm := now;
  l[1] := 1;
  for i := 2 to a.n do begin
    l[i] := l[i - 1] + 1;
    par[i] := i - 1;
    h := a.d[i];
    nh := a.d[i - 1];
    st := 1;
    j := i - 2;
    if((now - tm) * 86400 > 4.5)then
      timelimit := true;
    if(not timelimit)then
      while(2 * j - i + 1 > 0)do begin

        h := (h * osn + a.d[j + 1]) mod p;
        nh := nh - st * a.d[j + 1] mod p;
        nh := ((nh * osn)mod p * osn) mod p;
        nh := (nh + a.d[2 * j - i + 1] + a.d[2 * j - i + 2] * osn) mod p;
        while(nh < 0)do
          nh := nh + p;
        if(nh = h)then begin
          if(check(i, j))then begin
            if(l[j] + 1 < l[i])then begin
              l[i] := l[j] + 1;
              par[i] := j;
            end;
          end;
        end;
        st := (st * osn) mod p;
        dec(j);
      end else begin
        l[a.n] := l[i - 1] + a.n - i + 1;
        for j := i to a.n do
          par[j] := j - 1;
        break;
      end;
  end;
  writeln(l[a.n] + 1);
  i := a.n;
  while(par[i] > 0)do begin
    inc(count);
    if(i - par[i] = 1)then
      s[count] := a.d[i]
    else
      s[count] := par[i] - i;
    i := par[i];
  end;
  inc(count);
  s[count] := a.d[1];

  for i := count downto 1 do begin
    if(s[i] > 0)then
      writeln('Letter(' + chr(39) + chr(32 + s[i]) + chr(39) + ');')
    else
      writeln('Repeat(', -s[i] ,');');
  end;
  writeln('End.');
  close(output);
  close(input);
end.