#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

//const int  NN=500;
#define NN 500
#define BASE 1000

struct LLONG {
  long a[NN+1];
  int l;
};

FILE *fi, *fo;
LLONG n;
LLONG a,b,c,d,e,f;
LLONG nil;

int max(int a ,int b)
{
  return (a>b)?a:b;
}

int min(int a ,int b)
{
  return (a<b)?a:b;
}

int eq(LLONG *a, LLONG *b)
{
  int i;
  if(a->l<b->l) return -1;
  if(a->l>b->l) return 1;
  for(i=NN-a->l;(i<NN)&&(a->a[i]==b->a[i]);i++) ;
  if(i>=NN) return 0;
  if(a->a[i]>b->a[i]) return 1;
  if(a->a[i]<b->a[i]) return -1;
  return 0;
}

void sum(LLONG *a, LLONG *b, LLONG *c)
{
  int i;
  long r;
  c->l=max(a->l,b->l);
  r=0;
  for(i=NN-1;i>=NN-c->l;i--)
  {
    c->a[i]=a->a[i]+b->a[i]+r;
    r=c->a[i]/BASE;
    c->a[i]%=BASE;
  }
  while(r>0)
  {
    c->l++;
    c->a[NN-c->l]+=r%BASE;
    r/=BASE;
  }
  while((c->a[NN-c->l]==0)&&(c->l>0)) c->l--;
}

void umn(LLONG *a, long q, LLONG *c, int sh)
{
  int i;
  long r;
  for(i=NN-sh;i<NN;i++) c->a[i]=0;
  c->l=a->l+sh;
  r=0;
  for(i=NN-1;i>=NN-a->l;i--)
  {
    c->a[i-sh]=a->a[i]*q+r;
    r=c->a[i-sh]/BASE;
    c->a[i-sh]%=BASE;
  }
  while(r>0)
  {
    c->l++;
    c->a[NN-c->l]+=r%BASE;
    r/=BASE;
  }
  while((c->a[NN-c->l]==0)&&(c->l>0)) c->l--;
}

void lcopy(LLONG *a, LLONG *b)
{
  int i;
  a->l=b->l;
  for(i=0;i<NN;i++)
  {
    a->a[i]=b->a[i];
  }
}

void GetLong(LLONG *a)
{
  int c;
  int s[2*NN];
  int i;
  int q;
  q=0;
  for(i=0;i<NN;i++) a->a[i]=0;
  c=getc(fi);
  while(!isdigit(c)) c=getc(fi);
  while(isdigit(c))
  {
    s[q]=c-'0';
    q++;
    c=getc(fi);
  }
  i=NN;
  while(q>0)
  {
     if(q>=3)
     {
       i--;
       a->a[i]=s[q-3]*100+s[q-2]*10+s[q-1];
       q-=3;
     }
     else
     {
       i--;
       a->a[i]=0;
       for(c=0;c<q;c++)
       {
         a->a[i]=a->a[i]*10+s[c];
       }
       q=0;
     }
  }
  while((a->a[i]==0)&&(i<NN)) i++;
  a->l=NN-i;
}

void PutLong(LLONG *a)
{
  int i;
  while((a->a[NN-a->l]==0)&&(a->l>0)) a->l--;
  if(a->l>0)
  {
    fprintf(fo,"%li",a->a[NN-a->l]);
    for(i=NN-a->l+1;i<NN;i++)
    {
      if(a->a[i]<100) fprintf(fo,"0");
      if(a->a[i]<10) fprintf(fo,"0");
      fprintf(fo,"%li",a->a[i]);
    }
    fprintf(fo,"\n");
  }
  else
  {
    fprintf(fo,"0\n");
  }
}

int main()
{
  int i,j;
  long bb,ee,cc;
  fi=fopen("square.in","rt");
  fo=fopen("square.out","wt");

  GetLong(&n);

  for(i=0;i<NN;i++)
  {
    a.a[i]=0;
    b.a[i]=0;
    c.a[i]=0;
    d.a[i]=0;
    e.a[i]=0;
    nil.a[i]=0;
    f.a[i]=0;
  }
  a.l=0;
  b.l=0;
  c.l=0;
  d.l=0;
  f.l=0;
  nil.l=0;
  
  e.l=1;
  e.a[NN-1]=1;

  i=-1;
  umn(&e,1,&a,i);
  while((ee=eq(&a,&n))<0)
  {
    lcopy(&a,&nil);
    i++;
    umn(&e,1,&a,i);
  }
  if(ee>0)
  {
    i--;
  }
  lcopy(&a,&nil);
  a.l=i+1;
  while(i>=0)
  {
    ee=0;
    bb=BASE-1;
    lcopy(&d,&nil);
    umn(&e,bb*bb,&d,2*i);
    lcopy(&b,&nil);
    umn(&a,bb,&b,i);
    umn(&b,2,&b,0);
    lcopy(&c,&f);
    sum(&c,&b,&c);
    sum(&c,&d,&c);
    if(eq(&c,&n)<=0)
    {
      lcopy(&f,&c);
      a.a[NN-i-1]=bb;
    }
    else
    {
      while((bb-ee)>1)
      {
        cc=(bb+ee)/2;
        lcopy(&d,&nil);
        umn(&e,cc*cc,&d,2*i);
        lcopy(&b,&nil);
        umn(&a,cc,&b,i);
        umn(&b,2,&b,0);
        lcopy(&c,&f);
        sum(&c,&b,&c);
        sum(&c,&d,&c);
        if(eq(&c,&n)<=0)
          ee=cc;
        else
          bb=cc;
      }
      lcopy(&d,&nil);
      umn(&e,ee*ee,&d,2*i);
      lcopy(&b,&nil);
      umn(&a,ee,&b,i);
      umn(&b,2,&b,0);
      lcopy(&c,&f);
      sum(&c,&b,&c);
      sum(&c,&d,&c);
      lcopy(&f,&c);
      a.a[NN-i-1]=ee;
    }
    i--;
  }
  if(eq(&f,&n)!=0)
  {
    fprintf(fo,"-1\n");
  }
  else
  {
    while((a.a[NN-a.l]==0)&&(a.l>0)) a.l--;
    PutLong(&a);
  }
  

  fclose(fi);
  fclose(fo);
  return 0;
}
