{$I+,Q-,R-,S+}
program         Template;

const
  TABLE_SIZE    = 100;

var
  N             : DWord;
  Table         : array[1..9, 1..TABLE_SIZE] of Comp;
  Total         : array[0..TABLE_SIZE] of Comp;

procedure       OpenFiles;
begin
  Assign(Input, 'smooth.in');
  Reset(Input);
  Assign(Output, 'smooth.out');
  Rewrite(Output);
end;

procedure       CloseFiles;
begin
  Close(Input);
  Close(Output);
end;

procedure       ReadData;
begin
  ReadLn(N);
end;

procedure       Solve;
var
  I, J, K       : Integer;
  C             : Comp;
begin
  for I := 1 to 9 do
    Table[I, 1] := 1;

  Total[0] := 0; Total[1] := 9;
  for I := 2 to TABLE_SIZE do begin
    Total[I] := Total[I - 1];
    for J := 1 to 9 do begin
      Table[J, I] := 0;
      for K := J to 9 do
        Table[J, I] := Table[J, I] + Table[K, I - 1];
      Total[I] := Total[I] + Table[J, I];
    end;
  end;

  I := 1;
  while Total[I] < N do
    Inc(I);

  K := 1; C := N - Total[I - 1];
  for J := 1 to I do begin
    while Table[K, I - J + 1] < C do begin
      C := C - Table[K, I - J + 1];
      Inc(K);
    end;

    Write(K);
  end;
  WriteLn;
end;

begin
  OpenFiles;
  ReadData;
  Solve;
  CloseFiles;
end.
