type
  tLong=array[0..130] of Word;

var
  N,Up,Down,X,sX:tLong;

procedure OpenFiles;
begin
  assign(input,'square.in');
  assign(output,'square.out');
  reset(input);
  rewrite(output);
end;

procedure CloseFiles;
begin
  close(input);
  close(output);
end;

Procedure LongUp(var n:tLong);
var
  H,I:Integer;

begin
  H:=0;
  for I:=130 downto 1 do
  begin
    N[I]:=N[I]*10+H;
    H:=N[I] div 10000;
    N[I]:=N[I] mod 10000;
  end;
end;

procedure Di;
var
  H,I:INteger;

begin
  H:=0;
  for I:=x[0] to 130 do
  begin
    x[I]:=x[I]+H;
    if x[I] mod 2 <>0 then
      H:=10000;
    x[I]:=x[I] div 2;
  end;
  if x[0]=0 then
    inc(x[0]);
end;

procedure Sum(Q:Integer);
var
  I,H:Integer;

begin
  H:=Q;
  I:=130;
  while H<>0 do
  begin
    N[I]:=N[I]+H;
    H:=N[I] div 10000;
    N[I]:=N[I] mod 10000;
    dec(I);
  end;
end;

procedure ReadN;
var
  C:Char;

begin
  read(C);
  while (C>='0')and(C<='9') do
  begin
    LongUp(n);
    Sum(ord(C)-48);
    read(C);
  end;
end;

function min(a,b:longint):longint;
begin
  if a>b then
    min:=b
  else
    min:=a;
end;

function ravn:boolean;
var
  i:integer;

begin
  if up[0]<>down[0] then
  begin
    ravn:=false;
    exit;
  end;
  for i:=up[0] to 129 do
    if up[i]<>down[i] then
    begin
      ravn:=false;
      exit;
    end;
  if abs(down[130]-up[130])<2 then
    ravn:=true
  else
    ravn:=false;
end;

procedure longsum(a,b:tLong;var c:tLong);
var
  h,i:integer;

begin
  h:=0;
  for i:=130 downto min(a[0],b[0])-1 do
  begin
    c[i]:=a[i]+b[i]+h;
    h:=c[i] div 10000;
    c[i]:=c[i] mod 10000;
  end;
  c[0]:=min(a[0],b[0])-1;
  if c[c[0]]=0 then
    inc(c[0]);
end;

procedure lsd;
begin
  longsum(up,down,x);
  di;
end;

function bol(a,b:tLong):boolean;
var
  i:integer;

begin
  if a[0]<b[0] then
  begin
    bol:=true;
    exit;
  end;
  if a[0]>b[0] then
  begin
    bol:=false;
    exit;
  end;
  for i:=a[0] to 130 do
  begin
    if a[i]>b[i] then
    begin
      Bol:=true;
      exit;
    end;
    if a[i]<b[i] then
    begin
      bol:=false;
      exit;
    end;
  end;
  bol:=false;
end;

procedure Mn(a:tlong;b:word;var c:tlong);
var
  h,l,i:longint;

begin
  h:=0;
  fillchar(c,sizeof(c),0);
  for i:=130 downto a[0]-1 do
  begin
    l:=a[i];
    l:=l*b+h;
    h:=l div 10000;
    c[i]:=l mod 10000;
  end;
  if c[a[0]-1]<>0 then
    c[0]:=a[0]-1
  else
    c[0]:=a[0];
end;

procedure sqr;
var
  h,i,i1:longint;
  a:tlong;

begin
  fillchar(sx,sizeof(sx),0);
  for i:=130 downto x[0] do
  begin
    Mn(x,x[i],a);
    h:=0;
    for i1:=i downto 1 do
    begin
      sx[i1]:=sx[i1]+a[130-i+i1]+h;
      h:=sx[i1] div 10000;
      sx[i1]:=sx[i1] mod 10000;
    end;
  end;
  sx[0]:=0;
  while sx[sx[0]]=0 do
    inc(sx[0]);
end;

function rv:boolean;
var
  i:integer;

begin
  if n[0]<>sx[0] then
  begin
    rv:=false;
    exit;
  end;
  for i:=130 downto 1 do
    if n[i]<>sx[i] then
    begin
      rv:=false;
      exit;
    end;
  rv:=true;
end;

procedure Solve;
var
  i,k:integer;
  s:string;

begin
  readn;
  n[0]:=0;
  while n[n[0]]=0 do
    inc(n[0]);
  fillchar(up,sizeof(up),0);
  up[0]:=130;
  down:=n;
  while not(ravn) do
  begin
    lsd;
    sqr;
    if Bol(sx,n) then
      down:=x
    else
      up:=x;
  end;
  x:=up;
  sqr;
  if rv then
  begin
    k:=1;
    while x[k]=0 do
     inc(k);
    write(x[k]);
    for i:=k+1 to 130 do
    begin
      str(x[i],s);
      while length(s)<4 do
        s:='0'+s;
      write(s);
    end;
    exit;
  end;
  x:=down;
  sqr;
  if rv then
  begin
    k:=1;
    while x[k]=0 do
     inc(k);
    write(x[k]);
    for i:=k+1 to 130 do
    begin
      str(x[i],s);
      while length(s)<4 do
        s:='0'+s;
      write(s);
    end;
    exit;
  end;
  write(-1);
end;

begin
  OpenFiles;
  Solve;
  CloseFiles;
end.
