const
  inputfile = 'smooth.in';
  outputfile = 'smooth.out';
  maxn = 101;

type
  real = double;
  int = longint;
  bool = boolean;

var
  i, j, k, count: int;
  a: array[1..100, 1..9]of real;
  s: array[0..100]of real;
  n: real;
  c: array[1..100]of int;

begin
  assign(input, inputfile);
  reset(input);
  assign(output, outputfile);
  rewrite(output);
  read(n);

  for i := 1 to 9 do
    a[1, i] := 1;
  count := 1;
  s[1] := 9;

  for i := 2 to 100 do begin
    inc(count);
    for j := 1 to 9 do begin
      for k := j to 9 do
        a[i, j] := a[i, j] + a[i - 1, k];
      s[i] := s[i] + a[i, j];
    end;
    s[i] := s[i] + s[i - 1];
    if(s[i] >= n)then
      break;
  end;

  if(n < 10)then
    write(n:0:0)
  else begin
    n := n - s[count - 1];
    i := count;
    j := 1;
    while(i > 0)do begin
      while(n > a[i, j])do begin
        n := n - a[i, j];
        inc(j);
      end;
      c[i] := j;
      dec(i);
      write(j);
    end;
  end;

  close(output);
  close(input);
end.