const dt=0.000001;
var x1,y1,r1,x2,y2,r2:real;
    xa1,ya1,xa2,ya2:real;
    _f:text;

procedure solve;
var l,d,a,b,xt,yt:real;
    at,bt,len:real;
begin
  d:=sqrt(sqr(x1-x2)+sqr(y1-y2));
  l:=r1/r2;
  xt:=(x1+l*x2)/(l+1); yt:=(y1+l*y2)/(l+1);
  if abs(r1+r2-d)<dt then
  begin
    writeln(_f,1);
    write(_f,xt:1:6,' ',yt:1:6);
    close(_f);
    exit;
  end;
  len:=sqrt(sqr(r1)-(sqr(x1-xt)+sqr(y1-yt)));
  at:=y1-y2; bt:=x2-x1;
  a:=len*at/sqrt(sqr(at)+sqr(bt)); b:=len*bt/sqrt(sqr(at)+sqr(bt));
  xa1:=xt+b;
  ya1:=yt+a;
  xa2:=xt-b;
  ya2:=yt-a;
  writeln(_f,2);
  writeln(_f,xa1:1:6,' ',ya1:1:6);
  write(_f,xa2:1:6,' ',ya2:1:6);
  close(_f);
end;

begin
  assign(_f,'circles.in');
  reset(_f);
  read(_f,x1,y1,r1,x2,y2,r2);
  close(_f);
  assign(_f,'circles.out');
  rewrite(_f);
  if (x1=x2)and(y1=y2)and(r1=r2) then begin write(_f,-1); close(_f); exit; end;
  if (x1=x2)and(y1=y2)and(r1<>r2) then begin write(_f,0); close(_f); exit; end;
  if sqrt(sqr(x1-x2)+sqr(y1-y2))>r1+r2 then begin write(_f,0); close(_f); exit; end;
  solve;
end.