{$N+}
{.$define debug}

program template;
const
 h = 1;
 eps = 1e-8;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'tangent.in';
 coutfile = 'tangent.out';
 {$endif}
type
 int = longint;
 real = extended;
 t3 = record
  a,b,c :real;
 end;
var
 n :int;
 ans :int;
 x1,y1,r1 :real;
 x2,y2,r2 :real;
 p :array [1..4] of t3;

procedure init;
begin
 ans := 0;
 fillchar (p,sizeof(p),0);
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 read (x1,y1,r1);
 read (x2,y2,r2);
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans);
 close (output);
 halt;
end;

procedure outno;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (-1);
 close (output);
 halt;
end;

procedure only2;
var a1,b1,c1 :real;
begin

end;




procedure solve;
var i,j :int;
    d :real;
begin
 d := sqrt (sqr(x1-x2) + sqr(y1-y2));
 if d < r1-r2-eps then
  outdata;
 if (abs(x1-x2) < eps) and (abs(y1-y2) < eps) then
  outno;
 if d < r1+r2 then
  only2;

end;

begin
 init;
 readdata;
 solve;
 outdata;
end.