{$IFDEF NORMAL}
  {$I-,Q-,R-,S-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I-,Q-,R-,S-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-}
{$ENDIF RELEASE}
program p20_14_d;

const
  eps = 0.0000001;

var
  w1, w2, w3, k, ax, ay, bx, by, cx, cy, dx, dy, a1, a2, b1, b2, c1, c2, x, y : extended;

function max(a, b : extended) : extended;
begin
  if a > b then max := a
  else max := b;
end;

function min(a, b : extended) : extended;
begin
  if a < b then min := a
  else min := b;
end;

begin
  assign(input, 'segment.in');
  reset(input);
  assign(output, 'segment.out');
  rewrite(output);
  read(ax, ay, bx, by, cx, cy, dx, dy);
  if ax > bx then begin
    w1 := ax;
    ax := bx;
    bx := w1;
    w1 := ay;
    ay := by;
    by := w1;
  end;
  if cx > dx then begin
    w1 := cx;
    cx := dx;
    dx := w1;
    w1 := cy;
    cy := dy;
    dy := w1;
  end;
  a1 := ay - by;
  a2 := cy - dy;
  b1 := bx - ax;
  b2 := dx - cx;
  c1 := - (a1 * ax + b1 * ay);
  c2 := - (a2 * cx + b2 * cy);
  if (a1 <> 0) or (b1 <> 0) then begin
    w1 := a1 / sqrt(sqr(a1) + sqr(b1));
    w2 := b1 / sqrt(sqr(a1) + sqr(b1));
    w3 := c1 / sqrt(sqr(a1) + sqr(b1));
    a1 := w1;
    b1 := w2;
    c1 := w3;
  end;
  if (a2 <> 0) or (b2 <> 0) then begin
    w1 := a2 / sqrt(sqr(a2) + sqr(b2));
    w2 := b2 / sqrt(sqr(a2) + sqr(b2));
    w3 := c2 / sqrt(sqr(a2) + sqr(b2));
    a2 := w1;
    b2 := w2;
    c2 := w3;
  end;
  k := a2 * b1 - b2 * a1 + c1;
  if k <> 0 then begin
    x := -b1 * c2 / k;
    if b1 <> 0 then
      y := (-a1 * x - c1) / b1
    else
      y := (-a2 * x - c2) / b2;
    if (x <= max(ax, bx)) and (x >= min(ax, bx)) and (x <= max(cx, dx)) and (x >= min(cx, dx)) then begin
      write(x:0:6, ' ', y:0:6);
      close(output);
      halt;
    end else begin
      write('Empty');
      close(output);
      halt;
    end;
  end else begin
    if (abs(a1) < eps) and (abs(b1) < eps) and (abs(c1) < eps) then begin
      if (abs(a2) < eps) and (abs(b2) < eps) and (abs(c2) < eps) then begin
        if (ax = cx) and (ay = cy) then begin
          write(ax:0:6, ' ', ay:0:6);
          close(output);
          halt;
        end else begin
          write('Empty');
          close(output);
          halt;
        end;
      end;
      if (abs(a2 * ax + b2 * ay + c2) < eps) and (ax >= cx) and (ax <= dx) then begin
        write(ax:0:6, ' ', ay:0:6);
        close(output);
        halt;
      end else begin
        write('Empty');
        close(output);
        halt;
      end;
    end;
    if (abs(a2) < eps) and (abs(b2) < eps) and (abs(c2) < eps) then begin
      if (abs(a1 * cx + b1 * cy + c1) < eps) and (cx <= bx) and (cx >= ax) then begin
        write(cx:0:6, ' ', cy:0:6);
        close(output);
        halt;
      end else begin
        write('Empty');
        close(output);
        halt;
      end;
    end;
    if (abs(a1 - a2) < eps) and (abs(b1 - b2) < eps) and (abs(c1 - c2) < eps) then begin
      if (ax >= cx) and (bx <= dx) then begin
        write(ax:0:6, ' ', ay:0:6, ' ', bx:0:6, ' ', by:0:6);
        close(output);
        halt;
      end;
      if (cx >= ax) and (dx <= bx) then begin
        write(cx:0:6, ' ', cy:0:6, ' ', dx:0:6, ' ', dy:0:6);
        close(output);
        halt;
      end;
      if (ax >= cx) and (dx <= bx) then begin
        write(ax:0:6, ' ', ay:0:6, ' ', dx:0:6, ' ', dy:0:6);
        close(output);
        halt;
      end;
      if (cx >= ax) and (bx <= dx) then begin
        write(cx:0:6, ' ', cy:0:6, ' ', bx:0:6, ' ', by:0:6);
        close(output);
        halt;
      end;
      if (cx >= bx) or (ax >= dx) then begin
        write('Empty');
        close(output);
        halt;
      end;
    end;
    if ((bx = cx) and (by = cy)) or ((bx = dx) and (by = dy)) then begin
      write(cx:0:6, ' ', cy:0:6);
      close(output);
      halt;
    end;
    if ((ax = dx) and (ay = dy)) or ((ax = cx) and (ay = cy)) then begin
      write(ax:0:6, ' ', ay:0:6);
      close(output);
      halt;
    end;
    write('Empty');
  end;
end.
