{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 63840,0,655360}
const
 filein='circle.in';
 fileout='circle.out';
 e=0.0000001;
type
 table=array[1..3] of array[1..3] of double;
 vector=array[1..3] of double;
var
 z:table;
 x1,y1,x2,y2,r1,r2:double;
 x,y,rr,a,b:double;
 move_x,move_y,cosa,sina,r,d:double;
 rx1,rx2,ry1,ry2:double;
procedure trap1(x1,x2,a,b:double;var x:double);
begin
 x:=(x2*a+x1*b)/(a+b);
end;

procedure trap2(x1,x2,a,b:double;var x:double);
begin
 x:=(x1*b-x2*a)/(b-a);
end;

procedure trap3(x1,x2,a,b:double;var x:double);
begin
 x:=(x2*a-x1*b)/(a-b);
end;

procedure mxm(c:table;a:vector;var b:vector);
var
 i:integer;
begin
 fillchar(b,sizeof(b),0);
 for i:=1 to 3 do b[i]:=b[i]+a[1]*c[1,i]+a[2]*c[2,i]+a[3]*c[3,i];
end;
procedure no_points;
begin
 writeln(0);
 close(output);
 halt;
end;

procedure many_points;
begin
 writeln(-1);
 close(output);
 halt;
end;

procedure one_point1;
begin
 writeln(1);
 trap1(x1,x2,r1,r2,rx1);
 trap1(y1,y2,r1,r2,ry1);
 writeln(rx1:0:6,' ',ry1:0:6);
 close(output);
 halt;
end;

procedure one_point2;
begin
 writeln(1);
 trap2(x1,x2,r1,r2,rx1);
 trap2(y1,y2,r1,r2,ry1);
 writeln(rx1:0:6,' ',ry1:0:6);
 close(output);
 halt;
end;

procedure one_point3;
begin
 writeln(1);
 trap3(x1,x2,r1,r2,rx1);
 trap3(y1,y2,r1,r2,ry1);
 writeln(rx1:0:6,' ',ry1:0:6);
 close(output);
 halt;
end;

begin
 assign(input,filein);reset(input);
 assign(output,fileout);rewrite(output);

 read(x1,y1,r1);
 read(x2,y2,r2);

 r:=sqrt(sqr(x1-x2)+sqr(y1-y2));

 if (r1+r2-r)<-e then no_points;
 if (r1-r2+r)<-e then no_points;
 if (-r1+r2+r)<-e then no_points;

 if (abs(x1-x2)<e) and (abs(y1-y2)<e) and (r1=r2) then many_points;

 if abs(r1+r2-r)<e then one_point1;
 if abs(r1-r2+r)<e then one_point3;
 if abs(-r1+r2+r)<e then one_point2;

 move_x:=x1;
 move_y:=y1;

 x1:=x1-move_x;
 x2:=x2-move_x;

 y1:=y1-move_y;
 y2:=y2-move_y;


 if (r>r1) and (r>r2) then
 begin
  a:=(sqr(r1)-sqr(r2)+sqr(r))/(2*r);
  b:=(-sqr(r1)+sqr(r2)+sqr(r))/(2*r);
  trap1(0,x2,a,b,x);
  trap1(0,y2,a,b,y);
  d:=sqrt(sqr(r1)-sqr(a));
  cosa:=a/r1;
  sina:=d/r1;



  close(output);
  halt;
 end;



 close(output);
end.