{$I-,Q-,R-,S-}
Const
  FIn='segment.in';
  FOut='segment.out';
Var
  input,output:text;
Procedure Init;
begin
  Assign(input,FIn);
  Assign(output,FOut);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
  Halt(0);
end;
{---------------------------------------------------------------------------}
Const
  Eps=1E-10;
Type
  TPoint=Record
    X,Y:Real;
  end;
  TPr=Record
    A,B,C:Real;
  end;
Var
  Z1,Z2,Z,A,B,C,D:TPoint;
  SinL:Real;
  Pr1,Pr2:TPr;
  Res:Boolean;

Procedure Pr(A,B:TPoint; Var P:TPr);
begin
  P.A:=A.Y-B.Y;
  P.B:=B.X-A.X;
  P.C:=-(P.A*A.X+P.B*A.Y);
end;

Procedure Per(Pr1,Pr2:TPr; Var A:TPoint);
begin
  A.Y:=(Pr1.A*Pr2.C-Pr2.A*Pr1.C)/(Pr2.A*Pr1.B-Pr1.A*Pr2.B);
  A.X:=(Pr1.B*Pr2.C-Pr2.B*Pr1.C)/(Pr2.B*Pr1.A-Pr1.B*Pr2.A);
  { Y=(A1*C2-A2*C1)/(A2*B1-A1*B2)
    X=(B1*C2-B2*C1)/(B2*A1-B1*A2) }
end;

Function Test(X1,Y1,X2,Y2,X3,Y3,X4,Y4:Real):Boolean;
Var Z1,Z2:Real;
begin
  z1:=(x3-x1)*(y2-y1)-(y3-y1)*(x2-x1);
  z2:=(x4-x1)*(y2-y1)-(y4-y1)*(x2-x1);
  test:=z1*z2>0;
end;

Function Cmp(A,B:Real):Boolean;
begin
  Cmp:=abs(A-B)<=Eps;
end;

Procedure Swap(Var A,B:Real);
Var T:Real;
begin
  T:=A;
  A:=B;
  B:=T;
end;

Function PPP(X1,Y1,X2,Y2:Real; Var A:TPoint):Boolean;
begin
  PPP:=True;
  If X1>Y1 then Swap(X1,Y1);
  If X2>Y2 then Swap(X2,Y2);
  {}
  If X2>Y1 then PPP:=False else
  If X2<X1 then
  begin
    If Y2>Y1 then
    begin
      A.X:=X1;
      A.Y:=Y1;
    end else
    If Y2<X1 then PPP:=False else
    begin
      A.X:=X1;
      A.Y:=Y2;
    end;
  end else
  begin
    If Y2>Y1 then
    begin
      A.X:=X2;
      A.Y:=Y1;
    end else
    begin
      A.X:=X2;
      A.Y:=Y2;
    end;
  end;
end;

Procedure Obl;
begin
  If Res then
  begin
    Res:=PPP(A.X,B.X, C.X,D.X, Z1);
    If Res=False then
    begin
      WriteLn(Output,'Empty');
      Done;
    end;
    Res:=PPP(A.Y,B.Y, C.Y,D.Y, Z2);
    If Res=False then
    begin
      WriteLn(Output,'Empty');
      Done;
    end;
    WriteLn(Output,Z1.X:0:6,' ',Z2.X:0:6,' ',Z1.Y:0:6,' ',Z2.Y:0:6);
    Done;
  end;
end;

begin
  Init;
  Res:=True;
  {}
  Read(Input,A.X,A.Y ,B.X,B.Y ,C.X,C.Y, D.X,D.Y);
  If (A.X=B.X)and(A.Y=B.Y) then
  begin
    Pr(C,D, Pr2);
    Res:=Cmp(Pr2.A*A.X+Pr2.B*A.Y+Pr2.C,0);
    Obl;
  end else
  If (C.X=D.X)and(C.Y=D.Y) then
  begin
    Pr(A,B, Pr1);
    Res:=Cmp(Pr1.A*C.X+Pr1.B*C.Y+Pr1.C,0);
    Obl;
  end else
  If Test(A.X,A.Y,B.X,B.Y,C.X,C.Y,D.X,D.Y) then Res:=False else
  begin
    Pr(A,B, Pr1);
    Pr(C,D, Pr2);
    SinL:=(Pr1.A*Pr2.B-Pr2.A*Pr1.B)/sqrt((Pr1.A*Pr1.A+Pr1.B*Pr1.B)*(Pr2.A*Pr2.A+Pr2.B*Pr2.B));
    If Cmp(SinL,0) then
    begin
      Res:=Cmp(Pr1.A*C.X+Pr1.B*C.Y+Pr1.C,0);
      Obl;
    end else
    begin
      Per(Pr1,Pr2, Z);
      Res:=True;
    end;
  end;
  If Res then WriteLn(Output,Z.X:0:6,' ',Z.Y:0:6)
         else WriteLn(Output,'Empty');
  {}
  Done;
end.