const eps = 1E-10;

type Txy = record
       x,y: double;
     end;
     Tline = record
       a,b,c: double;
     end;

var a1, a2, b1, b2: Txy;
    al,bl: Tline;
    res: integer;
    p1,p2: txy;

function FlCmp(a,b: double):integer; {0: A=B -1: A<B 1:A>B}
begin
  if a-b>eps then FlCmp:=1 else
    if b-a>eps then FlCmp:=-1 else
      FlCmp:=0;
end;

function min(a,b: double):double;
Begin
  if flcmp(a,b)=-1 then min:=a else min:=b;
end;

function max(a,b: double):double;
Begin
  if flcmp(a,b)=1 then max:=a else max:=b;
end;

Procedure TwoP2Line(var p1,p2:txy;var l:tline);
var d: double;
begin
  l.a:=p1.y-p2.y;
  l.b:=p2.x-p1.x;
  l.c:=-(l.a*p1.x+l.b*p1.y);
  d:=sqrt(l.a*l.a+l.b*l.b);
  l.a:=l.a/d;
  l.b:=l.b/d;
  l.c:=l.c/d;
end;

function cmppts(p1,p2: Txy):boolean;
begin
  if (flcmp(p1.x,p2.x)=0) and (flcmp(p1.y,p2.y)=0) then cmppts:=true
    else cmppts:=false;
end;

function PLDist(l:TLine;p:tXY):double;
begin
  PLDist:=l.a*p.x+l.b*p.y+l.c;
end;

procedure Inter(var l1,l2:tline; var p: txy);
var d: double;
begin
  d:=l1.a*l2.b-l2.a*l1.b;
  p.x:=l1.c*l2.b-l2.c*l1.b;
  p.y:=-l1.c*l2.a+l2.c*l1.a;
end;


procedure Solve;
begin
  res:=0;
  if (min(a1.x,a2.x)<=max(b1.x,b2.x)) and
     (max(a1.x,a2.x)>=min(b1.x,b2.x)) and
     (min(a1.y,a2.y)<=max(b1.y,b2.y)) and
     (max(a1.y,a2.y)>=min(b1.y,b2.y)) then
    begin
      if cmppts(a1,a2) and cmppts(b1,b2) then begin
        res:=1;
        p1:=a1;
        exit;
      end;
      if cmppts(a1,a2) then begin {A - bad}
        TwoP2line(b1,b2,bl);
        if flCmp(PLdist(bl,a1),0)=0 then begin
          res:=1;
          p1:=a1;
          exit;
        end;
      end;
      if cmppts(b1,b2) then begin {B - bad}
        TwoP2line(a1,a2,al);
        if flCmp(PLdist(al,b1),0)=0 then begin
          res:=1;
          p1:=b1;
          exit;
        end;
      end;

      if cmppts(a1,b1) then begin
          res:=1;
          p1:=a1;
          exit;
      end;

      if cmppts(a1,b2) then begin
          res:=1;
          p1:=a1;
          exit;
      end;

      if cmppts(a2,b1) then begin
          res:=1;
          p1:=a2;
          exit;
      end;

      if cmppts(a2,b2) then begin
          res:=1;
          p1:=a2;
          exit;
      end;


      TwoP2line(a1,a2,al);
      TwoP2line(b1,b2,bl);

      {if (flcmp(PLdist(al,b1),0)=0) and
         (flcmp(PLdist(al,b1),0)=0) then begin
         res:=2;
        if a1.x=a2.x then  begin



        end else


        end;
        exit;
      end;   }
      inter(al,bl,p1);
      res:=1;



    end;
end;


procedure Save;
var f: text;
begin
  Assign(f,'segment.out');
  Rewrite(f);
  case res of
0: WriteLn(f,'Empty');
1: WriteLn(f,p1.x:6:6,' ',p1.y:6:6);
2: WriteLn(f,p1.x:6:6,' ',p1.y:6:6,' ',p2.x:6:6,' ',p2.y:6:6);
  end;
  Close(f);
end;

procedure Load;
var f: text;
begin
  Assign(f,'segment.in');
  reset(f);
  Read(f,a1.x,a1.y,a2.x,a2.y,b1.x,b1.y,b2.x,b2.y);
  Close(f);
end;

Begin
  Load;
  solve;
  Save;
End.
