{$N+}
const eps = 1e-7;
function bt(x, a, b: extended): boolean;
begin
  bt:=((a < x + eps) and (x < b + eps)) or
      ((b < x + eps) and (x < a + eps));
end;

var x0, y0, x1, y1, xx0, yy0, xx1, yy1: extended;
function check1(x, y: extended): boolean;
begin
  check1:= bt(x, x0, x1) and bt(y, y0, y1) and
           bt(x, xx0, xx1) and bt(y, yy0, yy1) ;
end;

var tmp, a, b, c, a1, b1, c1, a2, b2, c2: extended;
var d, d1, d2: extended;
begin
  assign(input, 'segment.in');
  assign(output, 'segment.out');
  reset(input);
  rewrite(output);
  read(x0, y0, x1, y1);
  read(xx0, yy0, xx1, yy1);
  if (xx0 = xx1) and (yy0 = yy1) then
    begin
      tmp:=x0;
      x0:=xx0;
      xx0:=tmp;

      tmp:=y0;
      y0:=yy0;
      yy0:=tmp;

      tmp:=x1;
      x1:=xx1;
      xx1:=tmp;

      tmp:=y1;
      y1:=yy1;
      yy1:=tmp;
    end;
  if (x0 = x1) and (y0 = y1) then
    begin
      if (xx0 = xx1) and (yy0 = yy1) then
        begin
          if (x0 = xx0) and (y0 = yy0) then
            begin
              writeln(x0: 0: 6, ' ', y0: 0: 6);
              close(input);
              close(output);
              exit;
            end;
          writeln('Empty');
          close(input);
          close(output);
          exit;
        end;
      a:=yy1 - yy0;
      b:=xx0 - xx1;
      c:=-a * xx1 - b * yy1;
      if abs(x0 * a + y0 * b + c) > eps then
        begin
          writeln('Empty');
          close(input);
          close(output);
          exit;
        end;
      if bt(x0, xx0, xx1) and bt(y0, yy0, yy1) then
        begin
          writeln(x0: 0: 6, ' ', y0: 0: 6);
          close(input);
          close(output);
          exit;
        end;
      writeln('Empty');
      close(input);
      close(output);
      exit;
    end;
  a1:=y1 - y0;
  b1:=x0 - x1;
  c1:=-a1 * x0 - b1 * y0;

  a2:=yy1 - yy0;
  b2:=xx0 - xx1;
  c2:=-a2 * xx0 - b2 * yy0;

  d:=a1 * b2 - a2 * b1;
  if abs(d) < eps then
    begin
      if abs(a1 * xx1 + b1 * yy1 + c1) > eps then
        begin
          writeln('Empty');
          close(input);
          close(output);
          exit;
        end;
      if bt(x0, xx0, xx1) and bt(y0, yy0, yy1) and
         bt(x1, xx0, xx1) and bt(y1, yy0, yy1) then
           begin
             writeln(x0: 0: 6, ' ', y0: 0: 6, ' ', x1: 0: 6, ' ', y1: 0: 6);
             close(input);
             close(output);
             exit;
           end;
      if bt(xx0, x0, x1) and bt(yy0, y0, y1) and
         bt(xx1, x0, x1) and bt(yy1, y0, y1) then
           begin
             writeln(xx0: 0: 6, ' ', yy0: 0: 6, ' ', xx1: 0: 6, ' ', yy1: 0: 6);
             close(input);
             close(output);
             exit;
           end;

      if (x0 > x1 + eps) or ((abs(x0 - x1) < eps) and (y0 > y1 + eps)) then
        begin
          tmp:=x0;
          x0:=x1;
          x1:=tmp;

          tmp:=y0;
          y0:=y1;
          y1:=tmp;
        end;
      if (xx0 > xx1 + eps) or ((abs(xx0 - xx1) < eps) and (yy0 > yy1 + eps)) then
        begin
          tmp:=xx0;
          xx0:=xx1;
          xx1:=tmp;

          tmp:=yy0;
          yy0:=yy1;
          yy1:=tmp;
        end;

      if (abs(x1 - xx0) < eps) and (abs(y1 - yy0) < eps) then
        begin
          writeln(x1: 0: 6, ' ', y1: 0: 6);
          close(input);
          close(output);
          exit;
        end;

      if (abs(xx1 - x0) < eps) and (abs(yy1 - y0) < eps) then
        begin
          writeln(x0: 0: 6, ' ', y0: 0: 6);
          close(input);
          close(output);
          exit;
        end;

      if bt(xx0, x0, x1) and bt(yy0, y0, y1) then
        begin
          writeln(xx0: 0: 6, ' ', yy0: 0: 6, ' ', x1: 0: 6, ' ', y1: 0: 6);
          close(input);
          close(output);
          exit;
        end;

      if bt(xx1, x0, x1) and bt(yy1, y0, y1) then
        begin
          writeln(x0: 0: 6, ' ', y0: 0: 6, ' ', xx1: 0: 6, ' ', yy1: 0: 6);
          close(input);
          close(output);
          exit;
        end;

      writeln('Empty');
      close(input);
      close(output);
      exit;
    end;
  d2:=a2 * c1 - a1 * c2;
  d1:=b1 * c2 - b2 * c1;

  if check1(d1 / d, d2 / d) then
    begin
      writeln((d1 / d) : 0 : 6, ' ', (d2 / d) : 0 : 6);
      close(input);
      close(output);
      exit;
    end
  else
    begin
      writeln('Empty');
      close(input);
      close(output);
      exit;
    end;
end.