{$A+,B-,D+,E-,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}
program circle;
const
  eps=1e-8;
var
  n,m,i,j,k:longint;
  x1,y1,x2,y2,r1,r2:longint;
  a,b,c,xx,yy,yy1,yy2,xx1,xx2:extended;
  a1,b1,c1,d1:extended;
  function s(x1,y1,x2,y2:longint):longint;
  begin
    s:=(sqr(x1-x2)+sqr(y1-y2));
  end;
  procedure init;
  begin
     assign(input,'circle.in');
     reset(input);
     assign(output,'circle.out');
     rewrite(output);
     read(x1,y1,r1);
     read(x2,y2,r2);
  end;
  procedure work;
  begin
     if (x1=x2) and (y1=y2) then
     begin
       if r1=r2 then
       begin
         writeln(-1);
         close(input);
         close(output);
         halt;
       end else
       begin
         writeln(0);
         close(input);
         close(output);
         halt;
       end;
     end;
     if (s(x1,y1,x2,y2)>sqr(r1+r2)) then
     begin
       writeln(0);
       close(input);
       close(output);
       halt;
     end;
     if x1=x2 then
     begin
       yy:=(sqr(r1)-sqr(r2)+sqr(y2)-sqr(y1)+sqr(x2)-sqr(x1))/(2*(y2-y1));
       a:=sqr(yy)-2*yy*y1+sqr(y1)-sqr(r1)+sqr(x1);
       b:=sqr(x1)-a;
       if abs(b)<eps then
       begin
         writeln(1);
         xx:=x1;
         write(xx:0:6);
         write(' ',yy:0:6);
         close(input);
         close(output);
         halt;
       end else
       begin
         writeln(2);
         xx1:=x1+sqrt(b);
         xx2:=x1-sqrt(b);
         writeln(2);
         write(xx1:0:6);
         write(' ',yy:0:6);
         writeln;
         write(xx2:0:6);
         write(' ',yy:0:6);
         close(input);
         close(output);
         halt;
       end;
     end else
     begin
       a:=(y2-y1)/(x1-x2);
       b:=(sqr(r1)-sqr(r2)+sqr(y2)-sqr(y1)+sqr(x2)-sqr(x1))/(2*(x2-x1));
       a1:=1+sqr(a);
       b1:=2*b*a-2*a*x1-2*y1;
       c1:=sqr(b)-2*b*x1+sqr(x1)+sqr(y1)-sqr(r1);
       d1:=sqr(b1)-4*a1*c1;
       if abs(d1)<eps then
       begin
         writeln(1);
         yy:=(-b1)/(2*a1);
         xx:=a*yy+b;
         write(xx:0:6);
         write(' ',yy:0:6);
         close(input);
         close(output);
         halt;

       end else
       begin
         writeln(2);
         yy1:=(-b1+sqrt(d1))/(2*a1);
         yy2:=(-b1-sqrt(d1))/(2*a1);
         xx1:=a*yy1+b;
         xx2:=a*yy2+b;
         write(xx1:0:6);
         write(' ',yy1:0:6);
         writeln;
         write(xx2:0:6);
         write(' ',yy2:0:6);
         close(input);
         close(output);
         halt;
       end;
     end;
  end;
  procedure otvet;
  begin
     close(input);
     close(output);
  end;
begin
  init;
  work;
  otvet;
end.