{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65500,0,655360}
  Type Tip=LongInt;
       Real=Double;
       TPoint2=Record
                X,Y : Real;
              End;
       TPoint=Record
                X,Y : Integer;
              End;
       TLine=Record
               A,B,C : Integer;
             End;
  Const Inp='segment.in';
        Out='segment.out';
        ZeroPnt : TPoint=(X : 0;Y : 0);
        Eps : Real=1e-7;
  Var Del,A,B,C,D,Zamena,Answer2,Answer3 : TPoint;
      Answer : TPoint2;
      Line,Line2 : TLine;
      Perebor : Tip;

Function Dist(Const A,B : TPoint) : Real;
Begin
  Dist :=Sqrt(Sqr(A.X-B.X)+Sqr(A.Y-B.Y));
End;

Function RealEq(Const A,B : Real) : Boolean;
Begin
  RealEq :=Abs(A-B)<=Eps;
End;

Function RealMore(Const A,B : Real) : Boolean;
Begin
  RealMore :=(A-B)>=-Eps;
End;

Function RealLess(Const A,B : Real) : Boolean;
Begin
  RealLess :=Not(RealMore(A,B)) And Not(RealEq(A,B));
End;

Function RealMax(Const A,B : Real) : Real;
Begin
  If RealMore(A,B) Then RealMax :=A Else RealMax :=B;
End;

Function RealMin(Const A,B : Real) : Real;
Begin
  If RealLess(A,B) Then RealMin :=A Else RealMin :=B;
End;

{Function SegmLineCross(Const FL,FR,SL,SR : TPoint) : Byte;
  Var MinF,MinS,MaxF,MaxS : Real;
Begin
  MinF :=RealMin(Dist(FL,ZeroPnt),Dist(FR,ZeroPnt));
  MaxF :=RealMax(Dist(FL,ZeroPnt),Dist(FR,ZeroPnt));
  MinS :=RealMin(Dist(SL,ZeroPnt),Dist(SR,ZeroPnt));
  MaxS :=RealMax(Dist(SL,ZeroPnt),Dist(SR,ZeroPnt));
  If RealEq(MinF,MaxS) Or RealEq(MaxF,MinS) Then
    SegmLineCross :=0
  Else If RealMore(MinS,MaxF) Or RealMore(MinF,MaxS) Then
    SegmLineCross :=1
      Else SegmLineCross :=2;
End;}

Procedure PointLine(Const L1,L2 : TLine;Var P : TPoint2);
  Var St : Real;
Begin
  St :=L1.A*L2.B-L2.A*L1.B;
  P.Y :=((-L1.C)*L2.B-L1.B*(-L2.C))/St;
  P.X :=(L1.A*(-L2.C)-(-L1.C)*L2.A)/St;
End;

Procedure GetLine(Const V,W : TPoint; Var L : Tline);
Begin
  L.A :=V.Y-W.Y;
  L.B :=W.X-V.X;
  L.C :=-(V.X*L.A+V.Y*L.B);
End;

Begin
  Assign(Input,Inp);
  ReSet(Input);
  Read(A.X,A.Y,B.X,B.Y,C.X,C.Y,D.X,D.Y);
  Close(Input);
  Assign(Output,Out);
  ReWrite(Output);
  {Case SegmLineCross(A,B,C,D) Of}
  If (D.X>=C.X) And (D.Y>=C.Y) Then
    Begin
      Zamena :=C;
      C :=D;
      D :=Zamena;
    End;
  If (B.X>=A.X) And (B.Y>=A.Y) Then
    Begin
      Zamena :=A;
      A :=B;
      B :=Zamena;
    End;
  GetLine(B,A,Line);
  GetLine(D,C,Line2);
  For Perebor :=Abs(Line.A) DownTo 1 Do
    If ((Line.A) Mod Perebor=0) And ((Line.B) Mod Perebor=0) And ((Line.C) Mod Perebor=0) Then
      Begin
        Line.B :=Line.B Div Perebor;
        Line.C :=Line.C Div Perebor;
        Line.A :=Line.A Div Perebor;
      End;
  For Perebor :=Abs(Line.B) DownTo 1 Do
    If ((Line.A) Mod Perebor=0) And ((Line.B) Mod Perebor=0) And ((Line.C) Mod Perebor=0) Then
      Begin
        Line.B :=Line.B Div Perebor;
        Line.C :=Line.C Div Perebor;
        Line.A :=Line.A Div Perebor;
      End;
  For Perebor :=Abs(Line2.A) DownTo 1 Do
    If ((Line2.A) Mod Perebor=0) And ((Line2.B) Mod Perebor=0) And ((Line2.C) Mod Perebor=0) Then
      Begin
        Line2.B :=Line2.B Div Perebor;
        Line2.C :=Line2.C Div Perebor;
        Line2.A :=Line2.A Div Perebor;
      End;
  For Perebor :=Abs(Line2.B) DownTo 1 Do
    If ((Line2.A) Mod Perebor=0) And ((Line2.B) Mod Perebor=0) And ((Line2.C) Mod Perebor=0) Then
      Begin
        Line2.B :=Line2.B Div Perebor;
        Line2.C :=Line2.C Div Perebor;
        Line2.A :=Line2.A Div Perebor;
      End;
  If ((Line.A=0) And (Line.B=0)) Or ((Line2.A=0) And (Line2.B=0)) Then
    Write('Empty')
  Else
  If (Line.A=Line2.A) And (Line.B=Line2.B) And (Line.C=Line2.C) Then
    Begin
          If (A.X<=C.X) And (A.Y<=C.Y) And (B.X>=D.X) And (B.Y>=D.Y) Then
            Begin
              Answer3 :=B;
              Answer2 :=A;
            End;
          If (A.X>=C.X) And (A.Y>=C.Y) And (B.X>=D.X) And (B.Y>=D.Y) Then
            Begin
              Answer3 :=B;
              Answer2 :=C;
            End;
          If (A.X<=C.X) And (A.Y<=C.Y) And (B.X<=D.X) And (B.Y<=D.Y) Then
            Begin
              Answer3 :=D;
              Answer2 :=A;
            End;
          If (A.X>=C.X) And (A.Y>=C.Y) And (B.X<=D.X) And (B.Y<=D.Y) Then
            Begin
              Answer3 :=D;
              Answer2 :=C;
            End;
          Writeln(Answer3.X,'.000000 ',Answer3.Y,'.000000 ',Answer2.X,'.000000 ',Answer2.Y,'.000000 ');
        End
  Else If (Line.A=Line2.A) And (Line.B=Line2.B) Then Writeln('Empty')
  Else
        Begin
          PointLine(Line,Line2,Answer);
          Writeln(Answer.X:0:6,' ',Answer.Y:0:6);
        End;
  Close(Output);
End.
