#include <stdio.h>
#include <stdlib.h>
#include <math.h>

struct POINT {
  long x,y;
};

struct POINTF {
  double x,y;
};

struct LINE {
  long a,b,c;
};

FILE *fi, *fo;
POINT a,b,c,d;
LINE l1,l2;
POINTF res;

void GetLine(POINT a, POINT b, LINE *p)
{
  p->a=b.y-a.y;
  p->b=a.x-b.x;
  p->c=a.y*b.x-a.x*b.y;
}

int GetPeres(LINE a, LINE b,POINTF *p)
{
  long aa,bb,cc,dd;
  if((a.a==0)&&(a.b==0)&&(a.c==0)&&(b.a==0)&&(b.b==0)&&(b.c==0)) return 3;
  if(((a.a==0)&&(a.b==0)&&(a.c==0))||((b.a==0)&&(b.b==0)&&(b.c==0))) return 2;
  aa=b.b*a.c-a.b*b.c;
  bb=a.b*b.a-a.a*b.b;
  cc=a.c*b.a-a.a*b.c;
  dd=b.b*a.a-a.b*b.a;
  if(bb==0)
  {
    if(aa==0)
    {
      return 1;
    }
    else
    {
      return -1;
    }
  }
  else
  {
    p->x=(double)aa/bb;
    p->y=(double)cc/dd;
    return 0;
  }
  return 0;
}

void GetPoint(POINT *p)
{
  fscanf(fi,"%li%li",&p->x,&p->y);
}

long ff(LINE l, POINT p)
{
  return l.a*p.x+l.b*p.y+l.c;
}

int cmp(POINT a, POINT b)
{
  if(a.x>b.x) return 1;
  if(b.x>a.x) return -1;
  if(a.y>b.y) return 1;
  if(a.y<b.y) return -1;
  return 0;
}

int main()
{
  int f;
  POINT tmp;
  POINT rr1,rr2;
  POINTF r1,r2;
  fi=fopen("segment.in","rt");
  fo=fopen("segment.out","wt");

  GetPoint(&a);
  GetPoint(&b);
  GetPoint(&c);
  GetPoint(&d);

  if(a.x>b.x)
  {
    tmp=a;
    a=b;
    b=tmp;
  }
  if((a.x==b.x)&&(a.y>b.y))
  {
    tmp=a;
    a=b;
    b=tmp;
  }
  if(c.x>d.x)
  {
    tmp=c;
    c=d;
    d=tmp;
  }
  if((c.x==d.x)&&(c.y>d.y))
  {
    tmp=c;
    c=d;
    d=tmp;
  }

  GetLine(a,b,&l1);
  GetLine(c,d,&l2);

  f=GetPeres(l1,l2,&res);
  if(f==0)
  {
    fprintf(fo,"%0.6lf %0.6lf\n",res.x,res.y);
  }
  if(f<0)
  {
    fprintf(fo,"Empty\n");
  }
  if(f==1)
  {
//    rr1=(a.x>c.x)?a:c;
//    rr2=(b.x<d.x)?b:d;
    rr1=(cmp(a,c)>0)?a:c;
    rr2=(cmp(b,d)<0)?b:d;
    if(rr1.x>rr2.x) fprintf(fo,"Empty\n");
    else
    {
      if((rr1.x==rr2.x)&&(rr1.y==rr2.y))
      {
        res.x=rr1.x;
        res.y=rr1.y;
        fprintf(fo,"%0.6lf %0.6lf\n",res.x,res.y);
      }
      else
      {
        if((rr1.x==rr2.x)&&(rr1.y>rr2.y)) fprintf(fo,"Empty\n");
        else
        {
          r1.x=rr1.x;
          r1.y=rr1.y;
          r2.x=rr2.x;
          r2.y=rr2.y;
          fprintf(fo,"%0.6lf %0.6lf %0.6lf %0.6lf\n",r1.x,r1.y,r2.x,r2.y);
        }
      }
    }
  }
  if(f==3)
  {
    if((a.x==c.x)&&(a.y==c.y))
    {
      res.x=a.x;
      res.y=a.y;
      fprintf(fo,"%0.6lf %0.6lf\n",res.x,res.y);
    }
    else
    {
      fprintf(fo,"Empty\n");
    }
  }
  if(f==2)
  {
    if((l1.a==0)&&(l1.b==0))
    {
      if((ff(l2,a)==0)&&(a.x>=c.x)&&(a.x<=d.x))
      {
        res.x=a.x;
        res.y=a.y;
        fprintf(fo,"%0.6lf %0.6lf\n",res.x,res.y);
      }
      else
      {
        fprintf(fo,"Empty\n");
      }
    }
    else
    {
      if(ff(l1,c)==0&&(c.x>=a.x)&&(c.x<=b.x))
      {
        res.x=c.x;
        res.y=c.y;
        fprintf(fo,"%0.6lf %0.6lf\n",res.x,res.y);
      }
      else
      {
        fprintf(fo,"Empty\n");
      }
    }
  }

  fclose(fi);
  fclose(fo);
  return 0;
}
