{$I-,Q-,R-,S-}
Uses SysUtils;
Const
  FIn='chess.in';
  FOut='chess.out';
Var
  input,output:text;
Procedure Init;
begin
  Assign(input,FIn);
  Assign(output,FOut);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
  Halt(0);
end;
{---------------------------------------------------------------------------}
Const
  MaxN=12;
  MaxCCC=2;
Var
  Time,OldTime:Double;
  CCC,N,Q,C:Byte;
  Col:LongInt;
  {}
  Mas:array[1..MaxN,1..MaxN]of Byte;
  B:array[1..MaxN,1..MaxN]of Byte;

Procedure PutL(X,Y:Byte; C:LongInt);
Var R:byte;
begin
  If C<>-1 then Mas[X,Y]:=1 else Mas[X,Y]:=0;
  For R:=1 to N do B[X,R]:=B[X,R]+C;
  For R:=1 to N do B[R,Y]:=B[R,Y]+C;
end;

Function PutF(X,Y:Byte; C:LongInt):Boolean;
Var R:Byte; F:Boolean;
begin
  PutL(X,Y,C);
  F:=False;
  If C<>-1 then Mas[X,Y]:=2 else Mas[X,Y]:=0;
  For R:=1 to N do
    If (X+R<=N)and(Y+R<=N) then
    begin
      If Mas[X+R,Y+R]<>0 then F:=True;
      B[X+R,Y+R]:=B[X+R,Y+R]+C;
    end else Break;
  For R:=1 to N do
    If (X-R>=1)and(Y+R<=N) then
    begin
      If Mas[X-R,Y+R]<>0 then F:=True;
      B[X-R,Y+R]:=B[X-R,Y+R]+C;
    end else Break;
  For R:=1 to N do
    If (X+R<=N)and(Y-R>=1) then
    begin
      If Mas[X+R,Y-R]<>0 then F:=True;
      B[X+R,Y-R]:=B[X+R,Y-R]+C;
    end else Break;
  For R:=1 to N do
    If (X-R>=1)and(Y-R>=1) then
    begin
      If Mas[X-R,Y-R]<>0 then F:=True;
      B[X-R,Y-R]:=B[X-R,Y-R]+C;
    end else Break;
  PutF:=F;
end;

Procedure Rec(Q,C,X,Y:Byte);
begin
  If (C=0)and(Q=0) then
  begin
    Col:=Col+1;
    Exit;
  end;
  While B[X,Y]<>0 do
  begin
    X:=X+1;
    If X>N then
    begin
      X:=1;
      Y:=Y+1;
      If Y>N then
      begin
        Time:=trunc(Now*100000);
        If OldTime<>Time then
        begin
          OldTime:=Time;
          CCC:=CCC+1;
        end;
        If CCC=MaxCCC then
        begin
          WriteLn(Output,0);
          Done;
        end;
        Exit;
      end;
    end;
  end;
  While True do
  begin
    If (C<>0)and(B[X,Y]=0) then
    begin
      PutL(X,Y,+1);
      Rec(Q,C-1,X,Y);
      PutL(X,Y,-1);
    end;
    If (Q<>0)and(B[X,Y]=0) then
    begin
      If Not PutF(X,Y,+1) then Rec(Q-1,C,X,Y);
      PutF(X,Y,-1);
    end;
    X:=X+1;
    If X>N then
    begin
      X:=1;
      Y:=Y+1;
      If Y>N then Exit;
    end;
  end;
end;

begin
  Init;
  FillChar(B,SizeOf(B),0);
  FillChar(Mas,SizeOf(Mas),0);
  Col:=0;
  {}
  CCC:=0; OldTime:=trunc(Now*100000);
  ReadLn(Input,N,Q,C);
  Rec(Q,C,1,1);
  WriteLn(Output,Col);
  {}
  Done;
end.
