  {$I-,Q-,R-,S-}
type
  tpoint=record
    x,y:integer;
  end;
  tp=^trec;
  trec=record
    x,y:integer;
    next:tp;
  end;

var
  a:array[1..5000,1..2]of tpoint;
  use:array[1..5000,1..2]of boolean;
  ver:array[1..10000] of tpoint;
  reb:array[1..10000] of tp;
  colors:array[1..10000,1..5]of boolean;
  n,cnt:integer;

procedure OpenFiles;
begin
  assign(input,'input.txt');
  assign(output,'output.txt');
  reset(input);
  rewrite(output);
end;

procedure CloseFiles;
begin
  close(input);
  close(output);
end;

procedure add(n:longint;x,y:integer);
var
  q:tp;

begin
  if reb[n]=nil then
  begin
    new(reb[n]);
    reb[n]^.x:=x;
    reb[n]^.y:=y;
    reb[n]^.next:=nil;
    exit;
  end;
  q:=reb[n];
  while q^.next<>nil do
    q:=q^.next;
  new(q^.next);
  q^.next^.x:=x;
  q^.next^.y:=y;
  q^.next^.next:=nil;
end;

procedure killcolor(x,y,c:integer);
var
  i:integer;

begin
  i:=1;
  while (ver[i].x<>x)or(ver[i].y<>y) do
    inc(i);
  colors[i,c]:=false;
end;

procedure Solve;
var
  i,i1,i2:integer;
  q:tp;

begin
  read(n);
  fillchar(use,sizeof(use),false);
  for i:=1 to n do
    read(a[i,1].x,a[i,1].y,a[i,2].x,a[i,2].y);
  for i:=1 to n do
    for i1:=1 to 2 do
      if not use[i,i1] then
      begin
      inc(cnt);
      ver[cnt]:=a[i,i1];
      for i2:=1 to n do
      begin
        if (a[i,i1].x=a[i2,1].x)and(a[i,i1].y=a[i2,1].y) then
        begin
          use[i2,1]:=true;
          add(cnt,a[i2,2].x,a[i2,2].y);
        end;
        if (a[i,i1].x=a[i2,2].x)and(a[i,i1].y=a[i2,2].y) then
        begin
          use[i2,2]:=true;
          add(cnt,a[i2,1].x,a[i2,1].y);
        end;
      end;
     end;
  fillchar(colors,sizeof(colors),true);
  for i:=1 to cnt do
  begin
    i1:=1;
    while (colors[i,i1]=false)and(i1<5) do
      inc(i1);
    for i2:=i1+1 to 5 do
      colors[i,i2]:=false;
    q:=reb[i];
    while q<>nil do
    begin
      killcolor(q^.x,q^.y,i1);
      q:=q^.next;
    end;
  end;
  for i:=1 to cnt do
  begin
    i1:=1;
    while (not colors[i,i1])and(i1<5) do
      inc(i1);
    writeln(ver[i].x,' ',ver[i].y,' ',i1);
  end;
end;

begin
  OpenFiles;
  Solve;
  CloseFiles;
end.
