{$A+,B-,D-,E+,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 63840,0,655360}
const
  filein='input.txt';
  fileout='output.txt';
  nmax=5000;
type
  rebro=record
    x1,y1,x2,y2:longint;
    v1,v2:integer;
  end;
  point=record
    x,y:longint;
    deg:integer;
    color:integer;
  end;
  List = array[1..nmax*2] of point;
var
  flag_1,flag_2:boolean;
  i,j,n,ver:integer;
  a:array[1..nmax] of rebro;
  v:list;
  z:point;
  col,nil_color:array[0..5] of boolean;
procedure QuickSort(var A: List; Lo, Hi: Integer);
procedure Sort(l, r: Integer);
var
  i, j, x: integer;
  y:point;
begin
  i := l; j := r; x := a[(l+r) DIV 2].deg;
  repeat
    while a[i].deg < x do i := i + 1;
    while x < a[j].deg do j := j - 1;
    if i <= j then
    begin
      y := a[i]; a[i] := a[j]; a[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;
begin
  Sort(Lo,Hi);
end;

begin
  fillchar(a,sizeof(a),0);
  fillchar(v,sizeof(v),0);
  ver:=0;

  assign(input,filein);reset(input);
  assign(output,fileout);rewrite(output);

  read(n);
  for i:=1 to n do read(a[i].x1,a[i].y1,a[i].x2,a[i].y2);

  for i:=1 to n do
  begin
    flag_1:=true;
    flag_2:=true;
    for j:=1 to ver do
    begin
      if (v[j].x=a[i].x1) and (v[j].y=a[i].y1) then
      begin
       inc(v[j].deg);
       flag_1:=false;
      end;

      if (v[j].x=a[i].x2) and (v[j].y=a[i].y2) then
      begin
       inc(v[j].deg);
       flag_2:=false;
      end;
    end;

    if flag_1 then
    begin
     inc(ver);
     inc(v[ver].deg);
     v[ver].x:=a[i].x1;
     v[ver].y:=a[i].y1;
    end;

    if flag_2 then
    begin
     inc(ver);
     inc(v[ver].deg);
     v[ver].x:=a[i].x2;
     v[ver].y:=a[i].y2;
    end;
  end;
  quicksort(v,1,ver);

  for i:=1 to (ver div 2) do
  begin
    z:=v[i];
    v[i]:=v[ver+1-i];
    v[ver+1-i]:=z;
  end;

  for i:=1 to n do
  begin
   j:=1;
   while (v[j].x<>a[i].x1) or (v[j].y<>a[i].y1) do inc(j);
   a[i].v1:=j;

   j:=1;
   while (v[j].x<>a[i].x2) or (v[j].y<>a[i].y2) do inc(j);
   a[i].v2:=j;
  end;

  fillchar(nil_color,sizeof(nil_color),0);
  for i:=1 to ver do
  begin
    col:=nil_color;
    for j:=1 to n do
    begin
      if a[j].v1=i then col[v[a[j].v2].color]:=true;
      if a[j].v2=i then col[v[a[j].v1].color]:=true;
    end;
    if not col[1] then v[i].color:=1
      else if not col[2] then v[i].color:=2
        else if not col[3] then v[i].color:=3
          else if not col[4] then v[i].color:=4
           else if not col[5] then v[i].color:=5
            else
            begin
             writeln('IMPOSSIBLE');
             close(output);
             halt;
            end;
  end;
  for i:=1 to ver do writeln(v[i].x,' ',v[i].y,' ',v[i].color);

  close(output);
end.
