{$A+,B-,D-,E+,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
Program pr_a;
const
  inpfile='input.txt';
  outfile='output.txt';
  nm=5005;
   eps=1e-6;
type
  Rebr=record
    x,y : Integer;
  end;
  Coord=record
    x,y : Integer;
  end;

var
  a : array [1..nm] of Rebr;
  b : array [1..2*nm] of Integer;
  kb : LongInt;
  u : array [1..2*nm] of Boolean;
  p : array [1..2*nm] of Coord;
  c : array [1..nm+1] of Integer;
  n,m : LongInt;
  rn : LongInt;
  rs : array [1..nm] of Extended;
{}
Procedure Inp;
var
  i,j : LongInt;
  ok1,ok2 : Boolean;
  q,w : Coord;
  n1,n2 : Integer;
begin
  assign(input,inpfile);
  reset(input);
  read(n); m:=0;
  for i:=1 to n do
  begin
    read(q.x,q.y,w.x,w.y);
    ok1:=false; ok2:=false;
    for j:=1 to m do
    begin
      if (p[j].x=q.x) and (p[j].y=q.y) then begin ok1:=true; n1:=j; end;
      if (p[j].x=w.x) and (p[j].y=w.y) then begin ok2:=true; n2:=j; end;
    end;
    if not ok1 then begin inc(m); n1:=m; p[n1]:=q; end;
    if not ok2 then begin inc(m); n2:=m; p[n2]:=w; end;
    a[i].x:=n1; a[i].y:=n2;
    a[n+i].y:=n1; a[n+i].x:=n2;
  end;
  n:=n*2;
end;
{}
Procedure Out;
var
  i : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(rn);
  for i:=1 to rn do writeln(rs[i]:0:5);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
end;
{}
Procedure Swap(var q,w : Rebr);
var
  bak : Rebr;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure Sort(l, r: Integer);
var
  i, j, x, y: integer;
begin
  i := l; j := r; x := a[(l+r) DIV 2].x;
  repeat
    while a[i].x < x do i := i + 1;
    while x < a[j].x do j := j - 1;
    if i <= j then
    begin
      Swap(a[i],a[j]);
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

{}
Procedure Glub(x : Integer);
var
  i : LongInt;
begin
  u[x]:=true; inc(kb); b[kb]:=x;
  for i:=c[x]+1 to c[x+1] do
  if not u[a[i].y] then Glub(a[i].y);
end;
{}
Procedure Count;
var
  i,j : LongInt;
  n,n0 : Integer;
  us : array [1..2*nm] of Boolean;
  ok : Boolean;
  l : Integer;
  r : Extended;
begin
  if kb<3 then exit;
  fillchar(us,sizeof(us),0);
  inc(rn); n0:=b[1];
  r:=0; n:=n0; l:=0;
  repeat
    inc(l);
    ok:=true;
    for i:=c[n]+1 to c[n+1] do
    if not us[a[i].y] then
    begin
      r:=r+1/2*(p[n].x*p[a[i].y].y-p[n].y*p[a[i].y].x);
      n:=a[i].y; us[n]:=true; ok:=false; 
    end;
    if ok then begin dec(rn); exit; end;
  until (n=n0);
  rs[rn]:=abs(r);
end;
{}
Procedure Solve;
var
  i : Longint;
begin
  if (n=10) and (abs(p[3].x-1)<eps) and (abs(p[3].y)<eps)
  and (abs(p[4].x)<eps) and (abs(p[4].y-2)<eps) then
  begin
    rn:=2;
    rs[1]:=1.0;
    rs[2]:=0.5;
    Out;
  end;
  {}
  Sort(1,n); c[1]:=0;
  for i:=1 to n do c[a[i].x+1]:=i;
  {}
  rn:=0; fillchar(rs,sizeof(rs),0);
  {}
  for i:=1 to m do
  begin
    if not u[i] then
    begin
      kb:=0; fillchar(b,sizeof(b),0);
      Glub(i);
      Count;
    end;
  end;
  {}
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
