const MAXS = 10001;
type int = longint;
var p, pp: array [0..MAXS + 100, 1..2] of int;
const r: array [0..5] of int = (0, 1, 5, 2, 4, 3);

procedure merge(l, h: int);
var a, b, c, j: int;
begin
  if l = h then exit;
  b:=(l + h) div 2;
  merge(l, b);
  merge(b + 1, h);
  a:=l;
  c:=b + 1;
  j:=l;
  while (a <= b) and (c <= h) do
    if (p[a][1] < p[c][1]) or ((p[a][1] = p[c][1]) and (p[a][2] < p[c][2])) then
      begin
        pp[j][1]:=p[a][1];
        pp[j][2]:=p[a][2];
        inc(a);
        inc(j);
      end
    else
      begin
        pp[j][1]:=p[c][1];
        pp[j][2]:=p[c][2];
        inc(c);
        inc(j);
      end;
  while (a <= b) do
    begin
      pp[j][1]:=p[a][1];
      pp[j][2]:=p[a][2];
      inc(a);
      inc(j);
    end;
  while (c <= h) do
    begin
      pp[j][1]:=p[c][1];
      pp[j][2]:=p[c][2];
      inc(c);
      inc(j);
    end;
  for j:=l to h do
    begin
      p[j][1]:=pp[j][1];
      p[j][2]:=pp[j][2];
    end;
end;

var m: int;
function find(x, y: int): int;
var l, h, u: int;
begin
  l:=0;
  h:=m + 1;
  p[0][1]:=-1000000;
  p[h][1]:= 1000000;
  while (l < h) do
    begin
      u:=(l + h) div 2;
      if (p[u][1] = x) and (p[u][2] = y) then break;
      if (p[u][1] < x) or ((p[u][1] = x) and (p[u][2] < y)) then
        l:=u
      else
        h:=u;
    end;
  find:=u;
end;

var t, x, y: array [1..MAXS + 100] of int;
var mark: array [1..MAXS + 100] of int;
var s: array [1..MAXS + 100] of int;
var ok: boolean;


function dfs(u: int): boolean;
var col: array [0..5] of byte;
var i, j: int;
var good: boolean;
begin
  if s[u] < 4 then
    begin
      dfs:=true;
      exit;
    end;
  if mark[u] <> 0 then
    begin
      dfs:=true;
      exit;
    end;
  for i:=1 to 5 do
    col[i]:=0;
  for i:=t[u] to t[u + 1] - 1 do
    col[mark[y[i]]]:=1;
  for i:=1 to 5 do
    if col[r[i]] = 0 then
      begin
        mark[u]:=r[i];
        good:=true;
        for j:=t[u] to t[u + 1] - 1 do
          if (mark[y[j]] = r[i]) or (not dfs(y[r[i]])) then good:=false;
        if good then
          begin
            dfs:=true;
            exit;
          end;
        mark[u]:=0;
      end;
end;


var u, j, last, n, i: int;
var c, xb, yb, xe, ye: array [1..MAXS + 100] of int;
var col: array [0..10] of int;
begin
  assign(input, 'input.txt');
  assign(output, 'output.txt');
  reset(input);
  rewrite(output);

  read(n);
  if n = 0 then
    begin
      close(input);
      close(output);
      exit;
    end;
  for i:=1 to n do
    read(xb[i], yb[i], xe[i], ye[i]);
  for i:=1 to n do
    begin
      p[2 * i - 1][1]:=xb[i];
      p[2 * i - 1][2]:=yb[i];
      p[2 * i][1]:=xe[i];
      p[2 * i][2]:=ye[i];
    end;
  merge(1, 2 * n);
  last:=1;
  j:=1;
  for i:=2 to 2 * n do
    if (p[i][1] <> p[last][1]) or (p[i][2] <> p[last][2]) then
      begin
        inc(j);
        p[j][1]:=p[i][1];
        p[j][2]:=p[i][2];
        last:=i;
      end;
  m:=j;
  for i:=1 to n do
    begin
      x[i]:=find(xb[i], yb[i]);
      y[i]:=find(xe[i], ye[i]);
      x[i + n]:=y[i];
      y[i + n]:=x[i];
    end;

  for i:=1 to m do
    begin
      c[i]:=0;
      t[i]:=0;
    end;
  for i:=1 to 2 * n do
    inc(c[x[i]]);
  t[1]:=1;
  for i:=2 to m do
    t[i]:=t[i - 1] + c[i - 1];
  t[m + 1]:=2 * n + 1;
  for i:=1 to 2 * n do
    begin
      u:=t[x[i]];
      xb[u]:=x[i];
      yb[u]:=y[i];
      inc(t[x[i]]);
    end;
  for i:=1 to 2 * n do
    begin
      x[i]:=xb[i];
      y[i]:=yb[i];
    end;
  t[1]:=1;
  for i:=2 to m do
    t[i]:=t[i - 1] + c[i - 1];
  t[m + 1]:=2 * n + 1;

  for i:=1 to m do
    mark[i]:=0;
  for i:=1 to m do
    s[i]:=t[i + 1] - t[i];

  ok:=false;
  for i:=1 to m do
    if mark[i] = 0 then
      if (not dfs(i)) then
        begin
          writeln('IMPOSSIBLE');
          close(input);
          close(output);
          exit;
        end;
  for i:=1 to m do
    if s[i] < 4 then
      begin
        for j:=0 to 5 do
          col[j]:=0;
        for j:=t[i] to t[i + 1] - 1 do
          col[mark[y[j]]]:=1;
        for j:=1 to 5 do
          if col[j] = 0 then
            mark[i]:=j;
      end;
  for i:=1 to m do
    writeln(p[i][1], ' ', p[i][2], ' ', mark[i]);
  close(input);
  close(output);
end.
