{$I-,Q-,R-,S-}
uses Math;
type PVertex=integer;
     TVertex=record
      v:integer;
      next:PVertex;
     end;

var vx,vy,vx2,vy2:array[1..10000] of longint;
    a,a2:array[1..5000] of PVertex;
    deg,deg2:array[1..5000] of integer;
    soo:array[1..5000] of integer;
    vs:array[1..10000] of TVertex;
    lvs:longint;
    x1,y1,x2,y2:integer;
    first,second,n,i,j,oj,nj,k,cv,ncv:integer;
    s:extended;
    ver,ver2:PVertex;
    Changed:boolean;
    people:integer;
    ps:array[1..10000] of extended;

procedure DeleteEdge(p,q:integer);
var ver,ver2:PVertex;
begin
 deg[p]:=0; ver:=a[p];
 a[p]:=0;
 while ver<>0 do begin
  ver2:=vs[ver].next;
  if vs[ver].v<>q then begin
   vs[ver].next:=a[p];
   a[p]:=ver; inc(deg[p]);
  end;
  ver:=ver2;
 end;
end;

procedure Normalize;
var Changed:boolean;
    i:integer;
    ver,ver2:PVertex;
begin
 repeat
  Changed:=false;
  ncv:=0;
  for i:=1 to cv do if deg[i]>=2 then begin
   inc(ncv);
   vx2[ncv]:=vx[i]; vy2[ncv]:=vy[i];
   a2[ncv]:=a[i]; soo[i]:=ncv;
  end;
  for i:=1 to ncv do begin
   deg2[i]:=0; ver:=a2[i];
   a2[i]:=0;
   while ver<>0 do begin
    ver2:=vs[ver].next;
    if deg[vs[ver].v]>=2 then begin
     vs[ver].v:=soo[vs[ver].v];
     vs[ver].next:=a2[i];
     a2[i]:=ver; inc(deg2[i]);
    end;
    ver:=ver2;
   end;
  end;
  if cv<>ncv then Changed:=true;
  a:=a2; vx:=vx2; vy:=vy2; cv:=ncv; deg:=deg2;
  fillchar(deg2,sizeof(deg2),0);
 until Changed=false;
end;

function Atan(x,y:longint):Extended;
begin
  if x<>0 then
   ATan:=Arctan2(-x,-y)+pi else
  if y>0 then Atan:=0 else atan:=pi;
end;

function FindUpper(i:integer):integer;
var ver:PVertex;
    fi,mfi:Extended;
    j:integer;
begin
 ver:=a[i];
 j:=i;
 mfi:=4;
 while ver<>0 do begin
  fi:=Atan(vx[vs[ver].v]-vx[i],vy[vs[ver].v]-vy[i]);
  if fi<mfi then begin j:=vs[ver].v; mfi:=fi end;
  ver:=vs[ver].next;
 end;
 FindUpper:=j;
end;

function FindLower(i,k:integer):longint;
var ver:PVertex;
    j:integer;
    fi,mfi,lfi:Extended;
begin
 j:=0;
 mfi:=-4;
 lfi:=pi-ATan(vx[i]-vx[k],vy[i]-vy[k]);
 if abs(lfi)<1e-10 then lfi:=lfi+2*pi;
 ver:=a[i];
 while ver<>0 do begin
  fi:=Atan(vx[vs[ver].v]-vx[i],vy[vs[ver].v]-vy[i])+lfi;
  while fi<0 do fi:=fi+2*pi;
  while fi>2*pi do fi:=fi-2*pi;
  if (vs[ver].v<>k)and(fi>mfi) then begin j:=vs[ver].v; mfi:=fi end;
  ver:=vs[ver].next;
 end;
 FindLower:=j;
end;

begin
 assign(input,'input.txt'); reset(input);
 assign(output,'output.txt'); rewrite(output);
 readln(n);
 for i:=1 to n do begin
  readln(x1,y1,x2,y2);
  vx[cv+1]:=x1;
  vy[cv+1]:=y1;
  for j:=1 to cv+1 do if (vx[j]=x1)and(vy[j]=y1) then break;
  if j=cv+1 then begin
   j:=x1; x1:=x2; x2:=j;
   j:=y1; y1:=y2; y2:=j;
   vx[cv+1]:=x1;
   vy[cv+1]:=y1;
   for j:=1 to cv+1 do if (vx[j]=x1)and(vy[j]=y1) then break;
  end;
  if j=cv+1 then begin
   inc(cv,2);
   vx[cv]:=x2; vy[cv]:=y2;
   inc(lvs); ver:=lvs;
   vs[ver].next:=0; vs[ver].v:=cv;
   a[cv-1]:=ver; inc(deg[cv-1]);
   inc(lvs); ver:=lvs;
   vs[ver].next:=0; vs[ver].v:=cv-1;
   a[cv]:=ver; inc(deg[cv]);
  end else begin
   vx[cv+1]:=x2;
   vy[cv+1]:=y2;
   for k:=1 to cv+1 do if (vx[k]=x2)and(vy[k]=y2) then break;
   if k=cv+1 then inc(cv);
   inc(lvs); ver:=lvs;
   vs[ver].next:=a[j]; vs[ver].v:=k; a[j]:=ver; inc(deg[j]);
   inc(lvs); ver:=lvs;
   vs[ver].next:=a[k]; vs[ver].v:=j; a[k]:=ver; inc(deg[k]);
  end;
 end;
 Normalize;
 while cv<>0 do begin
  j:=1; for i:=2 to cv do if vx[i]<vx[j] then j:=i;
  first:=j;
  second:=FindUpper(first);
  s:=1.0*vx[first]*vy[second]-1.0*vy[first]*vx[second];
  oj:=first; j:=second;
  repeat
   nj:=FindLower(j,oj);
   oj:=j; j:=nj;
   s:=s+1.0*vx[oj]*vy[j]-1.0*vy[oj]*vx[j];
  until j=first;
  inc(people);
  ps[people]:=s;
  DeleteEdge(first,second);
  DeleteEdge(second,first);
  Normalize;
 end;
 writeln(people);
 for i:=1 to people do writeln(abs(ps[i]/2));
 close(output);
end.
