{$I-,Q-,R-,S-}
uses Math;
const monsters:array[0..5] of string=('Divolimer','Disdfo','Yo','Gpaa','Alperon','Divolimer');
type PVertex=integer;
     TVertex=record
      v:integer;
      e:integer;
      next:PVertex;
     end;
     TVertex2=record
      v:integer;
      next:PVertex;
     end;

var vx,vy,vx2,vy2:array[1..10000] of longint;
    a,a2:array[1..5000] of PVertex;
    deg,deg2:array[0..5000] of integer;
    soo:array[1..5000] of integer;
    vs:array[1..10000] of TVertex;
    otrx1,otry1,otrx2,otry2:array[1..5000] of integer;
    otrl,otrr:array[1..5000] of integer;
    deleted:array[1..5000] of boolean;
    delx,dely,deln:array[1..5000] of integer;
    dels:array[1..5000] of extended;
    s:extended;
    cdel:integer;
    g:array[0..5000] of PVertex;
    mon:array[0..5000] of byte;
    vg:array[1..10000] of TVertex2;
    lvg:integer;
    lvs:longint;
    x1,y1,x2,y2:integer;
    first,second,n,i,j,oj,nj,k,cv,ncv:integer;
    ver,ver2:PVertex;
    curarea:integer;

procedure DeleteEdge(p,q:integer);
var ver,ver2:PVertex;
begin
 deg[p]:=0; ver:=a[p];
 a[p]:=0;
 while ver<>0 do begin
  ver2:=vs[ver].next;
  if vs[ver].v<>q then begin
   vs[ver].next:=a[p];
   a[p]:=ver; inc(deg[p]);
  end;
  ver:=ver2;
 end;
end;

procedure Normalize;
var Changed:boolean;
    i:integer;
    ver,ver2:PVertex;
begin
 repeat
  Changed:=false;
  ncv:=0;
  for i:=1 to cv do if deg[i]>=2 then begin
   inc(ncv);
   vx2[ncv]:=vx[i]; vy2[ncv]:=vy[i];
   a2[ncv]:=a[i]; soo[i]:=ncv;
  end;
  for i:=1 to ncv do begin
   deg2[i]:=0; ver:=a2[i];
   a2[i]:=0;
   while ver<>0 do begin
    ver2:=vs[ver].next;
    if deg[vs[ver].v]>=2 then begin
     vs[ver].v:=soo[vs[ver].v];
     vs[ver].next:=a2[i];
     a2[i]:=ver; inc(deg2[i]);
    end;
    ver:=ver2;
   end;
  end;
  if cv<>ncv then Changed:=true;
  a:=a2; vx:=vx2; vy:=vy2; cv:=ncv; deg:=deg2;
  fillchar(deg2,sizeof(deg2),0);
 until Changed=false;
end;

procedure NormalizeFirst;
var Changed:boolean;
    i,pq:integer;
    ver,ver2:PVertex;
begin
 repeat
  Changed:=false;
  ncv:=0;
  for i:=1 to cv do if deg[i]>=2 then begin
   inc(ncv);
   vx2[ncv]:=vx[i]; vy2[ncv]:=vy[i];
   a2[ncv]:=a[i]; soo[i]:=ncv;
  end;
  for pq:=1 to cv do if soo[pq]<>0 then begin
   i:=soo[pq];
   deg2[i]:=0; ver:=a2[i];
   a2[i]:=0;
   while ver<>0 do begin
    ver2:=vs[ver].next;
    if deg[vs[ver].v]>=2 then begin
     vs[ver].v:=soo[vs[ver].v];
     vs[ver].next:=a2[i];
     a2[i]:=ver; inc(deg2[i]);
    end else
     Deleted[vs[ver].e]:=true;
    ver:=ver2;
   end;
  end else begin
   ver:=a[pq];
   while ver<>0 do begin
    ver2:=vs[ver].next;
    Deleted[vs[ver].e]:=true;
    ver:=ver2;
   end;
  end;
  if cv<>ncv then Changed:=true;
  a:=a2; vx:=vx2; vy:=vy2; cv:=ncv; deg:=deg2;
  fillchar(deg2,sizeof(deg2),0);
 until Changed=false;
end;

function Atan(x,y:longint):Extended;
begin
  if x<>0 then
   ATan:=Arctan2(-x,-y)+pi else
  if y>0 then Atan:=0 else atan:=pi;
end;

function CountFi(ax,ay,bx,by:longint):extended;
var cosa,sina:extended;
begin
 cosa:=ax*bx+ay*by;
 sina:=ax*by-ay*bx;
 if sina<>0 then Countfi:=Arctan2(sina,cosa) else
  if cosa>0 then Countfi:=0 else Countfi:=pi;
end;

function FindUpper(i:integer):integer;
var ver:PVertex;
    fi,mfi:Extended;
    j,me:integer;
begin
 ver:=a[i];
 j:=i;
 mfi:=4;
 while ver<>0 do begin
  fi:=Atan(vx[vs[ver].v]-vx[i],vy[vs[ver].v]-vy[i]);
  if fi<mfi then begin j:=vs[ver].v; mfi:=fi; me:=vs[ver].e end;
  ver:=vs[ver].next;
 end;
 if (vx[i]=otrx2[me])and(vy[i]=otry2[me]) then otrl[me]:=curarea else otrr[me]:=curarea;
 for k:=1 to cdel do begin
  fi:=CountFi(vx[i]-delx[k],vy[i]-delx[k],vx[j]-delx[k],vy[j]-delx[k]);
  dels[k]:=dels[k]+fi;
 end;
 FindUpper:=j;
end;

function FindLower(i,k:integer):longint;
var ver:PVertex;
    j:integer;
    fi,mfi,lfi:Extended;
    me:integer;
begin
 j:=0;
 mfi:=-4;
 lfi:=pi-ATan(vx[i]-vx[k],vy[i]-vy[k]);
 if abs(lfi)<1e-10 then lfi:=lfi+2*pi;
 ver:=a[i];
 while ver<>0 do begin
  fi:=Atan(vx[vs[ver].v]-vx[i],vy[vs[ver].v]-vy[i])+lfi;
  while fi<0 do fi:=fi+2*pi;
  while fi>2*pi do fi:=fi-2*pi;
  if (vs[ver].v<>k)and(fi>mfi) then begin j:=vs[ver].v; mfi:=fi; me:=vs[ver].e end;
  ver:=vs[ver].next;
 end;
 if (vx[i]=otrx2[me])and(vy[i]=otry2[me]) then otrl[me]:=curarea else otrr[me]:=curarea;
 for k:=1 to cdel do begin
  fi:=CountFi(vx[i]-delx[k],vy[i]-delx[k],vx[j]-delx[k],vy[j]-delx[k]);
  dels[k]:=dels[k]+fi;
 end;
 FindLower:=j;
end;

function Find(p:integer):boolean;
var cls:array[0..5] of boolean;
    i:byte;
    ver:integer;
    k,kk:boolean;
begin
 k:=false;
 ver:=g[p];
 fillchar(cls,sizeof(cls),0);
 while ver<>0 do begin
  cls[mon[vg[ver].v]]:=true;
  ver:=vg[ver].next;
 end;
 find:=true;
 for i:=1 to 5 do if cls[i]=false then begin
  k:=true; kk:=true;
  mon[p]:=i;
{  if nver=cv then begin
   find:=true; exit;
  end;}
  ver:=g[p];
  while ver<>0 do begin
   if mon[vg[ver].v]=0 then if Find(vg[ver].v)=false then kk:=false;
   ver:=vg[ver].next;
  end;
  if kk then begin
   find:=true; exit
  end;
 end;
 if (not k)and(deg[p]>1) then find:=false;
 mon[p]:=0;
end;

begin
 assign(input,'input.txt'); reset(input);
 assign(output,'output.txt'); rewrite(output);
 readln(n);
 for i:=1 to n do begin
  readln(x1,y1,x2,y2);
  otrx1[i]:=x1; otry1[i]:=y1;
  otrx2[i]:=x2; otry2[i]:=y2;
  vx[cv+1]:=x1;
  vy[cv+1]:=y1;
  for j:=1 to cv+1 do if (vx[j]=x1)and(vy[j]=y1) then break;
  if j=cv+1 then begin
   j:=x1; x1:=x2; x2:=j;
   j:=y1; y1:=y2; y2:=j;
   vx[cv+1]:=x1;
   vy[cv+1]:=y1;
   for j:=1 to cv+1 do if (vx[j]=x1)and(vy[j]=y1) then break;
  end;
  if j=cv+1 then begin
   inc(cv,2);
   vx[cv]:=x2; vy[cv]:=y2;
   inc(lvs); ver:=lvs;
   vs[ver].next:=0; vs[ver].v:=cv; vs[ver].e:=i;
   a[cv-1]:=ver; inc(deg[cv-1]);
   inc(lvs); ver:=lvs;
   vs[ver].next:=0; vs[ver].v:=cv-1; vs[ver].e:=i;
   a[cv]:=ver; inc(deg[cv]);
  end else begin
   vx[cv+1]:=x2;
   vy[cv+1]:=y2;
   for k:=1 to cv+1 do if (vx[k]=x2)and(vy[k]=y2) then break;
   if k=cv+1 then inc(cv);
   inc(lvs); ver:=lvs; vs[ver].e:=i;
   vs[ver].next:=a[j]; vs[ver].v:=k; a[j]:=ver; inc(deg[j]);
   inc(lvs); ver:=lvs; vs[ver].e:=i;
   vs[ver].next:=a[k]; vs[ver].v:=j; a[k]:=ver; inc(deg[k]);
  end;
 end;
 NormalizeFirst;
 for i:=1 to n do if deleted[i] then begin
  inc(cdel);
  delx[cdel]:=otrx1[i]; dely[cdel]:=otry1[i];
  deln[cdel]:=i;
 end;
 while cv<>0 do begin
  fillchar(dels,sizeof(extended)*cdel,0);
  inc(curarea);
  j:=1; for i:=2 to cv do if vx[i]<vx[j] then j:=i;
  first:=j;
  second:=FindUpper(first);
  s:=1.0*vx[first]*vy[second]-1.0*vy[first]*vx[second];
  oj:=first; j:=second;
  repeat
   nj:=FindLower(j,oj);
   oj:=j; j:=nj;
   s:=s+1.0*vx[oj]*vy[j]-1.0*vy[oj]*vx[j];
  until j=first;
  for i:=1 to cdel do if Abs(Abs(dels[i])-2*pi)<1e-7 then begin
   otrl[deln[i]]:=curarea; otrr[deln[i]]:=curarea;
  end;
  DeleteEdge(first,second);
  DeleteEdge(second,first);
  Normalize;
 end;
 mon[0]:=1;
 fillchar(deg,sizeof(deg),0);
 lvg:=0;
 for i:=1 to n do begin
  inc(deg[otrr[i]]); inc(deg[otrl[i]]);
  inc(lvg);
  ver:=lvg; vg[ver].v:=otrr[i]; vg[ver].next:=g[otrl[i]]; g[otrl[i]]:=ver;
  inc(lvg);
  ver:=lvg; vg[ver].v:=otrl[i]; vg[ver].next:=g[otrr[i]]; g[otrr[i]]:=ver;
 end;
 Find(0);
 for i:=1 to n do begin
  write(otrx1[i],' ',otry1[i],' ',otrx2[i],' ',otry2[i],' ');
  writeln(monsters[mon[otrl[i]]],' ',monsters[mon[otrr[i]]]);
 end;
 close(output);
end.
