program Beatiful_And_Miserable;

const
  maxn = 100100; {100100}

var
  n : longint;
  s,b : array [1..maxn] of longint;
  Hn : longint;
  H : array [1 .. MaxN] of Longint;
  a : array [0 .. MaxN] of Longint;
  amax : longint;
  p : array [1 .. maxn] of Longint;

procedure Swap(X,Y : Longint);
var
  T : Longint;
begin
  T := H[X];
  H[X] := H[Y];
  H[Y] := T;
end;

procedure Heapify(X:Longint);
var
  Y : longint;
begin
  Y := X;
  if (2*X<=Hn) and ((s[h[2*X]]>s[h[Y]]) or ((s[h[2*x]]=s[h[y]]) and (b[h[2*x]]<b[h[y]]))) then
    Y := 2*X;
  if (2*X+1<=Hn) and ((s[h[2*X+1]]>s[h[Y]]) or ((s[h[2*x+1]]=s[h[y]]) and (b[h[2*x+1]]<b[h[y]]))) then
    Y := 2*X+1;
  if X<>Y then
  begin
    Swap(X,Y);
    Heapify(Y);
  end;
end;

procedure Build_Heap;
var
  I : longint;
begin
  for I:=N downto 1 do
    Heapify(I);
end;

procedure Heap_Sort;
var
  i : longint;
begin
  Hn := N;
  for i:=1 to n do
    h[i] := i;
  Build_Heap;
  while Hn>1 do
  begin
    Swap(1,Hn);
    Dec(Hn);
    Heapify(1);
  end;
end;

procedure Inp;
var
  i : longint;
begin
  assign(input,'beauty.in'); reset(input);
  assign(output,'beauty.out'); rewrite(output);
  read(n);
  for i := 1 to n do
    read(s[i],b[i]);
end;

function less(c,d : longint) : boolean;
begin
  less := (s[c]<s[d]) and (b[c]<b[d]);
end;

function find(y : longint) : longint;
var
  l,r,m : longint;
begin
  if (amax=0) or (not less(h[y],h[a[1]])) then
    find := 0
  else
  begin
    l := 1;
    r := amax;
    while (r-l>1) do
    begin
      m := (l+r) div 2;
      if less(h[y],h[a[m]]) then
        l := m
      else
        r := m;
    end;
    if less(h[y],h[a[r]]) then
      find := r
    else
      find := l;
  end;
end;

var
  posl : array [1 .. maxn] of longint;

procedure Run;
var
  i : longint;
  t : longint;
begin
  heap_sort;
  a[0] := 0;
  amax := 0;
  for i:=n downto 1 do
  begin
    t := find(i);
    if t=amax then
    begin
      p[i] := a[amax];
      inc(amax);
      a[amax] := i;
    end else
    begin
      p[i] := a[t];
      a[t+1] := i;
    end;
  end;
  posl[1] := a[amax];
  for i:=1 to amax-1 do
    posl[i+1] := p[posl[i]];
  writeln(amax);
  for i:=1 to amax do
    write(h[posl[i]],' ');
  writeln;
end;

procedure Outp;
begin
  close(input); close(output);
end;

begin
  Inp;
  Run;
  Outp;
end.
