#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define eps 1e-7

FILE *fi, *fo;
double n,m,k;
double d,d1,d2;
unsigned long kk;
unsigned long nn,mm;

unsigned long min(unsigned long a,unsigned long b)
{
  return (a<b)?a:b;
}

int main()
{
  fi=fopen("rooks.in","rt");
  fo=fopen("rooks.out","wt");

  fscanf(fi,"%lf%lf",&n,&m);
  
  d1=m+n+3.0-2.0*(sqrt(m+1))*(sqrt(n+1));
  d2=m+n+3.0+2.0*(sqrt(m+1))*(sqrt(n+1));
  d=sqrt(d1)*sqrt(d2);
  k=(m+n+3.0-d)/2.0;
  k+=eps;
  kk=(long)k;

  nn=(long)n;
  mm=(long)m;
  if(kk>min(nn,mm)) kk=min(nn,mm);

  fprintf(fo,"%li\n",kk);

  fclose(fi);
  fclose(fo);
  return 0;
}
