#include <stdio.h>
#include <stdlib.h>

#define NN 300

FILE *fi, *fo;
int n;
double a[NN][NN];
bool b[NN][NN];
double f;

void WriteLF(double a)
{
  double f;
  int pw;
  f=1;
  pw=0;
  while(f<=a)
  {
    f*=10.0;
    pw++;
  }
  while(f>a)
  {
    f/=10.0;
    pw--;
  }
  a/=f;
  fprintf(fo,"%0.5lfE",a);
  if(pw>=0)
    fprintf(fo,"+");
  else
  {
    fprintf(fo,"-");
    pw=-pw;
  }
  if(pw<100) fprintf(fo,"0");
  if(pw<10) fprintf(fo,"0");
  fprintf(fo,"%i\n",pw);
}

int main()
{
  int i,j;
  int m;
  char c;
  double aa;
  int bb;
  fi=fopen("math.in","rt");
  fo=fopen("math.out","wt");

  fscanf(fi,"%i",&n);

  for(i=0;i<n;i++)
  {
    for(j=0;j<n;j++)
    {
      a[i][j]=0;
      b[i][j]=false;
    }
    b[i][i]=true;
    a[i][i]=1;
    fscanf(fi,"%i",&m);
    for(j=0;j<m;j++)
    {
      while(((c=getc(fi))!='*')&&(c!='/'));
      fscanf(fi,"%lf%i",&aa,&bb);
      if(c=='/') aa=1.0/aa;
      if(!b[i][bb-1])
      {
        a[i][bb-1]=aa;
        b[i][bb-1]=true;
      }
      else
        if(fabs(a[i][bb-1])<fabs(aa)) a[i][bb-1]=aa;
//      if(((bb-1)==i)&&(aa<a[i][bb-1])&&(aa<-1)) a[i][bb-1]=aa;
    }
  }

  for(m=0;m<n;m++)
    for(i=0;i<n;i++)
      for(j=0;j<n;j++)
      {
        if(b[i][m]&&b[m][j])
        {
          if(!b[i][j])
          {
            b[i][j]=true;
            a[i][j]=a[i][m]*a[m][j];
          }
          else
            if(a[i][j]<a[i][m]*a[m][j]) a[i][j]=a[i][m]*a[m][j];
        }
      }

  for(i=0;i<n;i++)
  {
    if(b[0][i]&&((a[i][i]<-1)||(a[i][i]>1)))
    {
      for(j=0;j<n;j++)
      {
        if(b[i][j])
        {
          a[j][j]=a[i][i];
        }
      }
    }
  }

  for(i=0;i<n;i++)
  {
    if(!b[0][i])
      fprintf(fo,"NONE\n");
    else
    {
      if((a[i][i]>1)||(a[i][i])<-1)
        fprintf(fo,"INF\n");
      else
        WriteLF(a[0][i]);
    }
  }

  fclose(fi);
  fclose(fo);
  return 0;
}
