#include <stdio.h>
#include <math.h>

FILE*fi,*fo;

#define EPS ((double)1e-15)
#define INF ((double)1e1000)

#define MIN(a,b) (((a)<=(b))?(a):(b))

long n,m,k;

int main(void) {
  fi=fopen("rooks.in","rt");
  fscanf(fi,"%ld%ld",&n,&m);
  fclose(fi);
  long nm=MIN(n,m);
  double N,M,N_M_1,NM_1,D,K,KK[16],Z0,Z;
  long kk[16]; int kc,i;
  N=(double)n; M=(double)m;
  kk[0]=1; kc=1;
  N_M_1=N+M+1; NM_1=N*M-1;
  D=N_M_1*N_M_1-NM_1*4;
  K=(N_M_1-sqrt(D))/2;
  kk[kc]=(long)(floor(K)+EPS); if ((kk[kc]>=1)&&(kk[kc]<=nm)) kc++;
  kk[kc]=(long)(ceil(K)+EPS); if ((kk[kc]>=1)&&(kk[kc]<=nm)) kc++;
  for (i=0; i<kc; i++) KK[i]=(double)kk[i];
  Z0=(N-KK[0]+1)*(M-KK[0]+1)/(KK[0]); k=kk[0];
  for (i=1; i<kc; i++) {
    Z=(N-KK[i]+1)*(M-KK[i]+1)/(KK[i]);
    if (Z<1) continue;
    if ((Z0<1)||(Z0>Z)) { Z0=Z; k=kk[i]; }
  }
  fo=fopen("rooks.out","wt");
  fprintf(fo,"%ld",k);
  fclose(fo);
  return(0);
}
