{$N+}
{.$define debug}

program template;
const
 h = 100000;
 {$ifdef debug}
 cinfile = 'input.txt';
 coutfile = 'output.txt';
 {$else}
 cinfile = 'rooks.in';
 coutfile = 'rooks.out';
 {$endif}
type
 int = longint;
 real = extended;
var
 n,m :int;
 ans :int;

procedure init;
begin
 ans := 0;
end;

procedure readdata;
var i,j :int;
begin
 assign (input,cinfile);
 reset (input);
 read (n,m);
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans);
 close (output);
end;

function min (a,b :int):int;
begin
 if a < b then
  min := a
 else
  min := b;
end;

function c (x :int):real;
begin
 c := 1.0*(m-x+1)*(n-x+1)/x;
end;

procedure solve;
var i,j :int;
    l,r :int;
    mid :int;
    t :real;
begin
 l := 1;
 r := min (n,m);
 while r-l > 1 do
  begin
   mid := (l+r) shr 1;
   t := c(mid);
   if t > 1 then
    l := mid
   else
    r := mid;
  end;
 t := c(r);
 if t > 1 then
  ans := r
 else
  ans := l;

{ ans := mid;}
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.