type int = longint;
var num, t, x, y, xx, yy: array [1..1100] of int;
var pp, p, mark: array [1..110] of int;
var pn: int;

procedure dfs(u: int);
var i: int;
begin
  mark[u]:=1;
  for i:=t[u] to t[u + 1] - 1 do
    if mark[y[i]] = 0 then dfs(y[i]);
  inc(pn);
  p[pn]:=u;
end;

var path: array [1..1100] of int;
var plen: int;
var z: array [1..110] of int;

function find(u: int): int;
var i: int;
begin
  if z[u] <> -1 then
    begin
      find:=z[u];
      exit;
    end;
  for i:=t[u] to t[u + 1] - 1 do
    if y[i] <> 0 then
      begin
        if z[y[i]] = -1 then z[y[i]]:=find(y[i]);
        if z[y[i]] = 0 then continue;
        find:=y[i];
        exit;
      end;
  find:=0;
  z[u]:=0;
end;

procedure findpath(a, b: int);
var i, u: int;
begin
  for i:=1 to 110 do
    z[i]:=-1;
  z[b]:=b;
  plen:=0;
  for i:=t[a] to t[a + 1] - 1 do
    if (y[i] <> b) and (y[i] <> 0) then
      begin
        if find(y[i]) = 0 then continue;
        u:=y[i];
        plen:=1;
        path[1]:=a;
        while u <> b do
          begin
            inc(plen);
            path[plen]:=u;
            u:=find(u);
          end;
        inc(plen);
        path[plen]:=u;
      end;
end;

const MAXS = 1100;
var u, i, n, m: int;
var c: array [1..1100] of int;
var r: array [1..MAXS + 10, 1..MAXS + 10] of int;
var rc: array [1..1100] of int;

const MAXV = 110;
var w, ww: array [1..MAXV, 1..MAXV] of int;

var ans, tt, k, j, g, t1: int;
begin
  assign(input, 'comm.in');
  assign(output, 'comm.out');
  reset(input);
  rewrite(output);
  read(n, m);
  for i:=1 to m do
    read(x[i], y[i]);
  for i:=1 to m do
    inc(c[x[i]]);
  t[1]:=1;
  for i:=2 to n do
    t[i]:=t[i - 1] + c[i - 1];
  t[n + 1]:=m + 1;
  for i:=1 to m do
    begin
      w[x[i]][y[i]]:=i;
      u:=t[x[i]];
      xx[u]:=x[i];
      yy[u]:=y[i];
      num[u]:=i;
      inc(t[x[i]]);
    end;
  t[1]:=1;
  for i:=2 to n do
    t[i]:=t[i - 1] + c[i - 1];
  t[n + 1]:=m + 1;
  for i:=1 to m do
    begin
      x[i]:=xx[i];
      y[i]:=yy[i];
    end;

  for i:=1 to n do
    mark[i]:=0;
  pn:=0;
  for i:=1 to n do
    if mark[i] = 0 then dfs(i);
  for i:=1 to m do
    begin
      rc[i]:=1;
      r[i][1]:=i;
    end;
  for i:=1 to n do
    pp[i]:=p[n + 1 - i];
  for i:=1 to n do
    p[i]:=pp[i];
  pn:=n;

  for i:=1 to m do
    begin
      xx[i]:=x[i];
      yy[i]:=y[i];
    end;
  for i:=1 to n do
    begin
      pp[i]:=p[i];
      for j:=1 to n do
        ww[i][j]:=w[i][j];
    end;

  ans:=0;
  while true do
    begin
      if pn <= 1 then break;
      u:=p[pn];
      j:=0;
      for i:=1 to n do
        if w[i][u] <> 0 then
          begin
            j:=i;
            break;
          end;
      if j = 0 then
        begin
          dec(pn);
          continue;
        end;
      k:=0;
      for i:=1 to n do
        if (w[j][i] <> 0) and (i <> u) then
          begin
            k:=i;
            break;
          end;
      if k <> 0 then
        begin
          findpath(j, u);

          inc(ans);

          w[j][u]:=0;
          for t1:=t[j] to t[j + 1] - 1 do
            if y[t1] = u then y[t1]:=0;
          continue;
        end;
      k:=0;
      for i:=1 to n do
        if w[i][j] <> 0 then
          begin
            k:=i;
            for t1:=t[k] to t[k + 1] - 1 do
              if y[t1] = j then y[t1]:=u;
            w[k][u]:=w[k][j];
            for t1:=1 to rc[w[j][u]] do
              begin
                inc(rc[w[k][u]]);
                r[w[k][u]][rc[w[k][u]]]:=r[w[j][u]][t1];
              end;
            w[k][j]:=0;
          end;
      if k <> 0 then
        begin
          w[j][u]:=0;
          for t1:=t[j] to t[j + 1] - 1 do
            if y[t1] = u then y[t1]:=0;
          continue;
        end;
      w[j][u]:=0;
      for t1:=t[j] to t[j + 1] - 1 do
        if y[t1] = u then y[t1]:=0;
    end;

  for i:=1 to m do
    begin
      x[i]:=xx[i];
      y[i]:=yy[i];
    end;
  for i:=1 to n do
    begin
      p[i]:=pp[i];
      for j:=1 to n do
        w[i][j]:=ww[i][j];
    end;

  writeln(ans);
  pn:=n;
  for i:=1 to n do
    rc[i]:=1;
  for i:=1 to m do
    r[i][1]:=i;

  while true do
    begin
      if pn <= 1 then break;
      u:=p[pn];
      j:=0;
      for i:=1 to n do
        if w[i][u] <> 0 then
          begin
            j:=i;
            break;
          end;
      if j = 0 then
        begin
          dec(pn);
          continue;
        end;
      k:=0;
      for i:=1 to n do
        if (w[j][i] <> 0) and (i <> u) then
          begin
            k:=i;
            break;
          end;
      if k <> 0 then
        begin
          findpath(j, u);
          for t1:=1 to rc[w[j][u]] do
            write(r[w[j][u]][t1], ' ');
          write('=');
          for i:=1 to plen - 1 do
            begin
              g:=w[path[i]][path[i + 1]];

              for t1:=1 to rc[g] do
                write(' ', r[g][t1]);
            end;
          writeln;
          w[j][u]:=0;
          for t1:=t[j] to t[j + 1] - 1 do
            if y[t1] = u then y[t1]:=0;
          continue;
        end;
      k:=0;
      for i:=1 to n do
        if w[i][j] <> 0 then
          begin
            k:=i;
            for t1:=t[k] to t[k + 1] - 1 do
              if y[t1] = j then y[t1]:=u;
            w[k][u]:=w[k][j];
            for t1:=1 to rc[w[j][u]] do
              begin
                inc(rc[w[k][u]]);
                r[w[k][u]][rc[w[k][u]]]:=r[w[j][u]][t1];
              end;
            w[k][j]:=0;
          end;
      if k <> 0 then
        begin
          w[j][u]:=0;
          for t1:=t[j] to t[j + 1] - 1 do
            if y[t1] = u then y[t1]:=0;
          continue;
        end;
      w[j][u]:=0;
      for t1:=t[j] to t[j + 1] - 1 do
        if y[t1] = u then y[t1]:=0;
    end;


  close(input);
  close(output);
end.
