{Filimonov Vladislav}
Uses SysUtils;
Const
  InFileName='japan.in';
  OutFileName='japan.out';
  MaxN=2003;
  MaxK=2000;
  GivenTime=1/24/60/60;

Type TMas=Array[0..MaxN] Of Integer;
Var
  Fail:Text;
  BeginTime:Double;
  N:Integer;
  K:Integer;
  L:Array[1..MaxK] Of Integer;
  SumLen:Integer;
  Min:Integer;
  Max:Integer;
  K2:Integer;
  K1:Integer;
  A:TMas;
  B:TMas;

Procedure Get;
Var
  I:Integer;
  Begin
    Min:=2004;
    Max:=-1;
    K2:=0;
    K1:=0;
    Assign(Fail,InFileName);
    ReSet(Fail);
    ReadLn(Fail,N);
    Read(Fail,K);
    SumLen:=0;
    For I:=1 To K Do Begin
      Read(Fail,L[I]);
      Inc(SumLen,L[I]);
      If L[I]<Min Then Min:=L[I];
      If L[I]>Max Then Max:=L[I];
    End;
    ReadLn(Fail);
    For I:=1 To N Do Begin
      Read(Fail,A[I]);
      If A[I]=1 Then Inc(K1);
      If A[I]=2 Then Inc(K2);
    End;
    A[0]:=0;
    A[N+1]:=0;
    Close(Fail);
  End;

Procedure Save;
Var
  I:Integer;
  Begin
    Assign(Fail,OutFileName);
    ReWrite(Fail);
    For I:=1 To N Do Write(Fail,A[I],' ');
    Close(Fail);
    Halt;
  End;


Procedure Prepare(X,Y:Integer);
Var
  I,J:Integer;
  Begin
    If Abs(Y-X)+1<Min Then Begin
      For I:=X To Y Do Begin
        A[I]:=0;
        Dec(K2);
      End;
    End;
    For I:=X To Y Do Begin
      If (A[I]=1) And (Abs(I-X)+1<Min) Then Begin
        For J:=I+1 To I+Abs(Min-(Abs(I-X)+1)) Do Begin
          If A[J]=2 Then Begin
            Inc(K1);
            Dec(K2);
          End;
          A[J]:=1;
        End;
      End;
      If (A[I]=1) And (Abs(Y-I)+1<Min) Then Begin
        For J:=I-1 To I-Abs(Min-(Abs(Y-I)+1)) Do Begin
          If A[J]=2 Then Begin
            Inc(K1);
            Dec(K2);
          End;
          A[J]:=1;
        End;
      End;
    End;
  End;

Function Can(Var M:TMas;Poz:Integer):Boolean;
Var
  I:Integer;
  Can1,Can2:Boolean;
  W:Boolean;
  Cur,Kol:Integer;
  Begin
    If N>20 Then If (Now-BeginTime)>GivenTime*0.9 Then Save;
    W:=False;
    For I:=1 To N Do Begin
      If M[I]=2 Then Begin
        M[I]:=1;
        Can1:=Can(M,I+1);
        M[I]:=0;
        Can2:=Can(M,I+1);
        M[I]:=2;
        Can:=Can1 Or Can2;
        W:=True;
        Break;
      End;
    End;
    If W=False Then Begin
      Cur:=0;
      Kol:=0;
      For I:=1 To N+1 Do Begin
        If M[I]=1 Then Inc(Kol) Else If Kol<>0 Then Begin
          If Kol<>L[Cur+1] Then Begin
            Can:=False;
            Exit;
          End Else Begin
            Inc(Cur);
            Kol:=0;
          End;
        End;
      End;
      If Cur=K Then Can:=True Else Can:=False;
    End;
  End;

Procedure Solve;
Var
  I,J,Q:Integer;
  Kol:Integer;
  Kol2:Integer;
  Can1,Can2:Boolean;
  Begin
    For Q:=1 To 5 Do Begin
      Kol:=0;
      For I:=1 To N Do Begin
        If A[I]=1 Then Inc(Kol) Else Kol:=0;
        If Kol=Max Then Begin
          A[I-Kol]:=0;
          A[I+1]:=0;
        End;
        If (A[I-1]=0) And (A[I]=1) Then Begin
          For J:=1 To Min Do Begin
            If (A[I+J-1]=2) Then Begin
              Inc(K1);
              Dec(K2);
            End;
            A[I+J-1]:=1;
          End;
        End;
      End;
      Kol:=0;
      For I:=N DownTo 1 Do Begin
        If A[I]=1 Then Inc(Kol) Else Kol:=0;
        If Kol=Max Then Begin
          A[I+Kol]:=0;
          A[I-1]:=0;
        End;
        If (A[I+1]=0) And (A[I]=1) Then Begin
          For J:=1 To Min Do Begin
            If (A[I-J+1]=2) Then Begin
              Inc(K1);
              Dec(K2);
            End;
            A[I-J+1]:=1;
          End;
        End;
      End;
    End;
    If K2=0 Then Save;
    If K1=SumLen Then Begin
      For I:=1 To N Do Begin
        If A[I]=2 Then A[I]:=0;
      End;
      Save;
    End;
    Kol2:=0;
    For I:=0 To N+1 Do Begin
      If A[I]<>0 Then Inc(Kol2) Else Begin
        If (A[I]=0) And (Kol2>0) Then Begin
          Prepare(I-Kol2,I-1);
        End;
      End;
    End;

    For I:=1 To N Do B[I]:=A[I];
    For I:=1 To N Do Begin
      If A[I]=2 Then Begin
        B[I]:=1;
        Can1:=Can(B,I+1);
        B[I]:=0;
        Can2:=Can(B,I+1);
        B[I]:=2;
        If (Can1=True) And (Can2=False) Then Begin
          A[I]:=1;
          B[I]:=1;
        End;
        If (Can2=True) And (Can1=False) Then Begin
          A[I]:=0;
          B[I]:=0;
        End;
      End;
      If (Now-BeginTime)>GivenTime*0.9 Then Save;
    End;
  End;

Begin
  BeginTime:=Now;
  Get;
  Solve;
  Save;
End.
