{$R+}
type int = longint;

const MAXS = 100;

var ch: char;

var d: array [1..MAXS, 1..2] of string;
var dnum: int;

var s: array [1..MAXS] of string;
var snum: int;

var s_face: array [1..MAXS] of int;

var bug: boolean; {Is in quest bug?}

var z: array [1..MAXS, 1..MAXS] of int;

var every, nobody: array [1.. MAXS] of boolean;


function getword: string;
var ans: string;
begin
  ans:='';
  while (ch <= ' ') do read(ch);
  while ((ch >= 'a') and (ch <= 'z')) or
        ((ch >= 'A') and (ch <= 'Z')) or (ch = '''') do
          begin
            ans:=ans + ch;
            read(ch);
          end;
  getword:=ans;
end;

var quest: boolean;
function end_of_tense: boolean;
begin
  quest:=false;
  while (ch <= ' ') do
    read(ch);
  if ch = '.' then
    begin
      end_of_tense:=true;
      exit;
    end;
  if ch = '?' then
    begin
      end_of_tense:=true;
      quest:=true;
      exit;
    end;
  end_of_tense:=false;
end;

var tense: array [0..5] of string;
var wnum: int;

procedure do_add_neg;
var subj, i, dn: int;
begin
  for i:=1 to snum do
    if s[i] = tense[1] then break;
  if i > snum then
    begin
      inc(snum);
      s[snum]:=tense[1];
      i:=snum;
    end;
  subj:=i;

  if tense[2] = 'don''t' then
    s_face[i]:=1
  else
    s_face[i]:=2;

  for i:=5 to wnum do
    tense[4]:=tense[4] + tense[i];

  for i:=1 to dnum do
    if (tense[3] = d[i][1]) and (tense[4] = d[i][2]) then
      break;
  if i > dnum then
    begin
      inc(dnum);
      d[dnum][1]:=tense[3];
      d[dnum][2]:=tense[4];
      i:=dnum;
    end;
  dn:=i;

  if z[subj][dn] = 1 then
    bug:=true;

  z[subj][dn]:=-1;
end;

procedure do_add_pos;
var dn, subj, i: int;
var good: boolean;
begin
  if (tense[1] <> 'everybody') and (tense[1] <> 'nobody') then
    begin
      for i:=1 to snum do
        if s[i] = tense[1] then break;
      if i > snum then
        begin
          inc(snum);
          s[snum]:=tense[1];
          i:=snum;
        end;
      subj:=i;
    end
  else
    i:=MAXS;

  if tense[2][length(tense[2])] = 's' then
    s_face[i]:=2
  else
    s_face[i]:=1;

  if s_face[i] = 2 then
    tense[2]:=copy(tense[2], 1, length(tense[2]) - 1);

  for i:=4 to wnum do
    tense[3]:=tense[3] + ' ' + tense[i];

  good:=false;
  for i:=1 to dnum do
    if (tense[2] = d[i][1]) and (tense[3] = d[i][2]) then
      good:=true;
  if not good then
    begin
      inc(dnum);
      d[dnum][1]:=tense[2];
      d[dnum][2]:=tense[3];
      i:=dnum;
    end;
  dn:=i;

  if tense[1] = 'everybody' then
    begin
      for i:=1 to snum do
        if z[i][dn] =-1 then
          begin
            bug:=true;
            exit;
          end
      else
        z[i][dn]:=1;
      every[dn]:=true;
      exit;
    end;

  if tense[1] = 'nobody' then
    begin
      for i:=1 to snum do
        if z[i][dn] = 1 then
          begin
            bug:=true;
            exit;
          end
      else
        z[i][dn]:=-1;
      nobody[dn]:=true;
      exit;
    end;
  if z[subj][dn] = -1 then
    bug:=true;

  z[subj][dn]:=1;
end;


procedure do_add;
begin
  if (tense[2] = 'don''t') or (tense[2] = 'doesn''t') then
    do_add_neg
  else
    do_add_pos;
end;

procedure do_answer_1; { do/does ... }
var dn, i, subj: int;
var good: boolean;
begin
  if (tense[2] <> 'everybody') and (tense[2] <> 'nobody') then
    begin
      for i:=1 to snum do
        if s[i] = tense[2] then break;
      if i > snum then
        begin
          inc(snum);
          s[snum]:=tense[2];
          i:=snum;
        end;
      subj:=i;
    end;

  for i:=5 to wnum do
    tense[4]:=tense[4] + tense[i];

  good:=false;
  for i:=1 to dnum do
    if (tense[3] = d[i][1]) and (tense[4] = d[i][2]) then
      good:=true;
  if not good then
    begin
      writeln('maybe.');
      exit;
    end;
  dn:=i;

  if s[subj] = 'everybody' then
    begin
      if every[dn] then
        begin
          write('yes, everybody ');
          write(tense[3], 's ', tense[4]);
          exit;
        end
      else
        begin
          writeln('no, everybody doesn''t ', tense[3], ' ', tense[4]);
          exit;
        end;
    end;

  if s[subj] = 'nobody' then
    begin
      if every[dn] then
        begin
          write('yes, nobody ');
          write(tense[3], 's ', tense[4]);
          exit;
        end
      else
        begin
          writeln('no, nobody doesn''t ', tense[3], ' ', tense[4]);
          exit;
        end;
    end;

  if z[subj][i] = 0 then
    begin
      writeln('maybe.');
      exit;
    end;

  if z[subj][i] = 1 then
    begin
      write('yes, ');
      if (s[subj] = 'I') or (s[subj] = 'you') then
        begin
          if s[subj] = 'I' then write('you');
          if s[subj] = 'you' then write('I');
        end
      else
        write(s[subj]);
      write(' ', tense[3]);
      if s_face[subj] = 2 then write('s');
      writeln(' ', tense[4]);
      exit;
    end;

  if z[subj][i] = -1 then
    begin
      write('no, ', s[subj], ' ');
      if s_face[subj] = 1 then write('don''t') else write('doesn''t');
      writeln(' ', tense[3], ' ', tense[4]);
      exit;
    end;

end;

procedure do_answer_2; { who ... }
var last_subj, subj, k, i, dn: int;
var first: boolean;
var good: boolean;
begin
  for i:=4 to wnum do
    tense[3]:=tense[3] + tense[i];

  good:=false;
  for i:=1 to dnum do
    if (tense[2] = d[i][1]) and (tense[3] = d[i][2]) then
      good:=true;
  if not good then
    begin
      writeln('I don''t know.');
      exit;
    end;
  dn:=i;
  if every[dn] then
    begin
      writeln('everybody ', tense[2], 's ', tense[3]);
      exit;
    end;

  if nobody[dn] then
    begin
      writeln('nobody ', tense[2], 's ', tense[3]);
      exit;
    end;

  k:=0;
  for i:=1 to snum do
    if z[i][dn] = 1 then
      begin
        inc(k);
        subj:=i;
      end;
  if k = 0 then
    begin
      writeln('I don''t know.');
      exit;
    end;

  if k = 1 then
    begin
      write(s[subj], ' ', tense[2]);
      if s_face[subj] = 2 then write('s');
      write(' ', tense[3]);
      exit;
    end;

  last_subj:=subj;
  first:=false;
  for i:=1 to snum do
    if z[i][dn] = 1 then
      begin
        if last_subj = i then write(' and ') else
          if not first then write(', ') else write(' ');
        write(s[i]);
        first:=true;
      end;
  write(' ', tense[2], ' ', tense[3]);
end;

procedure do_answer_3; { what ? }
var first: boolean;
var face, subj, i, dn, k, last_d: int;
begin
  if tense[3] = 'everybody' then
    begin
      k:=0;
      for i:=1 to dnum do
        if every[i] then
          begin
            inc(k);
            last_d:=i;
          end;
      if k = 0 then
        begin
          writeln('I don''t know.');
          exit;
        end;
      if k = 1 then
        begin
          writeln('everybody ', d[last_d][1], 's ', d[last_d][2]);
          exit;
        end;
      first:= false;
      for i:=1 to dnum do
        if every[i] then
          begin
            if i = last_d then write(', and ') else
              if not first then write(', ') else write(' ');
            first:=false;
            write(d[i][1], 's ', d[i][2]);
          end;
      exit;
    end;

  if tense[3] = 'nobody' then
    begin
      k:=0;
      for i:=1 to dnum do
        if every[i] then
          begin
            inc(k);
            last_d:=i;
          end;
      if k = 0 then
        begin
          writeln('I don''t know.');
          exit;
        end;
      if k = 1 then
        begin
          writeln('nobody doesn''t ', d[last_d][1], ' ', d[last_d][2]);
          exit;
        end;
      first:= false;
      for i:=1 to dnum do
        if every[i] then
          begin
            if i = last_d then write(', and ') else
              if not first then write(', ') else write(' ');
            first:=false;
            write('doesn''t ', d[i][1], ' ', d[i][2]);
          end;
      exit;
    end;

  for i:=1 to snum do
    if s[i] = tense[3] then break;
  if i > snum then
    begin
      writeln('I don''t know.');
      exit;
    end;
  k:=0;
  for i:=1 to dnum do
    if (z[subj][i] <> 0) or every[i] then
      begin
        inc(k);
        last_d:=i;
      end;
  if (k = 0) then
    begin
      writeln('I don''t know.');
      exit;
    end;

  face:=s_face[subj];
  if (s[subj] <> 'I') and (s[subj] <> 'you') then
    write(s[subj], ' ')
  else
    begin
      if s[subj] = 'I' then write('you ');
      if s[subj] = 'you' then write('I ');
      face:=3 - face;
    end;
  if k = 1 then
    begin
      if z[subj][last_d] = 1 then
        begin
          write(' ', d[last_d][1]);
          if face = 2 then write('s ') else write(' ');
          writeln(d[last_d][2]);
          exit;
        end
      else
        begin
          if face = 2 then write(' doesn''t') else write(' don''t');
          write(' ', d[last_d][1]);
          write(' ');
          writeln(d[last_d][2]);
          exit;
        end;
    end;
  first:=false;
  for i:=1 to dnum do
    if z[subj][i] <> 0 then
      begin
        if last_d = i then write(', and ') else
          if not first then write(', ') else write(' ');
        first:=false;
        if z[subj][i] = 1 then
          begin
            write(d[i][1]);
            if face = 2 then write('s ');
            writeln(d[i][2]);
          end
        else
          begin
            if face = 2 then write('doesn''t ') else write('don''t ');
            write(d[i][1], ' ', d[i][2]);
          end;
      end;
end;


procedure do_answer;
begin
  if bug then
    begin
      writeln('I am abroad.');
      exit;
    end;
  if (tense[1] = 'do') or (tense[1] = 'does') then
    do_answer_1;
  if tense[1] = 'who' then
    do_answer_2;
  if tense[1] = 'what' then
    do_answer_3;
end;

procedure do_tense;
begin
  if tense[0] = '?' then
    do_answer
  else
    do_add;
end;

procedure gettense;
begin
  wnum:=0;
  while not end_of_tense do
    begin
      if ch = '!' then exit;
      inc(wnum);
      tense[wnum]:=getword;
    end;
  if quest then tense[0]:='?' else tense[0]:='.';
  do_tense;
end;

begin
  bug:=false;
  while not seekeof do
    begin
      read(ch);
      gettense;
      if ch = '!' then exit;
    end;
end.