{Filimonov Vladislav}
Const
  InFileName='input.txt';
  OutFileName='output.txt';
  MaxN=100002;
  MaxS=640000;

Var
  Fail:Text;
  N,M:LongInt;
  K:Int64;
  A:Array[1..MaxN] Of LongInt;
  B:Array[1..MaxN] Of LongInt;
  S:Array[1..MaxS] Of LongInt;
  Ans:LongInt;

Procedure Get;
Var
  I:LongInt;
  Begin
    Assign(Fail,InFileName);
    ReSet(Fail);
    ReadLn(Fail,N);
    For I:=1 To N Do Read(Fail,A[I]);
    ReadLn(Fail,M);
    For I:=1 To M Do Read(Fail,B[I]);
    ReadLn(Fail,K);
    Close(Fail);
  End;


Procedure QSortS(Left,Right:LongInt);
Var
  I:LongInt;
  L,R:LongInt;
  Mid:LongInt;
  P:LongInt;
  Begin
    L:=Left;
    R:=Right;
    Mid:=S[(L+R) Div 2];
    Repeat
      While S[L]<Mid Do Inc(L);
      While S[R]>Mid Do Dec(R);
      If L<=R Then Begin
        P:=S[L];
        S[L]:=S[R];
        S[R]:=P;
        Inc(L);
        Dec(R);
      End;
    Until L>R;
    If L<Right Then QSortS(L,Right);
    If R>Left Then QSortS(Left,R);
  End;

Procedure QSortA(Left,Right:LongInt);
Var
  I:LongInt;
  L,R:LongInt;
  Mid:LongInt;
  P:LongInt;
  Begin
    L:=Left;
    R:=Right;
    Mid:=A[(L+R) Div 2];
    Repeat
      While A[L]<Mid Do Inc(L);
      While A[R]>Mid Do Dec(R);
      If L<=R Then Begin
        P:=A[L];
        A[L]:=A[R];
        A[R]:=P;
        Inc(L);
        Dec(R);
      End;
    Until L>R;
    If L<Right Then QSortA(L,Right);
    If R>Left Then QSortA(Left,R);
  End;

Procedure QSortB(Left,Right:LongInt);
Var
  I:LongInt;
  L,R:LongInt;
  Mid:LongInt;
  P:LongInt;
  Begin
    L:=Left;
    R:=Right;
    Mid:=B[(L+R) Div 2];
    Repeat
      While B[L]<Mid Do Inc(L);
      While B[R]>Mid Do Dec(R);
      If L<=R Then Begin
        P:=B[L];
        B[L]:=B[R];
        B[R]:=P;
        Inc(L);
        Dec(R);
      End;
    Until L>R;
    If L<Right Then QSortB(L,Right);
    If R>Left Then QSortB(Left,R);
  End;


Procedure Save;
  Begin
    Assign(Fail,OutFileName);
    ReWrite(Fail);
    WriteLn(Fail,Ans);
    Close(Fail);
    Halt;
  End;

Procedure Solve;
Var
  I,J:LongInt;
  X,Y,Z,T:LongInt;
  Q:LongInt;
  Cur:LongInt;
  Begin
    QSortA(1,N);
    QSortA(1,M);
    If N*M<=MaxS Then Begin
      For I:=1 To N Do Begin
        For J:=1 To M Do S[(I-1)*M+J]:=A[I]+B[J];
      End;
      QSortS(1,N*M);
      Ans:=S[K];
      Save;
    End;
    If K=1 Then Begin
      Ans:=A[1]+B[1];
      Save;
    End;
    If K=N*M Then Begin
      Ans:=A[N]+B[M];
      Save;
    End;
    Q:=Trunc(SQRT(K));
    Cur:=0;
    For I:=1 To Q+1 Do Begin
      For J:=1 To Q+1 Do Begin
        S[Cur+1]:=A[I]+B[J];
        Inc(Cur);
        If (Cur=K) Or (Cur=MaxS) Then Begin
          QSortS(1,Cur);
          Ans:=S[Cur];
          Save;
        End;
      End;
    End;
  End;

Begin
  Get;
  Solve;
  Save;
End.
