{Filimonov Vladislav}
Const
  InFileName='input.txt';
  OutFileName='output.txt';
  MaxN=1002;
  MaxS=10002;

Var
  Fail:Text;
  N:LongInt;
  S:LongInt;
  A:Array[1..MaxN,1..2] Of LongInt;
  K:LongInt;
  W:Array[1..MaxS] Of Boolean;


Procedure Get;
Var
  I:LongInt;
  Begin
    Assign(Fail,InFileName);
    ReSet(Fail);
    ReadLn(Fail,N,S);
    For I:=1 To N Do ReadLn(Fail,A[I,1],A[I,2]);
    Close(Fail);
  End;


Procedure QSort(Left,Right:Integer);
Var
  I:LongInt;
  L,R:LongInt;
  Mid:LongInt;
  Mid2:LongInt;
  P:LongInt;
  Begin
    L:=Left;
    R:=Right;
    Mid:=A[(L+R) Div 2,1];
    Mid2:=A[(L+R) Div 2,2];
    Repeat
      While A[L,1]<Mid Do Inc(L);
      While (A[L,1]=Mid) And (A[L,2]<Mid2) Do Inc(L);
      While A[R,1]>Mid Do Dec(R);
      While (A[R,1]=Mid) And (A[R,2]>Mid2) Do Dec(R);
      If L<=R Then Begin
        P:=A[L,1];
        A[L,1]:=A[R,1];
        A[R,1]:=P;
        P:=A[L,2];
        A[L,2]:=A[R,2];
        A[R,2]:=P;
        Inc(L);
        Dec(R);
      End;
    Until L>R;
    If L<Right Then QSort(L,Right);
    If R>Left Then QSort(Left,R);
  End;

Function IsIn(X,Y,Z:LongInt):Boolean;
  Begin
    If (X>=Y) And (X<=Z) Then IsIn:=True Else IsIn:=False;
  End;

Procedure Solve;
Var
  I:Integer;
  Cur:LongInt;
  N1,N2:LongInt;
  X:LongInt;
  Vyz:LongInt;
  Begin
    FillChar(W,SizeOf(W),False);
    K:=0;
    QSort(1,N);
    I:=N;
    While I>0 Do Begin
      Vyz:=0;
      N1:=1;
      X:=A[1,1];
      A[1,1]:=MaxS+10;
      A[1,2]:=MaxS+10;
      Inc(N1);
      Inc(Vyz);
      While (A[N1,1]=X) And (N1<=I) Do Begin
        Inc(A[N1,1]);
        If (A[N1,1]>A[N1,2]) Then Begin
          A[N1,1]:=MaxS+10;
          A[N1,2]:=MaxS+10;
          Inc(Vyz);
        End;
        Inc(N1);
      End;

      QSort(1,I);
      Inc(K);
      Dec(I,Vyz);
    End;
  End;

Procedure Save;
  Begin
    Assign(Fail,OutFileName);
    ReWrite(Fail);
    WriteLn(Fail,K);
    Close(Fail);
  End;

Begin
  Get;
  Solve;
  Save;
End.
