{$A+,B-,D-,E+,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
Program pr_b;
const
  inpfile='input.txt';
  outfile='output.txt';
  sm=10005;
  nm=1005;
type
  Inspector=record
    x,y,c : Integer;
  end;
var
  b : array [1..sm] of Boolean;
  a : array [1..nm] of Inspector;
  n,s : LongInt;
  res : LongInt;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n,s);
  for i:=1 to n do
  begin
    read(a[i].x,a[i].y);
    a[i].c:=a[i].y-a[i].x;
  end;
end;
{}
Procedure Out;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(res);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
end;
{}
Procedure Swap(var q,w : Inspector);
var
  bak : Inspector;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure Sort(l, r: Integer);
var
  i, j, x: integer;
begin
  i := l; j := r; x := a[(l+r) DIV 2].c;
  repeat
    while a[i].c < x do i := i + 1;
    while x < a[j].c do j := j - 1;
    if i <= j then
    begin
      Swap(a[i],a[j]);
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

{}
Procedure Solve;
var
  i,j : LongInt;
begin
  Sort(1,n); res:=0;
  for i:=1 to n do
  begin
    for j:=a[i].x to a[i].y do
    if not b[j] then
    begin
      inc(res); b[j]:=true;
      break;
    end;
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
