#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define NN 100100
#define eps 1e-7

FILE *fi, *fo;
long a[NN];
long aa,bb;
long b[NN];
long c[2*NN];
long n,m;
double k;

void sift(long p,long q,long *b)
{
  long i,j;
  long x;
  x=b[p];
  i=p;
  j=2*i+1;
  if(j<q-1) if(b[j+1]>b[j]) j++;
  if(j>=q) return ;
  if(x>b[j]) j=q;
  while(j<q)
  {
    b[i]=b[j];
    i=j;
    j=2*i+1;
    if(j<q-1) if(b[j+1]>b[j]) j++;
    if(x>b[j]) j=q;
  }
  b[i]=x;
}

void HeapSort(long *b,long n)
{
  long p,q;
  long x;
  q=n;
  for(p=q/2;p>=0;p--) sift(p,q,b);
  p=0;
  while(q>0)
  {
    x=b[q-1];
    b[q-1]=b[0];
    b[0]=x;
    q--;
    sift(p,q,b);
  }
}

int main()
{
  long i,j;
  long q;
  long kk;
  double f1,f2;
  fi=fopen("input.txt","rt");
  fo=fopen("output.txt","wt");

  fscanf(fi,"%li",&n);
  for(i=0;i<n;i++)
    fscanf(fi,"%li",&a[i]);
  HeapSort(a,n);
  fscanf(fi,"%li",&m);
  for(i=0;i<m;i++)
    fscanf(fi,"%li",&b[i]);
  HeapSort(b,m);
  fscanf(fi,"%lf",&k);
  aa=0;
  bb=0;

  f1=n*m;
  f2=2*NN;

  if(fabs(k-1.0)<eps)
  {
    fprintf(fo,"%li\n",a[0]+b[0]);
    fclose(fi);
    fclose(fo);
    return 0;
  }

  if(fabs(k-f1)<eps)
  {
    fprintf(fo,"%li\n",a[n-1]+b[m-1]);
    fclose(fi);
    fclose(fo);
    return 0;
  }

  if(f1<f2)
  {
    q=0;
    for(i=0;i<n;i++)
      for(j=0;j<m;j++)
      {
        c[q]=a[i]+b[j];
        q++;
      }
    kk=(long)k;
    HeapSort(c,q);
    fprintf(fo,"%li\n",c[kk-1]);
    fclose(fi);
    fclose(fo);
    return 0;
  }

  while(k>(double)(m+n-aa-bb-1))
  {
    k-=(double)m+n-aa-bb-1;
    aa++;
    bb++;
  }
  kk=(long)k;
  i=aa+1;
  j=bb;
  q=0;
  while((j<m)||(i<n))
  {
    if(j>=m)
    {
      c[q]=b[bb]+a[i];
      i++;
      q++;
    }
    else
    {
      if(i>=n)
      {
        c[q]=a[aa]+b[j];
        j++;
        q++;
      }
      else
      {
        if((a[aa]+b[j])<(b[bb]+a[i]))
        {
          c[q]=a[aa]+b[j];
          j++;
        }
        else
        {
          c[q]=b[bb]+a[i];
          i++;
        }
        q++;
      }
    }
  }

  fprintf(fo,"%li\n",c[kk-1]);

  fclose(fi);
  fclose(fo);
  return 0;
}
