#include <stdio.h>
#include <stdlib.h>

#define SS 10100
#define NN 1100

struct POINT {
  int x,y;
};

FILE *fi, *fo;
POINT a[NN];
int match[SS+1];
bool used[SS+1];
bool ful[NN];

int cmp(int aa, int bb)
{
  if(a[aa].y<a[bb].y) return -1;
  else
    return 1;
}

void sift(long p,long q,int *b)
{
  long i,j;
  int x;
  x=b[p];
  i=p;
  j=2*i+1;
  if(j<q-1) if(cmp(b[j+1],b[j])>0) j++;
  if(j>=q) return ;
  if(cmp(x,b[j])>0) j=q;
  while(j<q)
  {
    b[i]=b[j];
    i=j;
    j=2*i+1;
    if(j<q-1) if(cmp(b[j+1],b[j])>0) j++;
    if(cmp(x,b[j])>0) j=q;
  }
  b[i]=x;
}

void HeapSort(int *b,long n)
{
  long p,q;
  int x;
  q=n;
  for(p=q/2;p>=0;p--) sift(p,q,b);
  p=0;
  while(q>0)
  {
    x=b[q-1];
    b[q-1]=b[0];
    b[0]=x;
    q--;
    sift(p,q,b);
  }
}

int main()
{
  int i,j;
  int q;
  int res;
  int n,s;
  int tmp[NN];
  int m;
  fi=fopen("input.txt","rt");
  fo=fopen("output.txt","wt");

  fscanf(fi,"%i%i",&n,&s);
  for(i=0;i<n;i++)
  {
    fscanf(fi,"%i%i",&a[i].x, &a[i].y);
  }
  for(i=0;i<n;i++)
  {
    ful[i]=false;
  }
  res=0;

  for(i=0;i<=s;i++)
  {
    q=0;
    for(j=0;j<n;j++)
    {
      if((!ful[j])&&(a[j].x<=i)&&(a[j].y>=i))
      {
        tmp[q]=j;
        q++;
      }
    }
    if(q>0)
    {
//      HeapSort(tmp,q);
      m=0;
      for(j=1;j<q;j++)
      {
        if(cmp(tmp[m],tmp[j])>0) m=j;
      }
      ful[tmp[m]]=true;
      res++;
    }
  }

  fprintf(fo,"%i\n",res);

  fclose(fi);
  fclose(fo);
  return 0;
}
