{$IFDEF NORMAL}
  {$I-,Q-,R-,S-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I+,Q+,R+,S+}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-}
{$ENDIF RELEASE}
program p24_14_a;

const
  max = 100000;
  tmax = 500000;

var
  wrk, wrk2, a, b, uk : array[1..max] of longint;
  table : array[0..tmax] of longint;
  i, j, l, step, now, m, n : longint;
  flag : boolean;
  k, loop : extended;

procedure Sorta;
var
  razm, ps, u1, u2, u3, mu1, mu2 : longint;
begin
  razm := 1;
  for ps := 1 to n do begin
    wrk[ps] := a[ps];
  end;
  repeat
    fillchar(wrk2, sizeof(wrk2), 0);
    u3 := 0;
    for ps := 1 to n div (2 * razm) + 1 do begin
      u1 := (ps - 1) * 2 * razm + 1;
      u2 := (ps - 1) * 2 * razm + 1 + razm;
      if (u1 > n) {or (u2 > n)} then break;
      mu1 := u1 + razm;
      mu2 := u2 + razm;
      repeat
        if ((wrk[u1] < wrk[u2]) or (u2 >= mu2) or (u2 > n)) and (u1 < mu1) then begin
          inc(u3);
          wrk2[u3] := wrk[u1];
          inc(u1);
        end else
        if ((wrk[u2] <= wrk[u1]) or (u1 >= mu1)) and (u2 < mu2) and (u2 <= n) then begin
          inc(u3);
          wrk2[u3] := wrk[u2];
          inc(u2);
        end;
      until (u1 > n) or (u1 >= mu1) and ((u2 >= mu2) or (u2 > n));
    end;
    wrk := wrk2;
    razm := razm * 2;
  until razm >= n;
  for j := 1 to n do
    a[j] := wrk[j];
end;

procedure Sortb;
var
  razm, ps, u1, u2, u3, mu1, mu2 : longint;
begin
  razm := 1;
  for ps := 1 to m do begin
    wrk[ps] := b[ps];
  end;
  repeat
    fillchar(wrk2, sizeof(wrk2), 0);
    u3 := 0;
    for ps := 1 to m div (2 * razm) + 1 do begin
      u1 := (ps - 1) * 2 * razm + 1;
      u2 := (ps - 1) * 2 * razm + 1 + razm;
      if (u1 > n) {or (u2 > n)} then break;
      mu1 := u1 + razm;
      mu2 := u2 + razm;
      repeat
        if ((wrk[u1] < wrk[u2]) or (u2 >= mu2) or (u2 > m)) and (u1 < mu1) then begin
          inc(u3);
          wrk2[u3] := wrk[u1];
          inc(u1);
        end else
        if ((wrk[u2] <= wrk[u1]) or (u1 >= mu1)) and (u2 < mu2) and (u2 <= m) then begin
          inc(u3);
          wrk2[u3] := wrk[u2];
          inc(u2);
        end;
      until (u1 > m) or (u1 >= mu1) and ((u2 >= mu2) or (u2 > m));
    end;
    wrk := wrk2;
    razm := razm * 2;
  until razm >= m;
  for j := 1 to m do
    b[j] := wrk[j];
end;

begin
  assign(input, 'input.txt');
  reset(input);
  assign(output, 'output.txt');
  rewrite(output);
  read(n);
  for i := 1 to n do read(a[i]);
  read(m);
  for i := 1 to m do read(b[i]);
  read(k);
  sorta;
  sortb;
  for i := 1 to n do begin
    uk[i] := 1;
  end;
  step := 0;
  while true do begin
    loop := 0;
    fillchar(table, sizeof(table), 0);
    for i := 1 to n do
      for j := uk[i] to m do begin
        if a[i] + b[j] <= step * tmax + tmax then begin
          loop := loop + 1;
          inc(table[a[i] + b[j] - step * tmax]);
        end else begin
          uk[i] := j;
          break;
        end;
        if (j = m) and (a[i] + b[j] <= step * tmax + tmax) then uk[i] := m + 1;
      end;
    if k <= loop then begin
      for i := 0 to tmax do begin
        k := k - table[i];
        if k <= 0 then begin
          writeln(i + tmax * step);
          close(output);
          halt;
        end;
      end;
    end else k := k - loop;
    inc(step);
  end;
end.
