const
  inf = 'input.txt'; ouf = 'output.txt';
  maxn = 100000;
type
  tar = array[1..maxn] of longint;
  procedure swap(var a, b: longint);
  var
    c: longint;
  begin
    c := a; a := b; b := c;
  end;
var
  b: tar; md: longint;
  procedure qsort(l, r: longint);
  var
    i, j: longint;
  begin
    i := l; j := r; md := b[(l + r) shr 1];
    repeat
      while (b[i] < md) do inc(i);
      while (b[j] > md) do dec(j);
      if (i <= j) then
      begin
        swap(b[i], b[j]);
        inc(i); dec(j);
      end;
    until i >= j;
    if (i < r) then qsort(i, r);
    if (j > l) then qsort(l, j);
  end;
var
  a: tar;
  cr, iq, jq: array[1..maxn] of longint;
  u: array[1..maxn] of byte;
  hs: longint;
  cur: longint;
  n, m: cardinal;
  procedure swh(ii, jj: longint);
  var
    cc: longint;
  begin
    cc := cr[ii]; cr[ii] := cr[jj]; cr[jj] := cc;
    cc := iq[ii]; iq[ii] := iq[jj]; iq[jj] := cc;
    cc := jq[ii]; jq[ii] := jq[jj]; jq[jj] := cc;
  end;
var
  lgs: longint;
  procedure heapify(k: longint);
  var
    l, r: longint;
  begin
    l := k shl 1; r := l + 1;
    if (l <= hs) and (cr[l] < cr[k]) then
      lgs := l else lgs := k;
    if (r <= hs) and (cr[r]  < cr[lgs]) then
      lgs := r;
    if (lgs <> k) then
    begin
      swh(k, lgs); heapify(lgs);
    end;
  end;
  procedure up(k, ik, jk: longint);
  var
    j: longint;
  begin
    inc(hs); j := hs;
    while (j > 1) and (cr[j shr 1] > k) do
    begin
      cr[j] := cr[j shr 1];
      iq[j] := iq[j shr 1]; jq[j] := jq[j shr 1];
      j := j shr 1;
    end;
    cr[j] := k; iq[j] := ik; jq[j] := jk;
  end;
  procedure extract;
  var
    ik, jk: longint;
  begin
    cur := cr[1]; ik := iq[1]; jk := jq[1];
    swh(1, hs); dec(hs);
    heapify(1);
    if (u[ik + 1] = 0) and (ik < n) then
    begin
      up(a[ik + 1] + b[1], ik + 1, 1); u[ik + 1] := 1;
    end;
    if (jk < m) then
      up(a[ik] + b[jk + 1], ik, jk + 1);
  end;
var
  i, k: cardinal;
begin
  assign(input, inf); reset(input);
  assign(output,ouf);rewrite(output);
  readln(input, n);
  fillchar(b, sizeof(b), 0);
  for i := 1 to n do read(input, b[i]);
  qsort(1, n); a := b;
  readln(input, m);
  fillchar(b, sizeof(b), 0);
  for i := 1 to m do read(input, b[i]);
  qsort(1, m);
  readln(input, k);
  fillchar(u, sizeof(u), 0);
  cr[1] := a[1] + b[1]; u[1] := 1;
  hs := 1; iq[1] := 1; jq[1] := 1;
  if (k = n * m) then
    cur := a[n] + b[m]
  else
  begin
    for i := 1 to k do
      extract;
  end;
  writeln(output, cur);
  close(input); close(output);
end.
