const
     FileIn='input.txt';
     FileOut='output.txt';
     MaxNM=100000;
type
    TMNArr=array [1..MaxNM*2] of LongInt;
var
   N: LongInt;
   M: LongInt;
   A, B: TMNArr;
   K: LongInt;
   Answer: LongInt;
   Cij: TMNArr;

procedure ReadData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for NItem:=1 to N
         do Read (F, A [NItem]);
     Readln (F);
     Readln (F, M);
     for NItem:=1 to M
         do Read (F, B [NItem]);
     Readln (F);
     Readln (F, K);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, Answer);
     Close (F);
end;

procedure QuickSort (var aA: TMNArr; aLo, aHi: LongInt);

procedure Sort (l, r: LongInt);
var
  i, j, x, y: LongInt;
begin
  i := l; j := r; x := aA[(l+r) DIV 2];
  repeat
    while aA[i] < x do i := i + 1;
    while x < aA[j] do j := j - 1;
    if i <= j then
    begin
      y := aA[i]; aA[i] := aA[j]; aA[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

begin
     Sort(aLo,aHi);
end;

procedure Solve;
var
   i, j, x: LongInt;
begin
     QuickSort (A, 1, N);
     QuickSort (B, 1, M);
     i:=0;
     j:=0;
     repeat
           if (A [i+1]<B [j+1]) or (j=M)
              then Inc (i)
              else Inc (j);
     until (i=N) and (j=M) or (i*j>=k);
     if i*j=k
        then Answer:=A [i]+B [j]
        else begin
             for x:=1 to i
                 do Cij [x]:=A [x]+B [j];
             for x:=1 to j
                 do Cij [i+x]:=A [i]+B [x];
             QuickSort (Cij, 1, i+j);
             Answer:=Cij [i*j-k];
        end;
end;

procedure Main;
begin
     ReadData;
     Solve;
     WriteData;
end;

begin
     Main;
end.
